<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAbsenceDriver ArrayType
 * @subpackage Arrays
 */
class ArrayOfAbsenceDriver extends AbstractStructArrayBase
{
    /**
     * The AbsenceDriver
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AbsenceDriver[]
     */
    public $AbsenceDriver;
    /**
     * Constructor method for ArrayOfAbsenceDriver
     * @uses ArrayOfAbsenceDriver::setAbsenceDriver()
     * @param \StructType\AbsenceDriver[] $absenceDriver
     */
    public function __construct(array $absenceDriver = array())
    {
        $this
            ->setAbsenceDriver($absenceDriver);
    }
    /**
     * Get AbsenceDriver value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AbsenceDriver[]|null
     */
    public function getAbsenceDriver()
    {
        return isset($this->AbsenceDriver) ? $this->AbsenceDriver : null;
    }
    /**
     * Set AbsenceDriver value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AbsenceDriver[] $absenceDriver
     * @return \ArrayType\ArrayOfAbsenceDriver
     */
    public function setAbsenceDriver(array $absenceDriver = array())
    {
        foreach ($absenceDriver as $arrayOfAbsenceDriverAbsenceDriverItem) {
            // validation for constraint: itemType
            if (!$arrayOfAbsenceDriverAbsenceDriverItem instanceof \StructType\AbsenceDriver) {
                throw new \InvalidArgumentException(sprintf('The AbsenceDriver property can only contain items of \StructType\AbsenceDriver, "%s" given', is_object($arrayOfAbsenceDriverAbsenceDriverItem) ? get_class($arrayOfAbsenceDriverAbsenceDriverItem) : gettype($arrayOfAbsenceDriverAbsenceDriverItem)), __LINE__);
            }
        }
        if (is_null($absenceDriver) || (is_array($absenceDriver) && empty($absenceDriver))) {
            unset($this->AbsenceDriver);
        } else {
            $this->AbsenceDriver = $absenceDriver;
        }
        return $this;
    }
    /**
     * Add item to AbsenceDriver value
     * @throws \InvalidArgumentException
     * @param \StructType\AbsenceDriver $item
     * @return \ArrayType\ArrayOfAbsenceDriver
     */
    public function addToAbsenceDriver(\StructType\AbsenceDriver $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AbsenceDriver) {
            throw new \InvalidArgumentException(sprintf('The AbsenceDriver property can only contain items of \StructType\AbsenceDriver, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AbsenceDriver[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AbsenceDriver|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AbsenceDriver|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AbsenceDriver|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AbsenceDriver|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AbsenceDriver|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AbsenceDriver
     */
    public function getAttributeName()
    {
        return 'AbsenceDriver';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAbsenceDriver
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
