<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAbsenceItem_V2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfAbsenceItem_V2 extends AbstractStructArrayBase
{
    /**
     * The AbsenceItem_V2
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AbsenceItem_V2[]
     */
    public $AbsenceItem_V2;
    /**
     * Constructor method for ArrayOfAbsenceItem_V2
     * @uses ArrayOfAbsenceItem_V2::setAbsenceItem_V2()
     * @param \StructType\AbsenceItem_V2[] $absenceItem_V2
     */
    public function __construct(array $absenceItem_V2 = array())
    {
        $this
            ->setAbsenceItem_V2($absenceItem_V2);
    }
    /**
     * Get AbsenceItem_V2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AbsenceItem_V2[]|null
     */
    public function getAbsenceItem_V2()
    {
        return isset($this->AbsenceItem_V2) ? $this->AbsenceItem_V2 : null;
    }
    /**
     * Set AbsenceItem_V2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AbsenceItem_V2[] $absenceItem_V2
     * @return \ArrayType\ArrayOfAbsenceItem_V2
     */
    public function setAbsenceItem_V2(array $absenceItem_V2 = array())
    {
        foreach ($absenceItem_V2 as $arrayOfAbsenceItem_V2AbsenceItem_V2Item) {
            // validation for constraint: itemType
            if (!$arrayOfAbsenceItem_V2AbsenceItem_V2Item instanceof \StructType\AbsenceItem_V2) {
                throw new \InvalidArgumentException(sprintf('The AbsenceItem_V2 property can only contain items of \StructType\AbsenceItem_V2, "%s" given', is_object($arrayOfAbsenceItem_V2AbsenceItem_V2Item) ? get_class($arrayOfAbsenceItem_V2AbsenceItem_V2Item) : gettype($arrayOfAbsenceItem_V2AbsenceItem_V2Item)), __LINE__);
            }
        }
        if (is_null($absenceItem_V2) || (is_array($absenceItem_V2) && empty($absenceItem_V2))) {
            unset($this->AbsenceItem_V2);
        } else {
            $this->AbsenceItem_V2 = $absenceItem_V2;
        }
        return $this;
    }
    /**
     * Add item to AbsenceItem_V2 value
     * @throws \InvalidArgumentException
     * @param \StructType\AbsenceItem_V2 $item
     * @return \ArrayType\ArrayOfAbsenceItem_V2
     */
    public function addToAbsenceItem_V2(\StructType\AbsenceItem_V2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AbsenceItem_V2) {
            throw new \InvalidArgumentException(sprintf('The AbsenceItem_V2 property can only contain items of \StructType\AbsenceItem_V2, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AbsenceItem_V2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AbsenceItem_V2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AbsenceItem_V2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AbsenceItem_V2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AbsenceItem_V2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AbsenceItem_V2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AbsenceItem_V2
     */
    public function getAttributeName()
    {
        return 'AbsenceItem_V2';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAbsenceItem_V2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
