<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCommentHistoricalResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfCommentHistoricalResult extends AbstractStructArrayBase
{
    /**
     * The CommentHistoricalResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CommentHistoricalResult[]
     */
    public $CommentHistoricalResult;
    /**
     * Constructor method for ArrayOfCommentHistoricalResult
     * @uses ArrayOfCommentHistoricalResult::setCommentHistoricalResult()
     * @param \StructType\CommentHistoricalResult[] $commentHistoricalResult
     */
    public function __construct(array $commentHistoricalResult = array())
    {
        $this
            ->setCommentHistoricalResult($commentHistoricalResult);
    }
    /**
     * Get CommentHistoricalResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CommentHistoricalResult[]|null
     */
    public function getCommentHistoricalResult()
    {
        return isset($this->CommentHistoricalResult) ? $this->CommentHistoricalResult : null;
    }
    /**
     * Set CommentHistoricalResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CommentHistoricalResult[] $commentHistoricalResult
     * @return \ArrayType\ArrayOfCommentHistoricalResult
     */
    public function setCommentHistoricalResult(array $commentHistoricalResult = array())
    {
        foreach ($commentHistoricalResult as $arrayOfCommentHistoricalResultCommentHistoricalResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfCommentHistoricalResultCommentHistoricalResultItem instanceof \StructType\CommentHistoricalResult) {
                throw new \InvalidArgumentException(sprintf('The CommentHistoricalResult property can only contain items of \StructType\CommentHistoricalResult, "%s" given', is_object($arrayOfCommentHistoricalResultCommentHistoricalResultItem) ? get_class($arrayOfCommentHistoricalResultCommentHistoricalResultItem) : gettype($arrayOfCommentHistoricalResultCommentHistoricalResultItem)), __LINE__);
            }
        }
        if (is_null($commentHistoricalResult) || (is_array($commentHistoricalResult) && empty($commentHistoricalResult))) {
            unset($this->CommentHistoricalResult);
        } else {
            $this->CommentHistoricalResult = $commentHistoricalResult;
        }
        return $this;
    }
    /**
     * Add item to CommentHistoricalResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CommentHistoricalResult $item
     * @return \ArrayType\ArrayOfCommentHistoricalResult
     */
    public function addToCommentHistoricalResult(\StructType\CommentHistoricalResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CommentHistoricalResult) {
            throw new \InvalidArgumentException(sprintf('The CommentHistoricalResult property can only contain items of \StructType\CommentHistoricalResult, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CommentHistoricalResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CommentHistoricalResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CommentHistoricalResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CommentHistoricalResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CommentHistoricalResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CommentHistoricalResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CommentHistoricalResult
     */
    public function getAttributeName()
    {
        return 'CommentHistoricalResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCommentHistoricalResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
