<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCompanyPOIGroupItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfCompanyPOIGroupItem extends AbstractStructArrayBase
{
    /**
     * The CompanyPOIGroupItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CompanyPOIGroupItem[]
     */
    public $CompanyPOIGroupItem;
    /**
     * Constructor method for ArrayOfCompanyPOIGroupItem
     * @uses ArrayOfCompanyPOIGroupItem::setCompanyPOIGroupItem()
     * @param \StructType\CompanyPOIGroupItem[] $companyPOIGroupItem
     */
    public function __construct(array $companyPOIGroupItem = array())
    {
        $this
            ->setCompanyPOIGroupItem($companyPOIGroupItem);
    }
    /**
     * Get CompanyPOIGroupItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CompanyPOIGroupItem[]|null
     */
    public function getCompanyPOIGroupItem()
    {
        return isset($this->CompanyPOIGroupItem) ? $this->CompanyPOIGroupItem : null;
    }
    /**
     * Set CompanyPOIGroupItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CompanyPOIGroupItem[] $companyPOIGroupItem
     * @return \ArrayType\ArrayOfCompanyPOIGroupItem
     */
    public function setCompanyPOIGroupItem(array $companyPOIGroupItem = array())
    {
        foreach ($companyPOIGroupItem as $arrayOfCompanyPOIGroupItemCompanyPOIGroupItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfCompanyPOIGroupItemCompanyPOIGroupItemItem instanceof \StructType\CompanyPOIGroupItem) {
                throw new \InvalidArgumentException(sprintf('The CompanyPOIGroupItem property can only contain items of \StructType\CompanyPOIGroupItem, "%s" given', is_object($arrayOfCompanyPOIGroupItemCompanyPOIGroupItemItem) ? get_class($arrayOfCompanyPOIGroupItemCompanyPOIGroupItemItem) : gettype($arrayOfCompanyPOIGroupItemCompanyPOIGroupItemItem)), __LINE__);
            }
        }
        if (is_null($companyPOIGroupItem) || (is_array($companyPOIGroupItem) && empty($companyPOIGroupItem))) {
            unset($this->CompanyPOIGroupItem);
        } else {
            $this->CompanyPOIGroupItem = $companyPOIGroupItem;
        }
        return $this;
    }
    /**
     * Add item to CompanyPOIGroupItem value
     * @throws \InvalidArgumentException
     * @param \StructType\CompanyPOIGroupItem $item
     * @return \ArrayType\ArrayOfCompanyPOIGroupItem
     */
    public function addToCompanyPOIGroupItem(\StructType\CompanyPOIGroupItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CompanyPOIGroupItem) {
            throw new \InvalidArgumentException(sprintf('The CompanyPOIGroupItem property can only contain items of \StructType\CompanyPOIGroupItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CompanyPOIGroupItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CompanyPOIGroupItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CompanyPOIGroupItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CompanyPOIGroupItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CompanyPOIGroupItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CompanyPOIGroupItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CompanyPOIGroupItem
     */
    public function getAttributeName()
    {
        return 'CompanyPOIGroupItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCompanyPOIGroupItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
