<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCompanyPOISubGroupItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfCompanyPOISubGroupItem extends AbstractStructArrayBase
{
    /**
     * The CompanyPOISubGroupItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CompanyPOISubGroupItem[]
     */
    public $CompanyPOISubGroupItem;
    /**
     * Constructor method for ArrayOfCompanyPOISubGroupItem
     * @uses ArrayOfCompanyPOISubGroupItem::setCompanyPOISubGroupItem()
     * @param \StructType\CompanyPOISubGroupItem[] $companyPOISubGroupItem
     */
    public function __construct(array $companyPOISubGroupItem = array())
    {
        $this
            ->setCompanyPOISubGroupItem($companyPOISubGroupItem);
    }
    /**
     * Get CompanyPOISubGroupItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CompanyPOISubGroupItem[]|null
     */
    public function getCompanyPOISubGroupItem()
    {
        return isset($this->CompanyPOISubGroupItem) ? $this->CompanyPOISubGroupItem : null;
    }
    /**
     * Set CompanyPOISubGroupItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CompanyPOISubGroupItem[] $companyPOISubGroupItem
     * @return \ArrayType\ArrayOfCompanyPOISubGroupItem
     */
    public function setCompanyPOISubGroupItem(array $companyPOISubGroupItem = array())
    {
        foreach ($companyPOISubGroupItem as $arrayOfCompanyPOISubGroupItemCompanyPOISubGroupItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfCompanyPOISubGroupItemCompanyPOISubGroupItemItem instanceof \StructType\CompanyPOISubGroupItem) {
                throw new \InvalidArgumentException(sprintf('The CompanyPOISubGroupItem property can only contain items of \StructType\CompanyPOISubGroupItem, "%s" given', is_object($arrayOfCompanyPOISubGroupItemCompanyPOISubGroupItemItem) ? get_class($arrayOfCompanyPOISubGroupItemCompanyPOISubGroupItemItem) : gettype($arrayOfCompanyPOISubGroupItemCompanyPOISubGroupItemItem)), __LINE__);
            }
        }
        if (is_null($companyPOISubGroupItem) || (is_array($companyPOISubGroupItem) && empty($companyPOISubGroupItem))) {
            unset($this->CompanyPOISubGroupItem);
        } else {
            $this->CompanyPOISubGroupItem = $companyPOISubGroupItem;
        }
        return $this;
    }
    /**
     * Add item to CompanyPOISubGroupItem value
     * @throws \InvalidArgumentException
     * @param \StructType\CompanyPOISubGroupItem $item
     * @return \ArrayType\ArrayOfCompanyPOISubGroupItem
     */
    public function addToCompanyPOISubGroupItem(\StructType\CompanyPOISubGroupItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CompanyPOISubGroupItem) {
            throw new \InvalidArgumentException(sprintf('The CompanyPOISubGroupItem property can only contain items of \StructType\CompanyPOISubGroupItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CompanyPOISubGroupItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CompanyPOISubGroupItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CompanyPOISubGroupItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CompanyPOISubGroupItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CompanyPOISubGroupItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CompanyPOISubGroupItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CompanyPOISubGroupItem
     */
    public function getAttributeName()
    {
        return 'CompanyPOISubGroupItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCompanyPOISubGroupItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
