<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfConsumptionReportItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfConsumptionReportItem extends AbstractStructArrayBase
{
    /**
     * The ConsumptionReportItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ConsumptionReportItem[]
     */
    public $ConsumptionReportItem;
    /**
     * Constructor method for ArrayOfConsumptionReportItem
     * @uses ArrayOfConsumptionReportItem::setConsumptionReportItem()
     * @param \StructType\ConsumptionReportItem[] $consumptionReportItem
     */
    public function __construct(array $consumptionReportItem = array())
    {
        $this
            ->setConsumptionReportItem($consumptionReportItem);
    }
    /**
     * Get ConsumptionReportItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ConsumptionReportItem[]|null
     */
    public function getConsumptionReportItem()
    {
        return isset($this->ConsumptionReportItem) ? $this->ConsumptionReportItem : null;
    }
    /**
     * Set ConsumptionReportItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ConsumptionReportItem[] $consumptionReportItem
     * @return \ArrayType\ArrayOfConsumptionReportItem
     */
    public function setConsumptionReportItem(array $consumptionReportItem = array())
    {
        foreach ($consumptionReportItem as $arrayOfConsumptionReportItemConsumptionReportItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfConsumptionReportItemConsumptionReportItemItem instanceof \StructType\ConsumptionReportItem) {
                throw new \InvalidArgumentException(sprintf('The ConsumptionReportItem property can only contain items of \StructType\ConsumptionReportItem, "%s" given', is_object($arrayOfConsumptionReportItemConsumptionReportItemItem) ? get_class($arrayOfConsumptionReportItemConsumptionReportItemItem) : gettype($arrayOfConsumptionReportItemConsumptionReportItemItem)), __LINE__);
            }
        }
        if (is_null($consumptionReportItem) || (is_array($consumptionReportItem) && empty($consumptionReportItem))) {
            unset($this->ConsumptionReportItem);
        } else {
            $this->ConsumptionReportItem = $consumptionReportItem;
        }
        return $this;
    }
    /**
     * Add item to ConsumptionReportItem value
     * @throws \InvalidArgumentException
     * @param \StructType\ConsumptionReportItem $item
     * @return \ArrayType\ArrayOfConsumptionReportItem
     */
    public function addToConsumptionReportItem(\StructType\ConsumptionReportItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ConsumptionReportItem) {
            throw new \InvalidArgumentException(sprintf('The ConsumptionReportItem property can only contain items of \StructType\ConsumptionReportItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ConsumptionReportItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ConsumptionReportItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ConsumptionReportItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ConsumptionReportItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ConsumptionReportItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ConsumptionReportItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ConsumptionReportItem
     */
    public function getAttributeName()
    {
        return 'ConsumptionReportItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfConsumptionReportItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
