<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCostCompensationCodeItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfCostCompensationCodeItem extends AbstractStructArrayBase
{
    /**
     * The CostCompensationCodeItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CostCompensationCodeItem[]
     */
    public $CostCompensationCodeItem;
    /**
     * Constructor method for ArrayOfCostCompensationCodeItem
     * @uses ArrayOfCostCompensationCodeItem::setCostCompensationCodeItem()
     * @param \StructType\CostCompensationCodeItem[] $costCompensationCodeItem
     */
    public function __construct(array $costCompensationCodeItem = array())
    {
        $this
            ->setCostCompensationCodeItem($costCompensationCodeItem);
    }
    /**
     * Get CostCompensationCodeItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CostCompensationCodeItem[]|null
     */
    public function getCostCompensationCodeItem()
    {
        return isset($this->CostCompensationCodeItem) ? $this->CostCompensationCodeItem : null;
    }
    /**
     * Set CostCompensationCodeItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CostCompensationCodeItem[] $costCompensationCodeItem
     * @return \ArrayType\ArrayOfCostCompensationCodeItem
     */
    public function setCostCompensationCodeItem(array $costCompensationCodeItem = array())
    {
        foreach ($costCompensationCodeItem as $arrayOfCostCompensationCodeItemCostCompensationCodeItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfCostCompensationCodeItemCostCompensationCodeItemItem instanceof \StructType\CostCompensationCodeItem) {
                throw new \InvalidArgumentException(sprintf('The CostCompensationCodeItem property can only contain items of \StructType\CostCompensationCodeItem, "%s" given', is_object($arrayOfCostCompensationCodeItemCostCompensationCodeItemItem) ? get_class($arrayOfCostCompensationCodeItemCostCompensationCodeItemItem) : gettype($arrayOfCostCompensationCodeItemCostCompensationCodeItemItem)), __LINE__);
            }
        }
        if (is_null($costCompensationCodeItem) || (is_array($costCompensationCodeItem) && empty($costCompensationCodeItem))) {
            unset($this->CostCompensationCodeItem);
        } else {
            $this->CostCompensationCodeItem = $costCompensationCodeItem;
        }
        return $this;
    }
    /**
     * Add item to CostCompensationCodeItem value
     * @throws \InvalidArgumentException
     * @param \StructType\CostCompensationCodeItem $item
     * @return \ArrayType\ArrayOfCostCompensationCodeItem
     */
    public function addToCostCompensationCodeItem(\StructType\CostCompensationCodeItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CostCompensationCodeItem) {
            throw new \InvalidArgumentException(sprintf('The CostCompensationCodeItem property can only contain items of \StructType\CostCompensationCodeItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CostCompensationCodeItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CostCompensationCodeItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CostCompensationCodeItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CostCompensationCodeItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CostCompensationCodeItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CostCompensationCodeItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CostCompensationCodeItem
     */
    public function getAttributeName()
    {
        return 'CostCompensationCodeItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCostCompensationCodeItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
