<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCostCompensationReportItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfCostCompensationReportItem extends AbstractStructArrayBase
{
    /**
     * The CostCompensationReportItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CostCompensationReportItem[]
     */
    public $CostCompensationReportItem;
    /**
     * Constructor method for ArrayOfCostCompensationReportItem
     * @uses ArrayOfCostCompensationReportItem::setCostCompensationReportItem()
     * @param \StructType\CostCompensationReportItem[] $costCompensationReportItem
     */
    public function __construct(array $costCompensationReportItem = array())
    {
        $this
            ->setCostCompensationReportItem($costCompensationReportItem);
    }
    /**
     * Get CostCompensationReportItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CostCompensationReportItem[]|null
     */
    public function getCostCompensationReportItem()
    {
        return isset($this->CostCompensationReportItem) ? $this->CostCompensationReportItem : null;
    }
    /**
     * Set CostCompensationReportItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CostCompensationReportItem[] $costCompensationReportItem
     * @return \ArrayType\ArrayOfCostCompensationReportItem
     */
    public function setCostCompensationReportItem(array $costCompensationReportItem = array())
    {
        foreach ($costCompensationReportItem as $arrayOfCostCompensationReportItemCostCompensationReportItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfCostCompensationReportItemCostCompensationReportItemItem instanceof \StructType\CostCompensationReportItem) {
                throw new \InvalidArgumentException(sprintf('The CostCompensationReportItem property can only contain items of \StructType\CostCompensationReportItem, "%s" given', is_object($arrayOfCostCompensationReportItemCostCompensationReportItemItem) ? get_class($arrayOfCostCompensationReportItemCostCompensationReportItemItem) : gettype($arrayOfCostCompensationReportItemCostCompensationReportItemItem)), __LINE__);
            }
        }
        if (is_null($costCompensationReportItem) || (is_array($costCompensationReportItem) && empty($costCompensationReportItem))) {
            unset($this->CostCompensationReportItem);
        } else {
            $this->CostCompensationReportItem = $costCompensationReportItem;
        }
        return $this;
    }
    /**
     * Add item to CostCompensationReportItem value
     * @throws \InvalidArgumentException
     * @param \StructType\CostCompensationReportItem $item
     * @return \ArrayType\ArrayOfCostCompensationReportItem
     */
    public function addToCostCompensationReportItem(\StructType\CostCompensationReportItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CostCompensationReportItem) {
            throw new \InvalidArgumentException(sprintf('The CostCompensationReportItem property can only contain items of \StructType\CostCompensationReportItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CostCompensationReportItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CostCompensationReportItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CostCompensationReportItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CostCompensationReportItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CostCompensationReportItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CostCompensationReportItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CostCompensationReportItem
     */
    public function getAttributeName()
    {
        return 'CostCompensationReportItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCostCompensationReportItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
