<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDayCode_V2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfDayCode_V2 extends AbstractStructArrayBase
{
    /**
     * The DayCode_V2
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DayCode_V2[]
     */
    public $DayCode_V2;
    /**
     * Constructor method for ArrayOfDayCode_V2
     * @uses ArrayOfDayCode_V2::setDayCode_V2()
     * @param \StructType\DayCode_V2[] $dayCode_V2
     */
    public function __construct(array $dayCode_V2 = array())
    {
        $this
            ->setDayCode_V2($dayCode_V2);
    }
    /**
     * Get DayCode_V2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DayCode_V2[]|null
     */
    public function getDayCode_V2()
    {
        return isset($this->DayCode_V2) ? $this->DayCode_V2 : null;
    }
    /**
     * Set DayCode_V2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DayCode_V2[] $dayCode_V2
     * @return \ArrayType\ArrayOfDayCode_V2
     */
    public function setDayCode_V2(array $dayCode_V2 = array())
    {
        foreach ($dayCode_V2 as $arrayOfDayCode_V2DayCode_V2Item) {
            // validation for constraint: itemType
            if (!$arrayOfDayCode_V2DayCode_V2Item instanceof \StructType\DayCode_V2) {
                throw new \InvalidArgumentException(sprintf('The DayCode_V2 property can only contain items of \StructType\DayCode_V2, "%s" given', is_object($arrayOfDayCode_V2DayCode_V2Item) ? get_class($arrayOfDayCode_V2DayCode_V2Item) : gettype($arrayOfDayCode_V2DayCode_V2Item)), __LINE__);
            }
        }
        if (is_null($dayCode_V2) || (is_array($dayCode_V2) && empty($dayCode_V2))) {
            unset($this->DayCode_V2);
        } else {
            $this->DayCode_V2 = $dayCode_V2;
        }
        return $this;
    }
    /**
     * Add item to DayCode_V2 value
     * @throws \InvalidArgumentException
     * @param \StructType\DayCode_V2 $item
     * @return \ArrayType\ArrayOfDayCode_V2
     */
    public function addToDayCode_V2(\StructType\DayCode_V2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DayCode_V2) {
            throw new \InvalidArgumentException(sprintf('The DayCode_V2 property can only contain items of \StructType\DayCode_V2, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DayCode_V2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DayCode_V2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DayCode_V2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DayCode_V2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DayCode_V2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DayCode_V2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DayCode_V2
     */
    public function getAttributeName()
    {
        return 'DayCode_V2';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDayCode_V2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
