<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDistanceReportItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfDistanceReportItem extends AbstractStructArrayBase
{
    /**
     * The DistanceReportItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DistanceReportItem[]
     */
    public $DistanceReportItem;
    /**
     * Constructor method for ArrayOfDistanceReportItem
     * @uses ArrayOfDistanceReportItem::setDistanceReportItem()
     * @param \StructType\DistanceReportItem[] $distanceReportItem
     */
    public function __construct(array $distanceReportItem = array())
    {
        $this
            ->setDistanceReportItem($distanceReportItem);
    }
    /**
     * Get DistanceReportItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DistanceReportItem[]|null
     */
    public function getDistanceReportItem()
    {
        return isset($this->DistanceReportItem) ? $this->DistanceReportItem : null;
    }
    /**
     * Set DistanceReportItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DistanceReportItem[] $distanceReportItem
     * @return \ArrayType\ArrayOfDistanceReportItem
     */
    public function setDistanceReportItem(array $distanceReportItem = array())
    {
        foreach ($distanceReportItem as $arrayOfDistanceReportItemDistanceReportItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfDistanceReportItemDistanceReportItemItem instanceof \StructType\DistanceReportItem) {
                throw new \InvalidArgumentException(sprintf('The DistanceReportItem property can only contain items of \StructType\DistanceReportItem, "%s" given', is_object($arrayOfDistanceReportItemDistanceReportItemItem) ? get_class($arrayOfDistanceReportItemDistanceReportItemItem) : gettype($arrayOfDistanceReportItemDistanceReportItemItem)), __LINE__);
            }
        }
        if (is_null($distanceReportItem) || (is_array($distanceReportItem) && empty($distanceReportItem))) {
            unset($this->DistanceReportItem);
        } else {
            $this->DistanceReportItem = $distanceReportItem;
        }
        return $this;
    }
    /**
     * Add item to DistanceReportItem value
     * @throws \InvalidArgumentException
     * @param \StructType\DistanceReportItem $item
     * @return \ArrayType\ArrayOfDistanceReportItem
     */
    public function addToDistanceReportItem(\StructType\DistanceReportItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DistanceReportItem) {
            throw new \InvalidArgumentException(sprintf('The DistanceReportItem property can only contain items of \StructType\DistanceReportItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DistanceReportItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DistanceReportItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DistanceReportItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DistanceReportItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DistanceReportItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DistanceReportItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DistanceReportItem
     */
    public function getAttributeName()
    {
        return 'DistanceReportItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDistanceReportItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
