<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDocumentsResult_V4 ArrayType
 * @subpackage Arrays
 */
class ArrayOfDocumentsResult_V4 extends AbstractStructArrayBase
{
    /**
     * The DocumentsResult_V4
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DocumentsResult_V4[]
     */
    public $DocumentsResult_V4;
    /**
     * Constructor method for ArrayOfDocumentsResult_V4
     * @uses ArrayOfDocumentsResult_V4::setDocumentsResult_V4()
     * @param \StructType\DocumentsResult_V4[] $documentsResult_V4
     */
    public function __construct(array $documentsResult_V4 = array())
    {
        $this
            ->setDocumentsResult_V4($documentsResult_V4);
    }
    /**
     * Get DocumentsResult_V4 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DocumentsResult_V4[]|null
     */
    public function getDocumentsResult_V4()
    {
        return isset($this->DocumentsResult_V4) ? $this->DocumentsResult_V4 : null;
    }
    /**
     * Set DocumentsResult_V4 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentsResult_V4[] $documentsResult_V4
     * @return \ArrayType\ArrayOfDocumentsResult_V4
     */
    public function setDocumentsResult_V4(array $documentsResult_V4 = array())
    {
        foreach ($documentsResult_V4 as $arrayOfDocumentsResult_V4DocumentsResult_V4Item) {
            // validation for constraint: itemType
            if (!$arrayOfDocumentsResult_V4DocumentsResult_V4Item instanceof \StructType\DocumentsResult_V4) {
                throw new \InvalidArgumentException(sprintf('The DocumentsResult_V4 property can only contain items of \StructType\DocumentsResult_V4, "%s" given', is_object($arrayOfDocumentsResult_V4DocumentsResult_V4Item) ? get_class($arrayOfDocumentsResult_V4DocumentsResult_V4Item) : gettype($arrayOfDocumentsResult_V4DocumentsResult_V4Item)), __LINE__);
            }
        }
        if (is_null($documentsResult_V4) || (is_array($documentsResult_V4) && empty($documentsResult_V4))) {
            unset($this->DocumentsResult_V4);
        } else {
            $this->DocumentsResult_V4 = $documentsResult_V4;
        }
        return $this;
    }
    /**
     * Add item to DocumentsResult_V4 value
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentsResult_V4 $item
     * @return \ArrayType\ArrayOfDocumentsResult_V4
     */
    public function addToDocumentsResult_V4(\StructType\DocumentsResult_V4 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DocumentsResult_V4) {
            throw new \InvalidArgumentException(sprintf('The DocumentsResult_V4 property can only contain items of \StructType\DocumentsResult_V4, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DocumentsResult_V4[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DocumentsResult_V4|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DocumentsResult_V4|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DocumentsResult_V4|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DocumentsResult_V4|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DocumentsResult_V4|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DocumentsResult_V4
     */
    public function getAttributeName()
    {
        return 'DocumentsResult_V4';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDocumentsResult_V4
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
