<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDriverTachoReadoutIdentifier ArrayType
 * @subpackage Arrays
 */
class ArrayOfDriverTachoReadoutIdentifier extends AbstractStructArrayBase
{
    /**
     * The DriverTachoReadoutIdentifier
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DriverTachoReadoutIdentifier[]
     */
    public $DriverTachoReadoutIdentifier;
    /**
     * Constructor method for ArrayOfDriverTachoReadoutIdentifier
     * @uses ArrayOfDriverTachoReadoutIdentifier::setDriverTachoReadoutIdentifier()
     * @param \StructType\DriverTachoReadoutIdentifier[] $driverTachoReadoutIdentifier
     */
    public function __construct(array $driverTachoReadoutIdentifier = array())
    {
        $this
            ->setDriverTachoReadoutIdentifier($driverTachoReadoutIdentifier);
    }
    /**
     * Get DriverTachoReadoutIdentifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DriverTachoReadoutIdentifier[]|null
     */
    public function getDriverTachoReadoutIdentifier()
    {
        return isset($this->DriverTachoReadoutIdentifier) ? $this->DriverTachoReadoutIdentifier : null;
    }
    /**
     * Set DriverTachoReadoutIdentifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DriverTachoReadoutIdentifier[] $driverTachoReadoutIdentifier
     * @return \ArrayType\ArrayOfDriverTachoReadoutIdentifier
     */
    public function setDriverTachoReadoutIdentifier(array $driverTachoReadoutIdentifier = array())
    {
        foreach ($driverTachoReadoutIdentifier as $arrayOfDriverTachoReadoutIdentifierDriverTachoReadoutIdentifierItem) {
            // validation for constraint: itemType
            if (!$arrayOfDriverTachoReadoutIdentifierDriverTachoReadoutIdentifierItem instanceof \StructType\DriverTachoReadoutIdentifier) {
                throw new \InvalidArgumentException(sprintf('The DriverTachoReadoutIdentifier property can only contain items of \StructType\DriverTachoReadoutIdentifier, "%s" given', is_object($arrayOfDriverTachoReadoutIdentifierDriverTachoReadoutIdentifierItem) ? get_class($arrayOfDriverTachoReadoutIdentifierDriverTachoReadoutIdentifierItem) : gettype($arrayOfDriverTachoReadoutIdentifierDriverTachoReadoutIdentifierItem)), __LINE__);
            }
        }
        if (is_null($driverTachoReadoutIdentifier) || (is_array($driverTachoReadoutIdentifier) && empty($driverTachoReadoutIdentifier))) {
            unset($this->DriverTachoReadoutIdentifier);
        } else {
            $this->DriverTachoReadoutIdentifier = $driverTachoReadoutIdentifier;
        }
        return $this;
    }
    /**
     * Add item to DriverTachoReadoutIdentifier value
     * @throws \InvalidArgumentException
     * @param \StructType\DriverTachoReadoutIdentifier $item
     * @return \ArrayType\ArrayOfDriverTachoReadoutIdentifier
     */
    public function addToDriverTachoReadoutIdentifier(\StructType\DriverTachoReadoutIdentifier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DriverTachoReadoutIdentifier) {
            throw new \InvalidArgumentException(sprintf('The DriverTachoReadoutIdentifier property can only contain items of \StructType\DriverTachoReadoutIdentifier, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DriverTachoReadoutIdentifier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DriverTachoReadoutIdentifier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DriverTachoReadoutIdentifier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DriverTachoReadoutIdentifier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DriverTachoReadoutIdentifier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DriverTachoReadoutIdentifier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DriverTachoReadoutIdentifier
     */
    public function getAttributeName()
    {
        return 'DriverTachoReadoutIdentifier';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDriverTachoReadoutIdentifier
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
