<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEcoAssistantDayItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfEcoAssistantDayItem extends AbstractStructArrayBase
{
    /**
     * The EcoAssistantDayItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EcoAssistantDayItem[]
     */
    public $EcoAssistantDayItem;
    /**
     * Constructor method for ArrayOfEcoAssistantDayItem
     * @uses ArrayOfEcoAssistantDayItem::setEcoAssistantDayItem()
     * @param \StructType\EcoAssistantDayItem[] $ecoAssistantDayItem
     */
    public function __construct(array $ecoAssistantDayItem = array())
    {
        $this
            ->setEcoAssistantDayItem($ecoAssistantDayItem);
    }
    /**
     * Get EcoAssistantDayItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EcoAssistantDayItem[]|null
     */
    public function getEcoAssistantDayItem()
    {
        return isset($this->EcoAssistantDayItem) ? $this->EcoAssistantDayItem : null;
    }
    /**
     * Set EcoAssistantDayItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EcoAssistantDayItem[] $ecoAssistantDayItem
     * @return \ArrayType\ArrayOfEcoAssistantDayItem
     */
    public function setEcoAssistantDayItem(array $ecoAssistantDayItem = array())
    {
        foreach ($ecoAssistantDayItem as $arrayOfEcoAssistantDayItemEcoAssistantDayItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfEcoAssistantDayItemEcoAssistantDayItemItem instanceof \StructType\EcoAssistantDayItem) {
                throw new \InvalidArgumentException(sprintf('The EcoAssistantDayItem property can only contain items of \StructType\EcoAssistantDayItem, "%s" given', is_object($arrayOfEcoAssistantDayItemEcoAssistantDayItemItem) ? get_class($arrayOfEcoAssistantDayItemEcoAssistantDayItemItem) : gettype($arrayOfEcoAssistantDayItemEcoAssistantDayItemItem)), __LINE__);
            }
        }
        if (is_null($ecoAssistantDayItem) || (is_array($ecoAssistantDayItem) && empty($ecoAssistantDayItem))) {
            unset($this->EcoAssistantDayItem);
        } else {
            $this->EcoAssistantDayItem = $ecoAssistantDayItem;
        }
        return $this;
    }
    /**
     * Add item to EcoAssistantDayItem value
     * @throws \InvalidArgumentException
     * @param \StructType\EcoAssistantDayItem $item
     * @return \ArrayType\ArrayOfEcoAssistantDayItem
     */
    public function addToEcoAssistantDayItem(\StructType\EcoAssistantDayItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EcoAssistantDayItem) {
            throw new \InvalidArgumentException(sprintf('The EcoAssistantDayItem property can only contain items of \StructType\EcoAssistantDayItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EcoAssistantDayItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EcoAssistantDayItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EcoAssistantDayItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EcoAssistantDayItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EcoAssistantDayItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EcoAssistantDayItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EcoAssistantDayItem
     */
    public function getAttributeName()
    {
        return 'EcoAssistantDayItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfEcoAssistantDayItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
