<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEcoMonitorReportItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfEcoMonitorReportItem extends AbstractStructArrayBase
{
    /**
     * The EcoMonitorReportItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EcoMonitorReportItem[]
     */
    public $EcoMonitorReportItem;
    /**
     * Constructor method for ArrayOfEcoMonitorReportItem
     * @uses ArrayOfEcoMonitorReportItem::setEcoMonitorReportItem()
     * @param \StructType\EcoMonitorReportItem[] $ecoMonitorReportItem
     */
    public function __construct(array $ecoMonitorReportItem = array())
    {
        $this
            ->setEcoMonitorReportItem($ecoMonitorReportItem);
    }
    /**
     * Get EcoMonitorReportItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EcoMonitorReportItem[]|null
     */
    public function getEcoMonitorReportItem()
    {
        return isset($this->EcoMonitorReportItem) ? $this->EcoMonitorReportItem : null;
    }
    /**
     * Set EcoMonitorReportItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EcoMonitorReportItem[] $ecoMonitorReportItem
     * @return \ArrayType\ArrayOfEcoMonitorReportItem
     */
    public function setEcoMonitorReportItem(array $ecoMonitorReportItem = array())
    {
        foreach ($ecoMonitorReportItem as $arrayOfEcoMonitorReportItemEcoMonitorReportItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfEcoMonitorReportItemEcoMonitorReportItemItem instanceof \StructType\EcoMonitorReportItem) {
                throw new \InvalidArgumentException(sprintf('The EcoMonitorReportItem property can only contain items of \StructType\EcoMonitorReportItem, "%s" given', is_object($arrayOfEcoMonitorReportItemEcoMonitorReportItemItem) ? get_class($arrayOfEcoMonitorReportItemEcoMonitorReportItemItem) : gettype($arrayOfEcoMonitorReportItemEcoMonitorReportItemItem)), __LINE__);
            }
        }
        if (is_null($ecoMonitorReportItem) || (is_array($ecoMonitorReportItem) && empty($ecoMonitorReportItem))) {
            unset($this->EcoMonitorReportItem);
        } else {
            $this->EcoMonitorReportItem = $ecoMonitorReportItem;
        }
        return $this;
    }
    /**
     * Add item to EcoMonitorReportItem value
     * @throws \InvalidArgumentException
     * @param \StructType\EcoMonitorReportItem $item
     * @return \ArrayType\ArrayOfEcoMonitorReportItem
     */
    public function addToEcoMonitorReportItem(\StructType\EcoMonitorReportItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EcoMonitorReportItem) {
            throw new \InvalidArgumentException(sprintf('The EcoMonitorReportItem property can only contain items of \StructType\EcoMonitorReportItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EcoMonitorReportItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EcoMonitorReportItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EcoMonitorReportItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EcoMonitorReportItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EcoMonitorReportItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EcoMonitorReportItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EcoMonitorReportItem
     */
    public function getAttributeName()
    {
        return 'EcoMonitorReportItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfEcoMonitorReportItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
