<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEcoMonitorReportItem_V2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfEcoMonitorReportItem_V2 extends AbstractStructArrayBase
{
    /**
     * The EcoMonitorReportItem_V2
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EcoMonitorReportItem_V2[]
     */
    public $EcoMonitorReportItem_V2;
    /**
     * Constructor method for ArrayOfEcoMonitorReportItem_V2
     * @uses ArrayOfEcoMonitorReportItem_V2::setEcoMonitorReportItem_V2()
     * @param \StructType\EcoMonitorReportItem_V2[] $ecoMonitorReportItem_V2
     */
    public function __construct(array $ecoMonitorReportItem_V2 = array())
    {
        $this
            ->setEcoMonitorReportItem_V2($ecoMonitorReportItem_V2);
    }
    /**
     * Get EcoMonitorReportItem_V2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EcoMonitorReportItem_V2[]|null
     */
    public function getEcoMonitorReportItem_V2()
    {
        return isset($this->EcoMonitorReportItem_V2) ? $this->EcoMonitorReportItem_V2 : null;
    }
    /**
     * Set EcoMonitorReportItem_V2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EcoMonitorReportItem_V2[] $ecoMonitorReportItem_V2
     * @return \ArrayType\ArrayOfEcoMonitorReportItem_V2
     */
    public function setEcoMonitorReportItem_V2(array $ecoMonitorReportItem_V2 = array())
    {
        foreach ($ecoMonitorReportItem_V2 as $arrayOfEcoMonitorReportItem_V2EcoMonitorReportItem_V2Item) {
            // validation for constraint: itemType
            if (!$arrayOfEcoMonitorReportItem_V2EcoMonitorReportItem_V2Item instanceof \StructType\EcoMonitorReportItem_V2) {
                throw new \InvalidArgumentException(sprintf('The EcoMonitorReportItem_V2 property can only contain items of \StructType\EcoMonitorReportItem_V2, "%s" given', is_object($arrayOfEcoMonitorReportItem_V2EcoMonitorReportItem_V2Item) ? get_class($arrayOfEcoMonitorReportItem_V2EcoMonitorReportItem_V2Item) : gettype($arrayOfEcoMonitorReportItem_V2EcoMonitorReportItem_V2Item)), __LINE__);
            }
        }
        if (is_null($ecoMonitorReportItem_V2) || (is_array($ecoMonitorReportItem_V2) && empty($ecoMonitorReportItem_V2))) {
            unset($this->EcoMonitorReportItem_V2);
        } else {
            $this->EcoMonitorReportItem_V2 = $ecoMonitorReportItem_V2;
        }
        return $this;
    }
    /**
     * Add item to EcoMonitorReportItem_V2 value
     * @throws \InvalidArgumentException
     * @param \StructType\EcoMonitorReportItem_V2 $item
     * @return \ArrayType\ArrayOfEcoMonitorReportItem_V2
     */
    public function addToEcoMonitorReportItem_V2(\StructType\EcoMonitorReportItem_V2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EcoMonitorReportItem_V2) {
            throw new \InvalidArgumentException(sprintf('The EcoMonitorReportItem_V2 property can only contain items of \StructType\EcoMonitorReportItem_V2, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EcoMonitorReportItem_V2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EcoMonitorReportItem_V2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EcoMonitorReportItem_V2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EcoMonitorReportItem_V2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EcoMonitorReportItem_V2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EcoMonitorReportItem_V2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EcoMonitorReportItem_V2
     */
    public function getAttributeName()
    {
        return 'EcoMonitorReportItem_V2';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfEcoMonitorReportItem_V2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
