<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEcoPerformanceReport ArrayType
 * @subpackage Arrays
 */
class ArrayOfEcoPerformanceReport extends AbstractStructArrayBase
{
    /**
     * The EcoPerformanceReport
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EcoPerformanceReport[]
     */
    public $EcoPerformanceReport;
    /**
     * Constructor method for ArrayOfEcoPerformanceReport
     * @uses ArrayOfEcoPerformanceReport::setEcoPerformanceReport()
     * @param \StructType\EcoPerformanceReport[] $ecoPerformanceReport
     */
    public function __construct(array $ecoPerformanceReport = array())
    {
        $this
            ->setEcoPerformanceReport($ecoPerformanceReport);
    }
    /**
     * Get EcoPerformanceReport value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EcoPerformanceReport[]|null
     */
    public function getEcoPerformanceReport()
    {
        return isset($this->EcoPerformanceReport) ? $this->EcoPerformanceReport : null;
    }
    /**
     * Set EcoPerformanceReport value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EcoPerformanceReport[] $ecoPerformanceReport
     * @return \ArrayType\ArrayOfEcoPerformanceReport
     */
    public function setEcoPerformanceReport(array $ecoPerformanceReport = array())
    {
        foreach ($ecoPerformanceReport as $arrayOfEcoPerformanceReportEcoPerformanceReportItem) {
            // validation for constraint: itemType
            if (!$arrayOfEcoPerformanceReportEcoPerformanceReportItem instanceof \StructType\EcoPerformanceReport) {
                throw new \InvalidArgumentException(sprintf('The EcoPerformanceReport property can only contain items of \StructType\EcoPerformanceReport, "%s" given', is_object($arrayOfEcoPerformanceReportEcoPerformanceReportItem) ? get_class($arrayOfEcoPerformanceReportEcoPerformanceReportItem) : gettype($arrayOfEcoPerformanceReportEcoPerformanceReportItem)), __LINE__);
            }
        }
        if (is_null($ecoPerformanceReport) || (is_array($ecoPerformanceReport) && empty($ecoPerformanceReport))) {
            unset($this->EcoPerformanceReport);
        } else {
            $this->EcoPerformanceReport = $ecoPerformanceReport;
        }
        return $this;
    }
    /**
     * Add item to EcoPerformanceReport value
     * @throws \InvalidArgumentException
     * @param \StructType\EcoPerformanceReport $item
     * @return \ArrayType\ArrayOfEcoPerformanceReport
     */
    public function addToEcoPerformanceReport(\StructType\EcoPerformanceReport $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EcoPerformanceReport) {
            throw new \InvalidArgumentException(sprintf('The EcoPerformanceReport property can only contain items of \StructType\EcoPerformanceReport, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EcoPerformanceReport[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EcoPerformanceReport|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EcoPerformanceReport|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EcoPerformanceReport|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EcoPerformanceReport|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EcoPerformanceReport|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EcoPerformanceReport
     */
    public function getAttributeName()
    {
        return 'EcoPerformanceReport';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfEcoPerformanceReport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
