<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEnumAlarmMessageType ArrayType
 * @subpackage Arrays
 */
class ArrayOfEnumAlarmMessageType extends AbstractStructArrayBase
{
    /**
     * The enumAlarmMessageType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $enumAlarmMessageType;
    /**
     * Constructor method for ArrayOfEnumAlarmMessageType
     * @uses ArrayOfEnumAlarmMessageType::setEnumAlarmMessageType()
     * @param string[] $enumAlarmMessageType
     */
    public function __construct(array $enumAlarmMessageType = array())
    {
        $this
            ->setEnumAlarmMessageType($enumAlarmMessageType);
    }
    /**
     * Get enumAlarmMessageType value
     * @return string[]|null
     */
    public function getEnumAlarmMessageType()
    {
        return $this->enumAlarmMessageType;
    }
    /**
     * Set enumAlarmMessageType value
     * @uses \EnumType\EnumAlarmMessageType::valueIsValid()
     * @uses \EnumType\EnumAlarmMessageType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $enumAlarmMessageType
     * @return \ArrayType\ArrayOfEnumAlarmMessageType
     */
    public function setEnumAlarmMessageType(array $enumAlarmMessageType = array())
    {
        $invalidValues = array();
        foreach ($enumAlarmMessageType as $arrayOfEnumAlarmMessageTypeEnumAlarmMessageTypeItem) {
            if (!\EnumType\EnumAlarmMessageType::valueIsValid($arrayOfEnumAlarmMessageTypeEnumAlarmMessageTypeItem)) {
                $invalidValues[] = var_export($arrayOfEnumAlarmMessageTypeEnumAlarmMessageTypeItem, true);
            }
        }
        if (!empty($invalidValues)) {
            throw new \InvalidArgumentException(sprintf('Value(s) "%s" is/are invalid, please use one of: %s', implode(', ', $invalidValues), implode(', ', \EnumType\EnumAlarmMessageType::getValidValues())), __LINE__);
        }
        $this->enumAlarmMessageType = $enumAlarmMessageType;
        return $this;
    }
    /**
     * Add item to enumAlarmMessageType value
     * @uses \EnumType\EnumAlarmMessageType::valueIsValid()
     * @uses \EnumType\EnumAlarmMessageType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfEnumAlarmMessageType
     */
    public function addToEnumAlarmMessageType($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\EnumAlarmMessageType::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $item, implode(', ', \EnumType\EnumAlarmMessageType::getValidValues())), __LINE__);
        }
        $this->enumAlarmMessageType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\EnumAlarmMessageType::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfEnumAlarmMessageType
     */
    public function add($item)
    {
        if (!\EnumType\EnumAlarmMessageType::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $item, implode(', ', \EnumType\EnumAlarmMessageType::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string enumAlarmMessageType
     */
    public function getAttributeName()
    {
        return 'enumAlarmMessageType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfEnumAlarmMessageType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
