<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFuelReportItem_V2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfFuelReportItem_V2 extends AbstractStructArrayBase
{
    /**
     * The FuelReportItem_V2
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FuelReportItem_V2[]
     */
    public $FuelReportItem_V2;
    /**
     * Constructor method for ArrayOfFuelReportItem_V2
     * @uses ArrayOfFuelReportItem_V2::setFuelReportItem_V2()
     * @param \StructType\FuelReportItem_V2[] $fuelReportItem_V2
     */
    public function __construct(array $fuelReportItem_V2 = array())
    {
        $this
            ->setFuelReportItem_V2($fuelReportItem_V2);
    }
    /**
     * Get FuelReportItem_V2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FuelReportItem_V2[]|null
     */
    public function getFuelReportItem_V2()
    {
        return isset($this->FuelReportItem_V2) ? $this->FuelReportItem_V2 : null;
    }
    /**
     * Set FuelReportItem_V2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FuelReportItem_V2[] $fuelReportItem_V2
     * @return \ArrayType\ArrayOfFuelReportItem_V2
     */
    public function setFuelReportItem_V2(array $fuelReportItem_V2 = array())
    {
        foreach ($fuelReportItem_V2 as $arrayOfFuelReportItem_V2FuelReportItem_V2Item) {
            // validation for constraint: itemType
            if (!$arrayOfFuelReportItem_V2FuelReportItem_V2Item instanceof \StructType\FuelReportItem_V2) {
                throw new \InvalidArgumentException(sprintf('The FuelReportItem_V2 property can only contain items of \StructType\FuelReportItem_V2, "%s" given', is_object($arrayOfFuelReportItem_V2FuelReportItem_V2Item) ? get_class($arrayOfFuelReportItem_V2FuelReportItem_V2Item) : gettype($arrayOfFuelReportItem_V2FuelReportItem_V2Item)), __LINE__);
            }
        }
        if (is_null($fuelReportItem_V2) || (is_array($fuelReportItem_V2) && empty($fuelReportItem_V2))) {
            unset($this->FuelReportItem_V2);
        } else {
            $this->FuelReportItem_V2 = $fuelReportItem_V2;
        }
        return $this;
    }
    /**
     * Add item to FuelReportItem_V2 value
     * @throws \InvalidArgumentException
     * @param \StructType\FuelReportItem_V2 $item
     * @return \ArrayType\ArrayOfFuelReportItem_V2
     */
    public function addToFuelReportItem_V2(\StructType\FuelReportItem_V2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FuelReportItem_V2) {
            throw new \InvalidArgumentException(sprintf('The FuelReportItem_V2 property can only contain items of \StructType\FuelReportItem_V2, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FuelReportItem_V2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FuelReportItem_V2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FuelReportItem_V2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FuelReportItem_V2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FuelReportItem_V2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FuelReportItem_V2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FuelReportItem_V2
     */
    public function getAttributeName()
    {
        return 'FuelReportItem_V2';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfFuelReportItem_V2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
