<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGeoZone ArrayType
 * @subpackage Arrays
 */
class ArrayOfGeoZone extends AbstractStructArrayBase
{
    /**
     * The GeoZone
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GeoZone[]
     */
    public $GeoZone;
    /**
     * Constructor method for ArrayOfGeoZone
     * @uses ArrayOfGeoZone::setGeoZone()
     * @param \StructType\GeoZone[] $geoZone
     */
    public function __construct(array $geoZone = array())
    {
        $this
            ->setGeoZone($geoZone);
    }
    /**
     * Get GeoZone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GeoZone[]|null
     */
    public function getGeoZone()
    {
        return isset($this->GeoZone) ? $this->GeoZone : null;
    }
    /**
     * Set GeoZone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GeoZone[] $geoZone
     * @return \ArrayType\ArrayOfGeoZone
     */
    public function setGeoZone(array $geoZone = array())
    {
        foreach ($geoZone as $arrayOfGeoZoneGeoZoneItem) {
            // validation for constraint: itemType
            if (!$arrayOfGeoZoneGeoZoneItem instanceof \StructType\GeoZone) {
                throw new \InvalidArgumentException(sprintf('The GeoZone property can only contain items of \StructType\GeoZone, "%s" given', is_object($arrayOfGeoZoneGeoZoneItem) ? get_class($arrayOfGeoZoneGeoZoneItem) : gettype($arrayOfGeoZoneGeoZoneItem)), __LINE__);
            }
        }
        if (is_null($geoZone) || (is_array($geoZone) && empty($geoZone))) {
            unset($this->GeoZone);
        } else {
            $this->GeoZone = $geoZone;
        }
        return $this;
    }
    /**
     * Add item to GeoZone value
     * @throws \InvalidArgumentException
     * @param \StructType\GeoZone $item
     * @return \ArrayType\ArrayOfGeoZone
     */
    public function addToGeoZone(\StructType\GeoZone $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GeoZone) {
            throw new \InvalidArgumentException(sprintf('The GeoZone property can only contain items of \StructType\GeoZone, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GeoZone[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GeoZone|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GeoZone|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GeoZone|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GeoZone|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GeoZone|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GeoZone
     */
    public function getAttributeName()
    {
        return 'GeoZone';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfGeoZone
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
