<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGetEcoScoreReportItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfGetEcoScoreReportItem extends AbstractStructArrayBase
{
    /**
     * The GetEcoScoreReportItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GetEcoScoreReportItem[]
     */
    public $GetEcoScoreReportItem;
    /**
     * Constructor method for ArrayOfGetEcoScoreReportItem
     * @uses ArrayOfGetEcoScoreReportItem::setGetEcoScoreReportItem()
     * @param \StructType\GetEcoScoreReportItem[] $getEcoScoreReportItem
     */
    public function __construct(array $getEcoScoreReportItem = array())
    {
        $this
            ->setGetEcoScoreReportItem($getEcoScoreReportItem);
    }
    /**
     * Get GetEcoScoreReportItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GetEcoScoreReportItem[]|null
     */
    public function getGetEcoScoreReportItem()
    {
        return isset($this->GetEcoScoreReportItem) ? $this->GetEcoScoreReportItem : null;
    }
    /**
     * Set GetEcoScoreReportItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GetEcoScoreReportItem[] $getEcoScoreReportItem
     * @return \ArrayType\ArrayOfGetEcoScoreReportItem
     */
    public function setGetEcoScoreReportItem(array $getEcoScoreReportItem = array())
    {
        foreach ($getEcoScoreReportItem as $arrayOfGetEcoScoreReportItemGetEcoScoreReportItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfGetEcoScoreReportItemGetEcoScoreReportItemItem instanceof \StructType\GetEcoScoreReportItem) {
                throw new \InvalidArgumentException(sprintf('The GetEcoScoreReportItem property can only contain items of \StructType\GetEcoScoreReportItem, "%s" given', is_object($arrayOfGetEcoScoreReportItemGetEcoScoreReportItemItem) ? get_class($arrayOfGetEcoScoreReportItemGetEcoScoreReportItemItem) : gettype($arrayOfGetEcoScoreReportItemGetEcoScoreReportItemItem)), __LINE__);
            }
        }
        if (is_null($getEcoScoreReportItem) || (is_array($getEcoScoreReportItem) && empty($getEcoScoreReportItem))) {
            unset($this->GetEcoScoreReportItem);
        } else {
            $this->GetEcoScoreReportItem = $getEcoScoreReportItem;
        }
        return $this;
    }
    /**
     * Add item to GetEcoScoreReportItem value
     * @throws \InvalidArgumentException
     * @param \StructType\GetEcoScoreReportItem $item
     * @return \ArrayType\ArrayOfGetEcoScoreReportItem
     */
    public function addToGetEcoScoreReportItem(\StructType\GetEcoScoreReportItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GetEcoScoreReportItem) {
            throw new \InvalidArgumentException(sprintf('The GetEcoScoreReportItem property can only contain items of \StructType\GetEcoScoreReportItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GetEcoScoreReportItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GetEcoScoreReportItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GetEcoScoreReportItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GetEcoScoreReportItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GetEcoScoreReportItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GetEcoScoreReportItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GetEcoScoreReportItem
     */
    public function getAttributeName()
    {
        return 'GetEcoScoreReportItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfGetEcoScoreReportItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
