<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIdentifierGeoFence ArrayType
 * @subpackage Arrays
 */
class ArrayOfIdentifierGeoFence extends AbstractStructArrayBase
{
    /**
     * The IdentifierGeoFence
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdentifierGeoFence[]
     */
    public $IdentifierGeoFence;
    /**
     * Constructor method for ArrayOfIdentifierGeoFence
     * @uses ArrayOfIdentifierGeoFence::setIdentifierGeoFence()
     * @param \StructType\IdentifierGeoFence[] $identifierGeoFence
     */
    public function __construct(array $identifierGeoFence = array())
    {
        $this
            ->setIdentifierGeoFence($identifierGeoFence);
    }
    /**
     * Get IdentifierGeoFence value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdentifierGeoFence[]|null
     */
    public function getIdentifierGeoFence()
    {
        return isset($this->IdentifierGeoFence) ? $this->IdentifierGeoFence : null;
    }
    /**
     * Set IdentifierGeoFence value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierGeoFence[] $identifierGeoFence
     * @return \ArrayType\ArrayOfIdentifierGeoFence
     */
    public function setIdentifierGeoFence(array $identifierGeoFence = array())
    {
        foreach ($identifierGeoFence as $arrayOfIdentifierGeoFenceIdentifierGeoFenceItem) {
            // validation for constraint: itemType
            if (!$arrayOfIdentifierGeoFenceIdentifierGeoFenceItem instanceof \StructType\IdentifierGeoFence) {
                throw new \InvalidArgumentException(sprintf('The IdentifierGeoFence property can only contain items of \StructType\IdentifierGeoFence, "%s" given', is_object($arrayOfIdentifierGeoFenceIdentifierGeoFenceItem) ? get_class($arrayOfIdentifierGeoFenceIdentifierGeoFenceItem) : gettype($arrayOfIdentifierGeoFenceIdentifierGeoFenceItem)), __LINE__);
            }
        }
        if (is_null($identifierGeoFence) || (is_array($identifierGeoFence) && empty($identifierGeoFence))) {
            unset($this->IdentifierGeoFence);
        } else {
            $this->IdentifierGeoFence = $identifierGeoFence;
        }
        return $this;
    }
    /**
     * Add item to IdentifierGeoFence value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierGeoFence $item
     * @return \ArrayType\ArrayOfIdentifierGeoFence
     */
    public function addToIdentifierGeoFence(\StructType\IdentifierGeoFence $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentifierGeoFence) {
            throw new \InvalidArgumentException(sprintf('The IdentifierGeoFence property can only contain items of \StructType\IdentifierGeoFence, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->IdentifierGeoFence[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IdentifierGeoFence|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IdentifierGeoFence|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IdentifierGeoFence|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IdentifierGeoFence|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IdentifierGeoFence|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IdentifierGeoFence
     */
    public function getAttributeName()
    {
        return 'IdentifierGeoFence';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfIdentifierGeoFence
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
