<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIdentifierPoiResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfIdentifierPoiResult extends AbstractStructArrayBase
{
    /**
     * The IdentifierPoiResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdentifierPoiResult[]
     */
    public $IdentifierPoiResult;
    /**
     * Constructor method for ArrayOfIdentifierPoiResult
     * @uses ArrayOfIdentifierPoiResult::setIdentifierPoiResult()
     * @param \StructType\IdentifierPoiResult[] $identifierPoiResult
     */
    public function __construct(array $identifierPoiResult = array())
    {
        $this
            ->setIdentifierPoiResult($identifierPoiResult);
    }
    /**
     * Get IdentifierPoiResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdentifierPoiResult[]|null
     */
    public function getIdentifierPoiResult()
    {
        return isset($this->IdentifierPoiResult) ? $this->IdentifierPoiResult : null;
    }
    /**
     * Set IdentifierPoiResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierPoiResult[] $identifierPoiResult
     * @return \ArrayType\ArrayOfIdentifierPoiResult
     */
    public function setIdentifierPoiResult(array $identifierPoiResult = array())
    {
        foreach ($identifierPoiResult as $arrayOfIdentifierPoiResultIdentifierPoiResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfIdentifierPoiResultIdentifierPoiResultItem instanceof \StructType\IdentifierPoiResult) {
                throw new \InvalidArgumentException(sprintf('The IdentifierPoiResult property can only contain items of \StructType\IdentifierPoiResult, "%s" given', is_object($arrayOfIdentifierPoiResultIdentifierPoiResultItem) ? get_class($arrayOfIdentifierPoiResultIdentifierPoiResultItem) : gettype($arrayOfIdentifierPoiResultIdentifierPoiResultItem)), __LINE__);
            }
        }
        if (is_null($identifierPoiResult) || (is_array($identifierPoiResult) && empty($identifierPoiResult))) {
            unset($this->IdentifierPoiResult);
        } else {
            $this->IdentifierPoiResult = $identifierPoiResult;
        }
        return $this;
    }
    /**
     * Add item to IdentifierPoiResult value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierPoiResult $item
     * @return \ArrayType\ArrayOfIdentifierPoiResult
     */
    public function addToIdentifierPoiResult(\StructType\IdentifierPoiResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentifierPoiResult) {
            throw new \InvalidArgumentException(sprintf('The IdentifierPoiResult property can only contain items of \StructType\IdentifierPoiResult, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->IdentifierPoiResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IdentifierPoiResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IdentifierPoiResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IdentifierPoiResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IdentifierPoiResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IdentifierPoiResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IdentifierPoiResult
     */
    public function getAttributeName()
    {
        return 'IdentifierPoiResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfIdentifierPoiResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
