<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIdentifierVehicleItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfIdentifierVehicleItem extends AbstractStructArrayBase
{
    /**
     * The IdentifierVehicleItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdentifierVehicleItem[]
     */
    public $IdentifierVehicleItem;
    /**
     * Constructor method for ArrayOfIdentifierVehicleItem
     * @uses ArrayOfIdentifierVehicleItem::setIdentifierVehicleItem()
     * @param \StructType\IdentifierVehicleItem[] $identifierVehicleItem
     */
    public function __construct(array $identifierVehicleItem = array())
    {
        $this
            ->setIdentifierVehicleItem($identifierVehicleItem);
    }
    /**
     * Get IdentifierVehicleItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdentifierVehicleItem[]|null
     */
    public function getIdentifierVehicleItem()
    {
        return isset($this->IdentifierVehicleItem) ? $this->IdentifierVehicleItem : null;
    }
    /**
     * Set IdentifierVehicleItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicleItem[] $identifierVehicleItem
     * @return \ArrayType\ArrayOfIdentifierVehicleItem
     */
    public function setIdentifierVehicleItem(array $identifierVehicleItem = array())
    {
        foreach ($identifierVehicleItem as $arrayOfIdentifierVehicleItemIdentifierVehicleItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfIdentifierVehicleItemIdentifierVehicleItemItem instanceof \StructType\IdentifierVehicleItem) {
                throw new \InvalidArgumentException(sprintf('The IdentifierVehicleItem property can only contain items of \StructType\IdentifierVehicleItem, "%s" given', is_object($arrayOfIdentifierVehicleItemIdentifierVehicleItemItem) ? get_class($arrayOfIdentifierVehicleItemIdentifierVehicleItemItem) : gettype($arrayOfIdentifierVehicleItemIdentifierVehicleItemItem)), __LINE__);
            }
        }
        if (is_null($identifierVehicleItem) || (is_array($identifierVehicleItem) && empty($identifierVehicleItem))) {
            unset($this->IdentifierVehicleItem);
        } else {
            $this->IdentifierVehicleItem = $identifierVehicleItem;
        }
        return $this;
    }
    /**
     * Add item to IdentifierVehicleItem value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicleItem $item
     * @return \ArrayType\ArrayOfIdentifierVehicleItem
     */
    public function addToIdentifierVehicleItem(\StructType\IdentifierVehicleItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentifierVehicleItem) {
            throw new \InvalidArgumentException(sprintf('The IdentifierVehicleItem property can only contain items of \StructType\IdentifierVehicleItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->IdentifierVehicleItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IdentifierVehicleItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IdentifierVehicleItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IdentifierVehicleItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IdentifierVehicleItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IdentifierVehicleItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IdentifierVehicleItem
     */
    public function getAttributeName()
    {
        return 'IdentifierVehicleItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfIdentifierVehicleItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
