<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIdentifierVehicleResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfIdentifierVehicleResult extends AbstractStructArrayBase
{
    /**
     * The IdentifierVehicleResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdentifierVehicleResult[]
     */
    public $IdentifierVehicleResult;
    /**
     * Constructor method for ArrayOfIdentifierVehicleResult
     * @uses ArrayOfIdentifierVehicleResult::setIdentifierVehicleResult()
     * @param \StructType\IdentifierVehicleResult[] $identifierVehicleResult
     */
    public function __construct(array $identifierVehicleResult = array())
    {
        $this
            ->setIdentifierVehicleResult($identifierVehicleResult);
    }
    /**
     * Get IdentifierVehicleResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdentifierVehicleResult[]|null
     */
    public function getIdentifierVehicleResult()
    {
        return isset($this->IdentifierVehicleResult) ? $this->IdentifierVehicleResult : null;
    }
    /**
     * Set IdentifierVehicleResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicleResult[] $identifierVehicleResult
     * @return \ArrayType\ArrayOfIdentifierVehicleResult
     */
    public function setIdentifierVehicleResult(array $identifierVehicleResult = array())
    {
        foreach ($identifierVehicleResult as $arrayOfIdentifierVehicleResultIdentifierVehicleResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfIdentifierVehicleResultIdentifierVehicleResultItem instanceof \StructType\IdentifierVehicleResult) {
                throw new \InvalidArgumentException(sprintf('The IdentifierVehicleResult property can only contain items of \StructType\IdentifierVehicleResult, "%s" given', is_object($arrayOfIdentifierVehicleResultIdentifierVehicleResultItem) ? get_class($arrayOfIdentifierVehicleResultIdentifierVehicleResultItem) : gettype($arrayOfIdentifierVehicleResultIdentifierVehicleResultItem)), __LINE__);
            }
        }
        if (is_null($identifierVehicleResult) || (is_array($identifierVehicleResult) && empty($identifierVehicleResult))) {
            unset($this->IdentifierVehicleResult);
        } else {
            $this->IdentifierVehicleResult = $identifierVehicleResult;
        }
        return $this;
    }
    /**
     * Add item to IdentifierVehicleResult value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicleResult $item
     * @return \ArrayType\ArrayOfIdentifierVehicleResult
     */
    public function addToIdentifierVehicleResult(\StructType\IdentifierVehicleResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentifierVehicleResult) {
            throw new \InvalidArgumentException(sprintf('The IdentifierVehicleResult property can only contain items of \StructType\IdentifierVehicleResult, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->IdentifierVehicleResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IdentifierVehicleResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IdentifierVehicleResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IdentifierVehicleResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IdentifierVehicleResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IdentifierVehicleResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IdentifierVehicleResult
     */
    public function getAttributeName()
    {
        return 'IdentifierVehicleResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfIdentifierVehicleResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
