<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIdentifierVehicleStrategy ArrayType
 * @subpackage Arrays
 */
class ArrayOfIdentifierVehicleStrategy extends AbstractStructArrayBase
{
    /**
     * The IdentifierVehicleStrategy
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdentifierVehicleStrategy[]
     */
    public $IdentifierVehicleStrategy;
    /**
     * Constructor method for ArrayOfIdentifierVehicleStrategy
     * @uses ArrayOfIdentifierVehicleStrategy::setIdentifierVehicleStrategy()
     * @param \StructType\IdentifierVehicleStrategy[] $identifierVehicleStrategy
     */
    public function __construct(array $identifierVehicleStrategy = array())
    {
        $this
            ->setIdentifierVehicleStrategy($identifierVehicleStrategy);
    }
    /**
     * Get IdentifierVehicleStrategy value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdentifierVehicleStrategy[]|null
     */
    public function getIdentifierVehicleStrategy()
    {
        return isset($this->IdentifierVehicleStrategy) ? $this->IdentifierVehicleStrategy : null;
    }
    /**
     * Set IdentifierVehicleStrategy value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicleStrategy[] $identifierVehicleStrategy
     * @return \ArrayType\ArrayOfIdentifierVehicleStrategy
     */
    public function setIdentifierVehicleStrategy(array $identifierVehicleStrategy = array())
    {
        foreach ($identifierVehicleStrategy as $arrayOfIdentifierVehicleStrategyIdentifierVehicleStrategyItem) {
            // validation for constraint: itemType
            if (!$arrayOfIdentifierVehicleStrategyIdentifierVehicleStrategyItem instanceof \StructType\IdentifierVehicleStrategy) {
                throw new \InvalidArgumentException(sprintf('The IdentifierVehicleStrategy property can only contain items of \StructType\IdentifierVehicleStrategy, "%s" given', is_object($arrayOfIdentifierVehicleStrategyIdentifierVehicleStrategyItem) ? get_class($arrayOfIdentifierVehicleStrategyIdentifierVehicleStrategyItem) : gettype($arrayOfIdentifierVehicleStrategyIdentifierVehicleStrategyItem)), __LINE__);
            }
        }
        if (is_null($identifierVehicleStrategy) || (is_array($identifierVehicleStrategy) && empty($identifierVehicleStrategy))) {
            unset($this->IdentifierVehicleStrategy);
        } else {
            $this->IdentifierVehicleStrategy = $identifierVehicleStrategy;
        }
        return $this;
    }
    /**
     * Add item to IdentifierVehicleStrategy value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicleStrategy $item
     * @return \ArrayType\ArrayOfIdentifierVehicleStrategy
     */
    public function addToIdentifierVehicleStrategy(\StructType\IdentifierVehicleStrategy $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentifierVehicleStrategy) {
            throw new \InvalidArgumentException(sprintf('The IdentifierVehicleStrategy property can only contain items of \StructType\IdentifierVehicleStrategy, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->IdentifierVehicleStrategy[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IdentifierVehicleStrategy|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IdentifierVehicleStrategy|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IdentifierVehicleStrategy|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IdentifierVehicleStrategy|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IdentifierVehicleStrategy|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IdentifierVehicleStrategy
     */
    public function getAttributeName()
    {
        return 'IdentifierVehicleStrategy';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfIdentifierVehicleStrategy
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
