<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIdentifierViaRoute ArrayType
 * @subpackage Arrays
 */
class ArrayOfIdentifierViaRoute extends AbstractStructArrayBase
{
    /**
     * The IdentifierViaRoute
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdentifierViaRoute[]
     */
    public $IdentifierViaRoute;
    /**
     * Constructor method for ArrayOfIdentifierViaRoute
     * @uses ArrayOfIdentifierViaRoute::setIdentifierViaRoute()
     * @param \StructType\IdentifierViaRoute[] $identifierViaRoute
     */
    public function __construct(array $identifierViaRoute = array())
    {
        $this
            ->setIdentifierViaRoute($identifierViaRoute);
    }
    /**
     * Get IdentifierViaRoute value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdentifierViaRoute[]|null
     */
    public function getIdentifierViaRoute()
    {
        return isset($this->IdentifierViaRoute) ? $this->IdentifierViaRoute : null;
    }
    /**
     * Set IdentifierViaRoute value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierViaRoute[] $identifierViaRoute
     * @return \ArrayType\ArrayOfIdentifierViaRoute
     */
    public function setIdentifierViaRoute(array $identifierViaRoute = array())
    {
        foreach ($identifierViaRoute as $arrayOfIdentifierViaRouteIdentifierViaRouteItem) {
            // validation for constraint: itemType
            if (!$arrayOfIdentifierViaRouteIdentifierViaRouteItem instanceof \StructType\IdentifierViaRoute) {
                throw new \InvalidArgumentException(sprintf('The IdentifierViaRoute property can only contain items of \StructType\IdentifierViaRoute, "%s" given', is_object($arrayOfIdentifierViaRouteIdentifierViaRouteItem) ? get_class($arrayOfIdentifierViaRouteIdentifierViaRouteItem) : gettype($arrayOfIdentifierViaRouteIdentifierViaRouteItem)), __LINE__);
            }
        }
        if (is_null($identifierViaRoute) || (is_array($identifierViaRoute) && empty($identifierViaRoute))) {
            unset($this->IdentifierViaRoute);
        } else {
            $this->IdentifierViaRoute = $identifierViaRoute;
        }
        return $this;
    }
    /**
     * Add item to IdentifierViaRoute value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierViaRoute $item
     * @return \ArrayType\ArrayOfIdentifierViaRoute
     */
    public function addToIdentifierViaRoute(\StructType\IdentifierViaRoute $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentifierViaRoute) {
            throw new \InvalidArgumentException(sprintf('The IdentifierViaRoute property can only contain items of \StructType\IdentifierViaRoute, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->IdentifierViaRoute[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IdentifierViaRoute|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IdentifierViaRoute|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IdentifierViaRoute|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IdentifierViaRoute|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IdentifierViaRoute|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IdentifierViaRoute
     */
    public function getAttributeName()
    {
        return 'IdentifierViaRoute';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfIdentifierViaRoute
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
