<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInsertGeoZoneResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfInsertGeoZoneResult extends AbstractStructArrayBase
{
    /**
     * The InsertGeoZoneResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InsertGeoZoneResult[]
     */
    public $InsertGeoZoneResult;
    /**
     * Constructor method for ArrayOfInsertGeoZoneResult
     * @uses ArrayOfInsertGeoZoneResult::setInsertGeoZoneResult()
     * @param \StructType\InsertGeoZoneResult[] $insertGeoZoneResult
     */
    public function __construct(array $insertGeoZoneResult = array())
    {
        $this
            ->setInsertGeoZoneResult($insertGeoZoneResult);
    }
    /**
     * Get InsertGeoZoneResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InsertGeoZoneResult[]|null
     */
    public function getInsertGeoZoneResult()
    {
        return isset($this->InsertGeoZoneResult) ? $this->InsertGeoZoneResult : null;
    }
    /**
     * Set InsertGeoZoneResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InsertGeoZoneResult[] $insertGeoZoneResult
     * @return \ArrayType\ArrayOfInsertGeoZoneResult
     */
    public function setInsertGeoZoneResult(array $insertGeoZoneResult = array())
    {
        foreach ($insertGeoZoneResult as $arrayOfInsertGeoZoneResultInsertGeoZoneResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfInsertGeoZoneResultInsertGeoZoneResultItem instanceof \StructType\InsertGeoZoneResult) {
                throw new \InvalidArgumentException(sprintf('The InsertGeoZoneResult property can only contain items of \StructType\InsertGeoZoneResult, "%s" given', is_object($arrayOfInsertGeoZoneResultInsertGeoZoneResultItem) ? get_class($arrayOfInsertGeoZoneResultInsertGeoZoneResultItem) : gettype($arrayOfInsertGeoZoneResultInsertGeoZoneResultItem)), __LINE__);
            }
        }
        if (is_null($insertGeoZoneResult) || (is_array($insertGeoZoneResult) && empty($insertGeoZoneResult))) {
            unset($this->InsertGeoZoneResult);
        } else {
            $this->InsertGeoZoneResult = $insertGeoZoneResult;
        }
        return $this;
    }
    /**
     * Add item to InsertGeoZoneResult value
     * @throws \InvalidArgumentException
     * @param \StructType\InsertGeoZoneResult $item
     * @return \ArrayType\ArrayOfInsertGeoZoneResult
     */
    public function addToInsertGeoZoneResult(\StructType\InsertGeoZoneResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InsertGeoZoneResult) {
            throw new \InvalidArgumentException(sprintf('The InsertGeoZoneResult property can only contain items of \StructType\InsertGeoZoneResult, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->InsertGeoZoneResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InsertGeoZoneResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InsertGeoZoneResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InsertGeoZoneResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InsertGeoZoneResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InsertGeoZoneResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InsertGeoZoneResult
     */
    public function getAttributeName()
    {
        return 'InsertGeoZoneResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfInsertGeoZoneResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
