<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInterfaceGeoZoneStrategy ArrayType
 * @subpackage Arrays
 */
class ArrayOfInterfaceGeoZoneStrategy extends AbstractStructArrayBase
{
    /**
     * The InterfaceGeoZoneStrategy
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InterfaceGeoZoneStrategy[]
     */
    public $InterfaceGeoZoneStrategy;
    /**
     * Constructor method for ArrayOfInterfaceGeoZoneStrategy
     * @uses ArrayOfInterfaceGeoZoneStrategy::setInterfaceGeoZoneStrategy()
     * @param \StructType\InterfaceGeoZoneStrategy[] $interfaceGeoZoneStrategy
     */
    public function __construct(array $interfaceGeoZoneStrategy = array())
    {
        $this
            ->setInterfaceGeoZoneStrategy($interfaceGeoZoneStrategy);
    }
    /**
     * Get InterfaceGeoZoneStrategy value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InterfaceGeoZoneStrategy[]|null
     */
    public function getInterfaceGeoZoneStrategy()
    {
        return isset($this->InterfaceGeoZoneStrategy) ? $this->InterfaceGeoZoneStrategy : null;
    }
    /**
     * Set InterfaceGeoZoneStrategy value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InterfaceGeoZoneStrategy[] $interfaceGeoZoneStrategy
     * @return \ArrayType\ArrayOfInterfaceGeoZoneStrategy
     */
    public function setInterfaceGeoZoneStrategy(array $interfaceGeoZoneStrategy = array())
    {
        foreach ($interfaceGeoZoneStrategy as $arrayOfInterfaceGeoZoneStrategyInterfaceGeoZoneStrategyItem) {
            // validation for constraint: itemType
            if (!$arrayOfInterfaceGeoZoneStrategyInterfaceGeoZoneStrategyItem instanceof \StructType\InterfaceGeoZoneStrategy) {
                throw new \InvalidArgumentException(sprintf('The InterfaceGeoZoneStrategy property can only contain items of \StructType\InterfaceGeoZoneStrategy, "%s" given', is_object($arrayOfInterfaceGeoZoneStrategyInterfaceGeoZoneStrategyItem) ? get_class($arrayOfInterfaceGeoZoneStrategyInterfaceGeoZoneStrategyItem) : gettype($arrayOfInterfaceGeoZoneStrategyInterfaceGeoZoneStrategyItem)), __LINE__);
            }
        }
        if (is_null($interfaceGeoZoneStrategy) || (is_array($interfaceGeoZoneStrategy) && empty($interfaceGeoZoneStrategy))) {
            unset($this->InterfaceGeoZoneStrategy);
        } else {
            $this->InterfaceGeoZoneStrategy = $interfaceGeoZoneStrategy;
        }
        return $this;
    }
    /**
     * Add item to InterfaceGeoZoneStrategy value
     * @throws \InvalidArgumentException
     * @param \StructType\InterfaceGeoZoneStrategy $item
     * @return \ArrayType\ArrayOfInterfaceGeoZoneStrategy
     */
    public function addToInterfaceGeoZoneStrategy(\StructType\InterfaceGeoZoneStrategy $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InterfaceGeoZoneStrategy) {
            throw new \InvalidArgumentException(sprintf('The InterfaceGeoZoneStrategy property can only contain items of \StructType\InterfaceGeoZoneStrategy, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->InterfaceGeoZoneStrategy[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InterfaceGeoZoneStrategy|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InterfaceGeoZoneStrategy|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InterfaceGeoZoneStrategy|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InterfaceGeoZoneStrategy|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InterfaceGeoZoneStrategy|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InterfaceGeoZoneStrategy
     */
    public function getAttributeName()
    {
        return 'InterfaceGeoZoneStrategy';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfInterfaceGeoZoneStrategy
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
