<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJobInsert ArrayType
 * @subpackage Arrays
 */
class ArrayOfJobInsert extends AbstractStructArrayBase
{
    /**
     * The JobInsert
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\JobInsert[]
     */
    public $JobInsert;
    /**
     * Constructor method for ArrayOfJobInsert
     * @uses ArrayOfJobInsert::setJobInsert()
     * @param \StructType\JobInsert[] $jobInsert
     */
    public function __construct(array $jobInsert = array())
    {
        $this
            ->setJobInsert($jobInsert);
    }
    /**
     * Get JobInsert value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\JobInsert[]|null
     */
    public function getJobInsert()
    {
        return isset($this->JobInsert) ? $this->JobInsert : null;
    }
    /**
     * Set JobInsert value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\JobInsert[] $jobInsert
     * @return \ArrayType\ArrayOfJobInsert
     */
    public function setJobInsert(array $jobInsert = array())
    {
        foreach ($jobInsert as $arrayOfJobInsertJobInsertItem) {
            // validation for constraint: itemType
            if (!$arrayOfJobInsertJobInsertItem instanceof \StructType\JobInsert) {
                throw new \InvalidArgumentException(sprintf('The JobInsert property can only contain items of \StructType\JobInsert, "%s" given', is_object($arrayOfJobInsertJobInsertItem) ? get_class($arrayOfJobInsertJobInsertItem) : gettype($arrayOfJobInsertJobInsertItem)), __LINE__);
            }
        }
        if (is_null($jobInsert) || (is_array($jobInsert) && empty($jobInsert))) {
            unset($this->JobInsert);
        } else {
            $this->JobInsert = $jobInsert;
        }
        return $this;
    }
    /**
     * Add item to JobInsert value
     * @throws \InvalidArgumentException
     * @param \StructType\JobInsert $item
     * @return \ArrayType\ArrayOfJobInsert
     */
    public function addToJobInsert(\StructType\JobInsert $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JobInsert) {
            throw new \InvalidArgumentException(sprintf('The JobInsert property can only contain items of \StructType\JobInsert, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->JobInsert[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JobInsert|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JobInsert|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JobInsert|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JobInsert|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JobInsert|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string JobInsert
     */
    public function getAttributeName()
    {
        return 'JobInsert';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJobInsert
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
