<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJobItemResult_V4 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJobItemResult_V4 extends AbstractStructArrayBase
{
    /**
     * The JobItemResult_V4
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\JobItemResult_V4[]
     */
    public $JobItemResult_V4;
    /**
     * Constructor method for ArrayOfJobItemResult_V4
     * @uses ArrayOfJobItemResult_V4::setJobItemResult_V4()
     * @param \StructType\JobItemResult_V4[] $jobItemResult_V4
     */
    public function __construct(array $jobItemResult_V4 = array())
    {
        $this
            ->setJobItemResult_V4($jobItemResult_V4);
    }
    /**
     * Get JobItemResult_V4 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\JobItemResult_V4[]|null
     */
    public function getJobItemResult_V4()
    {
        return isset($this->JobItemResult_V4) ? $this->JobItemResult_V4 : null;
    }
    /**
     * Set JobItemResult_V4 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\JobItemResult_V4[] $jobItemResult_V4
     * @return \ArrayType\ArrayOfJobItemResult_V4
     */
    public function setJobItemResult_V4(array $jobItemResult_V4 = array())
    {
        foreach ($jobItemResult_V4 as $arrayOfJobItemResult_V4JobItemResult_V4Item) {
            // validation for constraint: itemType
            if (!$arrayOfJobItemResult_V4JobItemResult_V4Item instanceof \StructType\JobItemResult_V4) {
                throw new \InvalidArgumentException(sprintf('The JobItemResult_V4 property can only contain items of \StructType\JobItemResult_V4, "%s" given', is_object($arrayOfJobItemResult_V4JobItemResult_V4Item) ? get_class($arrayOfJobItemResult_V4JobItemResult_V4Item) : gettype($arrayOfJobItemResult_V4JobItemResult_V4Item)), __LINE__);
            }
        }
        if (is_null($jobItemResult_V4) || (is_array($jobItemResult_V4) && empty($jobItemResult_V4))) {
            unset($this->JobItemResult_V4);
        } else {
            $this->JobItemResult_V4 = $jobItemResult_V4;
        }
        return $this;
    }
    /**
     * Add item to JobItemResult_V4 value
     * @throws \InvalidArgumentException
     * @param \StructType\JobItemResult_V4 $item
     * @return \ArrayType\ArrayOfJobItemResult_V4
     */
    public function addToJobItemResult_V4(\StructType\JobItemResult_V4 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JobItemResult_V4) {
            throw new \InvalidArgumentException(sprintf('The JobItemResult_V4 property can only contain items of \StructType\JobItemResult_V4, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->JobItemResult_V4[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JobItemResult_V4|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JobItemResult_V4|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JobItemResult_V4|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JobItemResult_V4|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JobItemResult_V4|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string JobItemResult_V4
     */
    public function getAttributeName()
    {
        return 'JobItemResult_V4';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJobItemResult_V4
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
