<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMagellanTracerGeoZoneInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfMagellanTracerGeoZoneInfo extends AbstractStructArrayBase
{
    /**
     * The MagellanTracerGeoZoneInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MagellanTracerGeoZoneInfo[]
     */
    public $MagellanTracerGeoZoneInfo;
    /**
     * Constructor method for ArrayOfMagellanTracerGeoZoneInfo
     * @uses ArrayOfMagellanTracerGeoZoneInfo::setMagellanTracerGeoZoneInfo()
     * @param \StructType\MagellanTracerGeoZoneInfo[] $magellanTracerGeoZoneInfo
     */
    public function __construct(array $magellanTracerGeoZoneInfo = array())
    {
        $this
            ->setMagellanTracerGeoZoneInfo($magellanTracerGeoZoneInfo);
    }
    /**
     * Get MagellanTracerGeoZoneInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MagellanTracerGeoZoneInfo[]|null
     */
    public function getMagellanTracerGeoZoneInfo()
    {
        return isset($this->MagellanTracerGeoZoneInfo) ? $this->MagellanTracerGeoZoneInfo : null;
    }
    /**
     * Set MagellanTracerGeoZoneInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MagellanTracerGeoZoneInfo[] $magellanTracerGeoZoneInfo
     * @return \ArrayType\ArrayOfMagellanTracerGeoZoneInfo
     */
    public function setMagellanTracerGeoZoneInfo(array $magellanTracerGeoZoneInfo = array())
    {
        foreach ($magellanTracerGeoZoneInfo as $arrayOfMagellanTracerGeoZoneInfoMagellanTracerGeoZoneInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfMagellanTracerGeoZoneInfoMagellanTracerGeoZoneInfoItem instanceof \StructType\MagellanTracerGeoZoneInfo) {
                throw new \InvalidArgumentException(sprintf('The MagellanTracerGeoZoneInfo property can only contain items of \StructType\MagellanTracerGeoZoneInfo, "%s" given', is_object($arrayOfMagellanTracerGeoZoneInfoMagellanTracerGeoZoneInfoItem) ? get_class($arrayOfMagellanTracerGeoZoneInfoMagellanTracerGeoZoneInfoItem) : gettype($arrayOfMagellanTracerGeoZoneInfoMagellanTracerGeoZoneInfoItem)), __LINE__);
            }
        }
        if (is_null($magellanTracerGeoZoneInfo) || (is_array($magellanTracerGeoZoneInfo) && empty($magellanTracerGeoZoneInfo))) {
            unset($this->MagellanTracerGeoZoneInfo);
        } else {
            $this->MagellanTracerGeoZoneInfo = $magellanTracerGeoZoneInfo;
        }
        return $this;
    }
    /**
     * Add item to MagellanTracerGeoZoneInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\MagellanTracerGeoZoneInfo $item
     * @return \ArrayType\ArrayOfMagellanTracerGeoZoneInfo
     */
    public function addToMagellanTracerGeoZoneInfo(\StructType\MagellanTracerGeoZoneInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MagellanTracerGeoZoneInfo) {
            throw new \InvalidArgumentException(sprintf('The MagellanTracerGeoZoneInfo property can only contain items of \StructType\MagellanTracerGeoZoneInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MagellanTracerGeoZoneInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MagellanTracerGeoZoneInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MagellanTracerGeoZoneInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MagellanTracerGeoZoneInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MagellanTracerGeoZoneInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MagellanTracerGeoZoneInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MagellanTracerGeoZoneInfo
     */
    public function getAttributeName()
    {
        return 'MagellanTracerGeoZoneInfo';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfMagellanTracerGeoZoneInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
