<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMagellanTracerIdentifier ArrayType
 * @subpackage Arrays
 */
class ArrayOfMagellanTracerIdentifier extends AbstractStructArrayBase
{
    /**
     * The MagellanTracerIdentifier
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MagellanTracerIdentifier[]
     */
    public $MagellanTracerIdentifier;
    /**
     * Constructor method for ArrayOfMagellanTracerIdentifier
     * @uses ArrayOfMagellanTracerIdentifier::setMagellanTracerIdentifier()
     * @param \StructType\MagellanTracerIdentifier[] $magellanTracerIdentifier
     */
    public function __construct(array $magellanTracerIdentifier = array())
    {
        $this
            ->setMagellanTracerIdentifier($magellanTracerIdentifier);
    }
    /**
     * Get MagellanTracerIdentifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MagellanTracerIdentifier[]|null
     */
    public function getMagellanTracerIdentifier()
    {
        return isset($this->MagellanTracerIdentifier) ? $this->MagellanTracerIdentifier : null;
    }
    /**
     * Set MagellanTracerIdentifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MagellanTracerIdentifier[] $magellanTracerIdentifier
     * @return \ArrayType\ArrayOfMagellanTracerIdentifier
     */
    public function setMagellanTracerIdentifier(array $magellanTracerIdentifier = array())
    {
        foreach ($magellanTracerIdentifier as $arrayOfMagellanTracerIdentifierMagellanTracerIdentifierItem) {
            // validation for constraint: itemType
            if (!$arrayOfMagellanTracerIdentifierMagellanTracerIdentifierItem instanceof \StructType\MagellanTracerIdentifier) {
                throw new \InvalidArgumentException(sprintf('The MagellanTracerIdentifier property can only contain items of \StructType\MagellanTracerIdentifier, "%s" given', is_object($arrayOfMagellanTracerIdentifierMagellanTracerIdentifierItem) ? get_class($arrayOfMagellanTracerIdentifierMagellanTracerIdentifierItem) : gettype($arrayOfMagellanTracerIdentifierMagellanTracerIdentifierItem)), __LINE__);
            }
        }
        if (is_null($magellanTracerIdentifier) || (is_array($magellanTracerIdentifier) && empty($magellanTracerIdentifier))) {
            unset($this->MagellanTracerIdentifier);
        } else {
            $this->MagellanTracerIdentifier = $magellanTracerIdentifier;
        }
        return $this;
    }
    /**
     * Add item to MagellanTracerIdentifier value
     * @throws \InvalidArgumentException
     * @param \StructType\MagellanTracerIdentifier $item
     * @return \ArrayType\ArrayOfMagellanTracerIdentifier
     */
    public function addToMagellanTracerIdentifier(\StructType\MagellanTracerIdentifier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MagellanTracerIdentifier) {
            throw new \InvalidArgumentException(sprintf('The MagellanTracerIdentifier property can only contain items of \StructType\MagellanTracerIdentifier, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MagellanTracerIdentifier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MagellanTracerIdentifier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MagellanTracerIdentifier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MagellanTracerIdentifier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MagellanTracerIdentifier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MagellanTracerIdentifier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MagellanTracerIdentifier
     */
    public function getAttributeName()
    {
        return 'MagellanTracerIdentifier';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfMagellanTracerIdentifier
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
