<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMagellanTracerPositionInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfMagellanTracerPositionInfo extends AbstractStructArrayBase
{
    /**
     * The MagellanTracerPositionInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MagellanTracerPositionInfo[]
     */
    public $MagellanTracerPositionInfo;
    /**
     * Constructor method for ArrayOfMagellanTracerPositionInfo
     * @uses ArrayOfMagellanTracerPositionInfo::setMagellanTracerPositionInfo()
     * @param \StructType\MagellanTracerPositionInfo[] $magellanTracerPositionInfo
     */
    public function __construct(array $magellanTracerPositionInfo = array())
    {
        $this
            ->setMagellanTracerPositionInfo($magellanTracerPositionInfo);
    }
    /**
     * Get MagellanTracerPositionInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MagellanTracerPositionInfo[]|null
     */
    public function getMagellanTracerPositionInfo()
    {
        return isset($this->MagellanTracerPositionInfo) ? $this->MagellanTracerPositionInfo : null;
    }
    /**
     * Set MagellanTracerPositionInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MagellanTracerPositionInfo[] $magellanTracerPositionInfo
     * @return \ArrayType\ArrayOfMagellanTracerPositionInfo
     */
    public function setMagellanTracerPositionInfo(array $magellanTracerPositionInfo = array())
    {
        foreach ($magellanTracerPositionInfo as $arrayOfMagellanTracerPositionInfoMagellanTracerPositionInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfMagellanTracerPositionInfoMagellanTracerPositionInfoItem instanceof \StructType\MagellanTracerPositionInfo) {
                throw new \InvalidArgumentException(sprintf('The MagellanTracerPositionInfo property can only contain items of \StructType\MagellanTracerPositionInfo, "%s" given', is_object($arrayOfMagellanTracerPositionInfoMagellanTracerPositionInfoItem) ? get_class($arrayOfMagellanTracerPositionInfoMagellanTracerPositionInfoItem) : gettype($arrayOfMagellanTracerPositionInfoMagellanTracerPositionInfoItem)), __LINE__);
            }
        }
        if (is_null($magellanTracerPositionInfo) || (is_array($magellanTracerPositionInfo) && empty($magellanTracerPositionInfo))) {
            unset($this->MagellanTracerPositionInfo);
        } else {
            $this->MagellanTracerPositionInfo = $magellanTracerPositionInfo;
        }
        return $this;
    }
    /**
     * Add item to MagellanTracerPositionInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\MagellanTracerPositionInfo $item
     * @return \ArrayType\ArrayOfMagellanTracerPositionInfo
     */
    public function addToMagellanTracerPositionInfo(\StructType\MagellanTracerPositionInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MagellanTracerPositionInfo) {
            throw new \InvalidArgumentException(sprintf('The MagellanTracerPositionInfo property can only contain items of \StructType\MagellanTracerPositionInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MagellanTracerPositionInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MagellanTracerPositionInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MagellanTracerPositionInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MagellanTracerPositionInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MagellanTracerPositionInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MagellanTracerPositionInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MagellanTracerPositionInfo
     */
    public function getAttributeName()
    {
        return 'MagellanTracerPositionInfo';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfMagellanTracerPositionInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
