<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMagellanTracerResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfMagellanTracerResult extends AbstractStructArrayBase
{
    /**
     * The MagellanTracerResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MagellanTracerResult[]
     */
    public $MagellanTracerResult;
    /**
     * Constructor method for ArrayOfMagellanTracerResult
     * @uses ArrayOfMagellanTracerResult::setMagellanTracerResult()
     * @param \StructType\MagellanTracerResult[] $magellanTracerResult
     */
    public function __construct(array $magellanTracerResult = array())
    {
        $this
            ->setMagellanTracerResult($magellanTracerResult);
    }
    /**
     * Get MagellanTracerResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MagellanTracerResult[]|null
     */
    public function getMagellanTracerResult()
    {
        return isset($this->MagellanTracerResult) ? $this->MagellanTracerResult : null;
    }
    /**
     * Set MagellanTracerResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MagellanTracerResult[] $magellanTracerResult
     * @return \ArrayType\ArrayOfMagellanTracerResult
     */
    public function setMagellanTracerResult(array $magellanTracerResult = array())
    {
        foreach ($magellanTracerResult as $arrayOfMagellanTracerResultMagellanTracerResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfMagellanTracerResultMagellanTracerResultItem instanceof \StructType\MagellanTracerResult) {
                throw new \InvalidArgumentException(sprintf('The MagellanTracerResult property can only contain items of \StructType\MagellanTracerResult, "%s" given', is_object($arrayOfMagellanTracerResultMagellanTracerResultItem) ? get_class($arrayOfMagellanTracerResultMagellanTracerResultItem) : gettype($arrayOfMagellanTracerResultMagellanTracerResultItem)), __LINE__);
            }
        }
        if (is_null($magellanTracerResult) || (is_array($magellanTracerResult) && empty($magellanTracerResult))) {
            unset($this->MagellanTracerResult);
        } else {
            $this->MagellanTracerResult = $magellanTracerResult;
        }
        return $this;
    }
    /**
     * Add item to MagellanTracerResult value
     * @throws \InvalidArgumentException
     * @param \StructType\MagellanTracerResult $item
     * @return \ArrayType\ArrayOfMagellanTracerResult
     */
    public function addToMagellanTracerResult(\StructType\MagellanTracerResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MagellanTracerResult) {
            throw new \InvalidArgumentException(sprintf('The MagellanTracerResult property can only contain items of \StructType\MagellanTracerResult, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MagellanTracerResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MagellanTracerResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MagellanTracerResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MagellanTracerResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MagellanTracerResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MagellanTracerResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MagellanTracerResult
     */
    public function getAttributeName()
    {
        return 'MagellanTracerResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfMagellanTracerResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
