<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMergedTachoServiceTimesItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfMergedTachoServiceTimesItem extends AbstractStructArrayBase
{
    /**
     * The MergedTachoServiceTimesItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MergedTachoServiceTimesItem[]
     */
    public $MergedTachoServiceTimesItem;
    /**
     * Constructor method for ArrayOfMergedTachoServiceTimesItem
     * @uses ArrayOfMergedTachoServiceTimesItem::setMergedTachoServiceTimesItem()
     * @param \StructType\MergedTachoServiceTimesItem[] $mergedTachoServiceTimesItem
     */
    public function __construct(array $mergedTachoServiceTimesItem = array())
    {
        $this
            ->setMergedTachoServiceTimesItem($mergedTachoServiceTimesItem);
    }
    /**
     * Get MergedTachoServiceTimesItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MergedTachoServiceTimesItem[]|null
     */
    public function getMergedTachoServiceTimesItem()
    {
        return isset($this->MergedTachoServiceTimesItem) ? $this->MergedTachoServiceTimesItem : null;
    }
    /**
     * Set MergedTachoServiceTimesItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MergedTachoServiceTimesItem[] $mergedTachoServiceTimesItem
     * @return \ArrayType\ArrayOfMergedTachoServiceTimesItem
     */
    public function setMergedTachoServiceTimesItem(array $mergedTachoServiceTimesItem = array())
    {
        foreach ($mergedTachoServiceTimesItem as $arrayOfMergedTachoServiceTimesItemMergedTachoServiceTimesItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfMergedTachoServiceTimesItemMergedTachoServiceTimesItemItem instanceof \StructType\MergedTachoServiceTimesItem) {
                throw new \InvalidArgumentException(sprintf('The MergedTachoServiceTimesItem property can only contain items of \StructType\MergedTachoServiceTimesItem, "%s" given', is_object($arrayOfMergedTachoServiceTimesItemMergedTachoServiceTimesItemItem) ? get_class($arrayOfMergedTachoServiceTimesItemMergedTachoServiceTimesItemItem) : gettype($arrayOfMergedTachoServiceTimesItemMergedTachoServiceTimesItemItem)), __LINE__);
            }
        }
        if (is_null($mergedTachoServiceTimesItem) || (is_array($mergedTachoServiceTimesItem) && empty($mergedTachoServiceTimesItem))) {
            unset($this->MergedTachoServiceTimesItem);
        } else {
            $this->MergedTachoServiceTimesItem = $mergedTachoServiceTimesItem;
        }
        return $this;
    }
    /**
     * Add item to MergedTachoServiceTimesItem value
     * @throws \InvalidArgumentException
     * @param \StructType\MergedTachoServiceTimesItem $item
     * @return \ArrayType\ArrayOfMergedTachoServiceTimesItem
     */
    public function addToMergedTachoServiceTimesItem(\StructType\MergedTachoServiceTimesItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MergedTachoServiceTimesItem) {
            throw new \InvalidArgumentException(sprintf('The MergedTachoServiceTimesItem property can only contain items of \StructType\MergedTachoServiceTimesItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MergedTachoServiceTimesItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MergedTachoServiceTimesItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MergedTachoServiceTimesItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MergedTachoServiceTimesItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MergedTachoServiceTimesItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MergedTachoServiceTimesItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MergedTachoServiceTimesItem
     */
    public function getAttributeName()
    {
        return 'MergedTachoServiceTimesItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfMergedTachoServiceTimesItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
