<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPOIResult_V2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPOIResult_V2 extends AbstractStructArrayBase
{
    /**
     * The POIResult_V2
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\POIResult_V2[]
     */
    public $POIResult_V2;
    /**
     * Constructor method for ArrayOfPOIResult_V2
     * @uses ArrayOfPOIResult_V2::setPOIResult_V2()
     * @param \StructType\POIResult_V2[] $pOIResult_V2
     */
    public function __construct(array $pOIResult_V2 = array())
    {
        $this
            ->setPOIResult_V2($pOIResult_V2);
    }
    /**
     * Get POIResult_V2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\POIResult_V2[]|null
     */
    public function getPOIResult_V2()
    {
        return isset($this->POIResult_V2) ? $this->POIResult_V2 : null;
    }
    /**
     * Set POIResult_V2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\POIResult_V2[] $pOIResult_V2
     * @return \ArrayType\ArrayOfPOIResult_V2
     */
    public function setPOIResult_V2(array $pOIResult_V2 = array())
    {
        foreach ($pOIResult_V2 as $arrayOfPOIResult_V2POIResult_V2Item) {
            // validation for constraint: itemType
            if (!$arrayOfPOIResult_V2POIResult_V2Item instanceof \StructType\POIResult_V2) {
                throw new \InvalidArgumentException(sprintf('The POIResult_V2 property can only contain items of \StructType\POIResult_V2, "%s" given', is_object($arrayOfPOIResult_V2POIResult_V2Item) ? get_class($arrayOfPOIResult_V2POIResult_V2Item) : gettype($arrayOfPOIResult_V2POIResult_V2Item)), __LINE__);
            }
        }
        if (is_null($pOIResult_V2) || (is_array($pOIResult_V2) && empty($pOIResult_V2))) {
            unset($this->POIResult_V2);
        } else {
            $this->POIResult_V2 = $pOIResult_V2;
        }
        return $this;
    }
    /**
     * Add item to POIResult_V2 value
     * @throws \InvalidArgumentException
     * @param \StructType\POIResult_V2 $item
     * @return \ArrayType\ArrayOfPOIResult_V2
     */
    public function addToPOIResult_V2(\StructType\POIResult_V2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\POIResult_V2) {
            throw new \InvalidArgumentException(sprintf('The POIResult_V2 property can only contain items of \StructType\POIResult_V2, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->POIResult_V2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\POIResult_V2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\POIResult_V2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\POIResult_V2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\POIResult_V2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\POIResult_V2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string POIResult_V2
     */
    public function getAttributeName()
    {
        return 'POIResult_V2';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPOIResult_V2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
