<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPersonalCommunicationInsert ArrayType
 * @subpackage Arrays
 */
class ArrayOfPersonalCommunicationInsert extends AbstractStructArrayBase
{
    /**
     * The PersonalCommunicationInsert
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PersonalCommunicationInsert[]
     */
    public $PersonalCommunicationInsert;
    /**
     * Constructor method for ArrayOfPersonalCommunicationInsert
     * @uses ArrayOfPersonalCommunicationInsert::setPersonalCommunicationInsert()
     * @param \StructType\PersonalCommunicationInsert[] $personalCommunicationInsert
     */
    public function __construct(array $personalCommunicationInsert = array())
    {
        $this
            ->setPersonalCommunicationInsert($personalCommunicationInsert);
    }
    /**
     * Get PersonalCommunicationInsert value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PersonalCommunicationInsert[]|null
     */
    public function getPersonalCommunicationInsert()
    {
        return isset($this->PersonalCommunicationInsert) ? $this->PersonalCommunicationInsert : null;
    }
    /**
     * Set PersonalCommunicationInsert value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PersonalCommunicationInsert[] $personalCommunicationInsert
     * @return \ArrayType\ArrayOfPersonalCommunicationInsert
     */
    public function setPersonalCommunicationInsert(array $personalCommunicationInsert = array())
    {
        foreach ($personalCommunicationInsert as $arrayOfPersonalCommunicationInsertPersonalCommunicationInsertItem) {
            // validation for constraint: itemType
            if (!$arrayOfPersonalCommunicationInsertPersonalCommunicationInsertItem instanceof \StructType\PersonalCommunicationInsert) {
                throw new \InvalidArgumentException(sprintf('The PersonalCommunicationInsert property can only contain items of \StructType\PersonalCommunicationInsert, "%s" given', is_object($arrayOfPersonalCommunicationInsertPersonalCommunicationInsertItem) ? get_class($arrayOfPersonalCommunicationInsertPersonalCommunicationInsertItem) : gettype($arrayOfPersonalCommunicationInsertPersonalCommunicationInsertItem)), __LINE__);
            }
        }
        if (is_null($personalCommunicationInsert) || (is_array($personalCommunicationInsert) && empty($personalCommunicationInsert))) {
            unset($this->PersonalCommunicationInsert);
        } else {
            $this->PersonalCommunicationInsert = $personalCommunicationInsert;
        }
        return $this;
    }
    /**
     * Add item to PersonalCommunicationInsert value
     * @throws \InvalidArgumentException
     * @param \StructType\PersonalCommunicationInsert $item
     * @return \ArrayType\ArrayOfPersonalCommunicationInsert
     */
    public function addToPersonalCommunicationInsert(\StructType\PersonalCommunicationInsert $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PersonalCommunicationInsert) {
            throw new \InvalidArgumentException(sprintf('The PersonalCommunicationInsert property can only contain items of \StructType\PersonalCommunicationInsert, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PersonalCommunicationInsert[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PersonalCommunicationInsert|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PersonalCommunicationInsert|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PersonalCommunicationInsert|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PersonalCommunicationInsert|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PersonalCommunicationInsert|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PersonalCommunicationInsert
     */
    public function getAttributeName()
    {
        return 'PersonalCommunicationInsert';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPersonalCommunicationInsert
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
