<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlaceInsert ArrayType
 * @subpackage Arrays
 */
class ArrayOfPlaceInsert extends AbstractStructArrayBase
{
    /**
     * The PlaceInsert
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PlaceInsert[]
     */
    public $PlaceInsert;
    /**
     * Constructor method for ArrayOfPlaceInsert
     * @uses ArrayOfPlaceInsert::setPlaceInsert()
     * @param \StructType\PlaceInsert[] $placeInsert
     */
    public function __construct(array $placeInsert = array())
    {
        $this
            ->setPlaceInsert($placeInsert);
    }
    /**
     * Get PlaceInsert value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PlaceInsert[]|null
     */
    public function getPlaceInsert()
    {
        return isset($this->PlaceInsert) ? $this->PlaceInsert : null;
    }
    /**
     * Set PlaceInsert value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceInsert[] $placeInsert
     * @return \ArrayType\ArrayOfPlaceInsert
     */
    public function setPlaceInsert(array $placeInsert = array())
    {
        foreach ($placeInsert as $arrayOfPlaceInsertPlaceInsertItem) {
            // validation for constraint: itemType
            if (!$arrayOfPlaceInsertPlaceInsertItem instanceof \StructType\PlaceInsert) {
                throw new \InvalidArgumentException(sprintf('The PlaceInsert property can only contain items of \StructType\PlaceInsert, "%s" given', is_object($arrayOfPlaceInsertPlaceInsertItem) ? get_class($arrayOfPlaceInsertPlaceInsertItem) : gettype($arrayOfPlaceInsertPlaceInsertItem)), __LINE__);
            }
        }
        if (is_null($placeInsert) || (is_array($placeInsert) && empty($placeInsert))) {
            unset($this->PlaceInsert);
        } else {
            $this->PlaceInsert = $placeInsert;
        }
        return $this;
    }
    /**
     * Add item to PlaceInsert value
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceInsert $item
     * @return \ArrayType\ArrayOfPlaceInsert
     */
    public function addToPlaceInsert(\StructType\PlaceInsert $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PlaceInsert) {
            throw new \InvalidArgumentException(sprintf('The PlaceInsert property can only contain items of \StructType\PlaceInsert, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PlaceInsert[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PlaceInsert|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PlaceInsert|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PlaceInsert|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PlaceInsert|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PlaceInsert|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlaceInsert
     */
    public function getAttributeName()
    {
        return 'PlaceInsert';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPlaceInsert
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
