<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlaceResultInsert ArrayType
 * @subpackage Arrays
 */
class ArrayOfPlaceResultInsert extends AbstractStructArrayBase
{
    /**
     * The PlaceResultInsert
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PlaceResultInsert[]
     */
    public $PlaceResultInsert;
    /**
     * Constructor method for ArrayOfPlaceResultInsert
     * @uses ArrayOfPlaceResultInsert::setPlaceResultInsert()
     * @param \StructType\PlaceResultInsert[] $placeResultInsert
     */
    public function __construct(array $placeResultInsert = array())
    {
        $this
            ->setPlaceResultInsert($placeResultInsert);
    }
    /**
     * Get PlaceResultInsert value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PlaceResultInsert[]|null
     */
    public function getPlaceResultInsert()
    {
        return isset($this->PlaceResultInsert) ? $this->PlaceResultInsert : null;
    }
    /**
     * Set PlaceResultInsert value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceResultInsert[] $placeResultInsert
     * @return \ArrayType\ArrayOfPlaceResultInsert
     */
    public function setPlaceResultInsert(array $placeResultInsert = array())
    {
        foreach ($placeResultInsert as $arrayOfPlaceResultInsertPlaceResultInsertItem) {
            // validation for constraint: itemType
            if (!$arrayOfPlaceResultInsertPlaceResultInsertItem instanceof \StructType\PlaceResultInsert) {
                throw new \InvalidArgumentException(sprintf('The PlaceResultInsert property can only contain items of \StructType\PlaceResultInsert, "%s" given', is_object($arrayOfPlaceResultInsertPlaceResultInsertItem) ? get_class($arrayOfPlaceResultInsertPlaceResultInsertItem) : gettype($arrayOfPlaceResultInsertPlaceResultInsertItem)), __LINE__);
            }
        }
        if (is_null($placeResultInsert) || (is_array($placeResultInsert) && empty($placeResultInsert))) {
            unset($this->PlaceResultInsert);
        } else {
            $this->PlaceResultInsert = $placeResultInsert;
        }
        return $this;
    }
    /**
     * Add item to PlaceResultInsert value
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceResultInsert $item
     * @return \ArrayType\ArrayOfPlaceResultInsert
     */
    public function addToPlaceResultInsert(\StructType\PlaceResultInsert $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PlaceResultInsert) {
            throw new \InvalidArgumentException(sprintf('The PlaceResultInsert property can only contain items of \StructType\PlaceResultInsert, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PlaceResultInsert[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PlaceResultInsert|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PlaceResultInsert|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PlaceResultInsert|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PlaceResultInsert|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PlaceResultInsert|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlaceResultInsert
     */
    public function getAttributeName()
    {
        return 'PlaceResultInsert';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPlaceResultInsert
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
