<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlanningResult_v2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPlanningResult_v2 extends AbstractStructArrayBase
{
    /**
     * The PlanningResult_v2
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PlanningResult_v2[]
     */
    public $PlanningResult_v2;
    /**
     * Constructor method for ArrayOfPlanningResult_v2
     * @uses ArrayOfPlanningResult_v2::setPlanningResult_v2()
     * @param \StructType\PlanningResult_v2[] $planningResult_v2
     */
    public function __construct(array $planningResult_v2 = array())
    {
        $this
            ->setPlanningResult_v2($planningResult_v2);
    }
    /**
     * Get PlanningResult_v2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PlanningResult_v2[]|null
     */
    public function getPlanningResult_v2()
    {
        return isset($this->PlanningResult_v2) ? $this->PlanningResult_v2 : null;
    }
    /**
     * Set PlanningResult_v2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PlanningResult_v2[] $planningResult_v2
     * @return \ArrayType\ArrayOfPlanningResult_v2
     */
    public function setPlanningResult_v2(array $planningResult_v2 = array())
    {
        foreach ($planningResult_v2 as $arrayOfPlanningResult_v2PlanningResult_v2Item) {
            // validation for constraint: itemType
            if (!$arrayOfPlanningResult_v2PlanningResult_v2Item instanceof \StructType\PlanningResult_v2) {
                throw new \InvalidArgumentException(sprintf('The PlanningResult_v2 property can only contain items of \StructType\PlanningResult_v2, "%s" given', is_object($arrayOfPlanningResult_v2PlanningResult_v2Item) ? get_class($arrayOfPlanningResult_v2PlanningResult_v2Item) : gettype($arrayOfPlanningResult_v2PlanningResult_v2Item)), __LINE__);
            }
        }
        if (is_null($planningResult_v2) || (is_array($planningResult_v2) && empty($planningResult_v2))) {
            unset($this->PlanningResult_v2);
        } else {
            $this->PlanningResult_v2 = $planningResult_v2;
        }
        return $this;
    }
    /**
     * Add item to PlanningResult_v2 value
     * @throws \InvalidArgumentException
     * @param \StructType\PlanningResult_v2 $item
     * @return \ArrayType\ArrayOfPlanningResult_v2
     */
    public function addToPlanningResult_v2(\StructType\PlanningResult_v2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PlanningResult_v2) {
            throw new \InvalidArgumentException(sprintf('The PlanningResult_v2 property can only contain items of \StructType\PlanningResult_v2, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PlanningResult_v2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PlanningResult_v2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PlanningResult_v2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PlanningResult_v2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PlanningResult_v2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PlanningResult_v2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlanningResult_v2
     */
    public function getAttributeName()
    {
        return 'PlanningResult_v2';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPlanningResult_v2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
