<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPositionItemResult_V4 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPositionItemResult_V4 extends AbstractStructArrayBase
{
    /**
     * The PositionItemResult_V4
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PositionItemResult_V4[]
     */
    public $PositionItemResult_V4;
    /**
     * Constructor method for ArrayOfPositionItemResult_V4
     * @uses ArrayOfPositionItemResult_V4::setPositionItemResult_V4()
     * @param \StructType\PositionItemResult_V4[] $positionItemResult_V4
     */
    public function __construct(array $positionItemResult_V4 = array())
    {
        $this
            ->setPositionItemResult_V4($positionItemResult_V4);
    }
    /**
     * Get PositionItemResult_V4 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PositionItemResult_V4[]|null
     */
    public function getPositionItemResult_V4()
    {
        return isset($this->PositionItemResult_V4) ? $this->PositionItemResult_V4 : null;
    }
    /**
     * Set PositionItemResult_V4 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PositionItemResult_V4[] $positionItemResult_V4
     * @return \ArrayType\ArrayOfPositionItemResult_V4
     */
    public function setPositionItemResult_V4(array $positionItemResult_V4 = array())
    {
        foreach ($positionItemResult_V4 as $arrayOfPositionItemResult_V4PositionItemResult_V4Item) {
            // validation for constraint: itemType
            if (!$arrayOfPositionItemResult_V4PositionItemResult_V4Item instanceof \StructType\PositionItemResult_V4) {
                throw new \InvalidArgumentException(sprintf('The PositionItemResult_V4 property can only contain items of \StructType\PositionItemResult_V4, "%s" given', is_object($arrayOfPositionItemResult_V4PositionItemResult_V4Item) ? get_class($arrayOfPositionItemResult_V4PositionItemResult_V4Item) : gettype($arrayOfPositionItemResult_V4PositionItemResult_V4Item)), __LINE__);
            }
        }
        if (is_null($positionItemResult_V4) || (is_array($positionItemResult_V4) && empty($positionItemResult_V4))) {
            unset($this->PositionItemResult_V4);
        } else {
            $this->PositionItemResult_V4 = $positionItemResult_V4;
        }
        return $this;
    }
    /**
     * Add item to PositionItemResult_V4 value
     * @throws \InvalidArgumentException
     * @param \StructType\PositionItemResult_V4 $item
     * @return \ArrayType\ArrayOfPositionItemResult_V4
     */
    public function addToPositionItemResult_V4(\StructType\PositionItemResult_V4 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PositionItemResult_V4) {
            throw new \InvalidArgumentException(sprintf('The PositionItemResult_V4 property can only contain items of \StructType\PositionItemResult_V4, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PositionItemResult_V4[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PositionItemResult_V4|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PositionItemResult_V4|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PositionItemResult_V4|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PositionItemResult_V4|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PositionItemResult_V4|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PositionItemResult_V4
     */
    public function getAttributeName()
    {
        return 'PositionItemResult_V4';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPositionItemResult_V4
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
