<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfQuestionPathInfo_v2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfQuestionPathInfo_v2 extends AbstractStructArrayBase
{
    /**
     * The QuestionPathInfo_v2
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\QuestionPathInfo_v2[]
     */
    public $QuestionPathInfo_v2;
    /**
     * Constructor method for ArrayOfQuestionPathInfo_v2
     * @uses ArrayOfQuestionPathInfo_v2::setQuestionPathInfo_v2()
     * @param \StructType\QuestionPathInfo_v2[] $questionPathInfo_v2
     */
    public function __construct(array $questionPathInfo_v2 = array())
    {
        $this
            ->setQuestionPathInfo_v2($questionPathInfo_v2);
    }
    /**
     * Get QuestionPathInfo_v2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\QuestionPathInfo_v2[]|null
     */
    public function getQuestionPathInfo_v2()
    {
        return isset($this->QuestionPathInfo_v2) ? $this->QuestionPathInfo_v2 : null;
    }
    /**
     * Set QuestionPathInfo_v2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\QuestionPathInfo_v2[] $questionPathInfo_v2
     * @return \ArrayType\ArrayOfQuestionPathInfo_v2
     */
    public function setQuestionPathInfo_v2(array $questionPathInfo_v2 = array())
    {
        foreach ($questionPathInfo_v2 as $arrayOfQuestionPathInfo_v2QuestionPathInfo_v2Item) {
            // validation for constraint: itemType
            if (!$arrayOfQuestionPathInfo_v2QuestionPathInfo_v2Item instanceof \StructType\QuestionPathInfo_v2) {
                throw new \InvalidArgumentException(sprintf('The QuestionPathInfo_v2 property can only contain items of \StructType\QuestionPathInfo_v2, "%s" given', is_object($arrayOfQuestionPathInfo_v2QuestionPathInfo_v2Item) ? get_class($arrayOfQuestionPathInfo_v2QuestionPathInfo_v2Item) : gettype($arrayOfQuestionPathInfo_v2QuestionPathInfo_v2Item)), __LINE__);
            }
        }
        if (is_null($questionPathInfo_v2) || (is_array($questionPathInfo_v2) && empty($questionPathInfo_v2))) {
            unset($this->QuestionPathInfo_v2);
        } else {
            $this->QuestionPathInfo_v2 = $questionPathInfo_v2;
        }
        return $this;
    }
    /**
     * Add item to QuestionPathInfo_v2 value
     * @throws \InvalidArgumentException
     * @param \StructType\QuestionPathInfo_v2 $item
     * @return \ArrayType\ArrayOfQuestionPathInfo_v2
     */
    public function addToQuestionPathInfo_v2(\StructType\QuestionPathInfo_v2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\QuestionPathInfo_v2) {
            throw new \InvalidArgumentException(sprintf('The QuestionPathInfo_v2 property can only contain items of \StructType\QuestionPathInfo_v2, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->QuestionPathInfo_v2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\QuestionPathInfo_v2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\QuestionPathInfo_v2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\QuestionPathInfo_v2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\QuestionPathInfo_v2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\QuestionPathInfo_v2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string QuestionPathInfo_v2
     */
    public function getAttributeName()
    {
        return 'QuestionPathInfo_v2';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfQuestionPathInfo_v2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
