<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRegistration ArrayType
 * @subpackage Arrays
 */
class ArrayOfRegistration extends AbstractStructArrayBase
{
    /**
     * The Registration
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Registration[]
     */
    public $Registration;
    /**
     * Constructor method for ArrayOfRegistration
     * @uses ArrayOfRegistration::setRegistration()
     * @param \StructType\Registration[] $registration
     */
    public function __construct(array $registration = array())
    {
        $this
            ->setRegistration($registration);
    }
    /**
     * Get Registration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Registration[]|null
     */
    public function getRegistration()
    {
        return isset($this->Registration) ? $this->Registration : null;
    }
    /**
     * Set Registration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Registration[] $registration
     * @return \ArrayType\ArrayOfRegistration
     */
    public function setRegistration(array $registration = array())
    {
        foreach ($registration as $arrayOfRegistrationRegistrationItem) {
            // validation for constraint: itemType
            if (!$arrayOfRegistrationRegistrationItem instanceof \StructType\Registration) {
                throw new \InvalidArgumentException(sprintf('The Registration property can only contain items of \StructType\Registration, "%s" given', is_object($arrayOfRegistrationRegistrationItem) ? get_class($arrayOfRegistrationRegistrationItem) : gettype($arrayOfRegistrationRegistrationItem)), __LINE__);
            }
        }
        if (is_null($registration) || (is_array($registration) && empty($registration))) {
            unset($this->Registration);
        } else {
            $this->Registration = $registration;
        }
        return $this;
    }
    /**
     * Add item to Registration value
     * @throws \InvalidArgumentException
     * @param \StructType\Registration $item
     * @return \ArrayType\ArrayOfRegistration
     */
    public function addToRegistration(\StructType\Registration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Registration) {
            throw new \InvalidArgumentException(sprintf('The Registration property can only contain items of \StructType\Registration, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Registration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Registration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Registration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Registration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Registration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Registration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Registration
     */
    public function getAttributeName()
    {
        return 'Registration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfRegistration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
