<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSendReeferCommandResultInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfSendReeferCommandResultInfo extends AbstractStructArrayBase
{
    /**
     * The SendReeferCommandResultInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SendReeferCommandResultInfo[]
     */
    public $SendReeferCommandResultInfo;
    /**
     * Constructor method for ArrayOfSendReeferCommandResultInfo
     * @uses ArrayOfSendReeferCommandResultInfo::setSendReeferCommandResultInfo()
     * @param \StructType\SendReeferCommandResultInfo[] $sendReeferCommandResultInfo
     */
    public function __construct(array $sendReeferCommandResultInfo = array())
    {
        $this
            ->setSendReeferCommandResultInfo($sendReeferCommandResultInfo);
    }
    /**
     * Get SendReeferCommandResultInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SendReeferCommandResultInfo[]|null
     */
    public function getSendReeferCommandResultInfo()
    {
        return isset($this->SendReeferCommandResultInfo) ? $this->SendReeferCommandResultInfo : null;
    }
    /**
     * Set SendReeferCommandResultInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SendReeferCommandResultInfo[] $sendReeferCommandResultInfo
     * @return \ArrayType\ArrayOfSendReeferCommandResultInfo
     */
    public function setSendReeferCommandResultInfo(array $sendReeferCommandResultInfo = array())
    {
        foreach ($sendReeferCommandResultInfo as $arrayOfSendReeferCommandResultInfoSendReeferCommandResultInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfSendReeferCommandResultInfoSendReeferCommandResultInfoItem instanceof \StructType\SendReeferCommandResultInfo) {
                throw new \InvalidArgumentException(sprintf('The SendReeferCommandResultInfo property can only contain items of \StructType\SendReeferCommandResultInfo, "%s" given', is_object($arrayOfSendReeferCommandResultInfoSendReeferCommandResultInfoItem) ? get_class($arrayOfSendReeferCommandResultInfoSendReeferCommandResultInfoItem) : gettype($arrayOfSendReeferCommandResultInfoSendReeferCommandResultInfoItem)), __LINE__);
            }
        }
        if (is_null($sendReeferCommandResultInfo) || (is_array($sendReeferCommandResultInfo) && empty($sendReeferCommandResultInfo))) {
            unset($this->SendReeferCommandResultInfo);
        } else {
            $this->SendReeferCommandResultInfo = $sendReeferCommandResultInfo;
        }
        return $this;
    }
    /**
     * Add item to SendReeferCommandResultInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\SendReeferCommandResultInfo $item
     * @return \ArrayType\ArrayOfSendReeferCommandResultInfo
     */
    public function addToSendReeferCommandResultInfo(\StructType\SendReeferCommandResultInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SendReeferCommandResultInfo) {
            throw new \InvalidArgumentException(sprintf('The SendReeferCommandResultInfo property can only contain items of \StructType\SendReeferCommandResultInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SendReeferCommandResultInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SendReeferCommandResultInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SendReeferCommandResultInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SendReeferCommandResultInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SendReeferCommandResultInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SendReeferCommandResultInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SendReeferCommandResultInfo
     */
    public function getAttributeName()
    {
        return 'SendReeferCommandResultInfo';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfSendReeferCommandResultInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
