<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfServiceTimeTachoDetail ArrayType
 * @subpackage Arrays
 */
class ArrayOfServiceTimeTachoDetail extends AbstractStructArrayBase
{
    /**
     * The ServiceTimeTachoDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ServiceTimeTachoDetail[]
     */
    public $ServiceTimeTachoDetail;
    /**
     * Constructor method for ArrayOfServiceTimeTachoDetail
     * @uses ArrayOfServiceTimeTachoDetail::setServiceTimeTachoDetail()
     * @param \StructType\ServiceTimeTachoDetail[] $serviceTimeTachoDetail
     */
    public function __construct(array $serviceTimeTachoDetail = array())
    {
        $this
            ->setServiceTimeTachoDetail($serviceTimeTachoDetail);
    }
    /**
     * Get ServiceTimeTachoDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ServiceTimeTachoDetail[]|null
     */
    public function getServiceTimeTachoDetail()
    {
        return isset($this->ServiceTimeTachoDetail) ? $this->ServiceTimeTachoDetail : null;
    }
    /**
     * Set ServiceTimeTachoDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceTimeTachoDetail[] $serviceTimeTachoDetail
     * @return \ArrayType\ArrayOfServiceTimeTachoDetail
     */
    public function setServiceTimeTachoDetail(array $serviceTimeTachoDetail = array())
    {
        foreach ($serviceTimeTachoDetail as $arrayOfServiceTimeTachoDetailServiceTimeTachoDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfServiceTimeTachoDetailServiceTimeTachoDetailItem instanceof \StructType\ServiceTimeTachoDetail) {
                throw new \InvalidArgumentException(sprintf('The ServiceTimeTachoDetail property can only contain items of \StructType\ServiceTimeTachoDetail, "%s" given', is_object($arrayOfServiceTimeTachoDetailServiceTimeTachoDetailItem) ? get_class($arrayOfServiceTimeTachoDetailServiceTimeTachoDetailItem) : gettype($arrayOfServiceTimeTachoDetailServiceTimeTachoDetailItem)), __LINE__);
            }
        }
        if (is_null($serviceTimeTachoDetail) || (is_array($serviceTimeTachoDetail) && empty($serviceTimeTachoDetail))) {
            unset($this->ServiceTimeTachoDetail);
        } else {
            $this->ServiceTimeTachoDetail = $serviceTimeTachoDetail;
        }
        return $this;
    }
    /**
     * Add item to ServiceTimeTachoDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceTimeTachoDetail $item
     * @return \ArrayType\ArrayOfServiceTimeTachoDetail
     */
    public function addToServiceTimeTachoDetail(\StructType\ServiceTimeTachoDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServiceTimeTachoDetail) {
            throw new \InvalidArgumentException(sprintf('The ServiceTimeTachoDetail property can only contain items of \StructType\ServiceTimeTachoDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ServiceTimeTachoDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ServiceTimeTachoDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ServiceTimeTachoDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ServiceTimeTachoDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ServiceTimeTachoDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ServiceTimeTachoDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ServiceTimeTachoDetail
     */
    public function getAttributeName()
    {
        return 'ServiceTimeTachoDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfServiceTimeTachoDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
