<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSmsCommunicationResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfSmsCommunicationResult extends AbstractStructArrayBase
{
    /**
     * The SmsCommunicationResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SmsCommunicationResult[]
     */
    public $SmsCommunicationResult;
    /**
     * Constructor method for ArrayOfSmsCommunicationResult
     * @uses ArrayOfSmsCommunicationResult::setSmsCommunicationResult()
     * @param \StructType\SmsCommunicationResult[] $smsCommunicationResult
     */
    public function __construct(array $smsCommunicationResult = array())
    {
        $this
            ->setSmsCommunicationResult($smsCommunicationResult);
    }
    /**
     * Get SmsCommunicationResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SmsCommunicationResult[]|null
     */
    public function getSmsCommunicationResult()
    {
        return isset($this->SmsCommunicationResult) ? $this->SmsCommunicationResult : null;
    }
    /**
     * Set SmsCommunicationResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SmsCommunicationResult[] $smsCommunicationResult
     * @return \ArrayType\ArrayOfSmsCommunicationResult
     */
    public function setSmsCommunicationResult(array $smsCommunicationResult = array())
    {
        foreach ($smsCommunicationResult as $arrayOfSmsCommunicationResultSmsCommunicationResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfSmsCommunicationResultSmsCommunicationResultItem instanceof \StructType\SmsCommunicationResult) {
                throw new \InvalidArgumentException(sprintf('The SmsCommunicationResult property can only contain items of \StructType\SmsCommunicationResult, "%s" given', is_object($arrayOfSmsCommunicationResultSmsCommunicationResultItem) ? get_class($arrayOfSmsCommunicationResultSmsCommunicationResultItem) : gettype($arrayOfSmsCommunicationResultSmsCommunicationResultItem)), __LINE__);
            }
        }
        if (is_null($smsCommunicationResult) || (is_array($smsCommunicationResult) && empty($smsCommunicationResult))) {
            unset($this->SmsCommunicationResult);
        } else {
            $this->SmsCommunicationResult = $smsCommunicationResult;
        }
        return $this;
    }
    /**
     * Add item to SmsCommunicationResult value
     * @throws \InvalidArgumentException
     * @param \StructType\SmsCommunicationResult $item
     * @return \ArrayType\ArrayOfSmsCommunicationResult
     */
    public function addToSmsCommunicationResult(\StructType\SmsCommunicationResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SmsCommunicationResult) {
            throw new \InvalidArgumentException(sprintf('The SmsCommunicationResult property can only contain items of \StructType\SmsCommunicationResult, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SmsCommunicationResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SmsCommunicationResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SmsCommunicationResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SmsCommunicationResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SmsCommunicationResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SmsCommunicationResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SmsCommunicationResult
     */
    public function getAttributeName()
    {
        return 'SmsCommunicationResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfSmsCommunicationResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
