<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSubcontractedResultStrategy ArrayType
 * @subpackage Arrays
 */
class ArrayOfSubcontractedResultStrategy extends AbstractStructArrayBase
{
    /**
     * The SubcontractedResultStrategy
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SubcontractedResultStrategy[]
     */
    public $SubcontractedResultStrategy;
    /**
     * Constructor method for ArrayOfSubcontractedResultStrategy
     * @uses ArrayOfSubcontractedResultStrategy::setSubcontractedResultStrategy()
     * @param \StructType\SubcontractedResultStrategy[] $subcontractedResultStrategy
     */
    public function __construct(array $subcontractedResultStrategy = array())
    {
        $this
            ->setSubcontractedResultStrategy($subcontractedResultStrategy);
    }
    /**
     * Get SubcontractedResultStrategy value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SubcontractedResultStrategy[]|null
     */
    public function getSubcontractedResultStrategy()
    {
        return isset($this->SubcontractedResultStrategy) ? $this->SubcontractedResultStrategy : null;
    }
    /**
     * Set SubcontractedResultStrategy value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SubcontractedResultStrategy[] $subcontractedResultStrategy
     * @return \ArrayType\ArrayOfSubcontractedResultStrategy
     */
    public function setSubcontractedResultStrategy(array $subcontractedResultStrategy = array())
    {
        foreach ($subcontractedResultStrategy as $arrayOfSubcontractedResultStrategySubcontractedResultStrategyItem) {
            // validation for constraint: itemType
            if (!$arrayOfSubcontractedResultStrategySubcontractedResultStrategyItem instanceof \StructType\SubcontractedResultStrategy) {
                throw new \InvalidArgumentException(sprintf('The SubcontractedResultStrategy property can only contain items of \StructType\SubcontractedResultStrategy, "%s" given', is_object($arrayOfSubcontractedResultStrategySubcontractedResultStrategyItem) ? get_class($arrayOfSubcontractedResultStrategySubcontractedResultStrategyItem) : gettype($arrayOfSubcontractedResultStrategySubcontractedResultStrategyItem)), __LINE__);
            }
        }
        if (is_null($subcontractedResultStrategy) || (is_array($subcontractedResultStrategy) && empty($subcontractedResultStrategy))) {
            unset($this->SubcontractedResultStrategy);
        } else {
            $this->SubcontractedResultStrategy = $subcontractedResultStrategy;
        }
        return $this;
    }
    /**
     * Add item to SubcontractedResultStrategy value
     * @throws \InvalidArgumentException
     * @param \StructType\SubcontractedResultStrategy $item
     * @return \ArrayType\ArrayOfSubcontractedResultStrategy
     */
    public function addToSubcontractedResultStrategy(\StructType\SubcontractedResultStrategy $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SubcontractedResultStrategy) {
            throw new \InvalidArgumentException(sprintf('The SubcontractedResultStrategy property can only contain items of \StructType\SubcontractedResultStrategy, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SubcontractedResultStrategy[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SubcontractedResultStrategy|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SubcontractedResultStrategy|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SubcontractedResultStrategy|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SubcontractedResultStrategy|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SubcontractedResultStrategy|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SubcontractedResultStrategy
     */
    public function getAttributeName()
    {
        return 'SubcontractedResultStrategy';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfSubcontractedResultStrategy
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
