<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSummarizedTachoDataItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfSummarizedTachoDataItem extends AbstractStructArrayBase
{
    /**
     * The SummarizedTachoDataItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SummarizedTachoDataItem[]
     */
    public $SummarizedTachoDataItem;
    /**
     * Constructor method for ArrayOfSummarizedTachoDataItem
     * @uses ArrayOfSummarizedTachoDataItem::setSummarizedTachoDataItem()
     * @param \StructType\SummarizedTachoDataItem[] $summarizedTachoDataItem
     */
    public function __construct(array $summarizedTachoDataItem = array())
    {
        $this
            ->setSummarizedTachoDataItem($summarizedTachoDataItem);
    }
    /**
     * Get SummarizedTachoDataItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SummarizedTachoDataItem[]|null
     */
    public function getSummarizedTachoDataItem()
    {
        return isset($this->SummarizedTachoDataItem) ? $this->SummarizedTachoDataItem : null;
    }
    /**
     * Set SummarizedTachoDataItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SummarizedTachoDataItem[] $summarizedTachoDataItem
     * @return \ArrayType\ArrayOfSummarizedTachoDataItem
     */
    public function setSummarizedTachoDataItem(array $summarizedTachoDataItem = array())
    {
        foreach ($summarizedTachoDataItem as $arrayOfSummarizedTachoDataItemSummarizedTachoDataItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfSummarizedTachoDataItemSummarizedTachoDataItemItem instanceof \StructType\SummarizedTachoDataItem) {
                throw new \InvalidArgumentException(sprintf('The SummarizedTachoDataItem property can only contain items of \StructType\SummarizedTachoDataItem, "%s" given', is_object($arrayOfSummarizedTachoDataItemSummarizedTachoDataItemItem) ? get_class($arrayOfSummarizedTachoDataItemSummarizedTachoDataItemItem) : gettype($arrayOfSummarizedTachoDataItemSummarizedTachoDataItemItem)), __LINE__);
            }
        }
        if (is_null($summarizedTachoDataItem) || (is_array($summarizedTachoDataItem) && empty($summarizedTachoDataItem))) {
            unset($this->SummarizedTachoDataItem);
        } else {
            $this->SummarizedTachoDataItem = $summarizedTachoDataItem;
        }
        return $this;
    }
    /**
     * Add item to SummarizedTachoDataItem value
     * @throws \InvalidArgumentException
     * @param \StructType\SummarizedTachoDataItem $item
     * @return \ArrayType\ArrayOfSummarizedTachoDataItem
     */
    public function addToSummarizedTachoDataItem(\StructType\SummarizedTachoDataItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SummarizedTachoDataItem) {
            throw new \InvalidArgumentException(sprintf('The SummarizedTachoDataItem property can only contain items of \StructType\SummarizedTachoDataItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SummarizedTachoDataItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SummarizedTachoDataItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SummarizedTachoDataItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SummarizedTachoDataItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SummarizedTachoDataItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SummarizedTachoDataItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SummarizedTachoDataItem
     */
    public function getAttributeName()
    {
        return 'SummarizedTachoDataItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfSummarizedTachoDataItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
