<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTachoDataSummary ArrayType
 * @subpackage Arrays
 */
class ArrayOfTachoDataSummary extends AbstractStructArrayBase
{
    /**
     * The TachoDataSummary
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TachoDataSummary[]
     */
    public $TachoDataSummary;
    /**
     * Constructor method for ArrayOfTachoDataSummary
     * @uses ArrayOfTachoDataSummary::setTachoDataSummary()
     * @param \StructType\TachoDataSummary[] $tachoDataSummary
     */
    public function __construct(array $tachoDataSummary = array())
    {
        $this
            ->setTachoDataSummary($tachoDataSummary);
    }
    /**
     * Get TachoDataSummary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TachoDataSummary[]|null
     */
    public function getTachoDataSummary()
    {
        return isset($this->TachoDataSummary) ? $this->TachoDataSummary : null;
    }
    /**
     * Set TachoDataSummary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TachoDataSummary[] $tachoDataSummary
     * @return \ArrayType\ArrayOfTachoDataSummary
     */
    public function setTachoDataSummary(array $tachoDataSummary = array())
    {
        foreach ($tachoDataSummary as $arrayOfTachoDataSummaryTachoDataSummaryItem) {
            // validation for constraint: itemType
            if (!$arrayOfTachoDataSummaryTachoDataSummaryItem instanceof \StructType\TachoDataSummary) {
                throw new \InvalidArgumentException(sprintf('The TachoDataSummary property can only contain items of \StructType\TachoDataSummary, "%s" given', is_object($arrayOfTachoDataSummaryTachoDataSummaryItem) ? get_class($arrayOfTachoDataSummaryTachoDataSummaryItem) : gettype($arrayOfTachoDataSummaryTachoDataSummaryItem)), __LINE__);
            }
        }
        if (is_null($tachoDataSummary) || (is_array($tachoDataSummary) && empty($tachoDataSummary))) {
            unset($this->TachoDataSummary);
        } else {
            $this->TachoDataSummary = $tachoDataSummary;
        }
        return $this;
    }
    /**
     * Add item to TachoDataSummary value
     * @throws \InvalidArgumentException
     * @param \StructType\TachoDataSummary $item
     * @return \ArrayType\ArrayOfTachoDataSummary
     */
    public function addToTachoDataSummary(\StructType\TachoDataSummary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TachoDataSummary) {
            throw new \InvalidArgumentException(sprintf('The TachoDataSummary property can only contain items of \StructType\TachoDataSummary, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TachoDataSummary[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TachoDataSummary|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TachoDataSummary|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TachoDataSummary|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TachoDataSummary|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TachoDataSummary|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TachoDataSummary
     */
    public function getAttributeName()
    {
        return 'TachoDataSummary';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTachoDataSummary
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
