<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTachoEvent ArrayType
 * @subpackage Arrays
 */
class ArrayOfTachoEvent extends AbstractStructArrayBase
{
    /**
     * The TachoEvent
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TachoEvent[]
     */
    public $TachoEvent;
    /**
     * Constructor method for ArrayOfTachoEvent
     * @uses ArrayOfTachoEvent::setTachoEvent()
     * @param \StructType\TachoEvent[] $tachoEvent
     */
    public function __construct(array $tachoEvent = array())
    {
        $this
            ->setTachoEvent($tachoEvent);
    }
    /**
     * Get TachoEvent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TachoEvent[]|null
     */
    public function getTachoEvent()
    {
        return isset($this->TachoEvent) ? $this->TachoEvent : null;
    }
    /**
     * Set TachoEvent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TachoEvent[] $tachoEvent
     * @return \ArrayType\ArrayOfTachoEvent
     */
    public function setTachoEvent(array $tachoEvent = array())
    {
        foreach ($tachoEvent as $arrayOfTachoEventTachoEventItem) {
            // validation for constraint: itemType
            if (!$arrayOfTachoEventTachoEventItem instanceof \StructType\TachoEvent) {
                throw new \InvalidArgumentException(sprintf('The TachoEvent property can only contain items of \StructType\TachoEvent, "%s" given', is_object($arrayOfTachoEventTachoEventItem) ? get_class($arrayOfTachoEventTachoEventItem) : gettype($arrayOfTachoEventTachoEventItem)), __LINE__);
            }
        }
        if (is_null($tachoEvent) || (is_array($tachoEvent) && empty($tachoEvent))) {
            unset($this->TachoEvent);
        } else {
            $this->TachoEvent = $tachoEvent;
        }
        return $this;
    }
    /**
     * Add item to TachoEvent value
     * @throws \InvalidArgumentException
     * @param \StructType\TachoEvent $item
     * @return \ArrayType\ArrayOfTachoEvent
     */
    public function addToTachoEvent(\StructType\TachoEvent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TachoEvent) {
            throw new \InvalidArgumentException(sprintf('The TachoEvent property can only contain items of \StructType\TachoEvent, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TachoEvent[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TachoEvent|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TachoEvent|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TachoEvent|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TachoEvent|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TachoEvent|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TachoEvent
     */
    public function getAttributeName()
    {
        return 'TachoEvent';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTachoEvent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
