<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTemperatureMeasurement ArrayType
 * @subpackage Arrays
 */
class ArrayOfTemperatureMeasurement extends AbstractStructArrayBase
{
    /**
     * The TemperatureMeasurement
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TemperatureMeasurement[]
     */
    public $TemperatureMeasurement;
    /**
     * Constructor method for ArrayOfTemperatureMeasurement
     * @uses ArrayOfTemperatureMeasurement::setTemperatureMeasurement()
     * @param \StructType\TemperatureMeasurement[] $temperatureMeasurement
     */
    public function __construct(array $temperatureMeasurement = array())
    {
        $this
            ->setTemperatureMeasurement($temperatureMeasurement);
    }
    /**
     * Get TemperatureMeasurement value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TemperatureMeasurement[]|null
     */
    public function getTemperatureMeasurement()
    {
        return isset($this->TemperatureMeasurement) ? $this->TemperatureMeasurement : null;
    }
    /**
     * Set TemperatureMeasurement value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TemperatureMeasurement[] $temperatureMeasurement
     * @return \ArrayType\ArrayOfTemperatureMeasurement
     */
    public function setTemperatureMeasurement(array $temperatureMeasurement = array())
    {
        foreach ($temperatureMeasurement as $arrayOfTemperatureMeasurementTemperatureMeasurementItem) {
            // validation for constraint: itemType
            if (!$arrayOfTemperatureMeasurementTemperatureMeasurementItem instanceof \StructType\TemperatureMeasurement) {
                throw new \InvalidArgumentException(sprintf('The TemperatureMeasurement property can only contain items of \StructType\TemperatureMeasurement, "%s" given', is_object($arrayOfTemperatureMeasurementTemperatureMeasurementItem) ? get_class($arrayOfTemperatureMeasurementTemperatureMeasurementItem) : gettype($arrayOfTemperatureMeasurementTemperatureMeasurementItem)), __LINE__);
            }
        }
        if (is_null($temperatureMeasurement) || (is_array($temperatureMeasurement) && empty($temperatureMeasurement))) {
            unset($this->TemperatureMeasurement);
        } else {
            $this->TemperatureMeasurement = $temperatureMeasurement;
        }
        return $this;
    }
    /**
     * Add item to TemperatureMeasurement value
     * @throws \InvalidArgumentException
     * @param \StructType\TemperatureMeasurement $item
     * @return \ArrayType\ArrayOfTemperatureMeasurement
     */
    public function addToTemperatureMeasurement(\StructType\TemperatureMeasurement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TemperatureMeasurement) {
            throw new \InvalidArgumentException(sprintf('The TemperatureMeasurement property can only contain items of \StructType\TemperatureMeasurement, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TemperatureMeasurement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TemperatureMeasurement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TemperatureMeasurement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TemperatureMeasurement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TemperatureMeasurement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TemperatureMeasurement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TemperatureMeasurement
     */
    public function getAttributeName()
    {
        return 'TemperatureMeasurement';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTemperatureMeasurement
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
