<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTextMessageInbox_V4 ArrayType
 * @subpackage Arrays
 */
class ArrayOfTextMessageInbox_V4 extends AbstractStructArrayBase
{
    /**
     * The TextMessageInbox_V4
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TextMessageInbox_V4[]
     */
    public $TextMessageInbox_V4;
    /**
     * Constructor method for ArrayOfTextMessageInbox_V4
     * @uses ArrayOfTextMessageInbox_V4::setTextMessageInbox_V4()
     * @param \StructType\TextMessageInbox_V4[] $textMessageInbox_V4
     */
    public function __construct(array $textMessageInbox_V4 = array())
    {
        $this
            ->setTextMessageInbox_V4($textMessageInbox_V4);
    }
    /**
     * Get TextMessageInbox_V4 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TextMessageInbox_V4[]|null
     */
    public function getTextMessageInbox_V4()
    {
        return isset($this->TextMessageInbox_V4) ? $this->TextMessageInbox_V4 : null;
    }
    /**
     * Set TextMessageInbox_V4 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TextMessageInbox_V4[] $textMessageInbox_V4
     * @return \ArrayType\ArrayOfTextMessageInbox_V4
     */
    public function setTextMessageInbox_V4(array $textMessageInbox_V4 = array())
    {
        foreach ($textMessageInbox_V4 as $arrayOfTextMessageInbox_V4TextMessageInbox_V4Item) {
            // validation for constraint: itemType
            if (!$arrayOfTextMessageInbox_V4TextMessageInbox_V4Item instanceof \StructType\TextMessageInbox_V4) {
                throw new \InvalidArgumentException(sprintf('The TextMessageInbox_V4 property can only contain items of \StructType\TextMessageInbox_V4, "%s" given', is_object($arrayOfTextMessageInbox_V4TextMessageInbox_V4Item) ? get_class($arrayOfTextMessageInbox_V4TextMessageInbox_V4Item) : gettype($arrayOfTextMessageInbox_V4TextMessageInbox_V4Item)), __LINE__);
            }
        }
        if (is_null($textMessageInbox_V4) || (is_array($textMessageInbox_V4) && empty($textMessageInbox_V4))) {
            unset($this->TextMessageInbox_V4);
        } else {
            $this->TextMessageInbox_V4 = $textMessageInbox_V4;
        }
        return $this;
    }
    /**
     * Add item to TextMessageInbox_V4 value
     * @throws \InvalidArgumentException
     * @param \StructType\TextMessageInbox_V4 $item
     * @return \ArrayType\ArrayOfTextMessageInbox_V4
     */
    public function addToTextMessageInbox_V4(\StructType\TextMessageInbox_V4 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TextMessageInbox_V4) {
            throw new \InvalidArgumentException(sprintf('The TextMessageInbox_V4 property can only contain items of \StructType\TextMessageInbox_V4, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TextMessageInbox_V4[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TextMessageInbox_V4|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TextMessageInbox_V4|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TextMessageInbox_V4|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TextMessageInbox_V4|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TextMessageInbox_V4|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TextMessageInbox_V4
     */
    public function getAttributeName()
    {
        return 'TextMessageInbox_V4';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTextMessageInbox_V4
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
