<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTextMessageInbox_V6 ArrayType
 * @subpackage Arrays
 */
class ArrayOfTextMessageInbox_V6 extends AbstractStructArrayBase
{
    /**
     * The TextMessageInbox_V6
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TextMessageInbox_V6[]
     */
    public $TextMessageInbox_V6;
    /**
     * Constructor method for ArrayOfTextMessageInbox_V6
     * @uses ArrayOfTextMessageInbox_V6::setTextMessageInbox_V6()
     * @param \StructType\TextMessageInbox_V6[] $textMessageInbox_V6
     */
    public function __construct(array $textMessageInbox_V6 = array())
    {
        $this
            ->setTextMessageInbox_V6($textMessageInbox_V6);
    }
    /**
     * Get TextMessageInbox_V6 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TextMessageInbox_V6[]|null
     */
    public function getTextMessageInbox_V6()
    {
        return isset($this->TextMessageInbox_V6) ? $this->TextMessageInbox_V6 : null;
    }
    /**
     * Set TextMessageInbox_V6 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TextMessageInbox_V6[] $textMessageInbox_V6
     * @return \ArrayType\ArrayOfTextMessageInbox_V6
     */
    public function setTextMessageInbox_V6(array $textMessageInbox_V6 = array())
    {
        foreach ($textMessageInbox_V6 as $arrayOfTextMessageInbox_V6TextMessageInbox_V6Item) {
            // validation for constraint: itemType
            if (!$arrayOfTextMessageInbox_V6TextMessageInbox_V6Item instanceof \StructType\TextMessageInbox_V6) {
                throw new \InvalidArgumentException(sprintf('The TextMessageInbox_V6 property can only contain items of \StructType\TextMessageInbox_V6, "%s" given', is_object($arrayOfTextMessageInbox_V6TextMessageInbox_V6Item) ? get_class($arrayOfTextMessageInbox_V6TextMessageInbox_V6Item) : gettype($arrayOfTextMessageInbox_V6TextMessageInbox_V6Item)), __LINE__);
            }
        }
        if (is_null($textMessageInbox_V6) || (is_array($textMessageInbox_V6) && empty($textMessageInbox_V6))) {
            unset($this->TextMessageInbox_V6);
        } else {
            $this->TextMessageInbox_V6 = $textMessageInbox_V6;
        }
        return $this;
    }
    /**
     * Add item to TextMessageInbox_V6 value
     * @throws \InvalidArgumentException
     * @param \StructType\TextMessageInbox_V6 $item
     * @return \ArrayType\ArrayOfTextMessageInbox_V6
     */
    public function addToTextMessageInbox_V6(\StructType\TextMessageInbox_V6 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TextMessageInbox_V6) {
            throw new \InvalidArgumentException(sprintf('The TextMessageInbox_V6 property can only contain items of \StructType\TextMessageInbox_V6, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TextMessageInbox_V6[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TextMessageInbox_V6|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TextMessageInbox_V6|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TextMessageInbox_V6|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TextMessageInbox_V6|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TextMessageInbox_V6|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TextMessageInbox_V6
     */
    public function getAttributeName()
    {
        return 'TextMessageInbox_V6';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTextMessageInbox_V6
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
