<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTextMessageOutbox ArrayType
 * @subpackage Arrays
 */
class ArrayOfTextMessageOutbox extends AbstractStructArrayBase
{
    /**
     * The TextMessageOutbox
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TextMessageOutbox[]
     */
    public $TextMessageOutbox;
    /**
     * Constructor method for ArrayOfTextMessageOutbox
     * @uses ArrayOfTextMessageOutbox::setTextMessageOutbox()
     * @param \StructType\TextMessageOutbox[] $textMessageOutbox
     */
    public function __construct(array $textMessageOutbox = array())
    {
        $this
            ->setTextMessageOutbox($textMessageOutbox);
    }
    /**
     * Get TextMessageOutbox value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TextMessageOutbox[]|null
     */
    public function getTextMessageOutbox()
    {
        return isset($this->TextMessageOutbox) ? $this->TextMessageOutbox : null;
    }
    /**
     * Set TextMessageOutbox value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TextMessageOutbox[] $textMessageOutbox
     * @return \ArrayType\ArrayOfTextMessageOutbox
     */
    public function setTextMessageOutbox(array $textMessageOutbox = array())
    {
        foreach ($textMessageOutbox as $arrayOfTextMessageOutboxTextMessageOutboxItem) {
            // validation for constraint: itemType
            if (!$arrayOfTextMessageOutboxTextMessageOutboxItem instanceof \StructType\TextMessageOutbox) {
                throw new \InvalidArgumentException(sprintf('The TextMessageOutbox property can only contain items of \StructType\TextMessageOutbox, "%s" given', is_object($arrayOfTextMessageOutboxTextMessageOutboxItem) ? get_class($arrayOfTextMessageOutboxTextMessageOutboxItem) : gettype($arrayOfTextMessageOutboxTextMessageOutboxItem)), __LINE__);
            }
        }
        if (is_null($textMessageOutbox) || (is_array($textMessageOutbox) && empty($textMessageOutbox))) {
            unset($this->TextMessageOutbox);
        } else {
            $this->TextMessageOutbox = $textMessageOutbox;
        }
        return $this;
    }
    /**
     * Add item to TextMessageOutbox value
     * @throws \InvalidArgumentException
     * @param \StructType\TextMessageOutbox $item
     * @return \ArrayType\ArrayOfTextMessageOutbox
     */
    public function addToTextMessageOutbox(\StructType\TextMessageOutbox $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TextMessageOutbox) {
            throw new \InvalidArgumentException(sprintf('The TextMessageOutbox property can only contain items of \StructType\TextMessageOutbox, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TextMessageOutbox[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TextMessageOutbox|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TextMessageOutbox|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TextMessageOutbox|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TextMessageOutbox|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TextMessageOutbox|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TextMessageOutbox
     */
    public function getAttributeName()
    {
        return 'TextMessageOutbox';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTextMessageOutbox
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
