<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTracerDistanceReportItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfTracerDistanceReportItem extends AbstractStructArrayBase
{
    /**
     * The TracerDistanceReportItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TracerDistanceReportItem[]
     */
    public $TracerDistanceReportItem;
    /**
     * Constructor method for ArrayOfTracerDistanceReportItem
     * @uses ArrayOfTracerDistanceReportItem::setTracerDistanceReportItem()
     * @param \StructType\TracerDistanceReportItem[] $tracerDistanceReportItem
     */
    public function __construct(array $tracerDistanceReportItem = array())
    {
        $this
            ->setTracerDistanceReportItem($tracerDistanceReportItem);
    }
    /**
     * Get TracerDistanceReportItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TracerDistanceReportItem[]|null
     */
    public function getTracerDistanceReportItem()
    {
        return isset($this->TracerDistanceReportItem) ? $this->TracerDistanceReportItem : null;
    }
    /**
     * Set TracerDistanceReportItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TracerDistanceReportItem[] $tracerDistanceReportItem
     * @return \ArrayType\ArrayOfTracerDistanceReportItem
     */
    public function setTracerDistanceReportItem(array $tracerDistanceReportItem = array())
    {
        foreach ($tracerDistanceReportItem as $arrayOfTracerDistanceReportItemTracerDistanceReportItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfTracerDistanceReportItemTracerDistanceReportItemItem instanceof \StructType\TracerDistanceReportItem) {
                throw new \InvalidArgumentException(sprintf('The TracerDistanceReportItem property can only contain items of \StructType\TracerDistanceReportItem, "%s" given', is_object($arrayOfTracerDistanceReportItemTracerDistanceReportItemItem) ? get_class($arrayOfTracerDistanceReportItemTracerDistanceReportItemItem) : gettype($arrayOfTracerDistanceReportItemTracerDistanceReportItemItem)), __LINE__);
            }
        }
        if (is_null($tracerDistanceReportItem) || (is_array($tracerDistanceReportItem) && empty($tracerDistanceReportItem))) {
            unset($this->TracerDistanceReportItem);
        } else {
            $this->TracerDistanceReportItem = $tracerDistanceReportItem;
        }
        return $this;
    }
    /**
     * Add item to TracerDistanceReportItem value
     * @throws \InvalidArgumentException
     * @param \StructType\TracerDistanceReportItem $item
     * @return \ArrayType\ArrayOfTracerDistanceReportItem
     */
    public function addToTracerDistanceReportItem(\StructType\TracerDistanceReportItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TracerDistanceReportItem) {
            throw new \InvalidArgumentException(sprintf('The TracerDistanceReportItem property can only contain items of \StructType\TracerDistanceReportItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TracerDistanceReportItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TracerDistanceReportItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TracerDistanceReportItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TracerDistanceReportItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TracerDistanceReportItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TracerDistanceReportItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TracerDistanceReportItem
     */
    public function getAttributeName()
    {
        return 'TracerDistanceReportItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTracerDistanceReportItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
