<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTrackedVehicle ArrayType
 * @subpackage Arrays
 */
class ArrayOfTrackedVehicle extends AbstractStructArrayBase
{
    /**
     * The TrackedVehicle
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TrackedVehicle[]
     */
    public $TrackedVehicle;
    /**
     * Constructor method for ArrayOfTrackedVehicle
     * @uses ArrayOfTrackedVehicle::setTrackedVehicle()
     * @param \StructType\TrackedVehicle[] $trackedVehicle
     */
    public function __construct(array $trackedVehicle = array())
    {
        $this
            ->setTrackedVehicle($trackedVehicle);
    }
    /**
     * Get TrackedVehicle value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TrackedVehicle[]|null
     */
    public function getTrackedVehicle()
    {
        return isset($this->TrackedVehicle) ? $this->TrackedVehicle : null;
    }
    /**
     * Set TrackedVehicle value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TrackedVehicle[] $trackedVehicle
     * @return \ArrayType\ArrayOfTrackedVehicle
     */
    public function setTrackedVehicle(array $trackedVehicle = array())
    {
        foreach ($trackedVehicle as $arrayOfTrackedVehicleTrackedVehicleItem) {
            // validation for constraint: itemType
            if (!$arrayOfTrackedVehicleTrackedVehicleItem instanceof \StructType\TrackedVehicle) {
                throw new \InvalidArgumentException(sprintf('The TrackedVehicle property can only contain items of \StructType\TrackedVehicle, "%s" given', is_object($arrayOfTrackedVehicleTrackedVehicleItem) ? get_class($arrayOfTrackedVehicleTrackedVehicleItem) : gettype($arrayOfTrackedVehicleTrackedVehicleItem)), __LINE__);
            }
        }
        if (is_null($trackedVehicle) || (is_array($trackedVehicle) && empty($trackedVehicle))) {
            unset($this->TrackedVehicle);
        } else {
            $this->TrackedVehicle = $trackedVehicle;
        }
        return $this;
    }
    /**
     * Add item to TrackedVehicle value
     * @throws \InvalidArgumentException
     * @param \StructType\TrackedVehicle $item
     * @return \ArrayType\ArrayOfTrackedVehicle
     */
    public function addToTrackedVehicle(\StructType\TrackedVehicle $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TrackedVehicle) {
            throw new \InvalidArgumentException(sprintf('The TrackedVehicle property can only contain items of \StructType\TrackedVehicle, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TrackedVehicle[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TrackedVehicle|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TrackedVehicle|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TrackedVehicle|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TrackedVehicle|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TrackedVehicle|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TrackedVehicle
     */
    public function getAttributeName()
    {
        return 'TrackedVehicle';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTrackedVehicle
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
