<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTrailerResult_V5 ArrayType
 * @subpackage Arrays
 */
class ArrayOfTrailerResult_V5 extends AbstractStructArrayBase
{
    /**
     * The TrailerResult_V5
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TrailerResult_V5[]
     */
    public $TrailerResult_V5;
    /**
     * Constructor method for ArrayOfTrailerResult_V5
     * @uses ArrayOfTrailerResult_V5::setTrailerResult_V5()
     * @param \StructType\TrailerResult_V5[] $trailerResult_V5
     */
    public function __construct(array $trailerResult_V5 = array())
    {
        $this
            ->setTrailerResult_V5($trailerResult_V5);
    }
    /**
     * Get TrailerResult_V5 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TrailerResult_V5[]|null
     */
    public function getTrailerResult_V5()
    {
        return isset($this->TrailerResult_V5) ? $this->TrailerResult_V5 : null;
    }
    /**
     * Set TrailerResult_V5 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TrailerResult_V5[] $trailerResult_V5
     * @return \ArrayType\ArrayOfTrailerResult_V5
     */
    public function setTrailerResult_V5(array $trailerResult_V5 = array())
    {
        foreach ($trailerResult_V5 as $arrayOfTrailerResult_V5TrailerResult_V5Item) {
            // validation for constraint: itemType
            if (!$arrayOfTrailerResult_V5TrailerResult_V5Item instanceof \StructType\TrailerResult_V5) {
                throw new \InvalidArgumentException(sprintf('The TrailerResult_V5 property can only contain items of \StructType\TrailerResult_V5, "%s" given', is_object($arrayOfTrailerResult_V5TrailerResult_V5Item) ? get_class($arrayOfTrailerResult_V5TrailerResult_V5Item) : gettype($arrayOfTrailerResult_V5TrailerResult_V5Item)), __LINE__);
            }
        }
        if (is_null($trailerResult_V5) || (is_array($trailerResult_V5) && empty($trailerResult_V5))) {
            unset($this->TrailerResult_V5);
        } else {
            $this->TrailerResult_V5 = $trailerResult_V5;
        }
        return $this;
    }
    /**
     * Add item to TrailerResult_V5 value
     * @throws \InvalidArgumentException
     * @param \StructType\TrailerResult_V5 $item
     * @return \ArrayType\ArrayOfTrailerResult_V5
     */
    public function addToTrailerResult_V5(\StructType\TrailerResult_V5 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TrailerResult_V5) {
            throw new \InvalidArgumentException(sprintf('The TrailerResult_V5 property can only contain items of \StructType\TrailerResult_V5, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TrailerResult_V5[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TrailerResult_V5|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TrailerResult_V5|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TrailerResult_V5|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TrailerResult_V5|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TrailerResult_V5|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TrailerResult_V5
     */
    public function getAttributeName()
    {
        return 'TrailerResult_V5';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTrailerResult_V5
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
