<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripInsert ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripInsert extends AbstractStructArrayBase
{
    /**
     * The TripInsert
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripInsert[]
     */
    public $TripInsert;
    /**
     * Constructor method for ArrayOfTripInsert
     * @uses ArrayOfTripInsert::setTripInsert()
     * @param \StructType\TripInsert[] $tripInsert
     */
    public function __construct(array $tripInsert = array())
    {
        $this
            ->setTripInsert($tripInsert);
    }
    /**
     * Get TripInsert value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripInsert[]|null
     */
    public function getTripInsert()
    {
        return isset($this->TripInsert) ? $this->TripInsert : null;
    }
    /**
     * Set TripInsert value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripInsert[] $tripInsert
     * @return \ArrayType\ArrayOfTripInsert
     */
    public function setTripInsert(array $tripInsert = array())
    {
        foreach ($tripInsert as $arrayOfTripInsertTripInsertItem) {
            // validation for constraint: itemType
            if (!$arrayOfTripInsertTripInsertItem instanceof \StructType\TripInsert) {
                throw new \InvalidArgumentException(sprintf('The TripInsert property can only contain items of \StructType\TripInsert, "%s" given', is_object($arrayOfTripInsertTripInsertItem) ? get_class($arrayOfTripInsertTripInsertItem) : gettype($arrayOfTripInsertTripInsertItem)), __LINE__);
            }
        }
        if (is_null($tripInsert) || (is_array($tripInsert) && empty($tripInsert))) {
            unset($this->TripInsert);
        } else {
            $this->TripInsert = $tripInsert;
        }
        return $this;
    }
    /**
     * Add item to TripInsert value
     * @throws \InvalidArgumentException
     * @param \StructType\TripInsert $item
     * @return \ArrayType\ArrayOfTripInsert
     */
    public function addToTripInsert(\StructType\TripInsert $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripInsert) {
            throw new \InvalidArgumentException(sprintf('The TripInsert property can only contain items of \StructType\TripInsert, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TripInsert[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripInsert|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripInsert|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripInsert|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripInsert|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripInsert|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripInsert
     */
    public function getAttributeName()
    {
        return 'TripInsert';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTripInsert
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
