<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripItemResult_V7 ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripItemResult_V7 extends AbstractStructArrayBase
{
    /**
     * The TripItemResult_V7
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripItemResult_V7[]
     */
    public $TripItemResult_V7;
    /**
     * Constructor method for ArrayOfTripItemResult_V7
     * @uses ArrayOfTripItemResult_V7::setTripItemResult_V7()
     * @param \StructType\TripItemResult_V7[] $tripItemResult_V7
     */
    public function __construct(array $tripItemResult_V7 = array())
    {
        $this
            ->setTripItemResult_V7($tripItemResult_V7);
    }
    /**
     * Get TripItemResult_V7 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripItemResult_V7[]|null
     */
    public function getTripItemResult_V7()
    {
        return isset($this->TripItemResult_V7) ? $this->TripItemResult_V7 : null;
    }
    /**
     * Set TripItemResult_V7 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripItemResult_V7[] $tripItemResult_V7
     * @return \ArrayType\ArrayOfTripItemResult_V7
     */
    public function setTripItemResult_V7(array $tripItemResult_V7 = array())
    {
        foreach ($tripItemResult_V7 as $arrayOfTripItemResult_V7TripItemResult_V7Item) {
            // validation for constraint: itemType
            if (!$arrayOfTripItemResult_V7TripItemResult_V7Item instanceof \StructType\TripItemResult_V7) {
                throw new \InvalidArgumentException(sprintf('The TripItemResult_V7 property can only contain items of \StructType\TripItemResult_V7, "%s" given', is_object($arrayOfTripItemResult_V7TripItemResult_V7Item) ? get_class($arrayOfTripItemResult_V7TripItemResult_V7Item) : gettype($arrayOfTripItemResult_V7TripItemResult_V7Item)), __LINE__);
            }
        }
        if (is_null($tripItemResult_V7) || (is_array($tripItemResult_V7) && empty($tripItemResult_V7))) {
            unset($this->TripItemResult_V7);
        } else {
            $this->TripItemResult_V7 = $tripItemResult_V7;
        }
        return $this;
    }
    /**
     * Add item to TripItemResult_V7 value
     * @throws \InvalidArgumentException
     * @param \StructType\TripItemResult_V7 $item
     * @return \ArrayType\ArrayOfTripItemResult_V7
     */
    public function addToTripItemResult_V7(\StructType\TripItemResult_V7 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripItemResult_V7) {
            throw new \InvalidArgumentException(sprintf('The TripItemResult_V7 property can only contain items of \StructType\TripItemResult_V7, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TripItemResult_V7[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripItemResult_V7|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripItemResult_V7|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripItemResult_V7|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripItemResult_V7|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripItemResult_V7|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripItemResult_V7
     */
    public function getAttributeName()
    {
        return 'TripItemResult_V7';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTripItemResult_V7
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
