<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripItemResult_v3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripItemResult_v3 extends AbstractStructArrayBase
{
    /**
     * The TripItemResult_v3
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripItemResult_v3[]
     */
    public $TripItemResult_v3;
    /**
     * Constructor method for ArrayOfTripItemResult_v3
     * @uses ArrayOfTripItemResult_v3::setTripItemResult_v3()
     * @param \StructType\TripItemResult_v3[] $tripItemResult_v3
     */
    public function __construct(array $tripItemResult_v3 = array())
    {
        $this
            ->setTripItemResult_v3($tripItemResult_v3);
    }
    /**
     * Get TripItemResult_v3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripItemResult_v3[]|null
     */
    public function getTripItemResult_v3()
    {
        return isset($this->TripItemResult_v3) ? $this->TripItemResult_v3 : null;
    }
    /**
     * Set TripItemResult_v3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripItemResult_v3[] $tripItemResult_v3
     * @return \ArrayType\ArrayOfTripItemResult_v3
     */
    public function setTripItemResult_v3(array $tripItemResult_v3 = array())
    {
        foreach ($tripItemResult_v3 as $arrayOfTripItemResult_v3TripItemResult_v3Item) {
            // validation for constraint: itemType
            if (!$arrayOfTripItemResult_v3TripItemResult_v3Item instanceof \StructType\TripItemResult_v3) {
                throw new \InvalidArgumentException(sprintf('The TripItemResult_v3 property can only contain items of \StructType\TripItemResult_v3, "%s" given', is_object($arrayOfTripItemResult_v3TripItemResult_v3Item) ? get_class($arrayOfTripItemResult_v3TripItemResult_v3Item) : gettype($arrayOfTripItemResult_v3TripItemResult_v3Item)), __LINE__);
            }
        }
        if (is_null($tripItemResult_v3) || (is_array($tripItemResult_v3) && empty($tripItemResult_v3))) {
            unset($this->TripItemResult_v3);
        } else {
            $this->TripItemResult_v3 = $tripItemResult_v3;
        }
        return $this;
    }
    /**
     * Add item to TripItemResult_v3 value
     * @throws \InvalidArgumentException
     * @param \StructType\TripItemResult_v3 $item
     * @return \ArrayType\ArrayOfTripItemResult_v3
     */
    public function addToTripItemResult_v3(\StructType\TripItemResult_v3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripItemResult_v3) {
            throw new \InvalidArgumentException(sprintf('The TripItemResult_v3 property can only contain items of \StructType\TripItemResult_v3, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TripItemResult_v3[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripItemResult_v3|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripItemResult_v3|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripItemResult_v3|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripItemResult_v3|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripItemResult_v3|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripItemResult_v3
     */
    public function getAttributeName()
    {
        return 'TripItemResult_v3';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTripItemResult_v3
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
