<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripReportActivitySummary ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripReportActivitySummary extends AbstractStructArrayBase
{
    /**
     * The TripReportActivitySummary
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripReportActivitySummary[]
     */
    public $TripReportActivitySummary;
    /**
     * Constructor method for ArrayOfTripReportActivitySummary
     * @uses ArrayOfTripReportActivitySummary::setTripReportActivitySummary()
     * @param \StructType\TripReportActivitySummary[] $tripReportActivitySummary
     */
    public function __construct(array $tripReportActivitySummary = array())
    {
        $this
            ->setTripReportActivitySummary($tripReportActivitySummary);
    }
    /**
     * Get TripReportActivitySummary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripReportActivitySummary[]|null
     */
    public function getTripReportActivitySummary()
    {
        return isset($this->TripReportActivitySummary) ? $this->TripReportActivitySummary : null;
    }
    /**
     * Set TripReportActivitySummary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripReportActivitySummary[] $tripReportActivitySummary
     * @return \ArrayType\ArrayOfTripReportActivitySummary
     */
    public function setTripReportActivitySummary(array $tripReportActivitySummary = array())
    {
        foreach ($tripReportActivitySummary as $arrayOfTripReportActivitySummaryTripReportActivitySummaryItem) {
            // validation for constraint: itemType
            if (!$arrayOfTripReportActivitySummaryTripReportActivitySummaryItem instanceof \StructType\TripReportActivitySummary) {
                throw new \InvalidArgumentException(sprintf('The TripReportActivitySummary property can only contain items of \StructType\TripReportActivitySummary, "%s" given', is_object($arrayOfTripReportActivitySummaryTripReportActivitySummaryItem) ? get_class($arrayOfTripReportActivitySummaryTripReportActivitySummaryItem) : gettype($arrayOfTripReportActivitySummaryTripReportActivitySummaryItem)), __LINE__);
            }
        }
        if (is_null($tripReportActivitySummary) || (is_array($tripReportActivitySummary) && empty($tripReportActivitySummary))) {
            unset($this->TripReportActivitySummary);
        } else {
            $this->TripReportActivitySummary = $tripReportActivitySummary;
        }
        return $this;
    }
    /**
     * Add item to TripReportActivitySummary value
     * @throws \InvalidArgumentException
     * @param \StructType\TripReportActivitySummary $item
     * @return \ArrayType\ArrayOfTripReportActivitySummary
     */
    public function addToTripReportActivitySummary(\StructType\TripReportActivitySummary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripReportActivitySummary) {
            throw new \InvalidArgumentException(sprintf('The TripReportActivitySummary property can only contain items of \StructType\TripReportActivitySummary, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TripReportActivitySummary[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripReportActivitySummary|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripReportActivitySummary|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripReportActivitySummary|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripReportActivitySummary|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripReportActivitySummary|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripReportActivitySummary
     */
    public function getAttributeName()
    {
        return 'TripReportActivitySummary';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTripReportActivitySummary
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
