<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripReportSummaryResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripReportSummaryResult extends AbstractStructArrayBase
{
    /**
     * The TripReportSummaryResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripReportSummaryResult[]
     */
    public $TripReportSummaryResult;
    /**
     * Constructor method for ArrayOfTripReportSummaryResult
     * @uses ArrayOfTripReportSummaryResult::setTripReportSummaryResult()
     * @param \StructType\TripReportSummaryResult[] $tripReportSummaryResult
     */
    public function __construct(array $tripReportSummaryResult = array())
    {
        $this
            ->setTripReportSummaryResult($tripReportSummaryResult);
    }
    /**
     * Get TripReportSummaryResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripReportSummaryResult[]|null
     */
    public function getTripReportSummaryResult()
    {
        return isset($this->TripReportSummaryResult) ? $this->TripReportSummaryResult : null;
    }
    /**
     * Set TripReportSummaryResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripReportSummaryResult[] $tripReportSummaryResult
     * @return \ArrayType\ArrayOfTripReportSummaryResult
     */
    public function setTripReportSummaryResult(array $tripReportSummaryResult = array())
    {
        foreach ($tripReportSummaryResult as $arrayOfTripReportSummaryResultTripReportSummaryResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfTripReportSummaryResultTripReportSummaryResultItem instanceof \StructType\TripReportSummaryResult) {
                throw new \InvalidArgumentException(sprintf('The TripReportSummaryResult property can only contain items of \StructType\TripReportSummaryResult, "%s" given', is_object($arrayOfTripReportSummaryResultTripReportSummaryResultItem) ? get_class($arrayOfTripReportSummaryResultTripReportSummaryResultItem) : gettype($arrayOfTripReportSummaryResultTripReportSummaryResultItem)), __LINE__);
            }
        }
        if (is_null($tripReportSummaryResult) || (is_array($tripReportSummaryResult) && empty($tripReportSummaryResult))) {
            unset($this->TripReportSummaryResult);
        } else {
            $this->TripReportSummaryResult = $tripReportSummaryResult;
        }
        return $this;
    }
    /**
     * Add item to TripReportSummaryResult value
     * @throws \InvalidArgumentException
     * @param \StructType\TripReportSummaryResult $item
     * @return \ArrayType\ArrayOfTripReportSummaryResult
     */
    public function addToTripReportSummaryResult(\StructType\TripReportSummaryResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripReportSummaryResult) {
            throw new \InvalidArgumentException(sprintf('The TripReportSummaryResult property can only contain items of \StructType\TripReportSummaryResult, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TripReportSummaryResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripReportSummaryResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripReportSummaryResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripReportSummaryResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripReportSummaryResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripReportSummaryResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripReportSummaryResult
     */
    public function getAttributeName()
    {
        return 'TripReportSummaryResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTripReportSummaryResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
