<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripReportTachoSummary ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripReportTachoSummary extends AbstractStructArrayBase
{
    /**
     * The TripReportTachoSummary
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripReportTachoSummary[]
     */
    public $TripReportTachoSummary;
    /**
     * Constructor method for ArrayOfTripReportTachoSummary
     * @uses ArrayOfTripReportTachoSummary::setTripReportTachoSummary()
     * @param \StructType\TripReportTachoSummary[] $tripReportTachoSummary
     */
    public function __construct(array $tripReportTachoSummary = array())
    {
        $this
            ->setTripReportTachoSummary($tripReportTachoSummary);
    }
    /**
     * Get TripReportTachoSummary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripReportTachoSummary[]|null
     */
    public function getTripReportTachoSummary()
    {
        return isset($this->TripReportTachoSummary) ? $this->TripReportTachoSummary : null;
    }
    /**
     * Set TripReportTachoSummary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripReportTachoSummary[] $tripReportTachoSummary
     * @return \ArrayType\ArrayOfTripReportTachoSummary
     */
    public function setTripReportTachoSummary(array $tripReportTachoSummary = array())
    {
        foreach ($tripReportTachoSummary as $arrayOfTripReportTachoSummaryTripReportTachoSummaryItem) {
            // validation for constraint: itemType
            if (!$arrayOfTripReportTachoSummaryTripReportTachoSummaryItem instanceof \StructType\TripReportTachoSummary) {
                throw new \InvalidArgumentException(sprintf('The TripReportTachoSummary property can only contain items of \StructType\TripReportTachoSummary, "%s" given', is_object($arrayOfTripReportTachoSummaryTripReportTachoSummaryItem) ? get_class($arrayOfTripReportTachoSummaryTripReportTachoSummaryItem) : gettype($arrayOfTripReportTachoSummaryTripReportTachoSummaryItem)), __LINE__);
            }
        }
        if (is_null($tripReportTachoSummary) || (is_array($tripReportTachoSummary) && empty($tripReportTachoSummary))) {
            unset($this->TripReportTachoSummary);
        } else {
            $this->TripReportTachoSummary = $tripReportTachoSummary;
        }
        return $this;
    }
    /**
     * Add item to TripReportTachoSummary value
     * @throws \InvalidArgumentException
     * @param \StructType\TripReportTachoSummary $item
     * @return \ArrayType\ArrayOfTripReportTachoSummary
     */
    public function addToTripReportTachoSummary(\StructType\TripReportTachoSummary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripReportTachoSummary) {
            throw new \InvalidArgumentException(sprintf('The TripReportTachoSummary property can only contain items of \StructType\TripReportTachoSummary, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TripReportTachoSummary[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripReportTachoSummary|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripReportTachoSummary|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripReportTachoSummary|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripReportTachoSummary|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripReportTachoSummary|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripReportTachoSummary
     */
    public function getAttributeName()
    {
        return 'TripReportTachoSummary';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTripReportTachoSummary
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
