<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripReportTrailerSummary ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripReportTrailerSummary extends AbstractStructArrayBase
{
    /**
     * The TripReportTrailerSummary
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripReportTrailerSummary[]
     */
    public $TripReportTrailerSummary;
    /**
     * Constructor method for ArrayOfTripReportTrailerSummary
     * @uses ArrayOfTripReportTrailerSummary::setTripReportTrailerSummary()
     * @param \StructType\TripReportTrailerSummary[] $tripReportTrailerSummary
     */
    public function __construct(array $tripReportTrailerSummary = array())
    {
        $this
            ->setTripReportTrailerSummary($tripReportTrailerSummary);
    }
    /**
     * Get TripReportTrailerSummary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripReportTrailerSummary[]|null
     */
    public function getTripReportTrailerSummary()
    {
        return isset($this->TripReportTrailerSummary) ? $this->TripReportTrailerSummary : null;
    }
    /**
     * Set TripReportTrailerSummary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripReportTrailerSummary[] $tripReportTrailerSummary
     * @return \ArrayType\ArrayOfTripReportTrailerSummary
     */
    public function setTripReportTrailerSummary(array $tripReportTrailerSummary = array())
    {
        foreach ($tripReportTrailerSummary as $arrayOfTripReportTrailerSummaryTripReportTrailerSummaryItem) {
            // validation for constraint: itemType
            if (!$arrayOfTripReportTrailerSummaryTripReportTrailerSummaryItem instanceof \StructType\TripReportTrailerSummary) {
                throw new \InvalidArgumentException(sprintf('The TripReportTrailerSummary property can only contain items of \StructType\TripReportTrailerSummary, "%s" given', is_object($arrayOfTripReportTrailerSummaryTripReportTrailerSummaryItem) ? get_class($arrayOfTripReportTrailerSummaryTripReportTrailerSummaryItem) : gettype($arrayOfTripReportTrailerSummaryTripReportTrailerSummaryItem)), __LINE__);
            }
        }
        if (is_null($tripReportTrailerSummary) || (is_array($tripReportTrailerSummary) && empty($tripReportTrailerSummary))) {
            unset($this->TripReportTrailerSummary);
        } else {
            $this->TripReportTrailerSummary = $tripReportTrailerSummary;
        }
        return $this;
    }
    /**
     * Add item to TripReportTrailerSummary value
     * @throws \InvalidArgumentException
     * @param \StructType\TripReportTrailerSummary $item
     * @return \ArrayType\ArrayOfTripReportTrailerSummary
     */
    public function addToTripReportTrailerSummary(\StructType\TripReportTrailerSummary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripReportTrailerSummary) {
            throw new \InvalidArgumentException(sprintf('The TripReportTrailerSummary property can only contain items of \StructType\TripReportTrailerSummary, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TripReportTrailerSummary[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripReportTrailerSummary|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripReportTrailerSummary|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripReportTrailerSummary|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripReportTrailerSummary|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripReportTrailerSummary|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripReportTrailerSummary
     */
    public function getAttributeName()
    {
        return 'TripReportTrailerSummary';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTripReportTrailerSummary
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
