<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripResultInsert ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripResultInsert extends AbstractStructArrayBase
{
    /**
     * The TripResultInsert
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripResultInsert[]
     */
    public $TripResultInsert;
    /**
     * Constructor method for ArrayOfTripResultInsert
     * @uses ArrayOfTripResultInsert::setTripResultInsert()
     * @param \StructType\TripResultInsert[] $tripResultInsert
     */
    public function __construct(array $tripResultInsert = array())
    {
        $this
            ->setTripResultInsert($tripResultInsert);
    }
    /**
     * Get TripResultInsert value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripResultInsert[]|null
     */
    public function getTripResultInsert()
    {
        return isset($this->TripResultInsert) ? $this->TripResultInsert : null;
    }
    /**
     * Set TripResultInsert value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripResultInsert[] $tripResultInsert
     * @return \ArrayType\ArrayOfTripResultInsert
     */
    public function setTripResultInsert(array $tripResultInsert = array())
    {
        foreach ($tripResultInsert as $arrayOfTripResultInsertTripResultInsertItem) {
            // validation for constraint: itemType
            if (!$arrayOfTripResultInsertTripResultInsertItem instanceof \StructType\TripResultInsert) {
                throw new \InvalidArgumentException(sprintf('The TripResultInsert property can only contain items of \StructType\TripResultInsert, "%s" given', is_object($arrayOfTripResultInsertTripResultInsertItem) ? get_class($arrayOfTripResultInsertTripResultInsertItem) : gettype($arrayOfTripResultInsertTripResultInsertItem)), __LINE__);
            }
        }
        if (is_null($tripResultInsert) || (is_array($tripResultInsert) && empty($tripResultInsert))) {
            unset($this->TripResultInsert);
        } else {
            $this->TripResultInsert = $tripResultInsert;
        }
        return $this;
    }
    /**
     * Add item to TripResultInsert value
     * @throws \InvalidArgumentException
     * @param \StructType\TripResultInsert $item
     * @return \ArrayType\ArrayOfTripResultInsert
     */
    public function addToTripResultInsert(\StructType\TripResultInsert $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripResultInsert) {
            throw new \InvalidArgumentException(sprintf('The TripResultInsert property can only contain items of \StructType\TripResultInsert, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TripResultInsert[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripResultInsert|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripResultInsert|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripResultInsert|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripResultInsert|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripResultInsert|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripResultInsert
     */
    public function getAttributeName()
    {
        return 'TripResultInsert';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTripResultInsert
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
