<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUpdateDatesItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfUpdateDatesItem extends AbstractStructArrayBase
{
    /**
     * The UpdateDatesItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UpdateDatesItem[]
     */
    public $UpdateDatesItem;
    /**
     * Constructor method for ArrayOfUpdateDatesItem
     * @uses ArrayOfUpdateDatesItem::setUpdateDatesItem()
     * @param \StructType\UpdateDatesItem[] $updateDatesItem
     */
    public function __construct(array $updateDatesItem = array())
    {
        $this
            ->setUpdateDatesItem($updateDatesItem);
    }
    /**
     * Get UpdateDatesItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UpdateDatesItem[]|null
     */
    public function getUpdateDatesItem()
    {
        return isset($this->UpdateDatesItem) ? $this->UpdateDatesItem : null;
    }
    /**
     * Set UpdateDatesItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateDatesItem[] $updateDatesItem
     * @return \ArrayType\ArrayOfUpdateDatesItem
     */
    public function setUpdateDatesItem(array $updateDatesItem = array())
    {
        foreach ($updateDatesItem as $arrayOfUpdateDatesItemUpdateDatesItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfUpdateDatesItemUpdateDatesItemItem instanceof \StructType\UpdateDatesItem) {
                throw new \InvalidArgumentException(sprintf('The UpdateDatesItem property can only contain items of \StructType\UpdateDatesItem, "%s" given', is_object($arrayOfUpdateDatesItemUpdateDatesItemItem) ? get_class($arrayOfUpdateDatesItemUpdateDatesItemItem) : gettype($arrayOfUpdateDatesItemUpdateDatesItemItem)), __LINE__);
            }
        }
        if (is_null($updateDatesItem) || (is_array($updateDatesItem) && empty($updateDatesItem))) {
            unset($this->UpdateDatesItem);
        } else {
            $this->UpdateDatesItem = $updateDatesItem;
        }
        return $this;
    }
    /**
     * Add item to UpdateDatesItem value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateDatesItem $item
     * @return \ArrayType\ArrayOfUpdateDatesItem
     */
    public function addToUpdateDatesItem(\StructType\UpdateDatesItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UpdateDatesItem) {
            throw new \InvalidArgumentException(sprintf('The UpdateDatesItem property can only contain items of \StructType\UpdateDatesItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->UpdateDatesItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UpdateDatesItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UpdateDatesItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UpdateDatesItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UpdateDatesItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UpdateDatesItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UpdateDatesItem
     */
    public function getAttributeName()
    {
        return 'UpdateDatesItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfUpdateDatesItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
