<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleProfileResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfVehicleProfileResult extends AbstractStructArrayBase
{
    /**
     * The VehicleProfileResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleProfileResult[]
     */
    public $VehicleProfileResult;
    /**
     * Constructor method for ArrayOfVehicleProfileResult
     * @uses ArrayOfVehicleProfileResult::setVehicleProfileResult()
     * @param \StructType\VehicleProfileResult[] $vehicleProfileResult
     */
    public function __construct(array $vehicleProfileResult = array())
    {
        $this
            ->setVehicleProfileResult($vehicleProfileResult);
    }
    /**
     * Get VehicleProfileResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleProfileResult[]|null
     */
    public function getVehicleProfileResult()
    {
        return isset($this->VehicleProfileResult) ? $this->VehicleProfileResult : null;
    }
    /**
     * Set VehicleProfileResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleProfileResult[] $vehicleProfileResult
     * @return \ArrayType\ArrayOfVehicleProfileResult
     */
    public function setVehicleProfileResult(array $vehicleProfileResult = array())
    {
        foreach ($vehicleProfileResult as $arrayOfVehicleProfileResultVehicleProfileResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleProfileResultVehicleProfileResultItem instanceof \StructType\VehicleProfileResult) {
                throw new \InvalidArgumentException(sprintf('The VehicleProfileResult property can only contain items of \StructType\VehicleProfileResult, "%s" given', is_object($arrayOfVehicleProfileResultVehicleProfileResultItem) ? get_class($arrayOfVehicleProfileResultVehicleProfileResultItem) : gettype($arrayOfVehicleProfileResultVehicleProfileResultItem)), __LINE__);
            }
        }
        if (is_null($vehicleProfileResult) || (is_array($vehicleProfileResult) && empty($vehicleProfileResult))) {
            unset($this->VehicleProfileResult);
        } else {
            $this->VehicleProfileResult = $vehicleProfileResult;
        }
        return $this;
    }
    /**
     * Add item to VehicleProfileResult value
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleProfileResult $item
     * @return \ArrayType\ArrayOfVehicleProfileResult
     */
    public function addToVehicleProfileResult(\StructType\VehicleProfileResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VehicleProfileResult) {
            throw new \InvalidArgumentException(sprintf('The VehicleProfileResult property can only contain items of \StructType\VehicleProfileResult, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->VehicleProfileResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VehicleProfileResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VehicleProfileResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VehicleProfileResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VehicleProfileResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VehicleProfileResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleProfileResult
     */
    public function getAttributeName()
    {
        return 'VehicleProfileResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfVehicleProfileResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
