<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleSubGroupItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfVehicleSubGroupItem extends AbstractStructArrayBase
{
    /**
     * The VehicleSubGroupItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleSubGroupItem[]
     */
    public $VehicleSubGroupItem;
    /**
     * Constructor method for ArrayOfVehicleSubGroupItem
     * @uses ArrayOfVehicleSubGroupItem::setVehicleSubGroupItem()
     * @param \StructType\VehicleSubGroupItem[] $vehicleSubGroupItem
     */
    public function __construct(array $vehicleSubGroupItem = array())
    {
        $this
            ->setVehicleSubGroupItem($vehicleSubGroupItem);
    }
    /**
     * Get VehicleSubGroupItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleSubGroupItem[]|null
     */
    public function getVehicleSubGroupItem()
    {
        return isset($this->VehicleSubGroupItem) ? $this->VehicleSubGroupItem : null;
    }
    /**
     * Set VehicleSubGroupItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleSubGroupItem[] $vehicleSubGroupItem
     * @return \ArrayType\ArrayOfVehicleSubGroupItem
     */
    public function setVehicleSubGroupItem(array $vehicleSubGroupItem = array())
    {
        foreach ($vehicleSubGroupItem as $arrayOfVehicleSubGroupItemVehicleSubGroupItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleSubGroupItemVehicleSubGroupItemItem instanceof \StructType\VehicleSubGroupItem) {
                throw new \InvalidArgumentException(sprintf('The VehicleSubGroupItem property can only contain items of \StructType\VehicleSubGroupItem, "%s" given', is_object($arrayOfVehicleSubGroupItemVehicleSubGroupItemItem) ? get_class($arrayOfVehicleSubGroupItemVehicleSubGroupItemItem) : gettype($arrayOfVehicleSubGroupItemVehicleSubGroupItemItem)), __LINE__);
            }
        }
        if (is_null($vehicleSubGroupItem) || (is_array($vehicleSubGroupItem) && empty($vehicleSubGroupItem))) {
            unset($this->VehicleSubGroupItem);
        } else {
            $this->VehicleSubGroupItem = $vehicleSubGroupItem;
        }
        return $this;
    }
    /**
     * Add item to VehicleSubGroupItem value
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleSubGroupItem $item
     * @return \ArrayType\ArrayOfVehicleSubGroupItem
     */
    public function addToVehicleSubGroupItem(\StructType\VehicleSubGroupItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VehicleSubGroupItem) {
            throw new \InvalidArgumentException(sprintf('The VehicleSubGroupItem property can only contain items of \StructType\VehicleSubGroupItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->VehicleSubGroupItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VehicleSubGroupItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VehicleSubGroupItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VehicleSubGroupItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VehicleSubGroupItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VehicleSubGroupItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleSubGroupItem
     */
    public function getAttributeName()
    {
        return 'VehicleSubGroupItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfVehicleSubGroupItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
