<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleTachoReadoutIdentifier ArrayType
 * @subpackage Arrays
 */
class ArrayOfVehicleTachoReadoutIdentifier extends AbstractStructArrayBase
{
    /**
     * The VehicleTachoReadoutIdentifier
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleTachoReadoutIdentifier[]
     */
    public $VehicleTachoReadoutIdentifier;
    /**
     * Constructor method for ArrayOfVehicleTachoReadoutIdentifier
     * @uses ArrayOfVehicleTachoReadoutIdentifier::setVehicleTachoReadoutIdentifier()
     * @param \StructType\VehicleTachoReadoutIdentifier[] $vehicleTachoReadoutIdentifier
     */
    public function __construct(array $vehicleTachoReadoutIdentifier = array())
    {
        $this
            ->setVehicleTachoReadoutIdentifier($vehicleTachoReadoutIdentifier);
    }
    /**
     * Get VehicleTachoReadoutIdentifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleTachoReadoutIdentifier[]|null
     */
    public function getVehicleTachoReadoutIdentifier()
    {
        return isset($this->VehicleTachoReadoutIdentifier) ? $this->VehicleTachoReadoutIdentifier : null;
    }
    /**
     * Set VehicleTachoReadoutIdentifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleTachoReadoutIdentifier[] $vehicleTachoReadoutIdentifier
     * @return \ArrayType\ArrayOfVehicleTachoReadoutIdentifier
     */
    public function setVehicleTachoReadoutIdentifier(array $vehicleTachoReadoutIdentifier = array())
    {
        foreach ($vehicleTachoReadoutIdentifier as $arrayOfVehicleTachoReadoutIdentifierVehicleTachoReadoutIdentifierItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleTachoReadoutIdentifierVehicleTachoReadoutIdentifierItem instanceof \StructType\VehicleTachoReadoutIdentifier) {
                throw new \InvalidArgumentException(sprintf('The VehicleTachoReadoutIdentifier property can only contain items of \StructType\VehicleTachoReadoutIdentifier, "%s" given', is_object($arrayOfVehicleTachoReadoutIdentifierVehicleTachoReadoutIdentifierItem) ? get_class($arrayOfVehicleTachoReadoutIdentifierVehicleTachoReadoutIdentifierItem) : gettype($arrayOfVehicleTachoReadoutIdentifierVehicleTachoReadoutIdentifierItem)), __LINE__);
            }
        }
        if (is_null($vehicleTachoReadoutIdentifier) || (is_array($vehicleTachoReadoutIdentifier) && empty($vehicleTachoReadoutIdentifier))) {
            unset($this->VehicleTachoReadoutIdentifier);
        } else {
            $this->VehicleTachoReadoutIdentifier = $vehicleTachoReadoutIdentifier;
        }
        return $this;
    }
    /**
     * Add item to VehicleTachoReadoutIdentifier value
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleTachoReadoutIdentifier $item
     * @return \ArrayType\ArrayOfVehicleTachoReadoutIdentifier
     */
    public function addToVehicleTachoReadoutIdentifier(\StructType\VehicleTachoReadoutIdentifier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VehicleTachoReadoutIdentifier) {
            throw new \InvalidArgumentException(sprintf('The VehicleTachoReadoutIdentifier property can only contain items of \StructType\VehicleTachoReadoutIdentifier, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->VehicleTachoReadoutIdentifier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VehicleTachoReadoutIdentifier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VehicleTachoReadoutIdentifier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VehicleTachoReadoutIdentifier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VehicleTachoReadoutIdentifier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VehicleTachoReadoutIdentifier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleTachoReadoutIdentifier
     */
    public function getAttributeName()
    {
        return 'VehicleTachoReadoutIdentifier';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfVehicleTachoReadoutIdentifier
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
