<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViaPointInsert ArrayType
 * @subpackage Arrays
 */
class ArrayOfViaPointInsert extends AbstractStructArrayBase
{
    /**
     * The ViaPointInsert
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViaPointInsert[]
     */
    public $ViaPointInsert;
    /**
     * Constructor method for ArrayOfViaPointInsert
     * @uses ArrayOfViaPointInsert::setViaPointInsert()
     * @param \StructType\ViaPointInsert[] $viaPointInsert
     */
    public function __construct(array $viaPointInsert = array())
    {
        $this
            ->setViaPointInsert($viaPointInsert);
    }
    /**
     * Get ViaPointInsert value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViaPointInsert[]|null
     */
    public function getViaPointInsert()
    {
        return isset($this->ViaPointInsert) ? $this->ViaPointInsert : null;
    }
    /**
     * Set ViaPointInsert value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViaPointInsert[] $viaPointInsert
     * @return \ArrayType\ArrayOfViaPointInsert
     */
    public function setViaPointInsert(array $viaPointInsert = array())
    {
        foreach ($viaPointInsert as $arrayOfViaPointInsertViaPointInsertItem) {
            // validation for constraint: itemType
            if (!$arrayOfViaPointInsertViaPointInsertItem instanceof \StructType\ViaPointInsert) {
                throw new \InvalidArgumentException(sprintf('The ViaPointInsert property can only contain items of \StructType\ViaPointInsert, "%s" given', is_object($arrayOfViaPointInsertViaPointInsertItem) ? get_class($arrayOfViaPointInsertViaPointInsertItem) : gettype($arrayOfViaPointInsertViaPointInsertItem)), __LINE__);
            }
        }
        if (is_null($viaPointInsert) || (is_array($viaPointInsert) && empty($viaPointInsert))) {
            unset($this->ViaPointInsert);
        } else {
            $this->ViaPointInsert = $viaPointInsert;
        }
        return $this;
    }
    /**
     * Add item to ViaPointInsert value
     * @throws \InvalidArgumentException
     * @param \StructType\ViaPointInsert $item
     * @return \ArrayType\ArrayOfViaPointInsert
     */
    public function addToViaPointInsert(\StructType\ViaPointInsert $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViaPointInsert) {
            throw new \InvalidArgumentException(sprintf('The ViaPointInsert property can only contain items of \StructType\ViaPointInsert, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ViaPointInsert[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViaPointInsert|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViaPointInsert|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViaPointInsert|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViaPointInsert|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViaPointInsert|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViaPointInsert
     */
    public function getAttributeName()
    {
        return 'ViaPointInsert';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfViaPointInsert
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
