<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViaRouteResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfViaRouteResult extends AbstractStructArrayBase
{
    /**
     * The ViaRouteResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViaRouteResult[]
     */
    public $ViaRouteResult;
    /**
     * Constructor method for ArrayOfViaRouteResult
     * @uses ArrayOfViaRouteResult::setViaRouteResult()
     * @param \StructType\ViaRouteResult[] $viaRouteResult
     */
    public function __construct(array $viaRouteResult = array())
    {
        $this
            ->setViaRouteResult($viaRouteResult);
    }
    /**
     * Get ViaRouteResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViaRouteResult[]|null
     */
    public function getViaRouteResult()
    {
        return isset($this->ViaRouteResult) ? $this->ViaRouteResult : null;
    }
    /**
     * Set ViaRouteResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViaRouteResult[] $viaRouteResult
     * @return \ArrayType\ArrayOfViaRouteResult
     */
    public function setViaRouteResult(array $viaRouteResult = array())
    {
        foreach ($viaRouteResult as $arrayOfViaRouteResultViaRouteResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfViaRouteResultViaRouteResultItem instanceof \StructType\ViaRouteResult) {
                throw new \InvalidArgumentException(sprintf('The ViaRouteResult property can only contain items of \StructType\ViaRouteResult, "%s" given', is_object($arrayOfViaRouteResultViaRouteResultItem) ? get_class($arrayOfViaRouteResultViaRouteResultItem) : gettype($arrayOfViaRouteResultViaRouteResultItem)), __LINE__);
            }
        }
        if (is_null($viaRouteResult) || (is_array($viaRouteResult) && empty($viaRouteResult))) {
            unset($this->ViaRouteResult);
        } else {
            $this->ViaRouteResult = $viaRouteResult;
        }
        return $this;
    }
    /**
     * Add item to ViaRouteResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ViaRouteResult $item
     * @return \ArrayType\ArrayOfViaRouteResult
     */
    public function addToViaRouteResult(\StructType\ViaRouteResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViaRouteResult) {
            throw new \InvalidArgumentException(sprintf('The ViaRouteResult property can only contain items of \StructType\ViaRouteResult, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ViaRouteResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViaRouteResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViaRouteResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViaRouteResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViaRouteResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViaRouteResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViaRouteResult
     */
    public function getAttributeName()
    {
        return 'ViaRouteResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfViaRouteResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
