<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViaRouteTransferResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfViaRouteTransferResult extends AbstractStructArrayBase
{
    /**
     * The ViaRouteTransferResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViaRouteTransferResult[]
     */
    public $ViaRouteTransferResult;
    /**
     * Constructor method for ArrayOfViaRouteTransferResult
     * @uses ArrayOfViaRouteTransferResult::setViaRouteTransferResult()
     * @param \StructType\ViaRouteTransferResult[] $viaRouteTransferResult
     */
    public function __construct(array $viaRouteTransferResult = array())
    {
        $this
            ->setViaRouteTransferResult($viaRouteTransferResult);
    }
    /**
     * Get ViaRouteTransferResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViaRouteTransferResult[]|null
     */
    public function getViaRouteTransferResult()
    {
        return isset($this->ViaRouteTransferResult) ? $this->ViaRouteTransferResult : null;
    }
    /**
     * Set ViaRouteTransferResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViaRouteTransferResult[] $viaRouteTransferResult
     * @return \ArrayType\ArrayOfViaRouteTransferResult
     */
    public function setViaRouteTransferResult(array $viaRouteTransferResult = array())
    {
        foreach ($viaRouteTransferResult as $arrayOfViaRouteTransferResultViaRouteTransferResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfViaRouteTransferResultViaRouteTransferResultItem instanceof \StructType\ViaRouteTransferResult) {
                throw new \InvalidArgumentException(sprintf('The ViaRouteTransferResult property can only contain items of \StructType\ViaRouteTransferResult, "%s" given', is_object($arrayOfViaRouteTransferResultViaRouteTransferResultItem) ? get_class($arrayOfViaRouteTransferResultViaRouteTransferResultItem) : gettype($arrayOfViaRouteTransferResultViaRouteTransferResultItem)), __LINE__);
            }
        }
        if (is_null($viaRouteTransferResult) || (is_array($viaRouteTransferResult) && empty($viaRouteTransferResult))) {
            unset($this->ViaRouteTransferResult);
        } else {
            $this->ViaRouteTransferResult = $viaRouteTransferResult;
        }
        return $this;
    }
    /**
     * Add item to ViaRouteTransferResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ViaRouteTransferResult $item
     * @return \ArrayType\ArrayOfViaRouteTransferResult
     */
    public function addToViaRouteTransferResult(\StructType\ViaRouteTransferResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViaRouteTransferResult) {
            throw new \InvalidArgumentException(sprintf('The ViaRouteTransferResult property can only contain items of \StructType\ViaRouteTransferResult, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ViaRouteTransferResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViaRouteTransferResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViaRouteTransferResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViaRouteTransferResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViaRouteTransferResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViaRouteTransferResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViaRouteTransferResult
     */
    public function getAttributeName()
    {
        return 'ViaRouteTransferResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfViaRouteTransferResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
