<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWorkingCodeDuration ArrayType
 * @subpackage Arrays
 */
class ArrayOfWorkingCodeDuration extends AbstractStructArrayBase
{
    /**
     * The WorkingCodeDuration
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WorkingCodeDuration[]
     */
    public $WorkingCodeDuration;
    /**
     * Constructor method for ArrayOfWorkingCodeDuration
     * @uses ArrayOfWorkingCodeDuration::setWorkingCodeDuration()
     * @param \StructType\WorkingCodeDuration[] $workingCodeDuration
     */
    public function __construct(array $workingCodeDuration = array())
    {
        $this
            ->setWorkingCodeDuration($workingCodeDuration);
    }
    /**
     * Get WorkingCodeDuration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WorkingCodeDuration[]|null
     */
    public function getWorkingCodeDuration()
    {
        return isset($this->WorkingCodeDuration) ? $this->WorkingCodeDuration : null;
    }
    /**
     * Set WorkingCodeDuration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WorkingCodeDuration[] $workingCodeDuration
     * @return \ArrayType\ArrayOfWorkingCodeDuration
     */
    public function setWorkingCodeDuration(array $workingCodeDuration = array())
    {
        foreach ($workingCodeDuration as $arrayOfWorkingCodeDurationWorkingCodeDurationItem) {
            // validation for constraint: itemType
            if (!$arrayOfWorkingCodeDurationWorkingCodeDurationItem instanceof \StructType\WorkingCodeDuration) {
                throw new \InvalidArgumentException(sprintf('The WorkingCodeDuration property can only contain items of \StructType\WorkingCodeDuration, "%s" given', is_object($arrayOfWorkingCodeDurationWorkingCodeDurationItem) ? get_class($arrayOfWorkingCodeDurationWorkingCodeDurationItem) : gettype($arrayOfWorkingCodeDurationWorkingCodeDurationItem)), __LINE__);
            }
        }
        if (is_null($workingCodeDuration) || (is_array($workingCodeDuration) && empty($workingCodeDuration))) {
            unset($this->WorkingCodeDuration);
        } else {
            $this->WorkingCodeDuration = $workingCodeDuration;
        }
        return $this;
    }
    /**
     * Add item to WorkingCodeDuration value
     * @throws \InvalidArgumentException
     * @param \StructType\WorkingCodeDuration $item
     * @return \ArrayType\ArrayOfWorkingCodeDuration
     */
    public function addToWorkingCodeDuration(\StructType\WorkingCodeDuration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WorkingCodeDuration) {
            throw new \InvalidArgumentException(sprintf('The WorkingCodeDuration property can only contain items of \StructType\WorkingCodeDuration, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->WorkingCodeDuration[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WorkingCodeDuration|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WorkingCodeDuration|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WorkingCodeDuration|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WorkingCodeDuration|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WorkingCodeDuration|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WorkingCodeDuration
     */
    public function getAttributeName()
    {
        return 'WorkingCodeDuration';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfWorkingCodeDuration
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
