<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Get_BuildVersion' => '\\StructType\\Get_BuildVersion',
            'Get_BuildVersionResponse' => '\\StructType\\Get_BuildVersionResponse',
            'Get_MergedTachoServiceTimes' => '\\StructType\\Get_MergedTachoServiceTimes',
            'Login' => '\\StructType\\Login',
            'MergedTachoServiceTimesSelection' => '\\StructType\\MergedTachoServiceTimesSelection',
            'Identifier' => '\\StructType\\Identifier',
            'DateTimeRangeSelection' => '\\StructType\\DateTimeRangeSelection',
            'Get_MergedTachoServiceTimesResponse' => '\\StructType\\Get_MergedTachoServiceTimesResponse',
            'MergedTachoServiceTimesResult' => '\\StructType\\MergedTachoServiceTimesResult',
            'ExecutionResult' => '\\StructType\\ExecutionResult',
            'ArrayOfError' => '\\ArrayType\\ArrayOfError',
            'Error' => '\\StructType\\Error',
            'ArrayOfWarning' => '\\ArrayType\\ArrayOfWarning',
            'Warning' => '\\StructType\\Warning',
            'ArrayOfMergedTachoServiceTimesItem' => '\\ArrayType\\ArrayOfMergedTachoServiceTimesItem',
            'MergedTachoServiceTimesItem' => '\\StructType\\MergedTachoServiceTimesItem',
            'IdentifierPerson' => '\\StructType\\IdentifierPerson',
            'IdentifierResult' => '\\StructType\\IdentifierResult',
            'IdentifierVehicleResult' => '\\StructType\\IdentifierVehicleResult',
            'CodeInfo' => '\\StructType\\CodeInfo',
            'ActivityInfo_Without_PathInfos' => '\\StructType\\ActivityInfo_Without_PathInfos',
            'Get_Remaining_Driving_Resting_Times' => '\\StructType\\Get_Remaining_Driving_Resting_Times',
            'RemainingDrivingRestingTimesSelection' => '\\StructType\\RemainingDrivingRestingTimesSelection',
            'ArrayOfIdentifier' => '\\ArrayType\\ArrayOfIdentifier',
            'Get_Remaining_Driving_Resting_TimesResponse' => '\\StructType\\Get_Remaining_Driving_Resting_TimesResponse',
            'GetRemainingDrivingRestingTimesResults' => '\\StructType\\GetRemainingDrivingRestingTimesResults',
            'ArrayOfGetRemainingDrivingRestingTimesResult' => '\\ArrayType\\ArrayOfGetRemainingDrivingRestingTimesResult',
            'GetRemainingDrivingRestingTimesResult' => '\\StructType\\GetRemainingDrivingRestingTimesResult',
            'RemainingDrivingTimes' => '\\StructType\\RemainingDrivingTimes',
            'RemainingTimeItemMax' => '\\StructType\\RemainingTimeItemMax',
            'RemainingDateItem' => '\\StructType\\RemainingDateItem',
            'RemainingRestingTimes' => '\\StructType\\RemainingRestingTimes',
            'RemainingTimeItemMin' => '\\StructType\\RemainingTimeItemMin',
            'OBC_Activity' => '\\StructType\\OBC_Activity',
            'Activity' => '\\StructType\\Activity',
            'Tacho_Activity' => '\\StructType\\Tacho_Activity',
            'Get_Remaining_Driving_Resting_Times_V2' => '\\StructType\\Get_Remaining_Driving_Resting_Times_V2',
            'Get_Remaining_Driving_Resting_Times_V2Response' => '\\StructType\\Get_Remaining_Driving_Resting_Times_V2Response',
            'GetRemainingDrivingRestingTimesResults_V2' => '\\StructType\\GetRemainingDrivingRestingTimesResults_V2',
            'ArrayOfGetRemainingDrivingRestingTimesResult_V2' => '\\ArrayType\\ArrayOfGetRemainingDrivingRestingTimesResult_V2',
            'GetRemainingDrivingRestingTimesResult_V2' => '\\StructType\\GetRemainingDrivingRestingTimesResult_V2',
            'IdentifierPerson_V2' => '\\StructType\\IdentifierPerson_V2',
            'IdentifierVehicleResult_V2' => '\\StructType\\IdentifierVehicleResult_V2',
            'Get_Remaining_Driving_Resting_Times_V3' => '\\StructType\\Get_Remaining_Driving_Resting_Times_V3',
            'Get_Remaining_Driving_Resting_Times_V3Response' => '\\StructType\\Get_Remaining_Driving_Resting_Times_V3Response',
            'GetRemainingDrivingRestingTimesResults_V3' => '\\StructType\\GetRemainingDrivingRestingTimesResults_V3',
            'ArrayOfGetRemainingDrivingRestingTimesResult_V3' => '\\ArrayType\\ArrayOfGetRemainingDrivingRestingTimesResult_V3',
            'GetRemainingDrivingRestingTimesResult_V3' => '\\StructType\\GetRemainingDrivingRestingTimesResult_V3',
            'RemainingDrivingTimes_V2' => '\\StructType\\RemainingDrivingTimes_V2',
            'WeeklyCompensatedRestingTimes' => '\\StructType\\WeeklyCompensatedRestingTimes',
            'Get_ServiceTimesTachoDetail' => '\\StructType\\Get_ServiceTimesTachoDetail',
            'ServiceTimesSelection' => '\\StructType\\ServiceTimesSelection',
            'DateTimeSelection' => '\\StructType\\DateTimeSelection',
            'Get_ServiceTimesTachoDetailResponse' => '\\StructType\\Get_ServiceTimesTachoDetailResponse',
            'GetServiceTimesTachoDetailResult' => '\\StructType\\GetServiceTimesTachoDetailResult',
            'ArrayOfServiceTimeTachoDetail' => '\\ArrayType\\ArrayOfServiceTimeTachoDetail',
            'ServiceTimeTachoDetail' => '\\StructType\\ServiceTimeTachoDetail',
            'Get_ServiceTimesTachoDetail_V2' => '\\StructType\\Get_ServiceTimesTachoDetail_V2',
            'ServiceTimesSelection_V2' => '\\StructType\\ServiceTimesSelection_V2',
            'Get_ServiceTimesTachoDetail_V2Response' => '\\StructType\\Get_ServiceTimesTachoDetail_V2Response',
            'GetServiceTimesTachoDetailResult_V2' => '\\StructType\\GetServiceTimesTachoDetailResult_V2',
            'ArrayOfServiceTimeTachoDetail_V2' => '\\ArrayType\\ArrayOfServiceTimeTachoDetail_V2',
            'ServiceTimeTachoDetail_V2' => '\\StructType\\ServiceTimeTachoDetail_V2',
            'PositionResult' => '\\StructType\\PositionResult',
            'Position' => '\\StructType\\Position',
            'Get_ServiceTimesTachoDetail_V3' => '\\StructType\\Get_ServiceTimesTachoDetail_V3',
            'ServiceTimesSelection_V3' => '\\StructType\\ServiceTimesSelection_V3',
            'ArrayOfIdentifierVehicleExtra' => '\\ArrayType\\ArrayOfIdentifierVehicleExtra',
            'IdentifierVehicleExtra' => '\\StructType\\IdentifierVehicleExtra',
            'PeriodSelectionWithDateType' => '\\StructType\\PeriodSelectionWithDateType',
            'Get_ServiceTimesTachoDetail_V3Response' => '\\StructType\\Get_ServiceTimesTachoDetail_V3Response',
            'GetServiceTimesTachoDetailResult_V3' => '\\StructType\\GetServiceTimesTachoDetailResult_V3',
            'ArrayOfServiceTimeTachoDetail_V3' => '\\ArrayType\\ArrayOfServiceTimeTachoDetail_V3',
            'ServiceTimeTachoDetail_V3' => '\\StructType\\ServiceTimeTachoDetail_V3',
            'IdentifierPerson_V3' => '\\StructType\\IdentifierPerson_V3',
            'TachoCardInfo' => '\\StructType\\TachoCardInfo',
            'Get_ServiceTimesTachoDetail_V4' => '\\StructType\\Get_ServiceTimesTachoDetail_V4',
            'Get_ServiceTimesTachoDetail_V4Response' => '\\StructType\\Get_ServiceTimesTachoDetail_V4Response',
            'GetServiceTimesTachoDetailResult_V4' => '\\StructType\\GetServiceTimesTachoDetailResult_V4',
            'ArrayOfServiceTimeTachoDetail_V4' => '\\ArrayType\\ArrayOfServiceTimeTachoDetail_V4',
            'ServiceTimeTachoDetail_V4' => '\\StructType\\ServiceTimeTachoDetail_V4',
            'Get_ServiceTimesTachoDetail_V5' => '\\StructType\\Get_ServiceTimesTachoDetail_V5',
            'ServiceTimesSelection_V4' => '\\StructType\\ServiceTimesSelection_V4',
            'Get_ServiceTimesTachoDetail_V5Response' => '\\StructType\\Get_ServiceTimesTachoDetail_V5Response',
            'GetServiceTimesTachoDetailResult_V5' => '\\StructType\\GetServiceTimesTachoDetailResult_V5',
            'ArrayOfServiceTimeTachoDetail_V5' => '\\ArrayType\\ArrayOfServiceTimeTachoDetail_V5',
            'ServiceTimeTachoDetail_V5' => '\\StructType\\ServiceTimeTachoDetail_V5',
            'PositionResult_V2' => '\\StructType\\PositionResult_V2',
            'Get_SummarizedTachoData' => '\\StructType\\Get_SummarizedTachoData',
            'SummarizedTachoDataSelection' => '\\StructType\\SummarizedTachoDataSelection',
            'Get_SummarizedTachoDataResponse' => '\\StructType\\Get_SummarizedTachoDataResponse',
            'SummarizedTachoDataResult' => '\\StructType\\SummarizedTachoDataResult',
            'ArrayOfSummarizedTachoDataItem' => '\\ArrayType\\ArrayOfSummarizedTachoDataItem',
            'SummarizedTachoDataItem' => '\\StructType\\SummarizedTachoDataItem',
            'ArrayOfTachoDataSummary' => '\\ArrayType\\ArrayOfTachoDataSummary',
            'TachoDataSummary' => '\\StructType\\TachoDataSummary',
            'Get_TachoEvents' => '\\StructType\\Get_TachoEvents',
            'TachoEventSelection' => '\\StructType\\TachoEventSelection',
            'ArrayOfIdentifierVehicle' => '\\ArrayType\\ArrayOfIdentifierVehicle',
            'IdentifierVehicle' => '\\StructType\\IdentifierVehicle',
            'Get_TachoEventsResponse' => '\\StructType\\Get_TachoEventsResponse',
            'GetTachoEventsResult' => '\\StructType\\GetTachoEventsResult',
            'ArrayOfTachoEvent' => '\\ArrayType\\ArrayOfTachoEvent',
            'TachoEvent' => '\\StructType\\TachoEvent',
            'Get_TelemetricData' => '\\StructType\\Get_TelemetricData',
            'TelemetricDataSelection' => '\\StructType\\TelemetricDataSelection',
            'DateTimeAndIdSelection' => '\\StructType\\DateTimeAndIdSelection',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'Get_TelemetricDataResponse' => '\\StructType\\Get_TelemetricDataResponse',
            'Get_TelemetricDataResult' => '\\StructType\\Get_TelemetricDataResult',
            'ArrayOfTelemetricDataItem' => '\\ArrayType\\ArrayOfTelemetricDataItem',
            'TelemetricDataItem' => '\\StructType\\TelemetricDataItem',
            'ContactObject' => '\\StructType\\ContactObject',
            'IdentifierTrailerResult' => '\\StructType\\IdentifierTrailerResult',
            'ArrayOfGenericItem' => '\\ArrayType\\ArrayOfGenericItem',
            'GenericItem' => '\\StructType\\GenericItem',
            'GenericBaseItem' => '\\StructType\\GenericBaseItem',
            'TemperatureObject' => '\\StructType\\TemperatureObject',
            'EbsObject' => '\\StructType\\EbsObject',
            'ReeferObject' => '\\StructType\\ReeferObject',
            'DoorContacts' => '\\StructType\\DoorContacts',
            'Get_Temperatures' => '\\StructType\\Get_Temperatures',
            'TemperatureSelection' => '\\StructType\\TemperatureSelection',
            'Get_TemperaturesResponse' => '\\StructType\\Get_TemperaturesResponse',
            'GetTemperatureResult' => '\\StructType\\GetTemperatureResult',
            'ArrayOfTemperatureResult' => '\\ArrayType\\ArrayOfTemperatureResult',
            'TemperatureResult' => '\\StructType\\TemperatureResult',
            'ArrayOfTemperatureMeasurement' => '\\ArrayType\\ArrayOfTemperatureMeasurement',
            'TemperatureMeasurement' => '\\StructType\\TemperatureMeasurement',
            'ArrayOfEngineActivity' => '\\ArrayType\\ArrayOfEngineActivity',
            'EngineActivity' => '\\StructType\\EngineActivity',
            'ArrayOfTemperatureInformation' => '\\ArrayType\\ArrayOfTemperatureInformation',
            'TemperatureInformation' => '\\StructType\\TemperatureInformation',
            'Get_Temperatures_V2' => '\\StructType\\Get_Temperatures_V2',
            'TemperatureSelection_With_Trailer_Info' => '\\StructType\\TemperatureSelection_With_Trailer_Info',
            'Get_Temperatures_V2Response' => '\\StructType\\Get_Temperatures_V2Response',
            'GetTemperatureResult_With_Trailer_Info' => '\\StructType\\GetTemperatureResult_With_Trailer_Info',
            'ArrayOfTemperatureResult_With_Trailer_Info' => '\\ArrayType\\ArrayOfTemperatureResult_With_Trailer_Info',
            'TemperatureResult_With_Trailer_Info' => '\\StructType\\TemperatureResult_With_Trailer_Info',
            'Get_Temperatures_V3' => '\\StructType\\Get_Temperatures_V3',
            'Get_Temperatures_V3Response' => '\\StructType\\Get_Temperatures_V3Response',
            'GetTemperatureResult_V3' => '\\StructType\\GetTemperatureResult_V3',
            'ArrayOfTemperatureResult_V3' => '\\ArrayType\\ArrayOfTemperatureResult_V3',
            'TemperatureResult_V3' => '\\StructType\\TemperatureResult_V3',
            'ArrayOfTemperatureMeasurement_V3' => '\\ArrayType\\ArrayOfTemperatureMeasurement_V3',
            'TemperatureMeasurement_V3' => '\\StructType\\TemperatureMeasurement_V3',
            'PlaceIdentifier' => '\\StructType\\PlaceIdentifier',
            'TripIdentifier' => '\\StructType\\TripIdentifier',
            'Set_TemperatureSettings' => '\\StructType\\Set_TemperatureSettings',
            'ArrayOfSetTemperaturesSelection' => '\\ArrayType\\ArrayOfSetTemperaturesSelection',
            'SetTemperaturesSelection' => '\\StructType\\SetTemperaturesSelection',
            'ArrayOfTemperatureSetting' => '\\ArrayType\\ArrayOfTemperatureSetting',
            'TemperatureSetting' => '\\StructType\\TemperatureSetting',
            'Set_TemperatureSettingsResponse' => '\\StructType\\Set_TemperatureSettingsResponse',
            'ResultSuccess' => '\\StructType\\ResultSuccess',
            'Get_MailboxInfo_V2' => '\\StructType\\Get_MailboxInfo_V2',
            'MailboxInfoSelection' => '\\StructType\\MailboxInfoSelection',
            'Get_MailboxInfo_V2Response' => '\\StructType\\Get_MailboxInfo_V2Response',
            'GetMailboxInfo_V2' => '\\StructType\\GetMailboxInfo_V2',
            'InboxInfo_V2' => '\\StructType\\InboxInfo_V2',
            'InboxInfo' => '\\StructType\\InboxInfo',
            'OutboxInfo' => '\\StructType\\OutboxInfo',
            'AlarmInfo' => '\\StructType\\AlarmInfo',
            'Get_TextMessages_Inbox' => '\\StructType\\Get_TextMessages_Inbox',
            'TextMessageInboxSelection' => '\\StructType\\TextMessageInboxSelection',
            'ArrayOfLong' => '\\ArrayType\\ArrayOfLong',
            'Get_TextMessages_InboxResponse' => '\\StructType\\Get_TextMessages_InboxResponse',
            'GetTextMessagesInbox' => '\\StructType\\GetTextMessagesInbox',
            'ArrayOfTextMessageInbox' => '\\ArrayType\\ArrayOfTextMessageInbox',
            'TextMessageInbox' => '\\StructType\\TextMessageInbox',
            'TextMessage' => '\\StructType\\TextMessage',
            'TextMessageOutbox' => '\\StructType\\TextMessageOutbox',
            'Get_TextMessages_Inbox_V2' => '\\StructType\\Get_TextMessages_Inbox_V2',
            'TextMessageInboxSelection_With_VehicleSelection' => '\\StructType\\TextMessageInboxSelection_With_VehicleSelection',
            'Get_TextMessages_Inbox_V2Response' => '\\StructType\\Get_TextMessages_Inbox_V2Response',
            'GetTextMessagesInbox_V2' => '\\StructType\\GetTextMessagesInbox_V2',
            'ArrayOfTextMessageInbox_V2' => '\\ArrayType\\ArrayOfTextMessageInbox_V2',
            'TextMessageInbox_V2' => '\\StructType\\TextMessageInbox_V2',
            'TextMessageOutbox_V2' => '\\StructType\\TextMessageOutbox_V2',
            'Get_TextMessages_Inbox_V3' => '\\StructType\\Get_TextMessages_Inbox_V3',
            'TextMessageInboxSelection_With_VehicleSelection_And_Treated_Status' => '\\StructType\\TextMessageInboxSelection_With_VehicleSelection_And_Treated_Status',
            'Get_TextMessages_Inbox_V3Response' => '\\StructType\\Get_TextMessages_Inbox_V3Response',
            'GetTextMessagesInbox_V3' => '\\StructType\\GetTextMessagesInbox_V3',
            'ArrayOfTextMessageInbox_V3' => '\\ArrayType\\ArrayOfTextMessageInbox_V3',
            'TextMessageInbox_V3' => '\\StructType\\TextMessageInbox_V3',
            'TextMessageOutbox_V3' => '\\StructType\\TextMessageOutbox_V3',
            'ArrayOfTextMessageOutbox_V3' => '\\ArrayType\\ArrayOfTextMessageOutbox_V3',
            'Get_TextMessages_Inbox_V4' => '\\StructType\\Get_TextMessages_Inbox_V4',
            'Get_TextMessages_Inbox_V4Response' => '\\StructType\\Get_TextMessages_Inbox_V4Response',
            'GetTextMessagesInbox_V4' => '\\StructType\\GetTextMessagesInbox_V4',
            'ArrayOfTextMessageInbox_V4' => '\\ArrayType\\ArrayOfTextMessageInbox_V4',
            'TextMessageInbox_V4' => '\\StructType\\TextMessageInbox_V4',
            'TextMessageOutbox_V4' => '\\StructType\\TextMessageOutbox_V4',
            'ArrayOfTextMessageOutbox_V4' => '\\ArrayType\\ArrayOfTextMessageOutbox_V4',
            'Get_TextMessages_Inbox_V5' => '\\StructType\\Get_TextMessages_Inbox_V5',
            'TextMessageInboxSelection_V2' => '\\StructType\\TextMessageInboxSelection_V2',
            'Get_TextMessages_Inbox_V5Response' => '\\StructType\\Get_TextMessages_Inbox_V5Response',
            'GetTextMessagesInbox_V5' => '\\StructType\\GetTextMessagesInbox_V5',
            'ArrayOfTextMessageInbox_V5' => '\\ArrayType\\ArrayOfTextMessageInbox_V5',
            'TextMessageInbox_V5' => '\\StructType\\TextMessageInbox_V5',
            'Get_TextMessages_Inbox_V6' => '\\StructType\\Get_TextMessages_Inbox_V6',
            'Get_TextMessages_Inbox_V6Response' => '\\StructType\\Get_TextMessages_Inbox_V6Response',
            'GetTextMessagesInbox_V6' => '\\StructType\\GetTextMessagesInbox_V6',
            'ArrayOfTextMessageInbox_V6' => '\\ArrayType\\ArrayOfTextMessageInbox_V6',
            'TextMessageInbox_V6' => '\\StructType\\TextMessageInbox_V6',
            'GroupResult' => '\\StructType\\GroupResult',
            'Get_TextMessages_Outbox' => '\\StructType\\Get_TextMessages_Outbox',
            'TextMessageOutboxSelection' => '\\StructType\\TextMessageOutboxSelection',
            'Get_TextMessages_OutboxResponse' => '\\StructType\\Get_TextMessages_OutboxResponse',
            'GetTextMessagesOutbox' => '\\StructType\\GetTextMessagesOutbox',
            'ArrayOfTextMessageOutbox' => '\\ArrayType\\ArrayOfTextMessageOutbox',
            'Get_TextMessages_Outbox_V2' => '\\StructType\\Get_TextMessages_Outbox_V2',
            'TextMessageOutboxSelection_With_Vehicle_Selection' => '\\StructType\\TextMessageOutboxSelection_With_Vehicle_Selection',
            'Get_TextMessages_Outbox_V2Response' => '\\StructType\\Get_TextMessages_Outbox_V2Response',
            'GetTextMessagesOutbox_V2' => '\\StructType\\GetTextMessagesOutbox_V2',
            'ArrayOfTextMessageOutbox_V2' => '\\ArrayType\\ArrayOfTextMessageOutbox_V2',
            'Get_TextMessages_Outbox_V3' => '\\StructType\\Get_TextMessages_Outbox_V3',
            'TextMessageOutboxSelection_With_Vehicle_Selection_And_Replies' => '\\StructType\\TextMessageOutboxSelection_With_Vehicle_Selection_And_Replies',
            'Get_TextMessages_Outbox_V3Response' => '\\StructType\\Get_TextMessages_Outbox_V3Response',
            'GetTextMessagesOutbox_V3' => '\\StructType\\GetTextMessagesOutbox_V3',
            'Get_TextMessages_Outbox_V4' => '\\StructType\\Get_TextMessages_Outbox_V4',
            'Get_TextMessages_Outbox_V4Response' => '\\StructType\\Get_TextMessages_Outbox_V4Response',
            'GetTextMessagesOutbox_V4' => '\\StructType\\GetTextMessagesOutbox_V4',
            'Get_TextMessages_Outbox_V5' => '\\StructType\\Get_TextMessages_Outbox_V5',
            'TextMessageOutboxSelection_V2' => '\\StructType\\TextMessageOutboxSelection_V2',
            'Get_TextMessages_Outbox_V5Response' => '\\StructType\\Get_TextMessages_Outbox_V5Response',
            'GetTextMessagesOutbox_V5' => '\\StructType\\GetTextMessagesOutbox_V5',
            'ArrayOfTextMessageOutbox_V5' => '\\ArrayType\\ArrayOfTextMessageOutbox_V5',
            'TextMessageOutbox_V5' => '\\StructType\\TextMessageOutbox_V5',
            'Send_TextMessage' => '\\StructType\\Send_TextMessage',
            'TextMessageSend' => '\\StructType\\TextMessageSend',
            'ArrayOfAdditionalRecipient' => '\\ArrayType\\ArrayOfAdditionalRecipient',
            'AdditionalRecipient' => '\\StructType\\AdditionalRecipient',
            'Send_TextMessageResponse' => '\\StructType\\Send_TextMessageResponse',
            'SendTextMessageResult' => '\\StructType\\SendTextMessageResult',
            'ArrayOfSendTextMessageResultInfo' => '\\ArrayType\\ArrayOfSendTextMessageResultInfo',
            'SendTextMessageResultInfo' => '\\StructType\\SendTextMessageResultInfo',
            'Send_TextMessage_ReturnID' => '\\StructType\\Send_TextMessage_ReturnID',
            'Send_TextMessage_ReturnIDResponse' => '\\StructType\\Send_TextMessage_ReturnIDResponse',
            'Update_TextMessage_Read' => '\\StructType\\Update_TextMessage_Read',
            'Update_TextMessage_ReadResponse' => '\\StructType\\Update_TextMessage_ReadResponse',
            'Update_TextMessage_Read_V2' => '\\StructType\\Update_TextMessage_Read_V2',
            'TextMessageReadSelection' => '\\StructType\\TextMessageReadSelection',
            'Update_TextMessage_Read_V2Response' => '\\StructType\\Update_TextMessage_Read_V2Response',
            'Update_TextMessage_Treated' => '\\StructType\\Update_TextMessage_Treated',
            'Update_TextMessage_TreatedResponse' => '\\StructType\\Update_TextMessage_TreatedResponse',
            'Get_TracerDistanceReport' => '\\StructType\\Get_TracerDistanceReport',
            'TracerDistanceReportSelection' => '\\StructType\\TracerDistanceReportSelection',
            'Get_TracerDistanceReportResponse' => '\\StructType\\Get_TracerDistanceReportResponse',
            'GetTracerDistanceReport' => '\\StructType\\GetTracerDistanceReport',
            'ArrayOfTracerDistanceReportItem' => '\\ArrayType\\ArrayOfTracerDistanceReportItem',
            'TracerDistanceReportItem' => '\\StructType\\TracerDistanceReportItem',
            'Assign_Vehicles_To_Dispatchers' => '\\StructType\\Assign_Vehicles_To_Dispatchers',
            'AssignIdentifiersToDispatchers' => '\\StructType\\AssignIdentifiersToDispatchers',
            'ArrayOfIdentifierVehicleItem' => '\\ArrayType\\ArrayOfIdentifierVehicleItem',
            'IdentifierVehicleItem' => '\\StructType\\IdentifierVehicleItem',
            'PeriodSelection' => '\\StructType\\PeriodSelection',
            'CompanyIdentifier' => '\\StructType\\CompanyIdentifier',
            'DispatcherSettings' => '\\StructType\\DispatcherSettings',
            'Assign_Vehicles_To_DispatchersResponse' => '\\StructType\\Assign_Vehicles_To_DispatchersResponse',
            'Remove_Vehicles_From_Dispatchers' => '\\StructType\\Remove_Vehicles_From_Dispatchers',
            'RemoveIdentifiersFromDispatchers' => '\\StructType\\RemoveIdentifiersFromDispatchers',
            'Remove_Vehicles_From_DispatchersResponse' => '\\StructType\\Remove_Vehicles_From_DispatchersResponse',
            'Get_WhoTracksWhat_Overview' => '\\StructType\\Get_WhoTracksWhat_Overview',
            'WhoTracksWhatSelection' => '\\StructType\\WhoTracksWhatSelection',
            'Get_WhoTracksWhat_OverviewResponse' => '\\StructType\\Get_WhoTracksWhat_OverviewResponse',
            'WhoTracksWhatResult' => '\\StructType\\WhoTracksWhatResult',
            'ArrayOfWhoTracksWhatPerDispatcherItem' => '\\ArrayType\\ArrayOfWhoTracksWhatPerDispatcherItem',
            'WhoTracksWhatPerDispatcherItem' => '\\StructType\\WhoTracksWhatPerDispatcherItem',
            'FollowedVehicleCollection' => '\\StructType\\FollowedVehicleCollection',
            'ArrayOfVehicleGroupItem' => '\\ArrayType\\ArrayOfVehicleGroupItem',
            'VehicleGroupItem' => '\\StructType\\VehicleGroupItem',
            'ArrayOfVehicleSubGroupItem' => '\\ArrayType\\ArrayOfVehicleSubGroupItem',
            'VehicleSubGroupItem' => '\\StructType\\VehicleSubGroupItem',
            'ArrayOfTrackedVehicle' => '\\ArrayType\\ArrayOfTrackedVehicle',
            'TrackedVehicle' => '\\StructType\\TrackedVehicle',
            'TrackingPeriod' => '\\StructType\\TrackingPeriod',
            'FollowedTrailerCollection' => '\\StructType\\FollowedTrailerCollection',
            'ArrayOfTrailerGroupItem' => '\\ArrayType\\ArrayOfTrailerGroupItem',
            'TrailerGroupItem' => '\\StructType\\TrailerGroupItem',
            'ArrayOfTrailerSubGroupItem' => '\\ArrayType\\ArrayOfTrailerSubGroupItem',
            'TrailerSubGroupItem' => '\\StructType\\TrailerSubGroupItem',
            'FollowedDriverCollection' => '\\StructType\\FollowedDriverCollection',
            'ArrayOfDriverGroupItem' => '\\ArrayType\\ArrayOfDriverGroupItem',
            'DriverGroupItem' => '\\StructType\\DriverGroupItem',
            'ArrayOfDriverSubGroupItem' => '\\ArrayType\\ArrayOfDriverSubGroupItem',
            'DriverSubGroupItem' => '\\StructType\\DriverSubGroupItem',
            'ArrayOfTrackedDriver' => '\\ArrayType\\ArrayOfTrackedDriver',
            'TrackedDriver' => '\\StructType\\TrackedDriver',
            'FollowedCompanyPOICollection' => '\\StructType\\FollowedCompanyPOICollection',
            'ArrayOfCompanyPOIGroupItem' => '\\ArrayType\\ArrayOfCompanyPOIGroupItem',
            'CompanyPOIGroupItem' => '\\StructType\\CompanyPOIGroupItem',
            'ArrayOfCompanyPOISubGroupItem' => '\\ArrayType\\ArrayOfCompanyPOISubGroupItem',
            'CompanyPOISubGroupItem' => '\\StructType\\CompanyPOISubGroupItem',
            'ArrayOfPOIBase' => '\\ArrayType\\ArrayOfPOIBase',
            'POIBase' => '\\StructType\\POIBase',
            'FollowedAssetCollection' => '\\StructType\\FollowedAssetCollection',
            'ArrayOfAssetGroupItem' => '\\ArrayType\\ArrayOfAssetGroupItem',
            'AssetGroupItem' => '\\StructType\\AssetGroupItem',
            'ArrayOfAssetSubGroupItem' => '\\ArrayType\\ArrayOfAssetSubGroupItem',
            'AssetSubGroupItem' => '\\StructType\\AssetSubGroupItem',
            'ArrayOfIdentifierResult' => '\\ArrayType\\ArrayOfIdentifierResult',
            'Get_Trailers' => '\\StructType\\Get_Trailers',
            'VehicleSelection' => '\\StructType\\VehicleSelection',
            'Get_TrailersResponse' => '\\StructType\\Get_TrailersResponse',
            'GetVehicleResult' => '\\StructType\\GetVehicleResult',
            'ArrayOfVehicleResult' => '\\ArrayType\\ArrayOfVehicleResult',
            'VehicleResult' => '\\StructType\\VehicleResult',
            'Vehicle' => '\\StructType\\Vehicle',
            'VehicleEngineInfo' => '\\StructType\\VehicleEngineInfo',
            'VehicleTechnicalInfo' => '\\StructType\\VehicleTechnicalInfo',
            'VehicleLoadInfo' => '\\StructType\\VehicleLoadInfo',
            'VehicleComfortInfo' => '\\StructType\\VehicleComfortInfo',
            'VehicleObcInfo' => '\\StructType\\VehicleObcInfo',
            'VehicleSoftwareInformation' => '\\StructType\\VehicleSoftwareInformation',
            'VehicleETAInfo' => '\\StructType\\VehicleETAInfo',
            'VehicleTemperatureInfo' => '\\StructType\\VehicleTemperatureInfo',
            'VehicleInfoFields' => '\\StructType\\VehicleInfoFields',
            'VehicleUpdateDates' => '\\StructType\\VehicleUpdateDates',
            'VehicleCostInfo' => '\\StructType\\VehicleCostInfo',
            'Get_Trailers_V2' => '\\StructType\\Get_Trailers_V2',
            'Get_Trailers_V2Response' => '\\StructType\\Get_Trailers_V2Response',
            'GetTrailerResult' => '\\StructType\\GetTrailerResult',
            'ArrayOfTrailerResult' => '\\ArrayType\\ArrayOfTrailerResult',
            'TrailerResult' => '\\StructType\\TrailerResult',
            'Trailer' => '\\StructType\\Trailer',
            'TrailerEngineInfo' => '\\StructType\\TrailerEngineInfo',
            'TrailerTechnicalInfo' => '\\StructType\\TrailerTechnicalInfo',
            'TrailerLoadInfo' => '\\StructType\\TrailerLoadInfo',
            'TrailerComfortInfo' => '\\StructType\\TrailerComfortInfo',
            'TrailerObcInfo' => '\\StructType\\TrailerObcInfo',
            'TrailerETAInfo' => '\\StructType\\TrailerETAInfo',
            'TrailerTemperatureInfo' => '\\StructType\\TrailerTemperatureInfo',
            'TrailerInfoFields' => '\\StructType\\TrailerInfoFields',
            'TrailerUpdateDates' => '\\StructType\\TrailerUpdateDates',
            'TrailerCostInfo' => '\\StructType\\TrailerCostInfo',
            'NextStopResult' => '\\StructType\\NextStopResult',
            'NextStopBase' => '\\StructType\\NextStopBase',
            'NextStopPosition' => '\\StructType\\NextStopPosition',
            'NextStopStreetInfo' => '\\StructType\\NextStopStreetInfo',
            'NextStopCity' => '\\StructType\\NextStopCity',
            'NextStopCreationInfo' => '\\StructType\\NextStopCreationInfo',
            'Get_Trailers_V3' => '\\StructType\\Get_Trailers_V3',
            'VehicleSelection_With_NextStop_Info' => '\\StructType\\VehicleSelection_With_NextStop_Info',
            'Get_Trailers_V3Response' => '\\StructType\\Get_Trailers_V3Response',
            'GetTrailerResult_V2' => '\\StructType\\GetTrailerResult_V2',
            'ArrayOfTrailerResult_V2' => '\\ArrayType\\ArrayOfTrailerResult_V2',
            'TrailerResult_V2' => '\\StructType\\TrailerResult_V2',
            'TrailerTemperatureInfo_V2' => '\\StructType\\TrailerTemperatureInfo_V2',
            'VehicleTemperatureInfo_V2' => '\\StructType\\VehicleTemperatureInfo_V2',
            'Get_Trailers_V4' => '\\StructType\\Get_Trailers_V4',
            'Get_Trailers_V4Response' => '\\StructType\\Get_Trailers_V4Response',
            'InterfaceGetTrailerResult_V3' => '\\StructType\\InterfaceGetTrailerResult_V3',
            'ArrayOfInterfaceTrailerResult_V3' => '\\ArrayType\\ArrayOfInterfaceTrailerResult_V3',
            'InterfaceTrailerResult_V3' => '\\StructType\\InterfaceTrailerResult_V3',
            'Get_Trailers_V5' => '\\StructType\\Get_Trailers_V5',
            'VehicleSelection_With_NextStop_Info_WithoutDate' => '\\StructType\\VehicleSelection_With_NextStop_Info_WithoutDate',
            'Get_Trailers_V5Response' => '\\StructType\\Get_Trailers_V5Response',
            'GetTrailerResult_V5' => '\\StructType\\GetTrailerResult_V5',
            'ArrayOfTrailerResult_V5' => '\\ArrayType\\ArrayOfTrailerResult_V5',
            'TrailerResult_V5' => '\\StructType\\TrailerResult_V5',
            'TrailerObcInfo_V2' => '\\StructType\\TrailerObcInfo_V2',
            'VehicleObcInfo_V2' => '\\StructType\\VehicleObcInfo_V2',
            'Get_Trailers_V6' => '\\StructType\\Get_Trailers_V6',
            'Get_Trailers_V6Response' => '\\StructType\\Get_Trailers_V6Response',
            'GetTrailerResult_V6' => '\\StructType\\GetTrailerResult_V6',
            'ArrayOfTrailerResult_V6' => '\\ArrayType\\ArrayOfTrailerResult_V6',
            'TrailerResult_V6' => '\\StructType\\TrailerResult_V6',
            'ArrayOfUpdateDatesItem' => '\\ArrayType\\ArrayOfUpdateDatesItem',
            'UpdateDatesItem' => '\\StructType\\UpdateDatesItem',
            'Insert_Trailer' => '\\StructType\\Insert_Trailer',
            'VehicleInsert' => '\\StructType\\VehicleInsert',
            'Vehicle_V2' => '\\StructType\\Vehicle_V2',
            'VehicleEngineInfo_V2' => '\\StructType\\VehicleEngineInfo_V2',
            'IdentifierSite' => '\\StructType\\IdentifierSite',
            'VehicleProfile' => '\\StructType\\VehicleProfile',
            'Insert_TrailerResponse' => '\\StructType\\Insert_TrailerResponse',
            'ResultInfo' => '\\StructType\\ResultInfo',
            'Insert_Trailer_V2' => '\\StructType\\Insert_Trailer_V2',
            'InterfaceTrailerInsert' => '\\StructType\\InterfaceTrailerInsert',
            'Insert_Trailer_V2Response' => '\\StructType\\Insert_Trailer_V2Response',
            'Update_Trailer' => '\\StructType\\Update_Trailer',
            'Update_TrailerResponse' => '\\StructType\\Update_TrailerResponse',
            'Update_Trailer_V2' => '\\StructType\\Update_Trailer_V2',
            'VehicleUpdate' => '\\StructType\\VehicleUpdate',
            'Update_Trailer_V2Response' => '\\StructType\\Update_Trailer_V2Response',
            'Update_Trailer_V3' => '\\StructType\\Update_Trailer_V3',
            'InterfaceTrailerUpdate' => '\\StructType\\InterfaceTrailerUpdate',
            'Update_Trailer_V3Response' => '\\StructType\\Update_Trailer_V3Response',
            'Get_InfringementReport' => '\\StructType\\Get_InfringementReport',
            'InfringementReportSelection' => '\\StructType\\InfringementReportSelection',
            'ReportingSelection' => '\\StructType\\ReportingSelection',
            'SynchronizationSelection' => '\\StructType\\SynchronizationSelection',
            'Get_InfringementReportResponse' => '\\StructType\\Get_InfringementReportResponse',
            'Get_InfringementReportResult' => '\\StructType\\Get_InfringementReportResult',
            'ArrayOfInfringementReportItem' => '\\ArrayType\\ArrayOfInfringementReportItem',
            'InfringementReportItem' => '\\StructType\\InfringementReportItem',
            'InfringementReport' => '\\StructType\\InfringementReport',
            'Infringement' => '\\StructType\\Infringement',
            'ArrayOfClassItem' => '\\ArrayType\\ArrayOfClassItem',
            'ClassItem' => '\\StructType\\ClassItem',
            'Get_InfringementCodes' => '\\StructType\\Get_InfringementCodes',
            'InfringementCodeSelection' => '\\StructType\\InfringementCodeSelection',
            'Get_InfringementCodesResponse' => '\\StructType\\Get_InfringementCodesResponse',
            'Get_InfringementCodesResult' => '\\StructType\\Get_InfringementCodesResult',
            'ArrayOfInfringementCodeItem' => '\\ArrayType\\ArrayOfInfringementCodeItem',
            'InfringementCodeItem' => '\\StructType\\InfringementCodeItem',
            'Get_Vehicles' => '\\StructType\\Get_Vehicles',
            'Get_VehiclesResponse' => '\\StructType\\Get_VehiclesResponse',
            'Get_Vehicles_V2' => '\\StructType\\Get_Vehicles_V2',
            'Get_Vehicles_V2Response' => '\\StructType\\Get_Vehicles_V2Response',
            'GetVehicleResult_With_NextStop_Info' => '\\StructType\\GetVehicleResult_With_NextStop_Info',
            'ArrayOfVehicleResult_With_NextStop_Info' => '\\ArrayType\\ArrayOfVehicleResult_With_NextStop_Info',
            'VehicleResult_With_NextStop_Info' => '\\StructType\\VehicleResult_With_NextStop_Info',
            'Get_Vehicles_V3' => '\\StructType\\Get_Vehicles_V3',
            'Get_Vehicles_V3Response' => '\\StructType\\Get_Vehicles_V3Response',
            'GetVehicleResult_V3' => '\\StructType\\GetVehicleResult_V3',
            'ArrayOfVehicleResult_V3' => '\\ArrayType\\ArrayOfVehicleResult_V3',
            'VehicleResult_V3' => '\\StructType\\VehicleResult_V3',
            'Get_Vehicles_V4' => '\\StructType\\Get_Vehicles_V4',
            'VehicleSelection_With_NextStop_Info_And_VehicleProfile' => '\\StructType\\VehicleSelection_With_NextStop_Info_And_VehicleProfile',
            'Get_Vehicles_V4Response' => '\\StructType\\Get_Vehicles_V4Response',
            'GetVehicleResult_V5' => '\\StructType\\GetVehicleResult_V5',
            'ArrayOfVehicleResult_V5' => '\\ArrayType\\ArrayOfVehicleResult_V5',
            'VehicleResult_V5' => '\\StructType\\VehicleResult_V5',
            'VehicleProfileResult' => '\\StructType\\VehicleProfileResult',
            'Get_Vehicles_V5' => '\\StructType\\Get_Vehicles_V5',
            'Get_Vehicles_V5Response' => '\\StructType\\Get_Vehicles_V5Response',
            'GetVehicleResult_V6' => '\\StructType\\GetVehicleResult_V6',
            'ArrayOfVehicleResult_V6' => '\\ArrayType\\ArrayOfVehicleResult_V6',
            'VehicleResult_V6' => '\\StructType\\VehicleResult_V6',
            'Get_Vehicles_V6' => '\\StructType\\Get_Vehicles_V6',
            'Get_Vehicles_V6Response' => '\\StructType\\Get_Vehicles_V6Response',
            'GetVehicleResult_V4' => '\\StructType\\GetVehicleResult_V4',
            'ArrayOfVehicleResult_V4' => '\\ArrayType\\ArrayOfVehicleResult_V4',
            'VehicleResult_V4' => '\\StructType\\VehicleResult_V4',
            'VehicleGeneralDiagnostics' => '\\StructType\\VehicleGeneralDiagnostics',
            'VehicleCANDiagnostics' => '\\StructType\\VehicleCANDiagnostics',
            'VehicleCommunicationDiagnostics' => '\\StructType\\VehicleCommunicationDiagnostics',
            'VehicleConfigurationDiagnostics' => '\\StructType\\VehicleConfigurationDiagnostics',
            'VehicleDigiDownloadDiagnostics' => '\\StructType\\VehicleDigiDownloadDiagnostics',
            'VehicleDocScanDiagnostics' => '\\StructType\\VehicleDocScanDiagnostics',
            'VehicleEcoDiagnostics' => '\\StructType\\VehicleEcoDiagnostics',
            'VehicleEngineDiagnostics' => '\\StructType\\VehicleEngineDiagnostics',
            'VehicleGPRSDiagnostics' => '\\StructType\\VehicleGPRSDiagnostics',
            'VehicleHardwareDiagnostics' => '\\StructType\\VehicleHardwareDiagnostics',
            'VehicleIdentificationDiagnostics' => '\\StructType\\VehicleIdentificationDiagnostics',
            'VehicleMapDiagnostics' => '\\StructType\\VehicleMapDiagnostics',
            'VehiclePositionDiagnostics' => '\\StructType\\VehiclePositionDiagnostics',
            'VehicleTachoDiagnostics' => '\\StructType\\VehicleTachoDiagnostics',
            'VehicleTimeDiagnostics' => '\\StructType\\VehicleTimeDiagnostics',
            'VehicleStateDiagnostics' => '\\StructType\\VehicleStateDiagnostics',
            'Get_Vehicles_V7' => '\\StructType\\Get_Vehicles_V7',
            'InterfaceVehicleSelection_V2' => '\\StructType\\InterfaceVehicleSelection_V2',
            'Get_Vehicles_V7Response' => '\\StructType\\Get_Vehicles_V7Response',
            'InterfaceGetVehicleResult_V7' => '\\StructType\\InterfaceGetVehicleResult_V7',
            'ArrayOfInterfaceVehicleResult_V7' => '\\ArrayType\\ArrayOfInterfaceVehicleResult_V7',
            'InterfaceVehicleResult_V7' => '\\StructType\\InterfaceVehicleResult_V7',
            'InterfaceTextMessageResult' => '\\StructType\\InterfaceTextMessageResult',
            'InterfaceAlarmMessageResult' => '\\StructType\\InterfaceAlarmMessageResult',
            'InterfaceBlockedVehicleResult' => '\\StructType\\InterfaceBlockedVehicleResult',
            'VehicleCompanyCard' => '\\StructType\\VehicleCompanyCard',
            'Get_Vehicles_V8' => '\\StructType\\Get_Vehicles_V8',
            'InterfaceVehicleSelection_V3' => '\\StructType\\InterfaceVehicleSelection_V3',
            'ArrayOfDiagnosticSearchItem' => '\\ArrayType\\ArrayOfDiagnosticSearchItem',
            'DiagnosticSearchItem' => '\\StructType\\DiagnosticSearchItem',
            'Get_Vehicles_V8Response' => '\\StructType\\Get_Vehicles_V8Response',
            'InterfaceGetVehicleResult_V8' => '\\StructType\\InterfaceGetVehicleResult_V8',
            'ArrayOfInterfaceVehicleResult_V8' => '\\ArrayType\\ArrayOfInterfaceVehicleResult_V8',
            'InterfaceVehicleResult_V8' => '\\StructType\\InterfaceVehicleResult_V8',
            'ArrayOfTemperatureInfoItem' => '\\ArrayType\\ArrayOfTemperatureInfoItem',
            'TemperatureInfoItem' => '\\StructType\\TemperatureInfoItem',
            'ArrayOfInfoFieldItem' => '\\ArrayType\\ArrayOfInfoFieldItem',
            'InfoFieldItem' => '\\StructType\\InfoFieldItem',
            'NextStopResult_V2' => '\\StructType\\NextStopResult_V2',
            'ArrayOfDiagnosticItem' => '\\ArrayType\\ArrayOfDiagnosticItem',
            'DiagnosticItem' => '\\StructType\\DiagnosticItem',
            'CurrentTrip' => '\\StructType\\CurrentTrip',
            'LastPlace' => '\\StructType\\LastPlace',
            'RemoteDigitalTachoDownload' => '\\StructType\\RemoteDigitalTachoDownload',
            'Get_Vehicles_V9' => '\\StructType\\Get_Vehicles_V9',
            'Get_Vehicles_V9Response' => '\\StructType\\Get_Vehicles_V9Response',
            'InterfaceGetVehicleResult_V9' => '\\StructType\\InterfaceGetVehicleResult_V9',
            'ArrayOfInterfaceVehicleResult_V9' => '\\ArrayType\\ArrayOfInterfaceVehicleResult_V9',
            'InterfaceVehicleResult_V9' => '\\StructType\\InterfaceVehicleResult_V9',
            'PositionResult_V4' => '\\StructType\\PositionResult_V4',
            'PositionResult_V3' => '\\StructType\\PositionResult_V3',
            'Get_Vehicles_V10' => '\\StructType\\Get_Vehicles_V10',
            'InterfaceVehicleSelection_V4' => '\\StructType\\InterfaceVehicleSelection_V4',
            'Get_Vehicles_V10Response' => '\\StructType\\Get_Vehicles_V10Response',
            'InterfaceGetVehicleResult_V10' => '\\StructType\\InterfaceGetVehicleResult_V10',
            'ArrayOfInterfaceVehicleResult_V10' => '\\ArrayType\\ArrayOfInterfaceVehicleResult_V10',
            'InterfaceVehicleResult_V10' => '\\StructType\\InterfaceVehicleResult_V10',
            'TruckGroups' => '\\StructType\\TruckGroups',
            'TXConnectGroups' => '\\StructType\\TXConnectGroups',
            'ArrayOfConnectGroup' => '\\ArrayType\\ArrayOfConnectGroup',
            'ConnectGroup' => '\\StructType\\ConnectGroup',
            'SocialGroup' => '\\StructType\\SocialGroup',
            'SocialSubGroup' => '\\StructType\\SocialSubGroup',
            'ExtraTruckInfo' => '\\StructType\\ExtraTruckInfo',
            'VehicleStatuses' => '\\StructType\\VehicleStatuses',
            'VehicleTags' => '\\StructType\\VehicleTags',
            'ArrayOfVehicleTag' => '\\ArrayType\\ArrayOfVehicleTag',
            'VehicleTag' => '\\StructType\\VehicleTag',
            'NextStopResult_V3' => '\\StructType\\NextStopResult_V3',
            'Get_Vehicles_V11' => '\\StructType\\Get_Vehicles_V11',
            'Get_Vehicles_V11Response' => '\\StructType\\Get_Vehicles_V11Response',
            'InterfaceGetVehicleResult_V11' => '\\StructType\\InterfaceGetVehicleResult_V11',
            'ArrayOfInterfaceVehicleResult_V11' => '\\ArrayType\\ArrayOfInterfaceVehicleResult_V11',
            'InterfaceVehicleResult_V11' => '\\StructType\\InterfaceVehicleResult_V11',
            'NextStopResult_V4' => '\\StructType\\NextStopResult_V4',
            'Get_VehicleProfiles' => '\\StructType\\Get_VehicleProfiles',
            'Get_VehicleProfilesResponse' => '\\StructType\\Get_VehicleProfilesResponse',
            'GetVehicleProfilesResult' => '\\StructType\\GetVehicleProfilesResult',
            'ArrayOfVehicleProfileResult' => '\\ArrayType\\ArrayOfVehicleProfileResult',
            'Get_VehicleInfo_On_Date' => '\\StructType\\Get_VehicleInfo_On_Date',
            'VehicleOnDateSelection' => '\\StructType\\VehicleOnDateSelection',
            'Get_VehicleInfo_On_DateResponse' => '\\StructType\\Get_VehicleInfo_On_DateResponse',
            'GetVehicleInfoOnDateResult' => '\\StructType\\GetVehicleInfoOnDateResult',
            'ArrayOfVehicleInfoOnDateItem' => '\\ArrayType\\ArrayOfVehicleInfoOnDateItem',
            'VehicleInfoOnDateItem' => '\\StructType\\VehicleInfoOnDateItem',
            'ActivityInfo' => '\\StructType\\ActivityInfo',
            'ArrayOfPath' => '\\ArrayType\\ArrayOfPath',
            'Path' => '\\StructType\\Path',
            'PathBase' => '\\StructType\\PathBase',
            'ArrayOfAnswer' => '\\ArrayType\\ArrayOfAnswer',
            'Answer' => '\\StructType\\Answer',
            'ArrayOfCodeInfo' => '\\ArrayType\\ArrayOfCodeInfo',
            'DataType' => '\\StructType\\DataType',
            'Get_VehicleActivityInfo' => '\\StructType\\Get_VehicleActivityInfo',
            'VehicleActivitySelection' => '\\StructType\\VehicleActivitySelection',
            'Get_VehicleActivityInfoResponse' => '\\StructType\\Get_VehicleActivityInfoResponse',
            'GetVehicleActivityInfoResult' => '\\StructType\\GetVehicleActivityInfoResult',
            'ArrayOfVehicleActivityInfoItem' => '\\ArrayType\\ArrayOfVehicleActivityInfoItem',
            'VehicleActivityInfoItem' => '\\StructType\\VehicleActivityInfoItem',
            'ActivityInfo_with_ActivityStatus' => '\\StructType\\ActivityInfo_with_ActivityStatus',
            'Get_VehicleActivityInfo_V2' => '\\StructType\\Get_VehicleActivityInfo_V2',
            'Get_VehicleActivityInfo_V2Response' => '\\StructType\\Get_VehicleActivityInfo_V2Response',
            'GetVehicleActivityInfoResult_V2' => '\\StructType\\GetVehicleActivityInfoResult_V2',
            'ArrayOfVehicleActivityInfoItem_V2' => '\\ArrayType\\ArrayOfVehicleActivityInfoItem_V2',
            'VehicleActivityInfoItem_V2' => '\\StructType\\VehicleActivityInfoItem_V2',
            'Insert_Vehicle' => '\\StructType\\Insert_Vehicle',
            'Insert_VehicleResponse' => '\\StructType\\Insert_VehicleResponse',
            'Update_Vehicle' => '\\StructType\\Update_Vehicle',
            'Update_VehicleResponse' => '\\StructType\\Update_VehicleResponse',
            'Update_Vehicle_V2' => '\\StructType\\Update_Vehicle_V2',
            'Update_Vehicle_V2Response' => '\\StructType\\Update_Vehicle_V2Response',
            'Get_ViaRoutes' => '\\StructType\\Get_ViaRoutes',
            'ViaRouteSelection' => '\\StructType\\ViaRouteSelection',
            'ArrayOfIdentifierViaRoute' => '\\ArrayType\\ArrayOfIdentifierViaRoute',
            'IdentifierViaRoute' => '\\StructType\\IdentifierViaRoute',
            'ArrayOfIdentifierPlace' => '\\ArrayType\\ArrayOfIdentifierPlace',
            'IdentifierPlace' => '\\StructType\\IdentifierPlace',
            'Get_ViaRoutesResponse' => '\\StructType\\Get_ViaRoutesResponse',
            'Get_ViaRoutesResult' => '\\StructType\\Get_ViaRoutesResult',
            'ArrayOfViaRouteResult' => '\\ArrayType\\ArrayOfViaRouteResult',
            'ViaRouteResult' => '\\StructType\\ViaRouteResult',
            'ViaRoute' => '\\StructType\\ViaRoute',
            'ArrayOfViaRouteTransferResult' => '\\ArrayType\\ArrayOfViaRouteTransferResult',
            'ViaRouteTransferResult' => '\\StructType\\ViaRouteTransferResult',
            'ArrayOfViaPointResult' => '\\ArrayType\\ArrayOfViaPointResult',
            'ViaPointResult' => '\\StructType\\ViaPointResult',
            'ViaPoint' => '\\StructType\\ViaPoint',
            'ArrayOfPlaceIdentifier' => '\\ArrayType\\ArrayOfPlaceIdentifier',
            'Get_ViaRoutes_V2' => '\\StructType\\Get_ViaRoutes_V2',
            'Get_ViaRoutes_V2Response' => '\\StructType\\Get_ViaRoutes_V2Response',
            'InterfaceGet_ViaRoutesResult_V2' => '\\StructType\\InterfaceGet_ViaRoutesResult_V2',
            'ArrayOfInterfaceViaRouteResult_V2' => '\\ArrayType\\ArrayOfInterfaceViaRouteResult_V2',
            'InterfaceViaRouteResult_V2' => '\\StructType\\InterfaceViaRouteResult_V2',
            'Get_ViaRoutes_V3' => '\\StructType\\Get_ViaRoutes_V3',
            'Get_ViaRoutes_V3Response' => '\\StructType\\Get_ViaRoutes_V3Response',
            'InterfaceGet_ViaRoutesResult_V3' => '\\StructType\\InterfaceGet_ViaRoutesResult_V3',
            'ArrayOfInterfaceViaRouteResult_V3' => '\\ArrayType\\ArrayOfInterfaceViaRouteResult_V3',
            'InterfaceViaRouteResult_V3' => '\\StructType\\InterfaceViaRouteResult_V3',
            'Get_ViaRoutes_V4' => '\\StructType\\Get_ViaRoutes_V4',
            'Get_ViaRoutes_V4Response' => '\\StructType\\Get_ViaRoutes_V4Response',
            'InterfaceGet_ViaRoutesResult_V4' => '\\StructType\\InterfaceGet_ViaRoutesResult_V4',
            'ArrayOfInterfaceViaRouteResult_V4' => '\\ArrayType\\ArrayOfInterfaceViaRouteResult_V4',
            'InterfaceViaRouteResult_V4' => '\\StructType\\InterfaceViaRouteResult_V4',
            'Insert_ViaRoute' => '\\StructType\\Insert_ViaRoute',
            'ViaRouteInsert' => '\\StructType\\ViaRouteInsert',
            'ViaRoute_WithBehavior' => '\\StructType\\ViaRoute_WithBehavior',
            'ArrayOfViaPointInsert' => '\\ArrayType\\ArrayOfViaPointInsert',
            'ViaPointInsert' => '\\StructType\\ViaPointInsert',
            'IdentifierAddress' => '\\StructType\\IdentifierAddress',
            'Insert_ViaRouteResponse' => '\\StructType\\Insert_ViaRouteResponse',
            'Update_ViaRoute' => '\\StructType\\Update_ViaRoute',
            'ViaRouteUpdate' => '\\StructType\\ViaRouteUpdate',
            'ArrayOfViaPointUpdate' => '\\ArrayType\\ArrayOfViaPointUpdate',
            'ViaPointUpdate' => '\\StructType\\ViaPointUpdate',
            'Update_ViaRouteResponse' => '\\StructType\\Update_ViaRouteResponse',
            'Send_ViaRoute_To_Vehicle' => '\\StructType\\Send_ViaRoute_To_Vehicle',
            'ViaRouteVehicleSelection' => '\\StructType\\ViaRouteVehicleSelection',
            'Send_ViaRoute_To_VehicleResponse' => '\\StructType\\Send_ViaRoute_To_VehicleResponse',
            'Remove_ViaRoute_From_Vehicle' => '\\StructType\\Remove_ViaRoute_From_Vehicle',
            'Remove_ViaRoute_From_VehicleResponse' => '\\StructType\\Remove_ViaRoute_From_VehicleResponse',
            'Import_ViaRoute_GPX' => '\\StructType\\Import_ViaRoute_GPX',
            'ViaRouteInsertGPX' => '\\StructType\\ViaRouteInsertGPX',
            'Import_ViaRoute_GPXResponse' => '\\StructType\\Import_ViaRoute_GPXResponse',
            'Export_ViaRoute_GPX' => '\\StructType\\Export_ViaRoute_GPX',
            'Export_ViaRoute_GPXResponse' => '\\StructType\\Export_ViaRoute_GPXResponse',
            'ExportViaRouteResult' => '\\StructType\\ExportViaRouteResult',
            'Get_Absences' => '\\StructType\\Get_Absences',
            'AbsenceSelection' => '\\StructType\\AbsenceSelection',
            'Get_AbsencesResponse' => '\\StructType\\Get_AbsencesResponse',
            'AbsenceResult' => '\\StructType\\AbsenceResult',
            'ArrayOfAbsenceItem' => '\\ArrayType\\ArrayOfAbsenceItem',
            'AbsenceItem' => '\\StructType\\AbsenceItem',
            'DayCode' => '\\StructType\\DayCode',
            'Get_Absences_V2' => '\\StructType\\Get_Absences_V2',
            'AbsenceSelection_V2' => '\\StructType\\AbsenceSelection_V2',
            'Get_Absences_V2Response' => '\\StructType\\Get_Absences_V2Response',
            'Get_AbsencesResult' => '\\StructType\\Get_AbsencesResult',
            'ArrayOfAbsenceItem_V2' => '\\ArrayType\\ArrayOfAbsenceItem_V2',
            'AbsenceItem_V2' => '\\StructType\\AbsenceItem_V2',
            'ArrayOfDayCode_V2' => '\\ArrayType\\ArrayOfDayCode_V2',
            'DayCode_V2' => '\\StructType\\DayCode_V2',
            'Insert_Absences' => '\\StructType\\Insert_Absences',
            'ArrayOfAbsenceDriver' => '\\ArrayType\\ArrayOfAbsenceDriver',
            'AbsenceDriver' => '\\StructType\\AbsenceDriver',
            'ArrayOfAbsence' => '\\ArrayType\\ArrayOfAbsence',
            'Absence' => '\\StructType\\Absence',
            'Insert_AbsencesResponse' => '\\StructType\\Insert_AbsencesResponse',
            'Get_AbsenceCodes' => '\\StructType\\Get_AbsenceCodes',
            'AbsenceCodeSelection' => '\\StructType\\AbsenceCodeSelection',
            'Get_AbsenceCodesResponse' => '\\StructType\\Get_AbsenceCodesResponse',
            'Get_AbsenceCodesResult' => '\\StructType\\Get_AbsenceCodesResult',
            'ArrayOfDayCode' => '\\ArrayType\\ArrayOfDayCode',
            'Get_ActivityRemarks' => '\\StructType\\Get_ActivityRemarks',
            'ActivityRemarkSelection' => '\\StructType\\ActivityRemarkSelection',
            'SynchronizationAndIdSelection' => '\\StructType\\SynchronizationAndIdSelection',
            'Get_ActivityRemarksResponse' => '\\StructType\\Get_ActivityRemarksResponse',
            'Get_ActivityRemarkResult' => '\\StructType\\Get_ActivityRemarkResult',
            'ArrayOfActivityRemarkItem' => '\\ArrayType\\ArrayOfActivityRemarkItem',
            'ActivityRemarkItem' => '\\StructType\\ActivityRemarkItem',
            'Get_ActivityReport' => '\\StructType\\Get_ActivityReport',
            'ActivityReportSelection' => '\\StructType\\ActivityReportSelection',
            'ArrayOfActivity' => '\\ArrayType\\ArrayOfActivity',
            'Get_ActivityReportResponse' => '\\StructType\\Get_ActivityReportResponse',
            'GetActivityReportResult' => '\\StructType\\GetActivityReportResult',
            'ArrayOfActivityReportItem' => '\\ArrayType\\ArrayOfActivityReportItem',
            'ActivityReportItem' => '\\StructType\\ActivityReportItem',
            'Get_ActivityReport_V2' => '\\StructType\\Get_ActivityReport_V2',
            'ActivityReportSelection_With_Remark_Info' => '\\StructType\\ActivityReportSelection_With_Remark_Info',
            'Get_ActivityReport_V2Response' => '\\StructType\\Get_ActivityReport_V2Response',
            'GetActivityReportResult_With_Remark_Info' => '\\StructType\\GetActivityReportResult_With_Remark_Info',
            'ArrayOfActivityReportItem_With_Remark_Info' => '\\ArrayType\\ArrayOfActivityReportItem_With_Remark_Info',
            'ActivityReportItem_With_Remark_Info' => '\\StructType\\ActivityReportItem_With_Remark_Info',
            'ArrayOfActivityRemark' => '\\ArrayType\\ArrayOfActivityRemark',
            'ActivityRemark' => '\\StructType\\ActivityRemark',
            'Get_ActivityReport_V3' => '\\StructType\\Get_ActivityReport_V3',
            'Get_ActivityReport_V3Response' => '\\StructType\\Get_ActivityReport_V3Response',
            'GetActivityReportResult_With_Version_Info' => '\\StructType\\GetActivityReportResult_With_Version_Info',
            'ArrayOfActivityReportItem_With_Version_Info' => '\\ArrayType\\ArrayOfActivityReportItem_With_Version_Info',
            'ActivityReportItem_With_Version_Info' => '\\StructType\\ActivityReportItem_With_Version_Info',
            'ActivityInfo_With_Version_Info' => '\\StructType\\ActivityInfo_With_Version_Info',
            'Get_ActivityReport_V4' => '\\StructType\\Get_ActivityReport_V4',
            'ActivityReportSelection_With_TimePeriodType' => '\\StructType\\ActivityReportSelection_With_TimePeriodType',
            'Get_ActivityReport_V4Response' => '\\StructType\\Get_ActivityReport_V4Response',
            'Get_ActivityReport_V5' => '\\StructType\\Get_ActivityReport_V5',
            'Get_ActivityReport_V5Response' => '\\StructType\\Get_ActivityReport_V5Response',
            'GetActivityReportResult_V5' => '\\StructType\\GetActivityReportResult_V5',
            'ArrayOfActivityReportItem_V5' => '\\ArrayType\\ArrayOfActivityReportItem_V5',
            'ActivityReportItem_V5' => '\\StructType\\ActivityReportItem_V5',
            'Get_ActivityReport_V6' => '\\StructType\\Get_ActivityReport_V6',
            'Get_ActivityReport_V6Response' => '\\StructType\\Get_ActivityReport_V6Response',
            'GetActivityReportResult_V6' => '\\StructType\\GetActivityReportResult_V6',
            'ArrayOfActivityReportItem_V6' => '\\ArrayType\\ArrayOfActivityReportItem_V6',
            'ActivityReportItem_V6' => '\\StructType\\ActivityReportItem_V6',
            'Get_ActivityReport_V7' => '\\StructType\\Get_ActivityReport_V7',
            'ActivityReportSelection_With_TimePeriodType_V2' => '\\StructType\\ActivityReportSelection_With_TimePeriodType_V2',
            'Get_ActivityReport_V7Response' => '\\StructType\\Get_ActivityReport_V7Response',
            'GetActivityReportResult_V7' => '\\StructType\\GetActivityReportResult_V7',
            'ArrayOfActivityReportItem_V7' => '\\ArrayType\\ArrayOfActivityReportItem_V7',
            'ActivityReportItem_V7' => '\\StructType\\ActivityReportItem_V7',
            'POI' => '\\StructType\\POI',
            'Get_ActivityReport_V8' => '\\StructType\\Get_ActivityReport_V8',
            'ActivityReportSelection_V2' => '\\StructType\\ActivityReportSelection_V2',
            'Get_ActivityReport_V8Response' => '\\StructType\\Get_ActivityReport_V8Response',
            'GetActivityReportResult_V8' => '\\StructType\\GetActivityReportResult_V8',
            'ArrayOfActivityReportItem_V8' => '\\ArrayType\\ArrayOfActivityReportItem_V8',
            'ActivityReportItem_V8' => '\\StructType\\ActivityReportItem_V8',
            'Get_ActivityReport_V9' => '\\StructType\\Get_ActivityReport_V9',
            'ActivityReportSelection_V3' => '\\StructType\\ActivityReportSelection_V3',
            'ActivityInfoFieldSelection' => '\\StructType\\ActivityInfoFieldSelection',
            'Get_ActivityReport_V9Response' => '\\StructType\\Get_ActivityReport_V9Response',
            'GetActivityReportResult_V9' => '\\StructType\\GetActivityReportResult_V9',
            'ArrayOfActivityReportItem_V9' => '\\ArrayType\\ArrayOfActivityReportItem_V9',
            'ActivityReportItem_V9' => '\\StructType\\ActivityReportItem_V9',
            'ActivityInfoFields' => '\\StructType\\ActivityInfoFields',
            'Get_ActivityReport_V10' => '\\StructType\\Get_ActivityReport_V10',
            'ActivityReportSelection_V4' => '\\StructType\\ActivityReportSelection_V4',
            'Get_ActivityReport_V10Response' => '\\StructType\\Get_ActivityReport_V10Response',
            'GetActivityReportResult_V10' => '\\StructType\\GetActivityReportResult_V10',
            'ArrayOfActivityReportItem_V10' => '\\ArrayType\\ArrayOfActivityReportItem_V10',
            'ActivityReportItem_V10' => '\\StructType\\ActivityReportItem_V10',
            'Get_ActivityReport_V11' => '\\StructType\\Get_ActivityReport_V11',
            'ActivityReportSelection_V5' => '\\StructType\\ActivityReportSelection_V5',
            'Get_ActivityReport_V11Response' => '\\StructType\\Get_ActivityReport_V11Response',
            'GetActivityReportResult_V11' => '\\StructType\\GetActivityReportResult_V11',
            'ArrayOfActivityReportItem_V11' => '\\ArrayType\\ArrayOfActivityReportItem_V11',
            'ActivityReportItem_V11' => '\\StructType\\ActivityReportItem_V11',
            'Get_ActivityReportDetail' => '\\StructType\\Get_ActivityReportDetail',
            'ActivityReportSelectionDetail' => '\\StructType\\ActivityReportSelectionDetail',
            'ActivityReportPathDetailSelection' => '\\StructType\\ActivityReportPathDetailSelection',
            'Get_ActivityReportDetailResponse' => '\\StructType\\Get_ActivityReportDetailResponse',
            'GetActivityReportDetailResult' => '\\StructType\\GetActivityReportDetailResult',
            'ArrayOfActivityReportDetailItem' => '\\ArrayType\\ArrayOfActivityReportDetailItem',
            'ActivityReportDetailItem' => '\\StructType\\ActivityReportDetailItem',
            'ArrayOfPathResult' => '\\ArrayType\\ArrayOfPathResult',
            'PathResult' => '\\StructType\\PathResult',
            'Get_ActivityReportDetail_V2' => '\\StructType\\Get_ActivityReportDetail_V2',
            'ActivityReportSelectionDetail_With_Remark_Info' => '\\StructType\\ActivityReportSelectionDetail_With_Remark_Info',
            'Get_ActivityReportDetail_V2Response' => '\\StructType\\Get_ActivityReportDetail_V2Response',
            'GetActivityReportDetailResult_With_Remark_Info' => '\\StructType\\GetActivityReportDetailResult_With_Remark_Info',
            'ArrayOfActivityReportDetailItem_With_Remark_Info' => '\\ArrayType\\ArrayOfActivityReportDetailItem_With_Remark_Info',
            'ActivityReportDetailItem_With_Remark_Info' => '\\StructType\\ActivityReportDetailItem_With_Remark_Info',
            'Get_ActivityReportDetail_V3' => '\\StructType\\Get_ActivityReportDetail_V3',
            'Get_ActivityReportDetail_V3Response' => '\\StructType\\Get_ActivityReportDetail_V3Response',
            'GetActivityReportDetailResult_With_Version_Info' => '\\StructType\\GetActivityReportDetailResult_With_Version_Info',
            'ArrayOfActivityReportDetailItem_With_Version_Info' => '\\ArrayType\\ArrayOfActivityReportDetailItem_With_Version_Info',
            'ActivityReportDetailItem_With_Version_Info' => '\\StructType\\ActivityReportDetailItem_With_Version_Info',
            'Get_ActivityReportDetail_V4' => '\\StructType\\Get_ActivityReportDetail_V4',
            'ActivityReportSelectionDetail_With_TimePeriodType' => '\\StructType\\ActivityReportSelectionDetail_With_TimePeriodType',
            'Get_ActivityReportDetail_V4Response' => '\\StructType\\Get_ActivityReportDetail_V4Response',
            'Get_ActivityReportDetail_V5' => '\\StructType\\Get_ActivityReportDetail_V5',
            'Get_ActivityReportDetail_V5Response' => '\\StructType\\Get_ActivityReportDetail_V5Response',
            'GetActivityReportDetailResult_V5' => '\\StructType\\GetActivityReportDetailResult_V5',
            'ArrayOfActivityReportDetailItem_V5' => '\\ArrayType\\ArrayOfActivityReportDetailItem_V5',
            'ActivityReportDetailItem_V5' => '\\StructType\\ActivityReportDetailItem_V5',
            'Get_ActivityReportDetail_V6' => '\\StructType\\Get_ActivityReportDetail_V6',
            'Get_ActivityReportDetail_V6Response' => '\\StructType\\Get_ActivityReportDetail_V6Response',
            'GetActivityReportDetailResult_V6' => '\\StructType\\GetActivityReportDetailResult_V6',
            'ArrayOfActivityReportDetailItem_V6' => '\\ArrayType\\ArrayOfActivityReportDetailItem_V6',
            'ActivityReportDetailItem_V6' => '\\StructType\\ActivityReportDetailItem_V6',
            'Get_ActivityReportDetail_V7' => '\\StructType\\Get_ActivityReportDetail_V7',
            'ActivityReportSelectionDetail_With_TimePeriodType_V2' => '\\StructType\\ActivityReportSelectionDetail_With_TimePeriodType_V2',
            'Get_ActivityReportDetail_V7Response' => '\\StructType\\Get_ActivityReportDetail_V7Response',
            'GetActivityReportDetailResult_V7' => '\\StructType\\GetActivityReportDetailResult_V7',
            'ArrayOfActivityReportDetailItem_V7' => '\\ArrayType\\ArrayOfActivityReportDetailItem_V7',
            'ActivityReportDetailItem_V7' => '\\StructType\\ActivityReportDetailItem_V7',
            'Get_ActivityReportDetail_V8' => '\\StructType\\Get_ActivityReportDetail_V8',
            'ActivityReportSelectionDetail_V2' => '\\StructType\\ActivityReportSelectionDetail_V2',
            'Get_ActivityReportDetail_V8Response' => '\\StructType\\Get_ActivityReportDetail_V8Response',
            'GetActivityReportDetailResult_V8' => '\\StructType\\GetActivityReportDetailResult_V8',
            'ArrayOfActivityReportDetailItem_V8' => '\\ArrayType\\ArrayOfActivityReportDetailItem_V8',
            'ActivityReportDetailItem_V8' => '\\StructType\\ActivityReportDetailItem_V8',
            'Get_ActivityReportDetail_V9' => '\\StructType\\Get_ActivityReportDetail_V9',
            'ActivityReportSelectionDetail_V3' => '\\StructType\\ActivityReportSelectionDetail_V3',
            'Get_ActivityReportDetail_V9Response' => '\\StructType\\Get_ActivityReportDetail_V9Response',
            'GetActivityReportDetailResult_V9' => '\\StructType\\GetActivityReportDetailResult_V9',
            'ArrayOfActivityReportDetailItem_V9' => '\\ArrayType\\ArrayOfActivityReportDetailItem_V9',
            'ActivityReportDetailItem_V9' => '\\StructType\\ActivityReportDetailItem_V9',
            'Get_AlarmMessages' => '\\StructType\\Get_AlarmMessages',
            'AlarmMessageSelection' => '\\StructType\\AlarmMessageSelection',
            'ArrayOfEnumAlarmMessageType' => '\\ArrayType\\ArrayOfEnumAlarmMessageType',
            'Get_AlarmMessagesResponse' => '\\StructType\\Get_AlarmMessagesResponse',
            'GetAlarmMessage' => '\\StructType\\GetAlarmMessage',
            'ArrayOfAlarmMessageResult' => '\\ArrayType\\ArrayOfAlarmMessageResult',
            'AlarmMessageResult' => '\\StructType\\AlarmMessageResult',
            'GeoZoneResult' => '\\StructType\\GeoZoneResult',
            'GeoZone' => '\\StructType\\GeoZone',
            'GeoZoneResult_v2' => '\\StructType\\GeoZoneResult_v2',
            'Get_AlarmMessages_V2' => '\\StructType\\Get_AlarmMessages_V2',
            'Get_AlarmMessages_V2Response' => '\\StructType\\Get_AlarmMessages_V2Response',
            'GetAlarmMessage_v2' => '\\StructType\\GetAlarmMessage_v2',
            'ArrayOfAlarmMessageResult_v2' => '\\ArrayType\\ArrayOfAlarmMessageResult_v2',
            'AlarmMessageResult_v2' => '\\StructType\\AlarmMessageResult_v2',
            'GeoFenceResult_v2' => '\\StructType\\GeoFenceResult_v2',
            'Get_AlarmMessages_V3' => '\\StructType\\Get_AlarmMessages_V3',
            'Get_AlarmMessages_V3Response' => '\\StructType\\Get_AlarmMessages_V3Response',
            'GetAlarmMessage_V3' => '\\StructType\\GetAlarmMessage_V3',
            'ArrayOfAlarmMessageResult_V3' => '\\ArrayType\\ArrayOfAlarmMessageResult_V3',
            'AlarmMessageResult_V3' => '\\StructType\\AlarmMessageResult_V3',
            'GeoFenceResult_v3' => '\\StructType\\GeoFenceResult_v3',
            'GeoZoneStrategy' => '\\StructType\\GeoZoneStrategy',
            'RadiusZone' => '\\StructType\\RadiusZone',
            'PolygonZone' => '\\StructType\\PolygonZone',
            'ArrayOfPosition_V2' => '\\ArrayType\\ArrayOfPosition_V2',
            'Position_V2' => '\\StructType\\Position_V2',
            'Get_AlarmMessages_V4' => '\\StructType\\Get_AlarmMessages_V4',
            'AlarmMessageResult_V4' => '\\StructType\\AlarmMessageResult_V4',
            'ArrayOfAlarmMessageResult_V4' => '\\ArrayType\\ArrayOfAlarmMessageResult_V4',
            'Get_AlarmMessages_V4Response' => '\\StructType\\Get_AlarmMessages_V4Response',
            'GetAlarmMessage_V4' => '\\StructType\\GetAlarmMessage_V4',
            'Get_AlarmMessages_V5' => '\\StructType\\Get_AlarmMessages_V5',
            'AlarmMessageSelection_V2' => '\\StructType\\AlarmMessageSelection_V2',
            'ArrayOfAlarmMessageResult_V5' => '\\ArrayType\\ArrayOfAlarmMessageResult_V5',
            'AlarmMessageResult_V5' => '\\StructType\\AlarmMessageResult_V5',
            'Get_AlarmMessages_V5Response' => '\\StructType\\Get_AlarmMessages_V5Response',
            'GetAlarmMessage_V5' => '\\StructType\\GetAlarmMessage_V5',
            'Get_AlarmMessages_V6' => '\\StructType\\Get_AlarmMessages_V6',
            'AlarmMessageSelection_V3' => '\\StructType\\AlarmMessageSelection_V3',
            'Get_AlarmMessages_V6Response' => '\\StructType\\Get_AlarmMessages_V6Response',
            'Get_AlarmMessages_V7' => '\\StructType\\Get_AlarmMessages_V7',
            'AlarmMessageSelection_V7' => '\\StructType\\AlarmMessageSelection_V7',
            'VehicleListStrategySelection' => '\\StructType\\VehicleListStrategySelection',
            'TrailerStrategyList' => '\\StructType\\TrailerStrategyList',
            'VehicleStrategyList' => '\\StructType\\VehicleStrategyList',
            'DateStrategySelection' => '\\StructType\\DateStrategySelection',
            'ActualSituation' => '\\StructType\\ActualSituation',
            'ChangedAfter' => '\\StructType\\ChangedAfter',
            'ChangedAfterId' => '\\StructType\\ChangedAfterId',
            'Period' => '\\StructType\\Period',
            'AlarmMessageResult_V7' => '\\StructType\\AlarmMessageResult_V7',
            'ArrayOfAlarmMessageResult_V7' => '\\ArrayType\\ArrayOfAlarmMessageResult_V7',
            'Get_AlarmMessages_V7Response' => '\\StructType\\Get_AlarmMessages_V7Response',
            'Update_AlarmMessages_Treated' => '\\StructType\\Update_AlarmMessages_Treated',
            'Update_AlarmMessages_TreatedResponse' => '\\StructType\\Update_AlarmMessages_TreatedResponse',
            'Get_AlarmMessageTypes' => '\\StructType\\Get_AlarmMessageTypes',
            'Get_AlarmMessageTypesResponse' => '\\StructType\\Get_AlarmMessageTypesResponse',
            'GetAlarmMessageTypesResult' => '\\StructType\\GetAlarmMessageTypesResult',
            'Get_BorderCrossingReport' => '\\StructType\\Get_BorderCrossingReport',
            'BorderCrossingSelection' => '\\StructType\\BorderCrossingSelection',
            'BorderCrossing' => '\\StructType\\BorderCrossing',
            'Country' => '\\StructType\\Country',
            'ArrayOfWorkingCodeDuration' => '\\ArrayType\\ArrayOfWorkingCodeDuration',
            'WorkingCodeDuration' => '\\StructType\\WorkingCodeDuration',
            'ArrayOfBorderCrossing' => '\\ArrayType\\ArrayOfBorderCrossing',
            'Get_BorderCrossingReportResponse' => '\\StructType\\Get_BorderCrossingReportResponse',
            'GetBorderCrossingReportResult' => '\\StructType\\GetBorderCrossingReportResult',
            'Get_ConsumptionReport' => '\\StructType\\Get_ConsumptionReport',
            'ConsumptionReportSelection' => '\\StructType\\ConsumptionReportSelection',
            'ConsumptionReportItem' => '\\StructType\\ConsumptionReportItem',
            'ArrayOfConsumptionReportItem' => '\\ArrayType\\ArrayOfConsumptionReportItem',
            'Get_ConsumptionReportResponse' => '\\StructType\\Get_ConsumptionReportResponse',
            'GetConsumptionReportResult' => '\\StructType\\GetConsumptionReportResult',
            'Get_SubcontractedVehicles' => '\\StructType\\Get_SubcontractedVehicles',
            'SubcontractedVehicleSelection' => '\\StructType\\SubcontractedVehicleSelection',
            'IdentifierVehicleStrategy' => '\\StructType\\IdentifierVehicleStrategy',
            'TrailerStrategy' => '\\StructType\\TrailerStrategy',
            'TruckStrategy' => '\\StructType\\TruckStrategy',
            'CompanyStrategySelection' => '\\StructType\\CompanyStrategySelection',
            'CompanyId' => '\\StructType\\CompanyId',
            'CompanyCode' => '\\StructType\\CompanyCode',
            'SubscriptionPeriod' => '\\StructType\\SubscriptionPeriod',
            'VehicleIdentifier' => '\\StructType\\VehicleIdentifier',
            'VehicleStrategy' => '\\StructType\\VehicleStrategy',
            'TruckResultStrategy' => '\\StructType\\TruckResultStrategy',
            'TrailerResultStrategy' => '\\StructType\\TrailerResultStrategy',
            'Company' => '\\StructType\\Company',
            'SubcontractedVehicleResult' => '\\StructType\\SubcontractedVehicleResult',
            'ArrayOfSubcontractedResultStrategy' => '\\ArrayType\\ArrayOfSubcontractedResultStrategy',
            'SubcontractedResultStrategy' => '\\StructType\\SubcontractedResultStrategy',
            'VehicleSubscription' => '\\StructType\\VehicleSubscription',
            'CompanySubscription' => '\\StructType\\CompanySubscription',
            'Get_SubcontractedVehiclesResponse' => '\\StructType\\Get_SubcontractedVehiclesResponse',
            'Get_SubcontractedVehicleResult' => '\\StructType\\Get_SubcontractedVehicleResult',
            'Set_SubcontractedVehicles' => '\\StructType\\Set_SubcontractedVehicles',
            'SubcontractedVehicleStrategy' => '\\StructType\\SubcontractedVehicleStrategy',
            'Assign' => '\\StructType\\Assign',
            'ArrayOfIdentifierVehicleStrategy' => '\\ArrayType\\ArrayOfIdentifierVehicleStrategy',
            'Remove' => '\\StructType\\Remove',
            'Update' => '\\StructType\\Update',
            'Set_SubcontractedVehiclesResponse' => '\\StructType\\Set_SubcontractedVehiclesResponse',
            'Set_SubcontractedVehicleResult' => '\\StructType\\Set_SubcontractedVehicleResult',
            'Control_Corridor' => '\\StructType\\Control_Corridor',
            'CorridorSelection' => '\\StructType\\CorridorSelection',
            'Control_CorridorResponse' => '\\StructType\\Control_CorridorResponse',
            'Get_CostAndCompensationReport' => '\\StructType\\Get_CostAndCompensationReport',
            'CostCompensationReportSelection' => '\\StructType\\CostCompensationReportSelection',
            'CostCompensationReportItem' => '\\StructType\\CostCompensationReportItem',
            'IdentifierSupplierResult' => '\\StructType\\IdentifierSupplierResult',
            'ArrayOfCostCompensationReportItem' => '\\ArrayType\\ArrayOfCostCompensationReportItem',
            'Get_CostAndCompensationReportResponse' => '\\StructType\\Get_CostAndCompensationReportResponse',
            'GetCostCompensationReportResult' => '\\StructType\\GetCostCompensationReportResult',
            'Get_CostAndCompensationReport_V3' => '\\StructType\\Get_CostAndCompensationReport_V3',
            'CostCompensationReportSelection_V3' => '\\StructType\\CostCompensationReportSelection_V3',
            'CostCompensationReportItem_V3' => '\\StructType\\CostCompensationReportItem_V3',
            'CostCompensationCode_V3' => '\\StructType\\CostCompensationCode_V3',
            'ArrayOfCostCompensationReportItem_V3' => '\\ArrayType\\ArrayOfCostCompensationReportItem_V3',
            'Get_CostAndCompensationReport_V3Response' => '\\StructType\\Get_CostAndCompensationReport_V3Response',
            'GetCostCompensationReportResult_V3' => '\\StructType\\GetCostCompensationReportResult_V3',
            'Get_CostAndCompensationCodes' => '\\StructType\\Get_CostAndCompensationCodes',
            'CostCompensationCodeSelection' => '\\StructType\\CostCompensationCodeSelection',
            'CostCompensationCodeItem' => '\\StructType\\CostCompensationCodeItem',
            'ArrayOfCostCompensationCodeItem' => '\\ArrayType\\ArrayOfCostCompensationCodeItem',
            'Get_CostAndCompensationCodesResponse' => '\\StructType\\Get_CostAndCompensationCodesResponse',
            'Get_CostCompensationCodesResult' => '\\StructType\\Get_CostCompensationCodesResult',
            'Send_Destination' => '\\StructType\\Send_Destination',
            'SendDestination' => '\\StructType\\SendDestination',
            'Destination' => '\\StructType\\Destination',
            'Send_DestinationResponse' => '\\StructType\\Send_DestinationResponse',
            'Get_Dispatchers' => '\\StructType\\Get_Dispatchers',
            'DispatcherSelection' => '\\StructType\\DispatcherSelection',
            'Dispatcher' => '\\StructType\\Dispatcher',
            'DispatcherResult' => '\\StructType\\DispatcherResult',
            'ArrayOfDispatcherResult' => '\\ArrayType\\ArrayOfDispatcherResult',
            'Get_DispatchersResponse' => '\\StructType\\Get_DispatchersResponse',
            'GetDispatcherResult' => '\\StructType\\GetDispatcherResult',
            'Get_Dispatchers_V2' => '\\StructType\\Get_Dispatchers_V2',
            'PersonalCommunication' => '\\StructType\\PersonalCommunication',
            'ArrayOfPersonalCommunication' => '\\ArrayType\\ArrayOfPersonalCommunication',
            'ArrayOfDispatcherResult_V2' => '\\ArrayType\\ArrayOfDispatcherResult_V2',
            'DispatcherResult_V2' => '\\StructType\\DispatcherResult_V2',
            'Get_Dispatchers_V2Response' => '\\StructType\\Get_Dispatchers_V2Response',
            'GetDispatcherResult_V2' => '\\StructType\\GetDispatcherResult_V2',
            'Get_Dispatchers_V3' => '\\StructType\\Get_Dispatchers_V3',
            'ArrayOfDispatcherResult_V3' => '\\ArrayType\\ArrayOfDispatcherResult_V3',
            'DispatcherResult_V3' => '\\StructType\\DispatcherResult_V3',
            'Get_Dispatchers_V3Response' => '\\StructType\\Get_Dispatchers_V3Response',
            'GetDispatcherResult_V3' => '\\StructType\\GetDispatcherResult_V3',
            'Insert_Dispatcher' => '\\StructType\\Insert_Dispatcher',
            'DispatcherInsert' => '\\StructType\\DispatcherInsert',
            'Insert_DispatcherResponse' => '\\StructType\\Insert_DispatcherResponse',
            'Insert_Dispatcher_V2' => '\\StructType\\Insert_Dispatcher_V2',
            'DispatcherInsert_V2' => '\\StructType\\DispatcherInsert_V2',
            'ArrayOfPersonalCommunicationInsert' => '\\ArrayType\\ArrayOfPersonalCommunicationInsert',
            'PersonalCommunicationInsert' => '\\StructType\\PersonalCommunicationInsert',
            'Insert_Dispatcher_V2Response' => '\\StructType\\Insert_Dispatcher_V2Response',
            'InsertDispatcherResult' => '\\StructType\\InsertDispatcherResult',
            'Update_Dispatcher' => '\\StructType\\Update_Dispatcher',
            'Update_DispatcherResponse' => '\\StructType\\Update_DispatcherResponse',
            'Update_Dispatcher_V2' => '\\StructType\\Update_Dispatcher_V2',
            'DispatcherUpdate' => '\\StructType\\DispatcherUpdate',
            'Update_Dispatcher_V2Response' => '\\StructType\\Update_Dispatcher_V2Response',
            'Delete_Dispatcher' => '\\StructType\\Delete_Dispatcher',
            'Delete_DispatcherResponse' => '\\StructType\\Delete_DispatcherResponse',
            'Get_DistanceReportSummary' => '\\StructType\\Get_DistanceReportSummary',
            'DistanceReportSelection' => '\\StructType\\DistanceReportSelection',
            'DistanceReportItem' => '\\StructType\\DistanceReportItem',
            'ArrayOfDistanceReportItem' => '\\ArrayType\\ArrayOfDistanceReportItem',
            'Get_DistanceReportSummaryResponse' => '\\StructType\\Get_DistanceReportSummaryResponse',
            'GetDistanceReport' => '\\StructType\\GetDistanceReport',
            'Get_DistanceReportSummary_V2' => '\\StructType\\Get_DistanceReportSummary_V2',
            'ArrayOfDistanceReportItem_v2' => '\\ArrayType\\ArrayOfDistanceReportItem_v2',
            'DistanceReportItem_v2' => '\\StructType\\DistanceReportItem_v2',
            'Get_DistanceReportSummary_V2Response' => '\\StructType\\Get_DistanceReportSummary_V2Response',
            'GetDistanceReport_v2' => '\\StructType\\GetDistanceReport_v2',
            'Get_DistanceReportSummary_V3' => '\\StructType\\Get_DistanceReportSummary_V3',
            'DistanceReportSelection_V2' => '\\StructType\\DistanceReportSelection_V2',
            'ArrayOfDistanceReportItem_V3' => '\\ArrayType\\ArrayOfDistanceReportItem_V3',
            'DistanceReportItem_V3' => '\\StructType\\DistanceReportItem_V3',
            'Get_DistanceReportSummary_V3Response' => '\\StructType\\Get_DistanceReportSummary_V3Response',
            'GetDistanceReport_V3' => '\\StructType\\GetDistanceReport_V3',
            'Get_Scanned_Document' => '\\StructType\\Get_Scanned_Document',
            'ScannedDocumentSelection' => '\\StructType\\ScannedDocumentSelection',
            'Document' => '\\StructType\\Document',
            'DocumentResult' => '\\StructType\\DocumentResult',
            'ArrayOfDocumentResult' => '\\ArrayType\\ArrayOfDocumentResult',
            'Get_Scanned_DocumentResponse' => '\\StructType\\Get_Scanned_DocumentResponse',
            'GetScannedDocument' => '\\StructType\\GetScannedDocument',
            'Get_Scanned_Document_V2' => '\\StructType\\Get_Scanned_Document_V2',
            'ArrayOfDocumentResult_V2' => '\\ArrayType\\ArrayOfDocumentResult_V2',
            'DocumentResult_V2' => '\\StructType\\DocumentResult_V2',
            'Document_V2' => '\\StructType\\Document_V2',
            'Get_Scanned_Document_V2Response' => '\\StructType\\Get_Scanned_Document_V2Response',
            'GetScannedDocument_V2' => '\\StructType\\GetScannedDocument_V2',
            'Get_Scanned_Document_V3' => '\\StructType\\Get_Scanned_Document_V3',
            'JobIdentifier' => '\\StructType\\JobIdentifier',
            'ArrayOfDocumentResult_V3' => '\\ArrayType\\ArrayOfDocumentResult_V3',
            'DocumentResult_V3' => '\\StructType\\DocumentResult_V3',
            'Get_Scanned_Document_V3Response' => '\\StructType\\Get_Scanned_Document_V3Response',
            'GetScannedDocument_V3' => '\\StructType\\GetScannedDocument_V3',
            'Get_Scanned_Document_V4' => '\\StructType\\Get_Scanned_Document_V4',
            'ProductIdentifier' => '\\StructType\\ProductIdentifier',
            'ArrayOfDocumentResult_V4' => '\\ArrayType\\ArrayOfDocumentResult_V4',
            'DocumentResult_V4' => '\\StructType\\DocumentResult_V4',
            'Get_Scanned_Document_V4Response' => '\\StructType\\Get_Scanned_Document_V4Response',
            'GetScannedDocument_V4' => '\\StructType\\GetScannedDocument_V4',
            'Get_Scanned_Documents' => '\\StructType\\Get_Scanned_Documents',
            'ScannedDocumentsSelection' => '\\StructType\\ScannedDocumentsSelection',
            'ArrayOfDocument' => '\\ArrayType\\ArrayOfDocument',
            'Get_Scanned_DocumentsResponse' => '\\StructType\\Get_Scanned_DocumentsResponse',
            'GetScannedDocuments' => '\\StructType\\GetScannedDocuments',
            'Get_Scanned_Documents_V2' => '\\StructType\\Get_Scanned_Documents_V2',
            'ScannedDocumentsSelection_V2' => '\\StructType\\ScannedDocumentsSelection_V2',
            'ArrayOfDocument_V3' => '\\ArrayType\\ArrayOfDocument_V3',
            'Document_V3' => '\\StructType\\Document_V3',
            'Get_Scanned_Documents_V2Response' => '\\StructType\\Get_Scanned_Documents_V2Response',
            'GetScannedDocuments_V2' => '\\StructType\\GetScannedDocuments_V2',
            'Get_Scanned_Documents_V3' => '\\StructType\\Get_Scanned_Documents_V3',
            'ArrayOfDocumentsResult_V3' => '\\ArrayType\\ArrayOfDocumentsResult_V3',
            'DocumentsResult_V3' => '\\StructType\\DocumentsResult_V3',
            'Get_Scanned_Documents_V3Response' => '\\StructType\\Get_Scanned_Documents_V3Response',
            'GetScannedDocuments_V3' => '\\StructType\\GetScannedDocuments_V3',
            'Get_Scanned_Documents_V4' => '\\StructType\\Get_Scanned_Documents_V4',
            'ArrayOfDocumentsResult_V4' => '\\ArrayType\\ArrayOfDocumentsResult_V4',
            'DocumentsResult_V4' => '\\StructType\\DocumentsResult_V4',
            'Get_Scanned_Documents_V4Response' => '\\StructType\\Get_Scanned_Documents_V4Response',
            'GetScannedDocuments_V4' => '\\StructType\\GetScannedDocuments_V4',
            'Get_Drivers' => '\\StructType\\Get_Drivers',
            'PersonSelection' => '\\StructType\\PersonSelection',
            'PersonRegistrations' => '\\StructType\\PersonRegistrations',
            'LastVehicleInfo' => '\\StructType\\LastVehicleInfo',
            'Person' => '\\StructType\\Person',
            'PersonTechnicalInfo' => '\\StructType\\PersonTechnicalInfo',
            'PersonPrivateInfo' => '\\StructType\\PersonPrivateInfo',
            'PersonContactInfo' => '\\StructType\\PersonContactInfo',
            'PersonAddress' => '\\StructType\\PersonAddress',
            'PersonResult' => '\\StructType\\PersonResult',
            'ArrayOfPersonResult' => '\\ArrayType\\ArrayOfPersonResult',
            'Get_DriversResponse' => '\\StructType\\Get_DriversResponse',
            'GetPersonResult' => '\\StructType\\GetPersonResult',
            'Get_Drivers_V2' => '\\StructType\\Get_Drivers_V2',
            'Person_V2' => '\\StructType\\Person_V2',
            'PersonContactInfo_V2' => '\\StructType\\PersonContactInfo_V2',
            'PersonAddress_V2' => '\\StructType\\PersonAddress_V2',
            'PersonResult_V2' => '\\StructType\\PersonResult_V2',
            'ArrayOfPersonResult_V2' => '\\ArrayType\\ArrayOfPersonResult_V2',
            'Get_Drivers_V2Response' => '\\StructType\\Get_Drivers_V2Response',
            'GetPersonResult_V2' => '\\StructType\\GetPersonResult_V2',
            'Get_Drivers_V3' => '\\StructType\\Get_Drivers_V3',
            'LastVehicleInfo_V2' => '\\StructType\\LastVehicleInfo_V2',
            'ArrayOfPersonResult_V3' => '\\ArrayType\\ArrayOfPersonResult_V3',
            'PersonResult_V3' => '\\StructType\\PersonResult_V3',
            'Get_Drivers_V3Response' => '\\StructType\\Get_Drivers_V3Response',
            'GetPersonResult_V3' => '\\StructType\\GetPersonResult_V3',
            'Get_Drivers_V4' => '\\StructType\\Get_Drivers_V4',
            'PersonSelection_V2' => '\\StructType\\PersonSelection_V2',
            'CurrentActivityResult' => '\\StructType\\CurrentActivityResult',
            'CurrentLocationResult' => '\\StructType\\CurrentLocationResult',
            'ArrayOfPersonResult_V4' => '\\ArrayType\\ArrayOfPersonResult_V4',
            'PersonResult_V4' => '\\StructType\\PersonResult_V4',
            'LastVehicleInfo_V3' => '\\StructType\\LastVehicleInfo_V3',
            'Get_Drivers_V4Response' => '\\StructType\\Get_Drivers_V4Response',
            'GetPersonResult_V4' => '\\StructType\\GetPersonResult_V4',
            'Get_Drivers_V5' => '\\StructType\\Get_Drivers_V5',
            'InterfaceTachoCardInfo_V2' => '\\StructType\\InterfaceTachoCardInfo_V2',
            'Person_V3' => '\\StructType\\Person_V3',
            'InterfacePersonContactInfo_V3' => '\\StructType\\InterfacePersonContactInfo_V3',
            'PersonAddress_V3' => '\\StructType\\PersonAddress_V3',
            'InterfacePersonResult_V5' => '\\StructType\\InterfacePersonResult_V5',
            'ArrayOfInterfacePersonResult_V5' => '\\ArrayType\\ArrayOfInterfacePersonResult_V5',
            'Get_Drivers_V5Response' => '\\StructType\\Get_Drivers_V5Response',
            'InterfaceGetPersonResult_V5' => '\\StructType\\InterfaceGetPersonResult_V5',
            'Get_Drivers_V6' => '\\StructType\\Get_Drivers_V6',
            'PersonSelection_V3' => '\\StructType\\PersonSelection_V3',
            'ArrayOfInterfacePersonResult_V6' => '\\ArrayType\\ArrayOfInterfacePersonResult_V6',
            'InterfacePersonResult_V6' => '\\StructType\\InterfacePersonResult_V6',
            'Get_Drivers_V6Response' => '\\StructType\\Get_Drivers_V6Response',
            'InterfaceGetPersonResult_V6' => '\\StructType\\InterfaceGetPersonResult_V6',
            'Get_Drivers_V7' => '\\StructType\\Get_Drivers_V7',
            'Person_V4' => '\\StructType\\Person_V4',
            'InterfacePersonContactInfo_V4' => '\\StructType\\InterfacePersonContactInfo_V4',
            'PersonAddress_V4' => '\\StructType\\PersonAddress_V4',
            'InterfacePersonResult_V7' => '\\StructType\\InterfacePersonResult_V7',
            'ArrayOfInterfacePersonResult_V7' => '\\ArrayType\\ArrayOfInterfacePersonResult_V7',
            'Get_Drivers_V7Response' => '\\StructType\\Get_Drivers_V7Response',
            'InterfaceGetPersonResult_V7' => '\\StructType\\InterfaceGetPersonResult_V7',
            'Get_Drivers_V8' => '\\StructType\\Get_Drivers_V8',
            'PersonSelection_V4' => '\\StructType\\PersonSelection_V4',
            'InterfaceTachoCardInfo_V3' => '\\StructType\\InterfaceTachoCardInfo_V3',
            'Person_V5' => '\\StructType\\Person_V5',
            'PersonLanguages' => '\\StructType\\PersonLanguages',
            'PersonLicenseInfo' => '\\StructType\\PersonLicenseInfo',
            'PersonHRInfo' => '\\StructType\\PersonHRInfo',
            'PersonStatuses' => '\\StructType\\PersonStatuses',
            'PersonTags' => '\\StructType\\PersonTags',
            'ArrayOfPersonTag' => '\\ArrayType\\ArrayOfPersonTag',
            'PersonTag' => '\\StructType\\PersonTag',
            'PersonGroups' => '\\StructType\\PersonGroups',
            'InterfacePersonResult_V8' => '\\StructType\\InterfacePersonResult_V8',
            'ArrayOfInterfacePersonResult_V8' => '\\ArrayType\\ArrayOfInterfacePersonResult_V8',
            'Get_Drivers_V8Response' => '\\StructType\\Get_Drivers_V8Response',
            'InterfaceGetPersonResult_V8' => '\\StructType\\InterfaceGetPersonResult_V8',
            'Get_Drivers_V9' => '\\StructType\\Get_Drivers_V9',
            'PersonSelection_V5' => '\\StructType\\PersonSelection_V5',
            'GenericFilter' => '\\StructType\\GenericFilter',
            'GenericItem_V1' => '\\StructType\\GenericItem_V1',
            'ArrayOfGenericItem_V1' => '\\ArrayType\\ArrayOfGenericItem_V1',
            'ArrayOfInterfacePersonResult_V9' => '\\ArrayType\\ArrayOfInterfacePersonResult_V9',
            'InterfacePersonResult_V9' => '\\StructType\\InterfacePersonResult_V9',
            'Get_Drivers_V9Response' => '\\StructType\\Get_Drivers_V9Response',
            'InterfaceGetPersonResult_V9' => '\\StructType\\InterfaceGetPersonResult_V9',
            'Insert_Driver' => '\\StructType\\Insert_Driver',
            'PersonInsert' => '\\StructType\\PersonInsert',
            'Insert_DriverResponse' => '\\StructType\\Insert_DriverResponse',
            'Insert_Driver_V2' => '\\StructType\\Insert_Driver_V2',
            'PersonInsert_V2' => '\\StructType\\PersonInsert_V2',
            'Insert_Driver_V2Response' => '\\StructType\\Insert_Driver_V2Response',
            'Insert_Driver_V3' => '\\StructType\\Insert_Driver_V3',
            'InterfacePersonInsert_V3' => '\\StructType\\InterfacePersonInsert_V3',
            'InterfaceTachoCardInfoInsert' => '\\StructType\\InterfaceTachoCardInfoInsert',
            'Insert_Driver_V3Response' => '\\StructType\\Insert_Driver_V3Response',
            'Update_Driver' => '\\StructType\\Update_Driver',
            'Update_DriverResponse' => '\\StructType\\Update_DriverResponse',
            'Update_Driver_V2' => '\\StructType\\Update_Driver_V2',
            'PersonUpdate' => '\\StructType\\PersonUpdate',
            'Update_Driver_V2Response' => '\\StructType\\Update_Driver_V2Response',
            'Update_Driver_V3' => '\\StructType\\Update_Driver_V3',
            'PersonUpdate_V2' => '\\StructType\\PersonUpdate_V2',
            'Update_Driver_V3Response' => '\\StructType\\Update_Driver_V3Response',
            'Update_Driver_V4' => '\\StructType\\Update_Driver_V4',
            'InterfacePersonUpdate_V3' => '\\StructType\\InterfacePersonUpdate_V3',
            'InterfaceTachoCardInfoUpdate' => '\\StructType\\InterfaceTachoCardInfoUpdate',
            'Update_Driver_V4Response' => '\\StructType\\Update_Driver_V4Response',
            'Get_EcoMonitor_Report' => '\\StructType\\Get_EcoMonitor_Report',
            'EcoMonitorReportSelection' => '\\StructType\\EcoMonitorReportSelection',
            'EcoMonitorReportItem' => '\\StructType\\EcoMonitorReportItem',
            'EcoMonitorDataResult' => '\\StructType\\EcoMonitorDataResult',
            'EcoMonitorIdlingResult' => '\\StructType\\EcoMonitorIdlingResult',
            'EcoMonitorOverSpeedingResult' => '\\StructType\\EcoMonitorOverSpeedingResult',
            'EcoMonitorCoastingResult' => '\\StructType\\EcoMonitorCoastingResult',
            'EcoMonitorAnticipationResult' => '\\StructType\\EcoMonitorAnticipationResult',
            'EcoMonitorGearingResult' => '\\StructType\\EcoMonitorGearingResult',
            'EcoMonitorPtoResult' => '\\StructType\\EcoMonitorPtoResult',
            'EcoMonitorCruisingResult' => '\\StructType\\EcoMonitorCruisingResult',
            'ArrayOfEcoMonitorReportItem' => '\\ArrayType\\ArrayOfEcoMonitorReportItem',
            'Get_EcoMonitor_ReportResponse' => '\\StructType\\Get_EcoMonitor_ReportResponse',
            'GetEcoMonitorReportResult' => '\\StructType\\GetEcoMonitorReportResult',
            'Get_EcoMonitor_Report_V2' => '\\StructType\\Get_EcoMonitor_Report_V2',
            'EcoMonitorReportItem_V2' => '\\StructType\\EcoMonitorReportItem_V2',
            'EcoMonitorAnticipationResult_V2' => '\\StructType\\EcoMonitorAnticipationResult_V2',
            'EcoMonitorGreenSpotResult' => '\\StructType\\EcoMonitorGreenSpotResult',
            'ArrayOfEcoMonitorReportItem_V2' => '\\ArrayType\\ArrayOfEcoMonitorReportItem_V2',
            'Get_EcoMonitor_Report_V2Response' => '\\StructType\\Get_EcoMonitor_Report_V2Response',
            'GetEcoMonitorReportResult_V2' => '\\StructType\\GetEcoMonitorReportResult_V2',
            'Get_EcoMonitor_Report_V3' => '\\StructType\\Get_EcoMonitor_Report_V3',
            'EcoMonitorReportSelection_V2' => '\\StructType\\EcoMonitorReportSelection_V2',
            'ModificationSelection' => '\\StructType\\ModificationSelection',
            'Get_EcoMonitor_Report_V3Response' => '\\StructType\\Get_EcoMonitor_Report_V3Response',
            'GetEcoMonitorReportResult_V3' => '\\StructType\\GetEcoMonitorReportResult_V3',
            'Get_EcoScore_Report' => '\\StructType\\Get_EcoScore_Report',
            'EcoScoreSelection' => '\\StructType\\EcoScoreSelection',
            'GetEcoScoreReportItem' => '\\StructType\\GetEcoScoreReportItem',
            'ArrayOfGetEcoScoreReportItem' => '\\ArrayType\\ArrayOfGetEcoScoreReportItem',
            'Get_EcoScore_ReportResponse' => '\\StructType\\Get_EcoScore_ReportResponse',
            'GetEcoScoreReportResult' => '\\StructType\\GetEcoScoreReportResult',
            'Get_EcoScore_Report_V2' => '\\StructType\\Get_EcoScore_Report_V2',
            'ArrayOfGetEcoScoreReportItem_V2' => '\\ArrayType\\ArrayOfGetEcoScoreReportItem_V2',
            'GetEcoScoreReportItem_V2' => '\\StructType\\GetEcoScoreReportItem_V2',
            'Get_EcoScore_Report_V2Response' => '\\StructType\\Get_EcoScore_Report_V2Response',
            'GetEcoScoreReportResult_V2' => '\\StructType\\GetEcoScoreReportResult_V2',
            'Get_Eco_Assistant' => '\\StructType\\Get_Eco_Assistant',
            'EcoAssistantSelection' => '\\StructType\\EcoAssistantSelection',
            'EcoAssistantItem' => '\\StructType\\EcoAssistantItem',
            'EcoAssistantWeekItem' => '\\StructType\\EcoAssistantWeekItem',
            'ArrayOfEcoAssistantDayItem' => '\\ArrayType\\ArrayOfEcoAssistantDayItem',
            'EcoAssistantDayItem' => '\\StructType\\EcoAssistantDayItem',
            'Get_Eco_AssistantResponse' => '\\StructType\\Get_Eco_AssistantResponse',
            'GetEcoAssistantResult' => '\\StructType\\GetEcoAssistantResult',
            'Get_EcoPerformance' => '\\StructType\\Get_EcoPerformance',
            'EcoPerformanceSelection' => '\\StructType\\EcoPerformanceSelection',
            'GroupIdentifier' => '\\StructType\\GroupIdentifier',
            'EcoPerformanceProfileSelection' => '\\StructType\\EcoPerformanceProfileSelection',
            'EcoPerformanceProfileDetails' => '\\StructType\\EcoPerformanceProfileDetails',
            'EcoPerformanceProfileParameter' => '\\StructType\\EcoPerformanceProfileParameter',
            'EcoPerformanceReport' => '\\StructType\\EcoPerformanceReport',
            'EcoPerformanceInfo' => '\\StructType\\EcoPerformanceInfo',
            'EcoPerformanceData' => '\\StructType\\EcoPerformanceData',
            'EcoPerformanceScore' => '\\StructType\\EcoPerformanceScore',
            'ArrayOfEcoPerformanceReport' => '\\ArrayType\\ArrayOfEcoPerformanceReport',
            'Get_EcoPerformanceResponse' => '\\StructType\\Get_EcoPerformanceResponse',
            'GetEcoPerformanceResult' => '\\StructType\\GetEcoPerformanceResult',
            'Get_EcoPerformance_Profiles' => '\\StructType\\Get_EcoPerformance_Profiles',
            'EcoPerformanceProfile' => '\\StructType\\EcoPerformanceProfile',
            'ArrayOfEcoPerformanceProfile' => '\\ArrayType\\ArrayOfEcoPerformanceProfile',
            'Get_EcoPerformance_ProfilesResponse' => '\\StructType\\Get_EcoPerformance_ProfilesResponse',
            'GetEcoPerformanceProfilesResult' => '\\StructType\\GetEcoPerformanceProfilesResult',
            'Send_ReeferCommand' => '\\StructType\\Send_ReeferCommand',
            'ReeferCommand' => '\\StructType\\ReeferCommand',
            'SendReeferCommandResultInfo' => '\\StructType\\SendReeferCommandResultInfo',
            'TrailerItem' => '\\StructType\\TrailerItem',
            'VehicleItem' => '\\StructType\\VehicleItem',
            'ArrayOfSendReeferCommandResultInfo' => '\\ArrayType\\ArrayOfSendReeferCommandResultInfo',
            'Send_ReeferCommandResponse' => '\\StructType\\Send_ReeferCommandResponse',
            'Send_ReeferCommandResult' => '\\StructType\\Send_ReeferCommandResult',
            'Get_Files' => '\\StructType\\Get_Files',
            'FileSelection' => '\\StructType\\FileSelection',
            'ArrayOfIdentifierFile' => '\\ArrayType\\ArrayOfIdentifierFile',
            'IdentifierFile' => '\\StructType\\IdentifierFile',
            'FileTransfer' => '\\StructType\\FileTransfer',
            'FileInfo' => '\\StructType\\FileInfo',
            'FileResultItem' => '\\StructType\\FileResultItem',
            'ArrayOfFileTransfer' => '\\ArrayType\\ArrayOfFileTransfer',
            'ArrayOfFileResultItem' => '\\ArrayType\\ArrayOfFileResultItem',
            'Get_FilesResponse' => '\\StructType\\Get_FilesResponse',
            'GetFileResult' => '\\StructType\\GetFileResult',
            'Send_File' => '\\StructType\\Send_File',
            'FileSend' => '\\StructType\\FileSend',
            'Send_FileResponse' => '\\StructType\\Send_FileResponse',
            'FileSendResult' => '\\StructType\\FileSendResult',
            'Get_RefuelReport' => '\\StructType\\Get_RefuelReport',
            'RefuelReportSelection' => '\\StructType\\RefuelReportSelection',
            'ArrayOfInt' => '\\ArrayType\\ArrayOfInt',
            'FuelReportItem' => '\\StructType\\FuelReportItem',
            'AddressIdentityInfo' => '\\StructType\\AddressIdentityInfo',
            'FuelInfo' => '\\StructType\\FuelInfo',
            'ArrayOfFuelReportItem' => '\\ArrayType\\ArrayOfFuelReportItem',
            'Get_RefuelReportResponse' => '\\StructType\\Get_RefuelReportResponse',
            'GetRefuelReport' => '\\StructType\\GetRefuelReport',
            'Get_RefuelReport_V2' => '\\StructType\\Get_RefuelReport_V2',
            'RefuelReportSelection_V2' => '\\StructType\\RefuelReportSelection_V2',
            'FuelReportItem_V2' => '\\StructType\\FuelReportItem_V2',
            'ArrayOfFuelReportItem_V2' => '\\ArrayType\\ArrayOfFuelReportItem_V2',
            'Get_RefuelReport_V2Response' => '\\StructType\\Get_RefuelReport_V2Response',
            'GetRefuelReport_V2' => '\\StructType\\GetRefuelReport_V2',
            'Get_RefuelReport_V4' => '\\StructType\\Get_RefuelReport_V4',
            'RefuelReportSelection_V3' => '\\StructType\\RefuelReportSelection_V3',
            'FuelReportItem_V4' => '\\StructType\\FuelReportItem_V4',
            'ArrayOfFuelReportItem_V4' => '\\ArrayType\\ArrayOfFuelReportItem_V4',
            'Get_RefuelReport_V4Response' => '\\StructType\\Get_RefuelReport_V4Response',
            'GetRefuelReport_V4' => '\\StructType\\GetRefuelReport_V4',
            'Insert_Refuelings' => '\\StructType\\Insert_Refuelings',
            'ArrayOfRefueling' => '\\ArrayType\\ArrayOfRefueling',
            'Refueling' => '\\StructType\\Refueling',
            'IdentifierProvider' => '\\StructType\\IdentifierProvider',
            'Insert_RefuelingsResponse' => '\\StructType\\Insert_RefuelingsResponse',
            'ResultList' => '\\StructType\\ResultList',
            'Get_ServerTime' => '\\StructType\\Get_ServerTime',
            'Get_ServerTimeResponse' => '\\StructType\\Get_ServerTimeResponse',
            'GetServerTimeResult' => '\\StructType\\GetServerTimeResult',
            'Get_GeoFences' => '\\StructType\\Get_GeoFences',
            'GeoFenceSelection' => '\\StructType\\GeoFenceSelection',
            'ArrayOfIdentifierGeoFence' => '\\ArrayType\\ArrayOfIdentifierGeoFence',
            'IdentifierGeoFence' => '\\StructType\\IdentifierGeoFence',
            'GeoFence' => '\\StructType\\GeoFence',
            'GeoValidityDate' => '\\StructType\\GeoValidityDate',
            'ActivityPlace' => '\\StructType\\ActivityPlace',
            'GeofenceResult' => '\\StructType\\GeofenceResult',
            'ArrayOfIdentifierVehicleGeoFenceResult' => '\\ArrayType\\ArrayOfIdentifierVehicleGeoFenceResult',
            'IdentifierVehicleGeoFenceResult' => '\\StructType\\IdentifierVehicleGeoFenceResult',
            'ArrayOfGeoZoneResult_v2' => '\\ArrayType\\ArrayOfGeoZoneResult_v2',
            'ArrayOfGeofenceResult' => '\\ArrayType\\ArrayOfGeofenceResult',
            'Get_GeoFencesResponse' => '\\StructType\\Get_GeoFencesResponse',
            'GetGeoFencesResult' => '\\StructType\\GetGeoFencesResult',
            'Get_GeoFences_V2' => '\\StructType\\Get_GeoFences_V2',
            'ArrayOfInterfaceGeoZoneResult_V2' => '\\ArrayType\\ArrayOfInterfaceGeoZoneResult_V2',
            'InterfaceGeoZoneResult_V2' => '\\StructType\\InterfaceGeoZoneResult_V2',
            'ArrayOfInterfaceGeofenceResult_V2' => '\\ArrayType\\ArrayOfInterfaceGeofenceResult_V2',
            'InterfaceGeofenceResult_V2' => '\\StructType\\InterfaceGeofenceResult_V2',
            'Get_GeoFences_V2Response' => '\\StructType\\Get_GeoFences_V2Response',
            'InterfaceGetGeoFencesResult_V2' => '\\StructType\\InterfaceGetGeoFencesResult_V2',
            'Get_GeoFences_V3' => '\\StructType\\Get_GeoFences_V3',
            'GeoFenceSelection_V3' => '\\StructType\\GeoFenceSelection_V3',
            'InterfaceGeofenceResult_V3' => '\\StructType\\InterfaceGeofenceResult_V3',
            'ArrayOfInterfaceGeoZoneStrategy' => '\\ArrayType\\ArrayOfInterfaceGeoZoneStrategy',
            'InterfaceGeoZoneStrategy' => '\\StructType\\InterfaceGeoZoneStrategy',
            'PolygonType' => '\\StructType\\PolygonType',
            'RadiusType' => '\\StructType\\RadiusType',
            'ArrayOfInterfaceGeofenceResult_V3' => '\\ArrayType\\ArrayOfInterfaceGeofenceResult_V3',
            'Get_GeoFences_V3Response' => '\\StructType\\Get_GeoFences_V3Response',
            'InterfaceGetGeoFencesResult_V3' => '\\StructType\\InterfaceGetGeoFencesResult_V3',
            'Insert_GeoFence' => '\\StructType\\Insert_GeoFence',
            'GeoFenceInsert' => '\\StructType\\GeoFenceInsert',
            'ArrayOfGeoZone' => '\\ArrayType\\ArrayOfGeoZone',
            'InsertGeoZoneResult' => '\\StructType\\InsertGeoZoneResult',
            'ArrayOfInsertGeoZoneResult' => '\\ArrayType\\ArrayOfInsertGeoZoneResult',
            'Insert_GeoFenceResponse' => '\\StructType\\Insert_GeoFenceResponse',
            'InsertGeoFenceResult' => '\\StructType\\InsertGeoFenceResult',
            'Insert_GeoFence_V2' => '\\StructType\\Insert_GeoFence_V2',
            'InterfaceGeoFenceInsert_V2' => '\\StructType\\InterfaceGeoFenceInsert_V2',
            'ArrayOfInterfaceGeoZone_V2' => '\\ArrayType\\ArrayOfInterfaceGeoZone_V2',
            'InterfaceGeoZone_V2' => '\\StructType\\InterfaceGeoZone_V2',
            'Insert_GeoFence_V2Response' => '\\StructType\\Insert_GeoFence_V2Response',
            'Update_GeoFence' => '\\StructType\\Update_GeoFence',
            'GeoFenceUpdate' => '\\StructType\\GeoFenceUpdate',
            'Update_GeoFenceResponse' => '\\StructType\\Update_GeoFenceResponse',
            'Update_GeoFence_V2' => '\\StructType\\Update_GeoFence_V2',
            'InterfaceGeoFenceUpdate_V2' => '\\StructType\\InterfaceGeoFenceUpdate_V2',
            'Update_GeoFence_V2Response' => '\\StructType\\Update_GeoFence_V2Response',
            'Send_GeoFence_To_Vehicle' => '\\StructType\\Send_GeoFence_To_Vehicle',
            'GeoFenceVehicleSelection' => '\\StructType\\GeoFenceVehicleSelection',
            'Send_GeoFence_To_VehicleResponse' => '\\StructType\\Send_GeoFence_To_VehicleResponse',
            'Remove_GeoFence_From_Vehicle' => '\\StructType\\Remove_GeoFence_From_Vehicle',
            'Remove_GeoFence_From_VehicleResponse' => '\\StructType\\Remove_GeoFence_From_VehicleResponse',
            'Assign_GeoFence' => '\\StructType\\Assign_GeoFence',
            'AssignGeoFenceSelection' => '\\StructType\\AssignGeoFenceSelection',
            'GeoFence_V2' => '\\StructType\\GeoFence_V2',
            'IdentifierGeofenceResult' => '\\StructType\\IdentifierGeofenceResult',
            'ArrayOfIdentifierGeofenceResult' => '\\ArrayType\\ArrayOfIdentifierGeofenceResult',
            'ArrayOfIdentifierVehicleResult' => '\\ArrayType\\ArrayOfIdentifierVehicleResult',
            'Assign_GeoFenceResponse' => '\\StructType\\Assign_GeoFenceResponse',
            'AssignGeoFenceResult' => '\\StructType\\AssignGeoFenceResult',
            'Unassign_GeoFence' => '\\StructType\\Unassign_GeoFence',
            'UnAssignGeoFenceSelection' => '\\StructType\\UnAssignGeoFenceSelection',
            'Unassign_GeoFenceResponse' => '\\StructType\\Unassign_GeoFenceResponse',
            'UnAssignGeoFenceResult' => '\\StructType\\UnAssignGeoFenceResult',
            'Get_Groups' => '\\StructType\\Get_Groups',
            'GroupSelection' => '\\StructType\\GroupSelection',
            'Group' => '\\StructType\\Group',
            'ArrayOfSubGroup' => '\\ArrayType\\ArrayOfSubGroup',
            'SubGroup' => '\\StructType\\SubGroup',
            'ArrayOfIdentifierPerson' => '\\ArrayType\\ArrayOfIdentifierPerson',
            'ArrayOfGroup' => '\\ArrayType\\ArrayOfGroup',
            'Get_GroupsResponse' => '\\StructType\\Get_GroupsResponse',
            'GetGroupResult' => '\\StructType\\GetGroupResult',
            'Get_Groups_V2' => '\\StructType\\Get_Groups_V2',
            'GroupSelectionV2' => '\\StructType\\GroupSelectionV2',
            'IdentifierPoiResult' => '\\StructType\\IdentifierPoiResult',
            'SubGroupBase' => '\\StructType\\SubGroupBase',
            'SubGroupResultV2' => '\\StructType\\SubGroupResultV2',
            'ArrayOfIdentifierVehicleResult_V2' => '\\ArrayType\\ArrayOfIdentifierVehicleResult_V2',
            'ArrayOfIdentifierPerson_V2' => '\\ArrayType\\ArrayOfIdentifierPerson_V2',
            'ArrayOfIdentifierPoiResult' => '\\ArrayType\\ArrayOfIdentifierPoiResult',
            'GroupBase' => '\\StructType\\GroupBase',
            'GroupResultV2' => '\\StructType\\GroupResultV2',
            'ArrayOfSubGroupResultV2' => '\\ArrayType\\ArrayOfSubGroupResultV2',
            'ArrayOfGroupResultV2' => '\\ArrayType\\ArrayOfGroupResultV2',
            'Get_Groups_V2Response' => '\\StructType\\Get_Groups_V2Response',
            'GetGroupResultV2' => '\\StructType\\GetGroupResultV2',
            'Insert_Group' => '\\StructType\\Insert_Group',
            'GroupInsert' => '\\StructType\\GroupInsert',
            'ArrayOfSubGroupInsert' => '\\ArrayType\\ArrayOfSubGroupInsert',
            'SubGroupInsert' => '\\StructType\\SubGroupInsert',
            'Insert_GroupResponse' => '\\StructType\\Insert_GroupResponse',
            'Assign_Vehicle_To_Group' => '\\StructType\\Assign_Vehicle_To_Group',
            'AssignVehicleToGroup' => '\\StructType\\AssignVehicleToGroup',
            'Assign_Vehicle_To_GroupResponse' => '\\StructType\\Assign_Vehicle_To_GroupResponse',
            'Remove_Vehicle_From_Group' => '\\StructType\\Remove_Vehicle_From_Group',
            'RemoveVehicleFromGroup' => '\\StructType\\RemoveVehicleFromGroup',
            'Remove_Vehicle_From_GroupResponse' => '\\StructType\\Remove_Vehicle_From_GroupResponse',
            'Assign_Trailer_To_Group' => '\\StructType\\Assign_Trailer_To_Group',
            'Assign_Trailer_To_GroupResponse' => '\\StructType\\Assign_Trailer_To_GroupResponse',
            'Remove_Trailer_From_Group' => '\\StructType\\Remove_Trailer_From_Group',
            'Remove_Trailer_From_GroupResponse' => '\\StructType\\Remove_Trailer_From_GroupResponse',
            'Assign_Driver_To_Group' => '\\StructType\\Assign_Driver_To_Group',
            'AssignDriverToGroup' => '\\StructType\\AssignDriverToGroup',
            'Assign_Driver_To_GroupResponse' => '\\StructType\\Assign_Driver_To_GroupResponse',
            'Remove_Driver_From_Group' => '\\StructType\\Remove_Driver_From_Group',
            'RemoveDriverFromGroup' => '\\StructType\\RemoveDriverFromGroup',
            'Remove_Driver_From_GroupResponse' => '\\StructType\\Remove_Driver_From_GroupResponse',
            'Assign_Group_To_Dispatcher' => '\\StructType\\Assign_Group_To_Dispatcher',
            'AssignGroupToDispatcher' => '\\StructType\\AssignGroupToDispatcher',
            'Assign_Group_To_DispatcherResponse' => '\\StructType\\Assign_Group_To_DispatcherResponse',
            'Remove_Group_From_Dispatcher' => '\\StructType\\Remove_Group_From_Dispatcher',
            'RemoveGroupFromDispatcher' => '\\StructType\\RemoveGroupFromDispatcher',
            'Remove_Group_From_DispatcherResponse' => '\\StructType\\Remove_Group_From_DispatcherResponse',
            'Assign_Resources_To_Group' => '\\StructType\\Assign_Resources_To_Group',
            'AssignResourcesToGroup' => '\\StructType\\AssignResourcesToGroup',
            'ArrayOfResourceIdentifier' => '\\ArrayType\\ArrayOfResourceIdentifier',
            'ResourceIdentifier' => '\\StructType\\ResourceIdentifier',
            'Assign_Resources_To_GroupResponse' => '\\StructType\\Assign_Resources_To_GroupResponse',
            'Remove_Resources_From_Group' => '\\StructType\\Remove_Resources_From_Group',
            'RemoveResourcesFromGroup' => '\\StructType\\RemoveResourcesFromGroup',
            'Remove_Resources_From_GroupResponse' => '\\StructType\\Remove_Resources_From_GroupResponse',
            'Get_ActivityList' => '\\StructType\\Get_ActivityList',
            'ActivitySelection' => '\\StructType\\ActivitySelection',
            'ActivityVersionResult' => '\\StructType\\ActivityVersionResult',
            'ArrayOfActivityInfo' => '\\ArrayType\\ArrayOfActivityInfo',
            'ArrayOfActivityVersionResult' => '\\ArrayType\\ArrayOfActivityVersionResult',
            'Get_ActivityListResponse' => '\\StructType\\Get_ActivityListResponse',
            'GetActivityList' => '\\StructType\\GetActivityList',
            'Get_ActivityList_V2' => '\\StructType\\Get_ActivityList_V2',
            'ActivityVersionResult_V5' => '\\StructType\\ActivityVersionResult_V5',
            'ArrayOfActivityInfo_V5' => '\\ArrayType\\ArrayOfActivityInfo_V5',
            'ActivityInfo_V5' => '\\StructType\\ActivityInfo_V5',
            'ArrayOfCode' => '\\ArrayType\\ArrayOfCode',
            'Code' => '\\StructType\\Code',
            'ArrayOfActivityVersionResult_V5' => '\\ArrayType\\ArrayOfActivityVersionResult_V5',
            'Get_ActivityList_V2Response' => '\\StructType\\Get_ActivityList_V2Response',
            'GetActivityList_V6' => '\\StructType\\GetActivityList_V6',
            'Get_MagellanAlarm' => '\\StructType\\Get_MagellanAlarm',
            'MagellanDataSelection_V2' => '\\StructType\\MagellanDataSelection_V2',
            'MagellanTracerIdentifier' => '\\StructType\\MagellanTracerIdentifier',
            'IDRangeSelection' => '\\StructType\\IDRangeSelection',
            'MagellanTracerAlarmInfo' => '\\StructType\\MagellanTracerAlarmInfo',
            'MagellanTracerIdentifierResult' => '\\StructType\\MagellanTracerIdentifierResult',
            'ArrayOfMagellanTracerAlarmInfo' => '\\ArrayType\\ArrayOfMagellanTracerAlarmInfo',
            'Get_MagellanAlarmResponse' => '\\StructType\\Get_MagellanAlarmResponse',
            'GetMagellanAlarm' => '\\StructType\\GetMagellanAlarm',
            'Get_MagellanData' => '\\StructType\\Get_MagellanData',
            'MagellanDataSelection' => '\\StructType\\MagellanDataSelection',
            'MagellanTracerPositionInfo' => '\\StructType\\MagellanTracerPositionInfo',
            'BatteryStatus' => '\\StructType\\BatteryStatus',
            'ArrayOfMagellanTracerPositionInfo' => '\\ArrayType\\ArrayOfMagellanTracerPositionInfo',
            'Get_MagellanDataResponse' => '\\StructType\\Get_MagellanDataResponse',
            'GetMagellanData' => '\\StructType\\GetMagellanData',
            'Get_MagellanData_V2' => '\\StructType\\Get_MagellanData_V2',
            'MagellanTracerPositionInfo_V2' => '\\StructType\\MagellanTracerPositionInfo_V2',
            'ContactStatus' => '\\StructType\\ContactStatus',
            'Contact' => '\\StructType\\Contact',
            'Temperatures' => '\\StructType\\Temperatures',
            'Temperature' => '\\StructType\\Temperature',
            'ArrayOfMagellanTracerPositionInfo_V2' => '\\ArrayType\\ArrayOfMagellanTracerPositionInfo_V2',
            'Get_MagellanData_V2Response' => '\\StructType\\Get_MagellanData_V2Response',
            'GetMagellanData_V2' => '\\StructType\\GetMagellanData_V2',
            'Get_MagellanData_V3' => '\\StructType\\Get_MagellanData_V3',
            'Get_MagellanData_V3Response' => '\\StructType\\Get_MagellanData_V3Response',
            'Get_MagellanData_V4' => '\\StructType\\Get_MagellanData_V4',
            'ArrayOfMagellanTracerPositionInfo_V3' => '\\ArrayType\\ArrayOfMagellanTracerPositionInfo_V3',
            'MagellanTracerPositionInfo_V3' => '\\StructType\\MagellanTracerPositionInfo_V3',
            'Get_MagellanData_V4Response' => '\\StructType\\Get_MagellanData_V4Response',
            'GetMagellanData_V3' => '\\StructType\\GetMagellanData_V3',
            'Get_MagellanGeoZones' => '\\StructType\\Get_MagellanGeoZones',
            'MagellanGeoZoneSelection' => '\\StructType\\MagellanGeoZoneSelection',
            'MagellanTracerGeoZoneInfo' => '\\StructType\\MagellanTracerGeoZoneInfo',
            'ArrayOfMagellanTracerGeoZoneInfo' => '\\ArrayType\\ArrayOfMagellanTracerGeoZoneInfo',
            'Get_MagellanGeoZonesResponse' => '\\StructType\\Get_MagellanGeoZonesResponse',
            'GetMagellanGeoZones' => '\\StructType\\GetMagellanGeoZones',
            'Get_MagellanTracers' => '\\StructType\\Get_MagellanTracers',
            'MagellanTracersSelection' => '\\StructType\\MagellanTracersSelection',
            'ArrayOfMagellanTracerIdentifier' => '\\ArrayType\\ArrayOfMagellanTracerIdentifier',
            'MagellanTracerResult' => '\\StructType\\MagellanTracerResult',
            'ArrayOfMagellanTracerResult' => '\\ArrayType\\ArrayOfMagellanTracerResult',
            'Get_MagellanTracersResponse' => '\\StructType\\Get_MagellanTracersResponse',
            'GetMagellanTracers' => '\\StructType\\GetMagellanTracers',
            'Get_MagellanTracers_V2' => '\\StructType\\Get_MagellanTracers_V2',
            'MagellanTracerResult_V2' => '\\StructType\\MagellanTracerResult_V2',
            'MagellanTracerIdentifierResult_V2' => '\\StructType\\MagellanTracerIdentifierResult_V2',
            'ArrayOfMagellanTracerResult_V2' => '\\ArrayType\\ArrayOfMagellanTracerResult_V2',
            'Get_MagellanTracers_V2Response' => '\\StructType\\Get_MagellanTracers_V2Response',
            'GetMagellanTracers_V2' => '\\StructType\\GetMagellanTracers_V2',
            'Get_Map' => '\\StructType\\Get_Map',
            'GetMapSelection' => '\\StructType\\GetMapSelection',
            'Size' => '\\StructType\\Size',
            'MapItem' => '\\StructType\\MapItem',
            'Bounds' => '\\StructType\\Bounds',
            'ArrayOfMapItem' => '\\ArrayType\\ArrayOfMapItem',
            'ArrayOfMapPosition' => '\\ArrayType\\ArrayOfMapPosition',
            'MapPosition' => '\\StructType\\MapPosition',
            'Get_MapResponse' => '\\StructType\\Get_MapResponse',
            'MapView' => '\\StructType\\MapView',
            'MapViewParent' => '\\StructType\\MapViewParent',
            'Get_Map_V2' => '\\StructType\\Get_Map_V2',
            'MapItem_V2' => '\\StructType\\MapItem_V2',
            'ArrayOfMapItem_V2' => '\\ArrayType\\ArrayOfMapItem_V2',
            'ArrayOfMapPosition_V2' => '\\ArrayType\\ArrayOfMapPosition_V2',
            'MapPosition_V2' => '\\StructType\\MapPosition_V2',
            'Get_Map_V2Response' => '\\StructType\\Get_Map_V2Response',
            'MapView_V2' => '\\StructType\\MapView_V2',
            'Get_Map_V3' => '\\StructType\\Get_Map_V3',
            'GetMapSelection_V2' => '\\StructType\\GetMapSelection_V2',
            'MapItem_V3' => '\\StructType\\MapItem_V3',
            'MapRoute' => '\\StructType\\MapRoute',
            'ArrayOfMapRoute' => '\\ArrayType\\ArrayOfMapRoute',
            'ArrayOfMapItem_V3' => '\\ArrayType\\ArrayOfMapItem_V3',
            'ArrayOfMapPosition_V3' => '\\ArrayType\\ArrayOfMapPosition_V3',
            'MapPosition_V3' => '\\StructType\\MapPosition_V3',
            'Get_Map_V3Response' => '\\StructType\\Get_Map_V3Response',
            'MapView_V3' => '\\StructType\\MapView_V3',
            'Get_Map_V4' => '\\StructType\\Get_Map_V4',
            'Get_Map_V4Response' => '\\StructType\\Get_Map_V4Response',
            'Get_MapImage' => '\\StructType\\Get_MapImage',
            'Get_MapImageResponse' => '\\StructType\\Get_MapImageResponse',
            'Get_MapImage_V2' => '\\StructType\\Get_MapImage_V2',
            'Get_MapImage_V2Response' => '\\StructType\\Get_MapImage_V2Response',
            'Get_MapImage_V3' => '\\StructType\\Get_MapImage_V3',
            'Get_MapImage_V3Response' => '\\StructType\\Get_MapImage_V3Response',
            'Get_MapImage_V4' => '\\StructType\\Get_MapImage_V4',
            'Get_MapImage_V4Response' => '\\StructType\\Get_MapImage_V4Response',
            'Send_NextStop' => '\\StructType\\Send_NextStop',
            'NextStopInsert' => '\\StructType\\NextStopInsert',
            'Send_NextStopResponse' => '\\StructType\\Send_NextStopResponse',
            'Remove_NextStops' => '\\StructType\\Remove_NextStops',
            'Remove_NextStopsResponse' => '\\StructType\\Remove_NextStopsResponse',
            'Get_Planning' => '\\StructType\\Get_Planning',
            'PlanningSelection' => '\\StructType\\PlanningSelection',
            'PlanningItemSelection' => '\\StructType\\PlanningItemSelection',
            'PlanningHistoricalSelection' => '\\StructType\\PlanningHistoricalSelection',
            'PlanningOptionsSelection' => '\\StructType\\PlanningOptionsSelection',
            'GetPlanningHistoricalSelectionResult' => '\\StructType\\GetPlanningHistoricalSelectionResult',
            'ArrayOfPlanningResult' => '\\ArrayType\\ArrayOfPlanningResult',
            'PlanningResult' => '\\StructType\\PlanningResult',
            'ArrayOfTripResult' => '\\ArrayType\\ArrayOfTripResult',
            'TripResult' => '\\StructType\\TripResult',
            'Trip' => '\\StructType\\Trip',
            'Reference' => '\\StructType\\Reference',
            'ReferenceProduct' => '\\StructType\\ReferenceProduct',
            'TripItemResult' => '\\StructType\\TripItemResult',
            'ArrayOfTachoActivity' => '\\ArrayType\\ArrayOfTachoActivity',
            'TachoActivity' => '\\StructType\\TachoActivity',
            'ArrayOfRegistration' => '\\ArrayType\\ArrayOfRegistration',
            'Registration' => '\\StructType\\Registration',
            'ArrayOfQuestionPathInfo' => '\\ArrayType\\ArrayOfQuestionPathInfo',
            'QuestionPathInfo' => '\\StructType\\QuestionPathInfo',
            'ArrayOfConsultation' => '\\ArrayType\\ArrayOfConsultation',
            'Consultation' => '\\StructType\\Consultation',
            'ArrayOfAnomaly' => '\\ArrayType\\ArrayOfAnomaly',
            'Anomaly' => '\\StructType\\Anomaly',
            'PlanningItem' => '\\StructType\\PlanningItem',
            'ArrayOfExtraInfo' => '\\ArrayType\\ArrayOfExtraInfo',
            'ExtraInfo' => '\\StructType\\ExtraInfo',
            'Transfer' => '\\StructType\\Transfer',
            'ArrayOfPlaceResult' => '\\ArrayType\\ArrayOfPlaceResult',
            'PlaceResult' => '\\StructType\\PlaceResult',
            'Place' => '\\StructType\\Place',
            'PlaceItemResult' => '\\StructType\\PlaceItemResult',
            'ArrayOfProductIdentifier' => '\\ArrayType\\ArrayOfProductIdentifier',
            'ArrayOfJobIdentifier' => '\\ArrayType\\ArrayOfJobIdentifier',
            'GeofencingResult' => '\\StructType\\GeofencingResult',
            'Geofencing' => '\\StructType\\Geofencing',
            'ArrayOfComment' => '\\ArrayType\\ArrayOfComment',
            'Comment' => '\\StructType\\Comment',
            'CommentHistoricalResult' => '\\StructType\\CommentHistoricalResult',
            'ArrayOfJobResult' => '\\ArrayType\\ArrayOfJobResult',
            'JobResult' => '\\StructType\\JobResult',
            'Job' => '\\StructType\\Job',
            'JobItemResult' => '\\StructType\\JobItemResult',
            'ArrayOfProductResult' => '\\ArrayType\\ArrayOfProductResult',
            'ProductResult' => '\\StructType\\ProductResult',
            'Product' => '\\StructType\\Product',
            'ProductItemResult' => '\\StructType\\ProductItemResult',
            'ArrayOfCommentHistoricalResult' => '\\ArrayType\\ArrayOfCommentHistoricalResult',
            'GetPlanningItemSelectionResult' => '\\StructType\\GetPlanningItemSelectionResult',
            'ArrayOfTripItemResult' => '\\ArrayType\\ArrayOfTripItemResult',
            'ArrayOfPlaceItemResult' => '\\ArrayType\\ArrayOfPlaceItemResult',
            'ArrayOfJobItemResult' => '\\ArrayType\\ArrayOfJobItemResult',
            'ArrayOfProductItemResult' => '\\ArrayType\\ArrayOfProductItemResult',
            'Get_PlanningResponse' => '\\StructType\\Get_PlanningResponse',
            'GetPlanningResult' => '\\StructType\\GetPlanningResult',
            'Get_Planning_V2' => '\\StructType\\Get_Planning_V2',
            'GetPlanningHistoricalSelectionResult_v2' => '\\StructType\\GetPlanningHistoricalSelectionResult_v2',
            'ArrayOfPlanningResult_v2' => '\\ArrayType\\ArrayOfPlanningResult_v2',
            'PlanningResult_v2' => '\\StructType\\PlanningResult_v2',
            'ArrayOfTripResult_v2' => '\\ArrayType\\ArrayOfTripResult_v2',
            'TripResult_v2' => '\\StructType\\TripResult_v2',
            'ArrayOfRegistration_v2' => '\\ArrayType\\ArrayOfRegistration_v2',
            'Registration_v2' => '\\StructType\\Registration_v2',
            'ArrayOfQuestionPathInfo_v2' => '\\ArrayType\\ArrayOfQuestionPathInfo_v2',
            'QuestionPathInfo_v2' => '\\StructType\\QuestionPathInfo_v2',
            'GetPlanningItemSelectionResult_v2' => '\\StructType\\GetPlanningItemSelectionResult_v2',
            'ArrayOfTripItemResult_v2' => '\\ArrayType\\ArrayOfTripItemResult_v2',
            'TripItemResult_v2' => '\\StructType\\TripItemResult_v2',
            'Get_Planning_V2Response' => '\\StructType\\Get_Planning_V2Response',
            'GetPlanningResult_v2' => '\\StructType\\GetPlanningResult_v2',
            'Get_Planning_V3' => '\\StructType\\Get_Planning_V3',
            'PlanningSelection_V2' => '\\StructType\\PlanningSelection_V2',
            'PlanningHistoricalSelection_V2' => '\\StructType\\PlanningHistoricalSelection_V2',
            'GetPlanningHistoricalSelectionInterfaceResult_v3' => '\\StructType\\GetPlanningHistoricalSelectionInterfaceResult_v3',
            'ArrayOfPlanningInterfaceResult_v3' => '\\ArrayType\\ArrayOfPlanningInterfaceResult_v3',
            'PlanningInterfaceResult_v3' => '\\StructType\\PlanningInterfaceResult_v3',
            'ArrayOfTripInterfaceResult_v3' => '\\ArrayType\\ArrayOfTripInterfaceResult_v3',
            'TripInterfaceResult_v3' => '\\StructType\\TripInterfaceResult_v3',
            'ArrayOfConsultation_V2' => '\\ArrayType\\ArrayOfConsultation_V2',
            'Consultation_V2' => '\\StructType\\Consultation_V2',
            'ArrayOfPlaceInterfaceResult_v2' => '\\ArrayType\\ArrayOfPlaceInterfaceResult_v2',
            'PlaceInterfaceResult_v2' => '\\StructType\\PlaceInterfaceResult_v2',
            'ArrayOfJobInterfaceResult_v2' => '\\ArrayType\\ArrayOfJobInterfaceResult_v2',
            'JobInterfaceResult_v2' => '\\StructType\\JobInterfaceResult_v2',
            'ArrayOfProductInterfaceResult_v2' => '\\ArrayType\\ArrayOfProductInterfaceResult_v2',
            'ProductInterfaceResult_v2' => '\\StructType\\ProductInterfaceResult_v2',
            'ViaRouteItemResult' => '\\StructType\\ViaRouteItemResult',
            'Customer' => '\\StructType\\Customer',
            'Shipper' => '\\StructType\\Shipper',
            'Get_Planning_V3Response' => '\\StructType\\Get_Planning_V3Response',
            'GetPlanningInterfaceResult_v3' => '\\StructType\\GetPlanningInterfaceResult_v3',
            'Get_Planning_V4' => '\\StructType\\Get_Planning_V4',
            'GetPlanningHistoricalSelectionInterfaceResult_v4' => '\\StructType\\GetPlanningHistoricalSelectionInterfaceResult_v4',
            'ArrayOfPlanningInterfaceResult_v4' => '\\ArrayType\\ArrayOfPlanningInterfaceResult_v4',
            'PlanningInterfaceResult_v4' => '\\StructType\\PlanningInterfaceResult_v4',
            'ArrayOfTripInterfaceResult_v4' => '\\ArrayType\\ArrayOfTripInterfaceResult_v4',
            'TripInterfaceResult_v4' => '\\StructType\\TripInterfaceResult_v4',
            'ArrayOfPlaceInterfaceResult_v3' => '\\ArrayType\\ArrayOfPlaceInterfaceResult_v3',
            'PlaceInterfaceResult_v3' => '\\StructType\\PlaceInterfaceResult_v3',
            'ArrayOfJobInterfaceResult_v3' => '\\ArrayType\\ArrayOfJobInterfaceResult_v3',
            'JobInterfaceResult_v3' => '\\StructType\\JobInterfaceResult_v3',
            'ArrayOfProductInterfaceResult_v3' => '\\ArrayType\\ArrayOfProductInterfaceResult_v3',
            'ProductInterfaceResult_v3' => '\\StructType\\ProductInterfaceResult_v3',
            'Get_Planning_V4Response' => '\\StructType\\Get_Planning_V4Response',
            'GetPlanningInterfaceResult_v4' => '\\StructType\\GetPlanningInterfaceResult_v4',
            'Get_Planning_V5' => '\\StructType\\Get_Planning_V5',
            'PlanningSelection_V3' => '\\StructType\\PlanningSelection_V3',
            'GetPlanningOptionsSelection' => '\\StructType\\GetPlanningOptionsSelection',
            'GetPlanningItemSelectionResult_v3' => '\\StructType\\GetPlanningItemSelectionResult_v3',
            'ArrayOfJobItemResult_V4' => '\\ArrayType\\ArrayOfJobItemResult_V4',
            'JobItemResult_V4' => '\\StructType\\JobItemResult_V4',
            'Get_Planning_V5Response' => '\\StructType\\Get_Planning_V5Response',
            'GetPlanningInterfaceResult_v5' => '\\StructType\\GetPlanningInterfaceResult_v5',
            'Get_Planning_V6' => '\\StructType\\Get_Planning_V6',
            'GetPlanningHistoricalSelectionInterfaceResult_V5' => '\\StructType\\GetPlanningHistoricalSelectionInterfaceResult_V5',
            'ArrayOfPlanningInterfaceResult_V5' => '\\ArrayType\\ArrayOfPlanningInterfaceResult_V5',
            'PlanningInterfaceResult_V5' => '\\StructType\\PlanningInterfaceResult_V5',
            'ArrayOfTripInterfaceResult_V5' => '\\ArrayType\\ArrayOfTripInterfaceResult_V5',
            'TripInterfaceResult_V5' => '\\StructType\\TripInterfaceResult_V5',
            'ArrayOfPlaceInterfaceResult_V4' => '\\ArrayType\\ArrayOfPlaceInterfaceResult_V4',
            'PlaceInterfaceResult_V4' => '\\StructType\\PlaceInterfaceResult_V4',
            'CustomerResult_V2' => '\\StructType\\CustomerResult_V2',
            'ShipperResult_V2' => '\\StructType\\ShipperResult_V2',
            'ShipperResult' => '\\StructType\\ShipperResult',
            'GetPlanningItemSelectionResult_V4' => '\\StructType\\GetPlanningItemSelectionResult_V4',
            'ArrayOfPlanningTripItemResult' => '\\ArrayType\\ArrayOfPlanningTripItemResult',
            'PlanningTripItemResult' => '\\StructType\\PlanningTripItemResult',
            'ArrayOfPlanningPlaceItemResult' => '\\ArrayType\\ArrayOfPlanningPlaceItemResult',
            'PlanningPlaceItemResult' => '\\StructType\\PlanningPlaceItemResult',
            'Get_Planning_V6Response' => '\\StructType\\Get_Planning_V6Response',
            'GetPlanningInterfaceResult_v6' => '\\StructType\\GetPlanningInterfaceResult_v6',
            'Get_Planning_Modifications' => '\\StructType\\Get_Planning_Modifications',
            'PlanningModificationsSelection' => '\\StructType\\PlanningModificationsSelection',
            'Get_Planning_ModificationsResponse' => '\\StructType\\Get_Planning_ModificationsResponse',
            'GetPlanningModificationsResult' => '\\StructType\\GetPlanningModificationsResult',
            'Get_Planning_Modifications_V2' => '\\StructType\\Get_Planning_Modifications_V2',
            'PlaceIdentifier_V2' => '\\StructType\\PlaceIdentifier_V2',
            'CustomerResult' => '\\StructType\\CustomerResult',
            'ArrayOfPlaceIdentifier_V2' => '\\ArrayType\\ArrayOfPlaceIdentifier_V2',
            'ArrayOfTripItemResult_v3' => '\\ArrayType\\ArrayOfTripItemResult_v3',
            'TripItemResult_v3' => '\\StructType\\TripItemResult_v3',
            'ArrayOfPlaceItemResult_v2' => '\\ArrayType\\ArrayOfPlaceItemResult_v2',
            'PlaceItemResult_v2' => '\\StructType\\PlaceItemResult_v2',
            'Get_Planning_Modifications_V2Response' => '\\StructType\\Get_Planning_Modifications_V2Response',
            'GetPlanningModificationsResult_V2' => '\\StructType\\GetPlanningModificationsResult_V2',
            'Get_Planning_Modifications_V3' => '\\StructType\\Get_Planning_Modifications_V3',
            'PlanningModificationsSelection_V2' => '\\StructType\\PlanningModificationsSelection_V2',
            'PlanningOptionsSelection_V2' => '\\StructType\\PlanningOptionsSelection_V2',
            'Document_V4' => '\\StructType\\Document_V4',
            'ExtraInfo_V2' => '\\StructType\\ExtraInfo_V2',
            'Consultation_V3' => '\\StructType\\Consultation_V3',
            'Anomaly_V2' => '\\StructType\\Anomaly_V2',
            'ArrayOfTripItemResult_V4' => '\\ArrayType\\ArrayOfTripItemResult_V4',
            'TripItemResult_V4' => '\\StructType\\TripItemResult_V4',
            'ArrayOfPlaceItemResult_V3' => '\\ArrayType\\ArrayOfPlaceItemResult_V3',
            'PlaceItemResult_V3' => '\\StructType\\PlaceItemResult_V3',
            'ArrayOfJobItemResult_V2' => '\\ArrayType\\ArrayOfJobItemResult_V2',
            'JobItemResult_V2' => '\\StructType\\JobItemResult_V2',
            'ArrayOfProductItemResult_V2' => '\\ArrayType\\ArrayOfProductItemResult_V2',
            'ProductItemResult_V2' => '\\StructType\\ProductItemResult_V2',
            'ArrayOfCommentHistoricalResult_V2' => '\\ArrayType\\ArrayOfCommentHistoricalResult_V2',
            'CommentHistoricalResult_V2' => '\\StructType\\CommentHistoricalResult_V2',
            'ArrayOfAnomaly_V2' => '\\ArrayType\\ArrayOfAnomaly_V2',
            'ArrayOfConsultation_V3' => '\\ArrayType\\ArrayOfConsultation_V3',
            'ArrayOfExtraInfo_V2' => '\\ArrayType\\ArrayOfExtraInfo_V2',
            'ArrayOfDocument_V4' => '\\ArrayType\\ArrayOfDocument_V4',
            'Get_Planning_Modifications_V3Response' => '\\StructType\\Get_Planning_Modifications_V3Response',
            'GetPlanningModificationsResult_V3' => '\\StructType\\GetPlanningModificationsResult_V3',
            'Get_Planning_Modifications_V4' => '\\StructType\\Get_Planning_Modifications_V4',
            'ArrayOfProductItemResult_V3' => '\\ArrayType\\ArrayOfProductItemResult_V3',
            'ProductItemResult_V3' => '\\StructType\\ProductItemResult_V3',
            'ArrayOfCommentHistoricalResult_V3' => '\\ArrayType\\ArrayOfCommentHistoricalResult_V3',
            'CommentHistoricalResult_V3' => '\\StructType\\CommentHistoricalResult_V3',
            'ArrayOfAnomaly_V3' => '\\ArrayType\\ArrayOfAnomaly_V3',
            'Anomaly_V3' => '\\StructType\\Anomaly_V3',
            'ArrayOfExtraInfo_V3' => '\\ArrayType\\ArrayOfExtraInfo_V3',
            'ExtraInfo_V3' => '\\StructType\\ExtraInfo_V3',
            'Get_Planning_Modifications_V4Response' => '\\StructType\\Get_Planning_Modifications_V4Response',
            'GetPlanningModificationsResult_V4' => '\\StructType\\GetPlanningModificationsResult_V4',
            'Get_Planning_Modifications_V5' => '\\StructType\\Get_Planning_Modifications_V5',
            'ArrayOfTripItemResult_V5' => '\\ArrayType\\ArrayOfTripItemResult_V5',
            'TripItemResult_V5' => '\\StructType\\TripItemResult_V5',
            'ArrayOfPlaceItemResult_V4' => '\\ArrayType\\ArrayOfPlaceItemResult_V4',
            'PlaceItemResult_V4' => '\\StructType\\PlaceItemResult_V4',
            'ArrayOfJobItemResult_V3' => '\\ArrayType\\ArrayOfJobItemResult_V3',
            'JobItemResult_V3' => '\\StructType\\JobItemResult_V3',
            'Get_Planning_Modifications_V5Response' => '\\StructType\\Get_Planning_Modifications_V5Response',
            'GetPlanningModificationsResult_V5' => '\\StructType\\GetPlanningModificationsResult_V5',
            'Get_Planning_Modifications_V6' => '\\StructType\\Get_Planning_Modifications_V6',
            'PlaceIdentifier_V3' => '\\StructType\\PlaceIdentifier_V3',
            'ArrayOfPlaceIdentifier_V3' => '\\ArrayType\\ArrayOfPlaceIdentifier_V3',
            'ArrayOfTripItemResult_V6' => '\\ArrayType\\ArrayOfTripItemResult_V6',
            'TripItemResult_V6' => '\\StructType\\TripItemResult_V6',
            'ArrayOfPlaceItemResult_V5' => '\\ArrayType\\ArrayOfPlaceItemResult_V5',
            'PlaceItemResult_V5' => '\\StructType\\PlaceItemResult_V5',
            'Get_Planning_Modifications_V6Response' => '\\StructType\\Get_Planning_Modifications_V6Response',
            'GetPlanningModificationsResult_V6' => '\\StructType\\GetPlanningModificationsResult_V6',
            'Get_Planning_Modifications_V7' => '\\StructType\\Get_Planning_Modifications_V7',
            'ArrayOfDocument_V5' => '\\ArrayType\\ArrayOfDocument_V5',
            'Document_V5' => '\\StructType\\Document_V5',
            'Get_Planning_Modifications_V7Response' => '\\StructType\\Get_Planning_Modifications_V7Response',
            'GetPlanningModificationsResult_V7' => '\\StructType\\GetPlanningModificationsResult_V7',
            'Get_Planning_Modifications_V8' => '\\StructType\\Get_Planning_Modifications_V8',
            'ArrayOfConsultation_V4' => '\\ArrayType\\ArrayOfConsultation_V4',
            'Consultation_V4' => '\\StructType\\Consultation_V4',
            'Get_Planning_Modifications_V8Response' => '\\StructType\\Get_Planning_Modifications_V8Response',
            'GetPlanningModificationsResult_V8' => '\\StructType\\GetPlanningModificationsResult_V8',
            'Get_Planning_Modifications_V9' => '\\StructType\\Get_Planning_Modifications_V9',
            'PlanningModificationsSelection_V3' => '\\StructType\\PlanningModificationsSelection_V3',
            'Document_V6' => '\\StructType\\Document_V6',
            'JobIdentifier_V2' => '\\StructType\\JobIdentifier_V2',
            'ProductIdentifier_V2' => '\\StructType\\ProductIdentifier_V2',
            'PlaceIdentifier_V4' => '\\StructType\\PlaceIdentifier_V4',
            'TripIdentifier_V2' => '\\StructType\\TripIdentifier_V2',
            'ExtraInfo_V4' => '\\StructType\\ExtraInfo_V4',
            'PalletInfo' => '\\StructType\\PalletInfo',
            'Consultation_V5' => '\\StructType\\Consultation_V5',
            'Anomaly_V4' => '\\StructType\\Anomaly_V4',
            'Product_V2' => '\\StructType\\Product_V2',
            'ProductItemResult_V4' => '\\StructType\\ProductItemResult_V4',
            'ArrayOfReferenceItem' => '\\ArrayType\\ArrayOfReferenceItem',
            'ReferenceItem' => '\\StructType\\ReferenceItem',
            'PlanningConfig' => '\\StructType\\PlanningConfig',
            'ArrayOfPlanningConfigItem' => '\\ArrayType\\ArrayOfPlanningConfigItem',
            'PlanningConfigItem' => '\\StructType\\PlanningConfigItem',
            'Job_V2' => '\\StructType\\Job_V2',
            'JobItemResult_V5' => '\\StructType\\JobItemResult_V5',
            'ArrayOfProductIdentifier_V2' => '\\ArrayType\\ArrayOfProductIdentifier_V2',
            'Place_V2' => '\\StructType\\Place_V2',
            'PlaceItemResult_V6' => '\\StructType\\PlaceItemResult_V6',
            'Trip_V2' => '\\StructType\\Trip_V2',
            'TripItemResult_V7' => '\\StructType\\TripItemResult_V7',
            'ArrayOfPlaceIdentifier_V4' => '\\ArrayType\\ArrayOfPlaceIdentifier_V4',
            'ArrayOfTripItemResult_V7' => '\\ArrayType\\ArrayOfTripItemResult_V7',
            'ArrayOfPlaceItemResult_V6' => '\\ArrayType\\ArrayOfPlaceItemResult_V6',
            'ArrayOfJobItemResult_V5' => '\\ArrayType\\ArrayOfJobItemResult_V5',
            'ArrayOfProductItemResult_V4' => '\\ArrayType\\ArrayOfProductItemResult_V4',
            'ArrayOfCommentHistoricalResult_V4' => '\\ArrayType\\ArrayOfCommentHistoricalResult_V4',
            'CommentHistoricalResult_V4' => '\\StructType\\CommentHistoricalResult_V4',
            'ArrayOfAnomaly_V4' => '\\ArrayType\\ArrayOfAnomaly_V4',
            'ArrayOfConsultation_V5' => '\\ArrayType\\ArrayOfConsultation_V5',
            'ArrayOfPalletInfo' => '\\ArrayType\\ArrayOfPalletInfo',
            'ArrayOfExtraInfo_V4' => '\\ArrayType\\ArrayOfExtraInfo_V4',
            'ArrayOfDocument_V6' => '\\ArrayType\\ArrayOfDocument_V6',
            'Get_Planning_Modifications_V9Response' => '\\StructType\\Get_Planning_Modifications_V9Response',
            'GetPlanningModificationsResult_V9' => '\\StructType\\GetPlanningModificationsResult_V9',
            'Get_Planning_UnPlannedInfo' => '\\StructType\\Get_Planning_UnPlannedInfo',
            'PlanningUnplannedInfoSelection' => '\\StructType\\PlanningUnplannedInfoSelection',
            'Get_Planning_UnPlannedInfoResponse' => '\\StructType\\Get_Planning_UnPlannedInfoResponse',
            'GetPlanningUnplannedInfoResult' => '\\StructType\\GetPlanningUnplannedInfoResult',
            'Get_TripReportSummary' => '\\StructType\\Get_TripReportSummary',
            'TripReportSummarySelection' => '\\StructType\\TripReportSummarySelection',
            'TripReportSummaryResult' => '\\StructType\\TripReportSummaryResult',
            'ArrayOfTripReportTrailerSummary' => '\\ArrayType\\ArrayOfTripReportTrailerSummary',
            'TripReportTrailerSummary' => '\\StructType\\TripReportTrailerSummary',
            'ArrayOfTripReportActivitySummary' => '\\ArrayType\\ArrayOfTripReportActivitySummary',
            'TripReportActivitySummary' => '\\StructType\\TripReportActivitySummary',
            'ArrayOfTripReportTachoSummary' => '\\ArrayType\\ArrayOfTripReportTachoSummary',
            'TripReportTachoSummary' => '\\StructType\\TripReportTachoSummary',
            'ArrayOfTripReportSummaryResult' => '\\ArrayType\\ArrayOfTripReportSummaryResult',
            'Get_TripReportSummaryResponse' => '\\StructType\\Get_TripReportSummaryResponse',
            'GetTripReportSummary' => '\\StructType\\GetTripReportSummary',
            'Get_PalletReport' => '\\StructType\\Get_PalletReport',
            'PalletReportSelection' => '\\StructType\\PalletReportSelection',
            'PositionRangeSelection' => '\\StructType\\PositionRangeSelection',
            'StreetInfo' => '\\StructType\\StreetInfo',
            'ArrayOfPalletReportItem' => '\\ArrayType\\ArrayOfPalletReportItem',
            'PalletReportItem' => '\\StructType\\PalletReportItem',
            'Get_PalletReportResponse' => '\\StructType\\Get_PalletReportResponse',
            'GetPalletReportResult' => '\\StructType\\GetPalletReportResult',
            'Insert_Planning' => '\\StructType\\Insert_Planning',
            'PlanningInsert' => '\\StructType\\PlanningInsert',
            'Planning' => '\\StructType\\Planning',
            'ArrayOfTripInsert' => '\\ArrayType\\ArrayOfTripInsert',
            'TripInsert' => '\\StructType\\TripInsert',
            'ArrayOfPlaceInsert' => '\\ArrayType\\ArrayOfPlaceInsert',
            'PlaceInsert' => '\\StructType\\PlaceInsert',
            'ArrayOfJobInsert' => '\\ArrayType\\ArrayOfJobInsert',
            'JobInsert' => '\\StructType\\JobInsert',
            'ArrayOfProductInsert' => '\\ArrayType\\ArrayOfProductInsert',
            'ProductInsert' => '\\StructType\\ProductInsert',
            'TripResultInsert' => '\\StructType\\TripResultInsert',
            'ArrayOfPlaceResultInsert' => '\\ArrayType\\ArrayOfPlaceResultInsert',
            'PlaceResultInsert' => '\\StructType\\PlaceResultInsert',
            'ArrayOfJobResultInsert' => '\\ArrayType\\ArrayOfJobResultInsert',
            'JobResultInsert' => '\\StructType\\JobResultInsert',
            'ArrayOfProductResultInsert' => '\\ArrayType\\ArrayOfProductResultInsert',
            'ProductResultInsert' => '\\StructType\\ProductResultInsert',
            'ArrayOfTripResultInsert' => '\\ArrayType\\ArrayOfTripResultInsert',
            'Insert_PlanningResponse' => '\\StructType\\Insert_PlanningResponse',
            'PlanningResultInsert' => '\\StructType\\PlanningResultInsert',
            'Update_Planning' => '\\StructType\\Update_Planning',
            'Update_PlanningResponse' => '\\StructType\\Update_PlanningResponse',
            'Cancel_Planning' => '\\StructType\\Cancel_Planning',
            'Cancel_PlanningResponse' => '\\StructType\\Cancel_PlanningResponse',
            'Cancel_Planning_V2' => '\\StructType\\Cancel_Planning_V2',
            'PlanningItemSelection_V2' => '\\StructType\\PlanningItemSelection_V2',
            'Cancel_Planning_V2Response' => '\\StructType\\Cancel_Planning_V2Response',
            'Insert_New_Comment_On_Trip' => '\\StructType\\Insert_New_Comment_On_Trip',
            'Insert_new_comment_on_trip' => '\\StructType\\Insert_new_comment_on_trip_1',
            'Insert_New_Comment_On_TripResponse' => '\\StructType\\Insert_New_Comment_On_TripResponse',
            'Insert_New_Job_On_Trip' => '\\StructType\\Insert_New_Job_On_Trip',
            'Insert_new_job_on_trip' => '\\StructType\\Insert_new_job_on_trip_1',
            'UpdatePlanning' => '\\StructType\\UpdatePlanning',
            'Insert_New_Job_On_TripResponse' => '\\StructType\\Insert_New_Job_On_TripResponse',
            'PlanningResultInsertNewJobOnTrip' => '\\StructType\\PlanningResultInsertNewJobOnTrip',
            'Insert_New_Place_On_Trip' => '\\StructType\\Insert_New_Place_On_Trip',
            'Insert_new_place_on_trip' => '\\StructType\\Insert_new_place_on_trip_1',
            'Insert_New_Place_On_TripResponse' => '\\StructType\\Insert_New_Place_On_TripResponse',
            'PlanningResultInsertNewPlaceOnTrip' => '\\StructType\\PlanningResultInsertNewPlaceOnTrip',
            'Insert_New_Product_On_Trip' => '\\StructType\\Insert_New_Product_On_Trip',
            'Insert_new_product_on_trip' => '\\StructType\\Insert_new_product_on_trip_1',
            'Insert_New_Product_On_TripResponse' => '\\StructType\\Insert_New_Product_On_TripResponse',
            'PlanningResultInsertNewProductOnTrip' => '\\StructType\\PlanningResultInsertNewProductOnTrip',
            'Update_Place_On_Trip' => '\\StructType\\Update_Place_On_Trip',
            'Update_Place_On_TripResponse' => '\\StructType\\Update_Place_On_TripResponse',
            'Get_POIs' => '\\StructType\\Get_POIs',
            'POISelection' => '\\StructType\\POISelection',
            'PositionArea' => '\\StructType\\PositionArea',
            'OpeningHours' => '\\StructType\\OpeningHours',
            'TimeInterval' => '\\StructType\\TimeInterval',
            'POIContactPerson' => '\\StructType\\POIContactPerson',
            'POIGroup' => '\\StructType\\POIGroup',
            'ArrayOfPOIGroup' => '\\ArrayType\\ArrayOfPOIGroup',
            'ArrayOfPOIResult' => '\\ArrayType\\ArrayOfPOIResult',
            'POIResult' => '\\StructType\\POIResult',
            'Get_POIsResponse' => '\\StructType\\Get_POIsResponse',
            'GetPOIResult' => '\\StructType\\GetPOIResult',
            'Get_POIs_V2' => '\\StructType\\Get_POIs_V2',
            'POISelection_V2' => '\\StructType\\POISelection_V2',
            'ArrayOfPOIResult_V2' => '\\ArrayType\\ArrayOfPOIResult_V2',
            'POIResult_V2' => '\\StructType\\POIResult_V2',
            'Get_POIs_V2Response' => '\\StructType\\Get_POIs_V2Response',
            'GetPOIResult_V2' => '\\StructType\\GetPOIResult_V2',
            'Insert_POI' => '\\StructType\\Insert_POI',
            'POIInsert' => '\\StructType\\POIInsert',
            'Insert_POIResponse' => '\\StructType\\Insert_POIResponse',
            'Update_POI' => '\\StructType\\Update_POI',
            'POIUpdate' => '\\StructType\\POIUpdate',
            'Update_POIResponse' => '\\StructType\\Update_POIResponse',
            'Get_Position_Area' => '\\StructType\\Get_Position_Area',
            'PositionAreaSelection' => '\\StructType\\PositionAreaSelection',
            'Get_Position_AreaResponse' => '\\StructType\\Get_Position_AreaResponse',
            'GetPositionAreaResult' => '\\StructType\\GetPositionAreaResult',
            'Get_PositionFromStreetInfo' => '\\StructType\\Get_PositionFromStreetInfo',
            'Get_PositionFromStreetInfoResponse' => '\\StructType\\Get_PositionFromStreetInfoResponse',
            'Get_PositionFromStreetInfoResult' => '\\StructType\\Get_PositionFromStreetInfoResult',
            'GeoPositionResult' => '\\StructType\\GeoPositionResult',
            'Get_StreetInfoFromPosition' => '\\StructType\\Get_StreetInfoFromPosition',
            'ArrayOfPosition' => '\\ArrayType\\ArrayOfPosition',
            'ArrayOfStreetInfoResult' => '\\ArrayType\\ArrayOfStreetInfoResult',
            'StreetInfoResult' => '\\StructType\\StreetInfoResult',
            'Get_StreetInfoFromPositionResponse' => '\\StructType\\Get_StreetInfoFromPositionResponse',
            'Get_StreetInfoFromPositionResult' => '\\StructType\\Get_StreetInfoFromPositionResult',
            'Get_Positions' => '\\StructType\\Get_Positions',
            'PositionSelection' => '\\StructType\\PositionSelection',
            'ArrayOfPositionItemResult' => '\\ArrayType\\ArrayOfPositionItemResult',
            'PositionItemResult' => '\\StructType\\PositionItemResult',
            'Get_PositionsResponse' => '\\StructType\\Get_PositionsResponse',
            'Get_PositionsResult' => '\\StructType\\Get_PositionsResult',
            'Get_Positions_V2' => '\\StructType\\Get_Positions_V2',
            'ArrayOfPositionItemResult_With_Country_Info' => '\\ArrayType\\ArrayOfPositionItemResult_With_Country_Info',
            'PositionItemResult_With_Country_Info' => '\\StructType\\PositionItemResult_With_Country_Info',
            'Get_Positions_V2Response' => '\\StructType\\Get_Positions_V2Response',
            'Get_PositionsResult_With_Country_Info' => '\\StructType\\Get_PositionsResult_With_Country_Info',
            'Get_Positions_V3' => '\\StructType\\Get_Positions_V3',
            'PositionSelection_V2' => '\\StructType\\PositionSelection_V2',
            'ArrayOfPositionItemResult_V3' => '\\ArrayType\\ArrayOfPositionItemResult_V3',
            'PositionItemResult_V3' => '\\StructType\\PositionItemResult_V3',
            'Get_Positions_V3Response' => '\\StructType\\Get_Positions_V3Response',
            'Get_PositionsResult_V3' => '\\StructType\\Get_PositionsResult_V3',
            'Get_Positions_V4' => '\\StructType\\Get_Positions_V4',
            'PositionSelection_V3' => '\\StructType\\PositionSelection_V3',
            'ArrayOfPositionItemResult_V4' => '\\ArrayType\\ArrayOfPositionItemResult_V4',
            'PositionItemResult_V4' => '\\StructType\\PositionItemResult_V4',
            'Get_Positions_V4Response' => '\\StructType\\Get_Positions_V4Response',
            'Get_PositionsResult_V4' => '\\StructType\\Get_PositionsResult_V4',
            'Get_Positions_V5' => '\\StructType\\Get_Positions_V5',
            'PositionSelection_V4' => '\\StructType\\PositionSelection_V4',
            'ArrayOfPositionItemResult_V5' => '\\ArrayType\\ArrayOfPositionItemResult_V5',
            'PositionItemResult_V5' => '\\StructType\\PositionItemResult_V5',
            'Get_Positions_V5Response' => '\\StructType\\Get_Positions_V5Response',
            'Get_PositionsResult_V5' => '\\StructType\\Get_PositionsResult_V5',
            'Get_Positions_V6' => '\\StructType\\Get_Positions_V6',
            'ArrayOfPositionItemResult_V6' => '\\ArrayType\\ArrayOfPositionItemResult_V6',
            'PositionItemResult_V6' => '\\StructType\\PositionItemResult_V6',
            'Get_Positions_V6Response' => '\\StructType\\Get_Positions_V6Response',
            'Get_PositionsResult_V6' => '\\StructType\\Get_PositionsResult_V6',
            'Get_Nearest_Position' => '\\StructType\\Get_Nearest_Position',
            'NearestPositionSelection' => '\\StructType\\NearestPositionSelection',
            'ArrayOfNearestPositionItem' => '\\ArrayType\\ArrayOfNearestPositionItem',
            'NearestPositionItem' => '\\StructType\\NearestPositionItem',
            'Get_Nearest_PositionResponse' => '\\StructType\\Get_Nearest_PositionResponse',
            'NearestPositionResult' => '\\StructType\\NearestPositionResult',
            'Get_DriverTachoReadoutFiles' => '\\StructType\\Get_DriverTachoReadoutFiles',
            'DriverTachoReadoutSelection' => '\\StructType\\DriverTachoReadoutSelection',
            'TachoReadoutSelection' => '\\StructType\\TachoReadoutSelection',
            'ArrayOfDriverTachoReadoutIdentifier' => '\\ArrayType\\ArrayOfDriverTachoReadoutIdentifier',
            'DriverTachoReadoutIdentifier' => '\\StructType\\DriverTachoReadoutIdentifier',
            'TachoReadoutIdentifier' => '\\StructType\\TachoReadoutIdentifier',
            'ArrayOfGroupIdentifier' => '\\ArrayType\\ArrayOfGroupIdentifier',
            'TachoReadoutItem' => '\\StructType\\TachoReadoutItem',
            'GroupIdentifierResult' => '\\StructType\\GroupIdentifierResult',
            'ArrayOfTachoReadoutItem' => '\\ArrayType\\ArrayOfTachoReadoutItem',
            'Get_DriverTachoReadoutFilesResponse' => '\\StructType\\Get_DriverTachoReadoutFilesResponse',
            'TachoReadoutResult' => '\\StructType\\TachoReadoutResult',
            'Get_VehicleTachoReadoutFiles' => '\\StructType\\Get_VehicleTachoReadoutFiles',
            'VehicleTachoReadoutSelection' => '\\StructType\\VehicleTachoReadoutSelection',
            'ArrayOfVehicleTachoReadoutIdentifier' => '\\ArrayType\\ArrayOfVehicleTachoReadoutIdentifier',
            'VehicleTachoReadoutIdentifier' => '\\StructType\\VehicleTachoReadoutIdentifier',
            'Get_VehicleTachoReadoutFilesResponse' => '\\StructType\\Get_VehicleTachoReadoutFilesResponse',
            'Initiate_RddDownload' => '\\StructType\\Initiate_RddDownload',
            'InitiateRddDownload' => '\\StructType\\InitiateRddDownload',
            'Initiate_RddDownloadResponse' => '\\StructType\\Initiate_RddDownloadResponse',
            'Get_SalaryPreCalculation' => '\\StructType\\Get_SalaryPreCalculation',
            'SalaryPreCalculationSelection' => '\\StructType\\SalaryPreCalculationSelection',
            'SalaryPreCalculationItem' => '\\StructType\\SalaryPreCalculationItem',
            'ArrayOfSalaryPreCalculationItem' => '\\ArrayType\\ArrayOfSalaryPreCalculationItem',
            'Get_SalaryPreCalculationResponse' => '\\StructType\\Get_SalaryPreCalculationResponse',
            'Get_SalaryPreCalculationResult' => '\\StructType\\Get_SalaryPreCalculationResult',
            'Get_SalaryPreCalculation_V2' => '\\StructType\\Get_SalaryPreCalculation_V2',
            'SalaryPreCalculationSelection_V2' => '\\StructType\\SalaryPreCalculationSelection_V2',
            'SalaryPreCalculationItem_V2' => '\\StructType\\SalaryPreCalculationItem_V2',
            'ArrayOfWorkDayItem' => '\\ArrayType\\ArrayOfWorkDayItem',
            'WorkDayItem' => '\\StructType\\WorkDayItem',
            'ArrayOfSalaryPreCalculationItem_V2' => '\\ArrayType\\ArrayOfSalaryPreCalculationItem_V2',
            'Get_SalaryPreCalculation_V2Response' => '\\StructType\\Get_SalaryPreCalculation_V2Response',
            'Get_SalaryPreCalculationResult_V2' => '\\StructType\\Get_SalaryPreCalculationResult_V2',
            'Set_SmsCommunicationConfig' => '\\StructType\\Set_SmsCommunicationConfig',
            'SetSmsCommunicationConfig' => '\\StructType\\SetSmsCommunicationConfig',
            'Set_SmsCommunicationConfigResponse' => '\\StructType\\Set_SmsCommunicationConfigResponse',
            'SetSmsCommunicationConfigResult' => '\\StructType\\SetSmsCommunicationConfigResult',
            'Get_SmsCommunicationConfig' => '\\StructType\\Get_SmsCommunicationConfig',
            'GetSmsCommunicationConfig' => '\\StructType\\GetSmsCommunicationConfig',
            'Get_SmsCommunicationConfigResponse' => '\\StructType\\Get_SmsCommunicationConfigResponse',
            'GetSmsCommunicationConfigResult' => '\\StructType\\GetSmsCommunicationConfigResult',
            'Get_SmsCommunication' => '\\StructType\\Get_SmsCommunication',
            'SmsCommunicationSelection' => '\\StructType\\SmsCommunicationSelection',
            'SmsInfoitem' => '\\StructType\\SmsInfoitem',
            'ArrayOfSmsInfoitem' => '\\ArrayType\\ArrayOfSmsInfoitem',
            'ArrayOfSmsCommunicationResult' => '\\ArrayType\\ArrayOfSmsCommunicationResult',
            'SmsCommunicationResult' => '\\StructType\\SmsCommunicationResult',
            'Get_SmsCommunicationResponse' => '\\StructType\\Get_SmsCommunicationResponse',
            'GetSmsCommunicationResult' => '\\StructType\\GetSmsCommunicationResult',
            'Send_SecurityCommand' => '\\StructType\\Send_SecurityCommand',
            'SecurityCommand' => '\\StructType\\SecurityCommand',
            'Send_SecurityCommandResponse' => '\\StructType\\Send_SecurityCommandResponse',
            'Send_DoorlockCommand' => '\\StructType\\Send_DoorlockCommand',
            'DoorlockCommand' => '\\StructType\\DoorlockCommand',
            'ArrayOfCommand' => '\\ArrayType\\ArrayOfCommand',
            'Command' => '\\StructType\\Command',
            'Send_DoorlockCommandResultInfo' => '\\StructType\\Send_DoorlockCommandResultInfo',
            'Send_DoorlockCommandResponse' => '\\StructType\\Send_DoorlockCommandResponse',
            'Send_DoorlockCommandResult' => '\\StructType\\Send_DoorlockCommandResult',
        );
    }
}
