<?php

namespace EnumType;

/**
 * This class stands for enumIdentifierVehicleType EnumType
 * @subpackage Enumerations
 */
class EnumIdentifierVehicleType
{
    /**
     * Constant for value 'ID'
     * @return string 'ID'
     */
    const VALUE_ID = 'ID';
    /**
     * Constant for value 'TRANSICS_ID'
     * @return string 'TRANSICS_ID'
     */
    const VALUE_TRANSICS_ID = 'TRANSICS_ID';
    /**
     * Constant for value 'CODE'
     * @return string 'CODE'
     */
    const VALUE_CODE = 'CODE';
    /**
     * Constant for value 'LICENSE_PLATE'
     * @return string 'LICENSE_PLATE'
     */
    const VALUE_LICENSE_PLATE = 'LICENSE_PLATE';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_ID
     * @uses self::VALUE_TRANSICS_ID
     * @uses self::VALUE_CODE
     * @uses self::VALUE_LICENSE_PLATE
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_ID,
            self::VALUE_TRANSICS_ID,
            self::VALUE_CODE,
            self::VALUE_LICENSE_PLATE,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
