<?php

namespace EnumType;

/**
 * This class stands for enumPlanningStatus EnumType
 * @subpackage Enumerations
 */
class EnumPlanningStatus
{
    /**
     * Constant for value 'NOT_EXECUTED'
     * @return string 'NOT_EXECUTED'
     */
    const VALUE_NOT_EXECUTED = 'NOT_EXECUTED';
    /**
     * Constant for value 'BUSY'
     * @return string 'BUSY'
     */
    const VALUE_BUSY = 'BUSY';
    /**
     * Constant for value 'FINISHED'
     * @return string 'FINISHED'
     */
    const VALUE_FINISHED = 'FINISHED';
    /**
     * Constant for value 'CANCELED'
     * @return string 'CANCELED'
     */
    const VALUE_CANCELED = 'CANCELED';
    /**
     * Constant for value 'PAUSE'
     * @return string 'PAUSE'
     */
    const VALUE_PAUSE = 'PAUSE';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_NOT_EXECUTED
     * @uses self::VALUE_BUSY
     * @uses self::VALUE_FINISHED
     * @uses self::VALUE_CANCELED
     * @uses self::VALUE_PAUSE
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_NOT_EXECUTED,
            self::VALUE_BUSY,
            self::VALUE_FINISHED,
            self::VALUE_CANCELED,
            self::VALUE_PAUSE,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
