<?php

namespace EnumType;

/**
 * This class stands for enumSelectionDateTimeAndIdType EnumType
 * @subpackage Enumerations
 */
class EnumSelectionDateTimeAndIdType
{
    /**
     * Constant for value 'MINUTES'
     * @return string 'MINUTES'
     */
    const VALUE_MINUTES = 'MINUTES';
    /**
     * Constant for value 'HOURS'
     * @return string 'HOURS'
     */
    const VALUE_HOURS = 'HOURS';
    /**
     * Constant for value 'DAYS'
     * @return string 'DAYS'
     */
    const VALUE_DAYS = 'DAYS';
    /**
     * Constant for value 'GET_ALL'
     * @return string 'GET_ALL'
     */
    const VALUE_GET_ALL = 'GET_ALL';
    /**
     * Constant for value 'GET_MODIFIED_SINCE_LAST_REQUEST'
     * @return string 'GET_MODIFIED_SINCE_LAST_REQUEST'
     */
    const VALUE_GET_MODIFIED_SINCE_LAST_REQUEST = 'GET_MODIFIED_SINCE_LAST_REQUEST';
    /**
     * Constant for value 'GET_MODIFIED_SINCE_LAST_ID'
     * @return string 'GET_MODIFIED_SINCE_LAST_ID'
     */
    const VALUE_GET_MODIFIED_SINCE_LAST_ID = 'GET_MODIFIED_SINCE_LAST_ID';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_MINUTES
     * @uses self::VALUE_HOURS
     * @uses self::VALUE_DAYS
     * @uses self::VALUE_GET_ALL
     * @uses self::VALUE_GET_MODIFIED_SINCE_LAST_REQUEST
     * @uses self::VALUE_GET_MODIFIED_SINCE_LAST_ID
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_MINUTES,
            self::VALUE_HOURS,
            self::VALUE_DAYS,
            self::VALUE_GET_ALL,
            self::VALUE_GET_MODIFIED_SINCE_LAST_REQUEST,
            self::VALUE_GET_MODIFIED_SINCE_LAST_ID,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
