<?php

namespace EnumType;

/**
 * This class stands for enumTemperatureType EnumType
 * @subpackage Enumerations
 */
class EnumTemperatureType
{
    /**
     * Constant for value 'RETURN_AIR'
     * @return string 'RETURN_AIR'
     */
    const VALUE_RETURN_AIR = 'RETURN_AIR';
    /**
     * Constant for value 'SET_AIR'
     * @return string 'SET_AIR'
     */
    const VALUE_SET_AIR = 'SET_AIR';
    /**
     * Constant for value 'SUPPLY_AIR'
     * @return string 'SUPPLY_AIR'
     */
    const VALUE_SUPPLY_AIR = 'SUPPLY_AIR';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_RETURN_AIR
     * @uses self::VALUE_SET_AIR
     * @uses self::VALUE_SUPPLY_AIR
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_RETURN_AIR,
            self::VALUE_SET_AIR,
            self::VALUE_SUPPLY_AIR,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
