<?php

namespace EnumType;

/**
 * This class stands for enumTripStatus EnumType
 * @subpackage Enumerations
 */
class EnumTripStatus
{
    /**
     * Constant for value 'Created'
     * @return string 'Created'
     */
    const VALUE_CREATED = 'Created';
    /**
     * Constant for value 'Sending'
     * @return string 'Sending'
     */
    const VALUE_SENDING = 'Sending';
    /**
     * Constant for value 'Delivered'
     * @return string 'Delivered'
     */
    const VALUE_DELIVERED = 'Delivered';
    /**
     * Constant for value 'Cancelled'
     * @return string 'Cancelled'
     */
    const VALUE_CANCELLED = 'Cancelled';
    /**
     * Constant for value 'ReadByDriver'
     * @return string 'ReadByDriver'
     */
    const VALUE_READ_BY_DRIVER = 'ReadByDriver';
    /**
     * Constant for value 'Started'
     * @return string 'Started'
     */
    const VALUE_STARTED = 'Started';
    /**
     * Constant for value 'Finished'
     * @return string 'Finished'
     */
    const VALUE_FINISHED = 'Finished';
    /**
     * Constant for value 'Paused'
     * @return string 'Paused'
     */
    const VALUE_PAUSED = 'Paused';
    /**
     * Constant for value 'Error'
     * @return string 'Error'
     */
    const VALUE_ERROR = 'Error';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_CREATED
     * @uses self::VALUE_SENDING
     * @uses self::VALUE_DELIVERED
     * @uses self::VALUE_CANCELLED
     * @uses self::VALUE_READ_BY_DRIVER
     * @uses self::VALUE_STARTED
     * @uses self::VALUE_FINISHED
     * @uses self::VALUE_PAUSED
     * @uses self::VALUE_ERROR
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_CREATED,
            self::VALUE_SENDING,
            self::VALUE_DELIVERED,
            self::VALUE_CANCELLED,
            self::VALUE_READ_BY_DRIVER,
            self::VALUE_STARTED,
            self::VALUE_FINISHED,
            self::VALUE_PAUSED,
            self::VALUE_ERROR,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
