<?php

namespace EnumType;

/**
 * This class stands for enumVehicleType EnumType
 * @subpackage Enumerations
 */
class EnumVehicleType
{
    /**
     * Constant for value 'DISPATCHER_FLEET'
     * @return string 'DISPATCHER_FLEET'
     */
    const VALUE_DISPATCHER_FLEET = 'DISPATCHER_FLEET';
    /**
     * Constant for value 'SINGLE_VEHICLES'
     * @return string 'SINGLE_VEHICLES'
     */
    const VALUE_SINGLE_VEHICLES = 'SINGLE_VEHICLES';
    /**
     * Constant for value 'FULL_FLEET'
     * @return string 'FULL_FLEET'
     */
    const VALUE_FULL_FLEET = 'FULL_FLEET';
    /**
     * Constant for value 'REPLY'
     * @return string 'REPLY'
     */
    const VALUE_REPLY = 'REPLY';
    /**
     * Constant for value 'NONE'
     * @return string 'NONE'
     */
    const VALUE_NONE = 'NONE';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_DISPATCHER_FLEET
     * @uses self::VALUE_SINGLE_VEHICLES
     * @uses self::VALUE_FULL_FLEET
     * @uses self::VALUE_REPLY
     * @uses self::VALUE_NONE
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_DISPATCHER_FLEET,
            self::VALUE_SINGLE_VEHICLES,
            self::VALUE_FULL_FLEET,
            self::VALUE_REPLY,
            self::VALUE_NONE,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
