<?php

namespace EnumType;

/**
 * This class stands for enumViaRoutePlanningType EnumType
 * @subpackage Enumerations
 */
class EnumViaRoutePlanningType
{
    /**
     * Constant for value 'NO_LINK_WITH_PLANNING'
     * @return string 'NO_LINK_WITH_PLANNING'
     */
    const VALUE_NO_LINK_WITH_PLANNING = 'NO_LINK_WITH_PLANNING';
    /**
     * Constant for value 'DRIVER_MUST_FIND_OWN_WAY_TO_PLACE'
     * @return string 'DRIVER_MUST_FIND_OWN_WAY_TO_PLACE'
     */
    const VALUE_DRIVER_MUST_FIND_OWN_WAY_TO_PLACE = 'DRIVER_MUST_FIND_OWN_WAY_TO_PLACE';
    /**
     * Constant for value 'ADD_PLACE_AS_LAST_VIAPOINT'
     * @return string 'ADD_PLACE_AS_LAST_VIAPOINT'
     */
    const VALUE_ADD_PLACE_AS_LAST_VIAPOINT = 'ADD_PLACE_AS_LAST_VIAPOINT';
    /**
     * Constant for value 'PLACE_IS_LAST_VIAPOINT'
     * @return string 'PLACE_IS_LAST_VIAPOINT'
     */
    const VALUE_PLACE_IS_LAST_VIAPOINT = 'PLACE_IS_LAST_VIAPOINT';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_NO_LINK_WITH_PLANNING
     * @uses self::VALUE_DRIVER_MUST_FIND_OWN_WAY_TO_PLACE
     * @uses self::VALUE_ADD_PLACE_AS_LAST_VIAPOINT
     * @uses self::VALUE_PLACE_IS_LAST_VIAPOINT
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_NO_LINK_WITH_PLANNING,
            self::VALUE_DRIVER_MUST_FIND_OWN_WAY_TO_PLACE,
            self::VALUE_ADD_PLACE_AS_LAST_VIAPOINT,
            self::VALUE_PLACE_IS_LAST_VIAPOINT,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
