<?php

namespace EnumType;

/**
 * This class stands for enumViaRouteTransferStatus EnumType
 * @subpackage Enumerations
 */
class EnumViaRouteTransferStatus
{
    /**
     * Constant for value 'NOT_TRANSFERED'
     * @return string 'NOT_TRANSFERED'
     */
    const VALUE_NOT_TRANSFERED = 'NOT_TRANSFERED';
    /**
     * Constant for value 'SENDING'
     * @return string 'SENDING'
     */
    const VALUE_SENDING = 'SENDING';
    /**
     * Constant for value 'DELIVERED'
     * @return string 'DELIVERED'
     */
    const VALUE_DELIVERED = 'DELIVERED';
    /**
     * Constant for value 'ERROR'
     * @return string 'ERROR'
     */
    const VALUE_ERROR = 'ERROR';
    /**
     * Constant for value 'OBCFAILURE'
     * @return string 'OBCFAILURE'
     */
    const VALUE_OBCFAILURE = 'OBCFAILURE';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_NOT_TRANSFERED
     * @uses self::VALUE_SENDING
     * @uses self::VALUE_DELIVERED
     * @uses self::VALUE_ERROR
     * @uses self::VALUE_OBCFAILURE
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_NOT_TRANSFERED,
            self::VALUE_SENDING,
            self::VALUE_DELIVERED,
            self::VALUE_ERROR,
            self::VALUE_OBCFAILURE,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
