<?php

namespace EnumType;

/**
 * This class stands for ReeferCommandType EnumType
 * @subpackage Enumerations
 */
class ReeferCommandType
{
    /**
     * Constant for value 'UpdateSetPoint'
     * @return string 'UpdateSetPoint'
     */
    const VALUE_UPDATE_SET_POINT = 'UpdateSetPoint';
    /**
     * Constant for value 'ClearAlarms'
     * @return string 'ClearAlarms'
     */
    const VALUE_CLEAR_ALARMS = 'ClearAlarms';
    /**
     * Constant for value 'ExecutepreTrip'
     * @return string 'ExecutepreTrip'
     */
    const VALUE_EXECUTEPRE_TRIP = 'ExecutepreTrip';
    /**
     * Constant for value 'Defrost'
     * @return string 'Defrost'
     */
    const VALUE_DEFROST = 'Defrost';
    /**
     * Constant for value 'OperatingMode'
     * @return string 'OperatingMode'
     */
    const VALUE_OPERATING_MODE = 'OperatingMode';
    /**
     * Constant for value 'RemoteOnOff'
     * @return string 'RemoteOnOff'
     */
    const VALUE_REMOTE_ON_OFF = 'RemoteOnOff';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_UPDATE_SET_POINT
     * @uses self::VALUE_CLEAR_ALARMS
     * @uses self::VALUE_EXECUTEPRE_TRIP
     * @uses self::VALUE_DEFROST
     * @uses self::VALUE_OPERATING_MODE
     * @uses self::VALUE_REMOTE_ON_OFF
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_UPDATE_SET_POINT,
            self::VALUE_CLEAR_ALARMS,
            self::VALUE_EXECUTEPRE_TRIP,
            self::VALUE_DEFROST,
            self::VALUE_OPERATING_MODE,
            self::VALUE_REMOTE_ON_OFF,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
