<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Assign ServiceType
 * @subpackage Services
 */
class Assign extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named Assign_Vehicles_To_Dispatchers
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Assign_Vehicles_To_Dispatchers $parameters
     * @return \StructType\Assign_Vehicles_To_DispatchersResponse|bool
     */
    public function Assign_Vehicles_To_Dispatchers(\StructType\Assign_Vehicles_To_Dispatchers $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Assign_Vehicles_To_Dispatchers($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Assign_GeoFence
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Assign_GeoFence $parameters
     * @return \StructType\Assign_GeoFenceResponse|bool
     */
    public function Assign_GeoFence(\StructType\Assign_GeoFence $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Assign_GeoFence($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Assign_Vehicle_To_Group
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Assign_Vehicle_To_Group $parameters
     * @return \StructType\Assign_Vehicle_To_GroupResponse|bool
     */
    public function Assign_Vehicle_To_Group(\StructType\Assign_Vehicle_To_Group $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Assign_Vehicle_To_Group($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Assign_Trailer_To_Group
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Assign_Trailer_To_Group $parameters
     * @return \StructType\Assign_Trailer_To_GroupResponse|bool
     */
    public function Assign_Trailer_To_Group(\StructType\Assign_Trailer_To_Group $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Assign_Trailer_To_Group($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Assign_Driver_To_Group
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Assign_Driver_To_Group $parameters
     * @return \StructType\Assign_Driver_To_GroupResponse|bool
     */
    public function Assign_Driver_To_Group(\StructType\Assign_Driver_To_Group $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Assign_Driver_To_Group($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Assign_Group_To_Dispatcher
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Assign_Group_To_Dispatcher $parameters
     * @return \StructType\Assign_Group_To_DispatcherResponse|bool
     */
    public function Assign_Group_To_Dispatcher(\StructType\Assign_Group_To_Dispatcher $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Assign_Group_To_Dispatcher($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Assign_Resources_To_Group
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Assign_Resources_To_Group $parameters
     * @return \StructType\Assign_Resources_To_GroupResponse|bool
     */
    public function Assign_Resources_To_Group(\StructType\Assign_Resources_To_Group $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Assign_Resources_To_Group($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\Assign_Driver_To_GroupResponse|\StructType\Assign_GeoFenceResponse|\StructType\Assign_Group_To_DispatcherResponse|\StructType\Assign_Resources_To_GroupResponse|\StructType\Assign_Trailer_To_GroupResponse|\StructType\Assign_Vehicles_To_DispatchersResponse|\StructType\Assign_Vehicle_To_GroupResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
