<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Insert ServiceType
 * @subpackage Services
 */
class Insert extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named Insert_Trailer
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_Trailer $parameters
     * @return \StructType\Insert_TrailerResponse|bool
     */
    public function Insert_Trailer(\StructType\Insert_Trailer $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_Trailer($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_Trailer_V2
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_Trailer_V2 $parameters
     * @return \StructType\Insert_Trailer_V2Response|bool
     */
    public function Insert_Trailer_V2(\StructType\Insert_Trailer_V2 $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_Trailer_V2($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_Vehicle
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_Vehicle $parameters
     * @return \StructType\Insert_VehicleResponse|bool
     */
    public function Insert_Vehicle(\StructType\Insert_Vehicle $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_Vehicle($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_ViaRoute
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_ViaRoute $parameters
     * @return \StructType\Insert_ViaRouteResponse|bool
     */
    public function Insert_ViaRoute(\StructType\Insert_ViaRoute $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_ViaRoute($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_Absences
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_Absences $parameters
     * @return \StructType\Insert_AbsencesResponse|bool
     */
    public function Insert_Absences(\StructType\Insert_Absences $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_Absences($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_Dispatcher
     * Meta informations extracted from the WSDL
     * - documentation: Insert dispatcher.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_Dispatcher $parameters
     * @return \StructType\Insert_DispatcherResponse|bool
     */
    public function Insert_Dispatcher(\StructType\Insert_Dispatcher $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_Dispatcher($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_Dispatcher_V2
     * Meta informations extracted from the WSDL
     * - documentation: Insert dispatcher.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_Dispatcher_V2 $parameters
     * @return \StructType\Insert_Dispatcher_V2Response|bool
     */
    public function Insert_Dispatcher_V2(\StructType\Insert_Dispatcher_V2 $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_Dispatcher_V2($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_Driver
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_Driver $parameters
     * @return \StructType\Insert_DriverResponse|bool
     */
    public function Insert_Driver(\StructType\Insert_Driver $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_Driver($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_Driver_V2
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_Driver_V2 $parameters
     * @return \StructType\Insert_Driver_V2Response|bool
     */
    public function Insert_Driver_V2(\StructType\Insert_Driver_V2 $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_Driver_V2($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_Driver_V3
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_Driver_V3 $parameters
     * @return \StructType\Insert_Driver_V3Response|bool
     */
    public function Insert_Driver_V3(\StructType\Insert_Driver_V3 $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_Driver_V3($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_Refuelings
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_Refuelings $parameters
     * @return \StructType\Insert_RefuelingsResponse|bool
     */
    public function Insert_Refuelings(\StructType\Insert_Refuelings $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_Refuelings($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_GeoFence
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_GeoFence $parameters
     * @return \StructType\Insert_GeoFenceResponse|bool
     */
    public function Insert_GeoFence(\StructType\Insert_GeoFence $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_GeoFence($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_GeoFence_V2
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_GeoFence_V2 $parameters
     * @return \StructType\Insert_GeoFence_V2Response|bool
     */
    public function Insert_GeoFence_V2(\StructType\Insert_GeoFence_V2 $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_GeoFence_V2($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_Group
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_Group $parameters
     * @return \StructType\Insert_GroupResponse|bool
     */
    public function Insert_Group(\StructType\Insert_Group $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_Group($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_Planning
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_Planning $parameters
     * @return \StructType\Insert_PlanningResponse|bool
     */
    public function Insert_Planning(\StructType\Insert_Planning $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_Planning($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_New_Comment_On_Trip
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_New_Comment_On_Trip $parameters
     * @return \StructType\Insert_New_Comment_On_TripResponse|bool
     */
    public function Insert_New_Comment_On_Trip(\StructType\Insert_New_Comment_On_Trip $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_New_Comment_On_Trip($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_New_Job_On_Trip
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_New_Job_On_Trip $parameters
     * @return \StructType\Insert_New_Job_On_TripResponse|bool
     */
    public function Insert_New_Job_On_Trip(\StructType\Insert_New_Job_On_Trip $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_New_Job_On_Trip($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_New_Place_On_Trip
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_New_Place_On_Trip $parameters
     * @return \StructType\Insert_New_Place_On_TripResponse|bool
     */
    public function Insert_New_Place_On_Trip(\StructType\Insert_New_Place_On_Trip $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_New_Place_On_Trip($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_New_Product_On_Trip
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_New_Product_On_Trip $parameters
     * @return \StructType\Insert_New_Product_On_TripResponse|bool
     */
    public function Insert_New_Product_On_Trip(\StructType\Insert_New_Product_On_Trip $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_New_Product_On_Trip($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Insert_POI
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Insert_POI $parameters
     * @return \StructType\Insert_POIResponse|bool
     */
    public function Insert_POI(\StructType\Insert_POI $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Insert_POI($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\Insert_AbsencesResponse|\StructType\Insert_DispatcherResponse|\StructType\Insert_Dispatcher_V2Response|\StructType\Insert_DriverResponse|\StructType\Insert_Driver_V2Response|\StructType\Insert_Driver_V3Response|\StructType\Insert_GeoFenceResponse|\StructType\Insert_GeoFence_V2Response|\StructType\Insert_GroupResponse|\StructType\Insert_New_Comment_On_TripResponse|\StructType\Insert_New_Job_On_TripResponse|\StructType\Insert_New_Place_On_TripResponse|\StructType\Insert_New_Product_On_TripResponse|\StructType\Insert_PlanningResponse|\StructType\Insert_POIResponse|\StructType\Insert_RefuelingsResponse|\StructType\Insert_TrailerResponse|\StructType\Insert_Trailer_V2Response|\StructType\Insert_VehicleResponse|\StructType\Insert_ViaRouteResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
