<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Update ServiceType
 * @subpackage Services
 */
class Update extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named Update_TextMessage_Read
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_TextMessage_Read $parameters
     * @return \StructType\Update_TextMessage_ReadResponse|bool
     */
    public function Update_TextMessage_Read(\StructType\Update_TextMessage_Read $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_TextMessage_Read($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_TextMessage_Read_V2
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_TextMessage_Read_V2 $parameters
     * @return \StructType\Update_TextMessage_Read_V2Response|bool
     */
    public function Update_TextMessage_Read_V2(\StructType\Update_TextMessage_Read_V2 $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_TextMessage_Read_V2($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_TextMessage_Treated
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_TextMessage_Treated $parameters
     * @return \StructType\Update_TextMessage_TreatedResponse|bool
     */
    public function Update_TextMessage_Treated(\StructType\Update_TextMessage_Treated $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_TextMessage_Treated($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_Trailer
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_Trailer $parameters
     * @return \StructType\Update_TrailerResponse|bool
     */
    public function Update_Trailer(\StructType\Update_Trailer $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_Trailer($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_Trailer_V2
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_Trailer_V2 $parameters
     * @return \StructType\Update_Trailer_V2Response|bool
     */
    public function Update_Trailer_V2(\StructType\Update_Trailer_V2 $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_Trailer_V2($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_Trailer_V3
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_Trailer_V3 $parameters
     * @return \StructType\Update_Trailer_V3Response|bool
     */
    public function Update_Trailer_V3(\StructType\Update_Trailer_V3 $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_Trailer_V3($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_Vehicle
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_Vehicle $parameters
     * @return \StructType\Update_VehicleResponse|bool
     */
    public function Update_Vehicle(\StructType\Update_Vehicle $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_Vehicle($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_Vehicle_V2
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_Vehicle_V2 $parameters
     * @return \StructType\Update_Vehicle_V2Response|bool
     */
    public function Update_Vehicle_V2(\StructType\Update_Vehicle_V2 $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_Vehicle_V2($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_ViaRoute
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_ViaRoute $parameters
     * @return \StructType\Update_ViaRouteResponse|bool
     */
    public function Update_ViaRoute(\StructType\Update_ViaRoute $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_ViaRoute($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_AlarmMessages_Treated
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_AlarmMessages_Treated $parameters
     * @return \StructType\Update_AlarmMessages_TreatedResponse|bool
     */
    public function Update_AlarmMessages_Treated(\StructType\Update_AlarmMessages_Treated $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_AlarmMessages_Treated($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_Dispatcher
     * Meta informations extracted from the WSDL
     * - documentation: Update dispatcher.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_Dispatcher $parameters
     * @return \StructType\Update_DispatcherResponse|bool
     */
    public function Update_Dispatcher(\StructType\Update_Dispatcher $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_Dispatcher($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_Dispatcher_V2
     * Meta informations extracted from the WSDL
     * - documentation: Update dispatcher.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_Dispatcher_V2 $parameters
     * @return \StructType\Update_Dispatcher_V2Response|bool
     */
    public function Update_Dispatcher_V2(\StructType\Update_Dispatcher_V2 $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_Dispatcher_V2($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_Driver
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_Driver $parameters
     * @return \StructType\Update_DriverResponse|bool
     */
    public function Update_Driver(\StructType\Update_Driver $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_Driver($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_Driver_V2
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_Driver_V2 $parameters
     * @return \StructType\Update_Driver_V2Response|bool
     */
    public function Update_Driver_V2(\StructType\Update_Driver_V2 $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_Driver_V2($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_Driver_V3
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_Driver_V3 $parameters
     * @return \StructType\Update_Driver_V3Response|bool
     */
    public function Update_Driver_V3(\StructType\Update_Driver_V3 $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_Driver_V3($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_Driver_V4
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_Driver_V4 $parameters
     * @return \StructType\Update_Driver_V4Response|bool
     */
    public function Update_Driver_V4(\StructType\Update_Driver_V4 $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_Driver_V4($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_GeoFence
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_GeoFence $parameters
     * @return \StructType\Update_GeoFenceResponse|bool
     */
    public function Update_GeoFence(\StructType\Update_GeoFence $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_GeoFence($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_GeoFence_V2
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_GeoFence_V2 $parameters
     * @return \StructType\Update_GeoFence_V2Response|bool
     */
    public function Update_GeoFence_V2(\StructType\Update_GeoFence_V2 $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_GeoFence_V2($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_Planning
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_Planning $parameters
     * @return \StructType\Update_PlanningResponse|bool
     */
    public function Update_Planning(\StructType\Update_Planning $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_Planning($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_Place_On_Trip
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_Place_On_Trip $parameters
     * @return \StructType\Update_Place_On_TripResponse|bool
     */
    public function Update_Place_On_Trip(\StructType\Update_Place_On_Trip $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_Place_On_Trip($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named Update_POI
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Update_POI $parameters
     * @return \StructType\Update_POIResponse|bool
     */
    public function Update_POI(\StructType\Update_POI $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->Update_POI($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\Update_AlarmMessages_TreatedResponse|\StructType\Update_DispatcherResponse|\StructType\Update_Dispatcher_V2Response|\StructType\Update_DriverResponse|\StructType\Update_Driver_V2Response|\StructType\Update_Driver_V3Response|\StructType\Update_Driver_V4Response|\StructType\Update_GeoFenceResponse|\StructType\Update_GeoFence_V2Response|\StructType\Update_Place_On_TripResponse|\StructType\Update_PlanningResponse|\StructType\Update_POIResponse|\StructType\Update_TextMessage_ReadResponse|\StructType\Update_TextMessage_Read_V2Response|\StructType\Update_TextMessage_TreatedResponse|\StructType\Update_TrailerResponse|\StructType\Update_Trailer_V2Response|\StructType\Update_Trailer_V3Response|\StructType\Update_VehicleResponse|\StructType\Update_Vehicle_V2Response|\StructType\Update_ViaRouteResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
