<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ActivityReportDetailItem_V9 StructType
 * @subpackage Structs
 */
class ActivityReportDetailItem_V9 extends ActivityReportItem_V9
{
    /**
     * The PathInfoDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfPathResult
     */
    public $PathInfoDetail;
    /**
     * The PathInfoSummary
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PathInfoSummary;
    /**
     * Constructor method for ActivityReportDetailItem_V9
     * @uses ActivityReportDetailItem_V9::setPathInfoDetail()
     * @uses ActivityReportDetailItem_V9::setPathInfoSummary()
     * @param \ArrayType\ArrayOfPathResult $pathInfoDetail
     * @param string $pathInfoSummary
     */
    public function __construct(\ArrayType\ArrayOfPathResult $pathInfoDetail = null, $pathInfoSummary = null)
    {
        $this
            ->setPathInfoDetail($pathInfoDetail)
            ->setPathInfoSummary($pathInfoSummary);
    }
    /**
     * Get PathInfoDetail value
     * @return \ArrayType\ArrayOfPathResult|null
     */
    public function getPathInfoDetail()
    {
        return $this->PathInfoDetail;
    }
    /**
     * Set PathInfoDetail value
     * @param \ArrayType\ArrayOfPathResult $pathInfoDetail
     * @return \StructType\ActivityReportDetailItem_V9
     */
    public function setPathInfoDetail(\ArrayType\ArrayOfPathResult $pathInfoDetail = null)
    {
        $this->PathInfoDetail = $pathInfoDetail;
        return $this;
    }
    /**
     * Get PathInfoSummary value
     * @return string|null
     */
    public function getPathInfoSummary()
    {
        return $this->PathInfoSummary;
    }
    /**
     * Set PathInfoSummary value
     * @param string $pathInfoSummary
     * @return \StructType\ActivityReportDetailItem_V9
     */
    public function setPathInfoSummary($pathInfoSummary = null)
    {
        // validation for constraint: string
        if (!is_null($pathInfoSummary) && !is_string($pathInfoSummary)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pathInfoSummary)), __LINE__);
        }
        $this->PathInfoSummary = $pathInfoSummary;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ActivityReportDetailItem_V9
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
