<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ActivityReportSelection_V5 StructType
 * @subpackage Structs
 */
class ActivityReportSelection_V5 extends ActivityReportSelection_V4
{
    /**
     * The ValidatedHours
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $ValidatedHours;
    /**
     * Constructor method for ActivityReportSelection_V5
     * @uses ActivityReportSelection_V5::setValidatedHours()
     * @param string $validatedHours
     */
    public function __construct($validatedHours = null)
    {
        $this
            ->setValidatedHours($validatedHours);
    }
    /**
     * Get ValidatedHours value
     * @return string
     */
    public function getValidatedHours()
    {
        return $this->ValidatedHours;
    }
    /**
     * Set ValidatedHours value
     * @uses \EnumType\EnumValidatedHours::valueIsValid()
     * @uses \EnumType\EnumValidatedHours::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $validatedHours
     * @return \StructType\ActivityReportSelection_V5
     */
    public function setValidatedHours($validatedHours = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\EnumValidatedHours::valueIsValid($validatedHours)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $validatedHours, implode(', ', \EnumType\EnumValidatedHours::getValidValues())), __LINE__);
        }
        $this->ValidatedHours = $validatedHours;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ActivityReportSelection_V5
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
