<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AlarmMessageSelection_V2 StructType
 * @subpackage Structs
 */
class AlarmMessageSelection_V2 extends AbstractStructBase
{
    /**
     * The OnlyVisiblePopups
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $OnlyVisiblePopups;
    /**
     * The Vehicles
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifierVehicle
     */
    public $Vehicles;
    /**
     * The Trailers
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifierVehicle
     */
    public $Trailers;
    /**
     * The DateTimeRange
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateTimeRangeSelection
     */
    public $DateTimeRange;
    /**
     * The SelectionFromToday
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateTimeAndIdSelection
     */
    public $SelectionFromToday;
    /**
     * The AlarmMessageTypes
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfEnumAlarmMessageType
     */
    public $AlarmMessageTypes;
    /**
     * The AlarmIds
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfLong
     */
    public $AlarmIds;
    /**
     * Constructor method for AlarmMessageSelection_V2
     * @uses AlarmMessageSelection_V2::setOnlyVisiblePopups()
     * @uses AlarmMessageSelection_V2::setVehicles()
     * @uses AlarmMessageSelection_V2::setTrailers()
     * @uses AlarmMessageSelection_V2::setDateTimeRange()
     * @uses AlarmMessageSelection_V2::setSelectionFromToday()
     * @uses AlarmMessageSelection_V2::setAlarmMessageTypes()
     * @uses AlarmMessageSelection_V2::setAlarmIds()
     * @param bool $onlyVisiblePopups
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @param \ArrayType\ArrayOfIdentifierVehicle $trailers
     * @param \StructType\DateTimeRangeSelection $dateTimeRange
     * @param \StructType\DateTimeAndIdSelection $selectionFromToday
     * @param \ArrayType\ArrayOfEnumAlarmMessageType $alarmMessageTypes
     * @param \ArrayType\ArrayOfLong $alarmIds
     */
    public function __construct($onlyVisiblePopups = null, \ArrayType\ArrayOfIdentifierVehicle $vehicles = null, \ArrayType\ArrayOfIdentifierVehicle $trailers = null, \StructType\DateTimeRangeSelection $dateTimeRange = null, \StructType\DateTimeAndIdSelection $selectionFromToday = null, \ArrayType\ArrayOfEnumAlarmMessageType $alarmMessageTypes = null, \ArrayType\ArrayOfLong $alarmIds = null)
    {
        $this
            ->setOnlyVisiblePopups($onlyVisiblePopups)
            ->setVehicles($vehicles)
            ->setTrailers($trailers)
            ->setDateTimeRange($dateTimeRange)
            ->setSelectionFromToday($selectionFromToday)
            ->setAlarmMessageTypes($alarmMessageTypes)
            ->setAlarmIds($alarmIds);
    }
    /**
     * Get OnlyVisiblePopups value
     * @return bool
     */
    public function getOnlyVisiblePopups()
    {
        return $this->OnlyVisiblePopups;
    }
    /**
     * Set OnlyVisiblePopups value
     * @param bool $onlyVisiblePopups
     * @return \StructType\AlarmMessageSelection_V2
     */
    public function setOnlyVisiblePopups($onlyVisiblePopups = null)
    {
        // validation for constraint: boolean
        if (!is_null($onlyVisiblePopups) && !is_bool($onlyVisiblePopups)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($onlyVisiblePopups)), __LINE__);
        }
        $this->OnlyVisiblePopups = $onlyVisiblePopups;
        return $this;
    }
    /**
     * Get Vehicles value
     * @return \ArrayType\ArrayOfIdentifierVehicle|null
     */
    public function getVehicles()
    {
        return $this->Vehicles;
    }
    /**
     * Set Vehicles value
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @return \StructType\AlarmMessageSelection_V2
     */
    public function setVehicles(\ArrayType\ArrayOfIdentifierVehicle $vehicles = null)
    {
        $this->Vehicles = $vehicles;
        return $this;
    }
    /**
     * Get Trailers value
     * @return \ArrayType\ArrayOfIdentifierVehicle|null
     */
    public function getTrailers()
    {
        return $this->Trailers;
    }
    /**
     * Set Trailers value
     * @param \ArrayType\ArrayOfIdentifierVehicle $trailers
     * @return \StructType\AlarmMessageSelection_V2
     */
    public function setTrailers(\ArrayType\ArrayOfIdentifierVehicle $trailers = null)
    {
        $this->Trailers = $trailers;
        return $this;
    }
    /**
     * Get DateTimeRange value
     * @return \StructType\DateTimeRangeSelection|null
     */
    public function getDateTimeRange()
    {
        return $this->DateTimeRange;
    }
    /**
     * Set DateTimeRange value
     * @param \StructType\DateTimeRangeSelection $dateTimeRange
     * @return \StructType\AlarmMessageSelection_V2
     */
    public function setDateTimeRange(\StructType\DateTimeRangeSelection $dateTimeRange = null)
    {
        $this->DateTimeRange = $dateTimeRange;
        return $this;
    }
    /**
     * Get SelectionFromToday value
     * @return \StructType\DateTimeAndIdSelection|null
     */
    public function getSelectionFromToday()
    {
        return $this->SelectionFromToday;
    }
    /**
     * Set SelectionFromToday value
     * @param \StructType\DateTimeAndIdSelection $selectionFromToday
     * @return \StructType\AlarmMessageSelection_V2
     */
    public function setSelectionFromToday(\StructType\DateTimeAndIdSelection $selectionFromToday = null)
    {
        $this->SelectionFromToday = $selectionFromToday;
        return $this;
    }
    /**
     * Get AlarmMessageTypes value
     * @return \ArrayType\ArrayOfEnumAlarmMessageType|null
     */
    public function getAlarmMessageTypes()
    {
        return $this->AlarmMessageTypes;
    }
    /**
     * Set AlarmMessageTypes value
     * @param \ArrayType\ArrayOfEnumAlarmMessageType $alarmMessageTypes
     * @return \StructType\AlarmMessageSelection_V2
     */
    public function setAlarmMessageTypes(\ArrayType\ArrayOfEnumAlarmMessageType $alarmMessageTypes = null)
    {
        $this->AlarmMessageTypes = $alarmMessageTypes;
        return $this;
    }
    /**
     * Get AlarmIds value
     * @return \ArrayType\ArrayOfLong|null
     */
    public function getAlarmIds()
    {
        return $this->AlarmIds;
    }
    /**
     * Set AlarmIds value
     * @param \ArrayType\ArrayOfLong $alarmIds
     * @return \StructType\AlarmMessageSelection_V2
     */
    public function setAlarmIds(\ArrayType\ArrayOfLong $alarmIds = null)
    {
        $this->AlarmIds = $alarmIds;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AlarmMessageSelection_V2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
