<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AlarmMessageSelection_V7 StructType
 * @subpackage Structs
 */
class AlarmMessageSelection_V7 extends AbstractStructBase
{
    /**
     * The OnlyVisiblePopups
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $OnlyVisiblePopups;
    /**
     * The VehicleListStrategySelection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\VehicleListStrategySelection
     */
    public $VehicleListStrategySelection;
    /**
     * The DateStrategySelection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateStrategySelection
     */
    public $DateStrategySelection;
    /**
     * The AlarmMessageTypes
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $AlarmMessageTypes;
    /**
     * The AlarmIds
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfLong
     */
    public $AlarmIds;
    /**
     * Constructor method for AlarmMessageSelection_V7
     * @uses AlarmMessageSelection_V7::setOnlyVisiblePopups()
     * @uses AlarmMessageSelection_V7::setVehicleListStrategySelection()
     * @uses AlarmMessageSelection_V7::setDateStrategySelection()
     * @uses AlarmMessageSelection_V7::setAlarmMessageTypes()
     * @uses AlarmMessageSelection_V7::setAlarmIds()
     * @param bool $onlyVisiblePopups
     * @param \StructType\VehicleListStrategySelection $vehicleListStrategySelection
     * @param \StructType\DateStrategySelection $dateStrategySelection
     * @param \ArrayType\ArrayOfString $alarmMessageTypes
     * @param \ArrayType\ArrayOfLong $alarmIds
     */
    public function __construct($onlyVisiblePopups = null, \StructType\VehicleListStrategySelection $vehicleListStrategySelection = null, \StructType\DateStrategySelection $dateStrategySelection = null, \ArrayType\ArrayOfString $alarmMessageTypes = null, \ArrayType\ArrayOfLong $alarmIds = null)
    {
        $this
            ->setOnlyVisiblePopups($onlyVisiblePopups)
            ->setVehicleListStrategySelection($vehicleListStrategySelection)
            ->setDateStrategySelection($dateStrategySelection)
            ->setAlarmMessageTypes($alarmMessageTypes)
            ->setAlarmIds($alarmIds);
    }
    /**
     * Get OnlyVisiblePopups value
     * @return bool
     */
    public function getOnlyVisiblePopups()
    {
        return $this->OnlyVisiblePopups;
    }
    /**
     * Set OnlyVisiblePopups value
     * @param bool $onlyVisiblePopups
     * @return \StructType\AlarmMessageSelection_V7
     */
    public function setOnlyVisiblePopups($onlyVisiblePopups = null)
    {
        // validation for constraint: boolean
        if (!is_null($onlyVisiblePopups) && !is_bool($onlyVisiblePopups)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($onlyVisiblePopups)), __LINE__);
        }
        $this->OnlyVisiblePopups = $onlyVisiblePopups;
        return $this;
    }
    /**
     * Get VehicleListStrategySelection value
     * @return \StructType\VehicleListStrategySelection|null
     */
    public function getVehicleListStrategySelection()
    {
        return $this->VehicleListStrategySelection;
    }
    /**
     * Set VehicleListStrategySelection value
     * @param \StructType\VehicleListStrategySelection $vehicleListStrategySelection
     * @return \StructType\AlarmMessageSelection_V7
     */
    public function setVehicleListStrategySelection(\StructType\VehicleListStrategySelection $vehicleListStrategySelection = null)
    {
        $this->VehicleListStrategySelection = $vehicleListStrategySelection;
        return $this;
    }
    /**
     * Get DateStrategySelection value
     * @return \StructType\DateStrategySelection|null
     */
    public function getDateStrategySelection()
    {
        return $this->DateStrategySelection;
    }
    /**
     * Set DateStrategySelection value
     * @param \StructType\DateStrategySelection $dateStrategySelection
     * @return \StructType\AlarmMessageSelection_V7
     */
    public function setDateStrategySelection(\StructType\DateStrategySelection $dateStrategySelection = null)
    {
        $this->DateStrategySelection = $dateStrategySelection;
        return $this;
    }
    /**
     * Get AlarmMessageTypes value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getAlarmMessageTypes()
    {
        return $this->AlarmMessageTypes;
    }
    /**
     * Set AlarmMessageTypes value
     * @param \ArrayType\ArrayOfString $alarmMessageTypes
     * @return \StructType\AlarmMessageSelection_V7
     */
    public function setAlarmMessageTypes(\ArrayType\ArrayOfString $alarmMessageTypes = null)
    {
        $this->AlarmMessageTypes = $alarmMessageTypes;
        return $this;
    }
    /**
     * Get AlarmIds value
     * @return \ArrayType\ArrayOfLong|null
     */
    public function getAlarmIds()
    {
        return $this->AlarmIds;
    }
    /**
     * Set AlarmIds value
     * @param \ArrayType\ArrayOfLong $alarmIds
     * @return \StructType\AlarmMessageSelection_V7
     */
    public function setAlarmIds(\ArrayType\ArrayOfLong $alarmIds = null)
    {
        $this->AlarmIds = $alarmIds;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AlarmMessageSelection_V7
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
