<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CompanySubscription StructType
 * @subpackage Structs
 */
class CompanySubscription extends SubcontractedResultStrategy
{
    /**
     * The Company
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Company
     */
    public $Company;
    /**
     * Constructor method for CompanySubscription
     * @uses CompanySubscription::setCompany()
     * @param \StructType\Company $company
     */
    public function __construct(\StructType\Company $company = null)
    {
        $this
            ->setCompany($company);
    }
    /**
     * Get Company value
     * @return \StructType\Company|null
     */
    public function getCompany()
    {
        return $this->Company;
    }
    /**
     * Set Company value
     * @param \StructType\Company $company
     * @return \StructType\CompanySubscription
     */
    public function setCompany(\StructType\Company $company = null)
    {
        $this->Company = $company;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CompanySubscription
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
