<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Consultation_V4 StructType
 * @subpackage Structs
 */
class Consultation_V4 extends Consultation_V3
{
    /**
     * The State
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $State;
    /**
     * Constructor method for Consultation_V4
     * @uses Consultation_V4::setState()
     * @param string $state
     */
    public function __construct($state = null)
    {
        $this
            ->setState($state);
    }
    /**
     * Get State value
     * @return string
     */
    public function getState()
    {
        return $this->State;
    }
    /**
     * Set State value
     * @uses \EnumType\EnumActivityState::valueIsValid()
     * @uses \EnumType\EnumActivityState::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $state
     * @return \StructType\Consultation_V4
     */
    public function setState($state = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\EnumActivityState::valueIsValid($state)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $state, implode(', ', \EnumType\EnumActivityState::getValidValues())), __LINE__);
        }
        $this->State = $state;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Consultation_V4
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
