<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CorridorSelection StructType
 * @subpackage Structs
 */
class CorridorSelection extends AbstractStructBase
{
    /**
     * The Activate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Activate;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Vehicle
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\IdentifierVehicle
     */
    public $Vehicle;
    /**
     * Constructor method for CorridorSelection
     * @uses CorridorSelection::setActivate()
     * @uses CorridorSelection::setName()
     * @uses CorridorSelection::setVehicle()
     * @param bool $activate
     * @param string $name
     * @param \StructType\IdentifierVehicle $vehicle
     */
    public function __construct($activate = null, $name = null, \StructType\IdentifierVehicle $vehicle = null)
    {
        $this
            ->setActivate($activate)
            ->setName($name)
            ->setVehicle($vehicle);
    }
    /**
     * Get Activate value
     * @return bool
     */
    public function getActivate()
    {
        return $this->Activate;
    }
    /**
     * Set Activate value
     * @param bool $activate
     * @return \StructType\CorridorSelection
     */
    public function setActivate($activate = null)
    {
        // validation for constraint: boolean
        if (!is_null($activate) && !is_bool($activate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($activate)), __LINE__);
        }
        $this->Activate = $activate;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\CorridorSelection
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Vehicle value
     * @return \StructType\IdentifierVehicle|null
     */
    public function getVehicle()
    {
        return $this->Vehicle;
    }
    /**
     * Set Vehicle value
     * @param \StructType\IdentifierVehicle $vehicle
     * @return \StructType\CorridorSelection
     */
    public function setVehicle(\StructType\IdentifierVehicle $vehicle = null)
    {
        $this->Vehicle = $vehicle;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CorridorSelection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
