<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DistanceReportItem_v2 StructType
 * @subpackage Structs
 */
class DistanceReportItem_v2 extends DistanceReportItem
{
    /**
     * The Consumption
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Consumption;
    /**
     * The Consumption_L_Per_100km
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Consumption_L_Per_100km;
    /**
     * The Consumption_Km_Per_L
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Consumption_Km_Per_L;
    /**
     * Constructor method for DistanceReportItem_v2
     * @uses DistanceReportItem_v2::setConsumption()
     * @uses DistanceReportItem_v2::setConsumption_L_Per_100km()
     * @uses DistanceReportItem_v2::setConsumption_Km_Per_L()
     * @param float $consumption
     * @param float $consumption_L_Per_100km
     * @param float $consumption_Km_Per_L
     */
    public function __construct($consumption = null, $consumption_L_Per_100km = null, $consumption_Km_Per_L = null)
    {
        $this
            ->setConsumption($consumption)
            ->setConsumption_L_Per_100km($consumption_L_Per_100km)
            ->setConsumption_Km_Per_L($consumption_Km_Per_L);
    }
    /**
     * Get Consumption value
     * @return float
     */
    public function getConsumption()
    {
        return $this->Consumption;
    }
    /**
     * Set Consumption value
     * @param float $consumption
     * @return \StructType\DistanceReportItem_v2
     */
    public function setConsumption($consumption = null)
    {
        $this->Consumption = $consumption;
        return $this;
    }
    /**
     * Get Consumption_L_Per_100km value
     * @return float
     */
    public function getConsumption_L_Per_100km()
    {
        return $this->Consumption_L_Per_100km;
    }
    /**
     * Set Consumption_L_Per_100km value
     * @param float $consumption_L_Per_100km
     * @return \StructType\DistanceReportItem_v2
     */
    public function setConsumption_L_Per_100km($consumption_L_Per_100km = null)
    {
        $this->Consumption_L_Per_100km = $consumption_L_Per_100km;
        return $this;
    }
    /**
     * Get Consumption_Km_Per_L value
     * @return float
     */
    public function getConsumption_Km_Per_L()
    {
        return $this->Consumption_Km_Per_L;
    }
    /**
     * Set Consumption_Km_Per_L value
     * @param float $consumption_Km_Per_L
     * @return \StructType\DistanceReportItem_v2
     */
    public function setConsumption_Km_Per_L($consumption_Km_Per_L = null)
    {
        $this->Consumption_Km_Per_L = $consumption_Km_Per_L;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DistanceReportItem_v2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
