<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DocumentResult_V4 StructType
 * @subpackage Structs
 */
class DocumentResult_V4 extends DocumentResult_V3
{
    /**
     * The Product
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ProductIdentifier
     */
    public $Product;
    /**
     * Constructor method for DocumentResult_V4
     * @uses DocumentResult_V4::setProduct()
     * @param \StructType\ProductIdentifier $product
     */
    public function __construct(\StructType\ProductIdentifier $product = null)
    {
        $this
            ->setProduct($product);
    }
    /**
     * Get Product value
     * @return \StructType\ProductIdentifier|null
     */
    public function getProduct()
    {
        return $this->Product;
    }
    /**
     * Set Product value
     * @param \StructType\ProductIdentifier $product
     * @return \StructType\DocumentResult_V4
     */
    public function setProduct(\StructType\ProductIdentifier $product = null)
    {
        $this->Product = $product;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DocumentResult_V4
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
