<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EcoPerformanceProfileParameter StructType
 * @subpackage Structs
 */
class EcoPerformanceProfileParameter extends AbstractStructBase
{
    /**
     * The Target
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Target;
    /**
     * The Sensitivity
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Sensitivity;
    /**
     * The Weight
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Weight;
    /**
     * Constructor method for EcoPerformanceProfileParameter
     * @uses EcoPerformanceProfileParameter::setTarget()
     * @uses EcoPerformanceProfileParameter::setSensitivity()
     * @uses EcoPerformanceProfileParameter::setWeight()
     * @param float $target
     * @param float $sensitivity
     * @param float $weight
     */
    public function __construct($target = null, $sensitivity = null, $weight = null)
    {
        $this
            ->setTarget($target)
            ->setSensitivity($sensitivity)
            ->setWeight($weight);
    }
    /**
     * Get Target value
     * @return float
     */
    public function getTarget()
    {
        return $this->Target;
    }
    /**
     * Set Target value
     * @param float $target
     * @return \StructType\EcoPerformanceProfileParameter
     */
    public function setTarget($target = null)
    {
        $this->Target = $target;
        return $this;
    }
    /**
     * Get Sensitivity value
     * @return float
     */
    public function getSensitivity()
    {
        return $this->Sensitivity;
    }
    /**
     * Set Sensitivity value
     * @param float $sensitivity
     * @return \StructType\EcoPerformanceProfileParameter
     */
    public function setSensitivity($sensitivity = null)
    {
        $this->Sensitivity = $sensitivity;
        return $this;
    }
    /**
     * Get Weight value
     * @return float
     */
    public function getWeight()
    {
        return $this->Weight;
    }
    /**
     * Set Weight value
     * @param float $weight
     * @return \StructType\EcoPerformanceProfileParameter
     */
    public function setWeight($weight = null)
    {
        $this->Weight = $weight;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EcoPerformanceProfileParameter
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
