<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EcoPerformanceScore StructType
 * @subpackage Structs
 */
class EcoPerformanceScore extends AbstractStructBase
{
    /**
     * The ScoreFuelConsumption
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ScoreFuelConsumption;
    /**
     * The ScoreAverageSpeed
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ScoreAverageSpeed;
    /**
     * The ScoreIdling
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ScoreIdling;
    /**
     * The ScoreHighRpm
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ScoreHighRpm;
    /**
     * The ScoreOverspeeding
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ScoreOverspeeding;
    /**
     * The ScoreCoasting
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ScoreCoasting;
    /**
     * The ScorePanicBraking
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ScorePanicBraking;
    /**
     * The ScoreDurationRetarder
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ScoreDurationRetarder;
    /**
     * The ScoreDistanceCruiseControl
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ScoreDistanceCruiseControl;
    /**
     * The ScoreStops100Km
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ScoreStops100Km;
    /**
     * The ScoreBraking100Km
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ScoreBraking100Km;
    /**
     * The ScoreGearingInGreenSpot
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ScoreGearingInGreenSpot;
    /**
     * The ScoreTopSpeedFluctuations
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ScoreTopSpeedFluctuations;
    /**
     * The ScoreRedRpm
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ScoreRedRpm;
    /**
     * The TotalScore
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $TotalScore;
    /**
     * Constructor method for EcoPerformanceScore
     * @uses EcoPerformanceScore::setScoreFuelConsumption()
     * @uses EcoPerformanceScore::setScoreAverageSpeed()
     * @uses EcoPerformanceScore::setScoreIdling()
     * @uses EcoPerformanceScore::setScoreHighRpm()
     * @uses EcoPerformanceScore::setScoreOverspeeding()
     * @uses EcoPerformanceScore::setScoreCoasting()
     * @uses EcoPerformanceScore::setScorePanicBraking()
     * @uses EcoPerformanceScore::setScoreDurationRetarder()
     * @uses EcoPerformanceScore::setScoreDistanceCruiseControl()
     * @uses EcoPerformanceScore::setScoreStops100Km()
     * @uses EcoPerformanceScore::setScoreBraking100Km()
     * @uses EcoPerformanceScore::setScoreGearingInGreenSpot()
     * @uses EcoPerformanceScore::setScoreTopSpeedFluctuations()
     * @uses EcoPerformanceScore::setScoreRedRpm()
     * @uses EcoPerformanceScore::setTotalScore()
     * @param float $scoreFuelConsumption
     * @param float $scoreAverageSpeed
     * @param float $scoreIdling
     * @param float $scoreHighRpm
     * @param float $scoreOverspeeding
     * @param float $scoreCoasting
     * @param float $scorePanicBraking
     * @param float $scoreDurationRetarder
     * @param float $scoreDistanceCruiseControl
     * @param float $scoreStops100Km
     * @param float $scoreBraking100Km
     * @param float $scoreGearingInGreenSpot
     * @param float $scoreTopSpeedFluctuations
     * @param float $scoreRedRpm
     * @param float $totalScore
     */
    public function __construct($scoreFuelConsumption = null, $scoreAverageSpeed = null, $scoreIdling = null, $scoreHighRpm = null, $scoreOverspeeding = null, $scoreCoasting = null, $scorePanicBraking = null, $scoreDurationRetarder = null, $scoreDistanceCruiseControl = null, $scoreStops100Km = null, $scoreBraking100Km = null, $scoreGearingInGreenSpot = null, $scoreTopSpeedFluctuations = null, $scoreRedRpm = null, $totalScore = null)
    {
        $this
            ->setScoreFuelConsumption($scoreFuelConsumption)
            ->setScoreAverageSpeed($scoreAverageSpeed)
            ->setScoreIdling($scoreIdling)
            ->setScoreHighRpm($scoreHighRpm)
            ->setScoreOverspeeding($scoreOverspeeding)
            ->setScoreCoasting($scoreCoasting)
            ->setScorePanicBraking($scorePanicBraking)
            ->setScoreDurationRetarder($scoreDurationRetarder)
            ->setScoreDistanceCruiseControl($scoreDistanceCruiseControl)
            ->setScoreStops100Km($scoreStops100Km)
            ->setScoreBraking100Km($scoreBraking100Km)
            ->setScoreGearingInGreenSpot($scoreGearingInGreenSpot)
            ->setScoreTopSpeedFluctuations($scoreTopSpeedFluctuations)
            ->setScoreRedRpm($scoreRedRpm)
            ->setTotalScore($totalScore);
    }
    /**
     * Get ScoreFuelConsumption value
     * @return float
     */
    public function getScoreFuelConsumption()
    {
        return $this->ScoreFuelConsumption;
    }
    /**
     * Set ScoreFuelConsumption value
     * @param float $scoreFuelConsumption
     * @return \StructType\EcoPerformanceScore
     */
    public function setScoreFuelConsumption($scoreFuelConsumption = null)
    {
        $this->ScoreFuelConsumption = $scoreFuelConsumption;
        return $this;
    }
    /**
     * Get ScoreAverageSpeed value
     * @return float
     */
    public function getScoreAverageSpeed()
    {
        return $this->ScoreAverageSpeed;
    }
    /**
     * Set ScoreAverageSpeed value
     * @param float $scoreAverageSpeed
     * @return \StructType\EcoPerformanceScore
     */
    public function setScoreAverageSpeed($scoreAverageSpeed = null)
    {
        $this->ScoreAverageSpeed = $scoreAverageSpeed;
        return $this;
    }
    /**
     * Get ScoreIdling value
     * @return float
     */
    public function getScoreIdling()
    {
        return $this->ScoreIdling;
    }
    /**
     * Set ScoreIdling value
     * @param float $scoreIdling
     * @return \StructType\EcoPerformanceScore
     */
    public function setScoreIdling($scoreIdling = null)
    {
        $this->ScoreIdling = $scoreIdling;
        return $this;
    }
    /**
     * Get ScoreHighRpm value
     * @return float
     */
    public function getScoreHighRpm()
    {
        return $this->ScoreHighRpm;
    }
    /**
     * Set ScoreHighRpm value
     * @param float $scoreHighRpm
     * @return \StructType\EcoPerformanceScore
     */
    public function setScoreHighRpm($scoreHighRpm = null)
    {
        $this->ScoreHighRpm = $scoreHighRpm;
        return $this;
    }
    /**
     * Get ScoreOverspeeding value
     * @return float
     */
    public function getScoreOverspeeding()
    {
        return $this->ScoreOverspeeding;
    }
    /**
     * Set ScoreOverspeeding value
     * @param float $scoreOverspeeding
     * @return \StructType\EcoPerformanceScore
     */
    public function setScoreOverspeeding($scoreOverspeeding = null)
    {
        $this->ScoreOverspeeding = $scoreOverspeeding;
        return $this;
    }
    /**
     * Get ScoreCoasting value
     * @return float
     */
    public function getScoreCoasting()
    {
        return $this->ScoreCoasting;
    }
    /**
     * Set ScoreCoasting value
     * @param float $scoreCoasting
     * @return \StructType\EcoPerformanceScore
     */
    public function setScoreCoasting($scoreCoasting = null)
    {
        $this->ScoreCoasting = $scoreCoasting;
        return $this;
    }
    /**
     * Get ScorePanicBraking value
     * @return float
     */
    public function getScorePanicBraking()
    {
        return $this->ScorePanicBraking;
    }
    /**
     * Set ScorePanicBraking value
     * @param float $scorePanicBraking
     * @return \StructType\EcoPerformanceScore
     */
    public function setScorePanicBraking($scorePanicBraking = null)
    {
        $this->ScorePanicBraking = $scorePanicBraking;
        return $this;
    }
    /**
     * Get ScoreDurationRetarder value
     * @return float
     */
    public function getScoreDurationRetarder()
    {
        return $this->ScoreDurationRetarder;
    }
    /**
     * Set ScoreDurationRetarder value
     * @param float $scoreDurationRetarder
     * @return \StructType\EcoPerformanceScore
     */
    public function setScoreDurationRetarder($scoreDurationRetarder = null)
    {
        $this->ScoreDurationRetarder = $scoreDurationRetarder;
        return $this;
    }
    /**
     * Get ScoreDistanceCruiseControl value
     * @return float
     */
    public function getScoreDistanceCruiseControl()
    {
        return $this->ScoreDistanceCruiseControl;
    }
    /**
     * Set ScoreDistanceCruiseControl value
     * @param float $scoreDistanceCruiseControl
     * @return \StructType\EcoPerformanceScore
     */
    public function setScoreDistanceCruiseControl($scoreDistanceCruiseControl = null)
    {
        $this->ScoreDistanceCruiseControl = $scoreDistanceCruiseControl;
        return $this;
    }
    /**
     * Get ScoreStops100Km value
     * @return float
     */
    public function getScoreStops100Km()
    {
        return $this->ScoreStops100Km;
    }
    /**
     * Set ScoreStops100Km value
     * @param float $scoreStops100Km
     * @return \StructType\EcoPerformanceScore
     */
    public function setScoreStops100Km($scoreStops100Km = null)
    {
        $this->ScoreStops100Km = $scoreStops100Km;
        return $this;
    }
    /**
     * Get ScoreBraking100Km value
     * @return float
     */
    public function getScoreBraking100Km()
    {
        return $this->ScoreBraking100Km;
    }
    /**
     * Set ScoreBraking100Km value
     * @param float $scoreBraking100Km
     * @return \StructType\EcoPerformanceScore
     */
    public function setScoreBraking100Km($scoreBraking100Km = null)
    {
        $this->ScoreBraking100Km = $scoreBraking100Km;
        return $this;
    }
    /**
     * Get ScoreGearingInGreenSpot value
     * @return float
     */
    public function getScoreGearingInGreenSpot()
    {
        return $this->ScoreGearingInGreenSpot;
    }
    /**
     * Set ScoreGearingInGreenSpot value
     * @param float $scoreGearingInGreenSpot
     * @return \StructType\EcoPerformanceScore
     */
    public function setScoreGearingInGreenSpot($scoreGearingInGreenSpot = null)
    {
        $this->ScoreGearingInGreenSpot = $scoreGearingInGreenSpot;
        return $this;
    }
    /**
     * Get ScoreTopSpeedFluctuations value
     * @return float
     */
    public function getScoreTopSpeedFluctuations()
    {
        return $this->ScoreTopSpeedFluctuations;
    }
    /**
     * Set ScoreTopSpeedFluctuations value
     * @param float $scoreTopSpeedFluctuations
     * @return \StructType\EcoPerformanceScore
     */
    public function setScoreTopSpeedFluctuations($scoreTopSpeedFluctuations = null)
    {
        $this->ScoreTopSpeedFluctuations = $scoreTopSpeedFluctuations;
        return $this;
    }
    /**
     * Get ScoreRedRpm value
     * @return float
     */
    public function getScoreRedRpm()
    {
        return $this->ScoreRedRpm;
    }
    /**
     * Set ScoreRedRpm value
     * @param float $scoreRedRpm
     * @return \StructType\EcoPerformanceScore
     */
    public function setScoreRedRpm($scoreRedRpm = null)
    {
        $this->ScoreRedRpm = $scoreRedRpm;
        return $this;
    }
    /**
     * Get TotalScore value
     * @return float
     */
    public function getTotalScore()
    {
        return $this->TotalScore;
    }
    /**
     * Set TotalScore value
     * @param float $totalScore
     * @return \StructType\EcoPerformanceScore
     */
    public function setTotalScore($totalScore = null)
    {
        $this->TotalScore = $totalScore;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EcoPerformanceScore
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
