<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EcoPerformanceSelection StructType
 * @subpackage Structs
 */
class EcoPerformanceSelection extends AbstractStructBase
{
    /**
     * The Drivers
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifier
     */
    public $Drivers;
    /**
     * The DriverGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\GroupIdentifier
     */
    public $DriverGroup;
    /**
     * The DateTimeRangeSelection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateTimeRangeSelection
     */
    public $DateTimeRangeSelection;
    /**
     * The Profile
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\EcoPerformanceProfileSelection
     */
    public $Profile;
    /**
     * Constructor method for EcoPerformanceSelection
     * @uses EcoPerformanceSelection::setDrivers()
     * @uses EcoPerformanceSelection::setDriverGroup()
     * @uses EcoPerformanceSelection::setDateTimeRangeSelection()
     * @uses EcoPerformanceSelection::setProfile()
     * @param \ArrayType\ArrayOfIdentifier $drivers
     * @param \StructType\GroupIdentifier $driverGroup
     * @param \StructType\DateTimeRangeSelection $dateTimeRangeSelection
     * @param \StructType\EcoPerformanceProfileSelection $profile
     */
    public function __construct(\ArrayType\ArrayOfIdentifier $drivers = null, \StructType\GroupIdentifier $driverGroup = null, \StructType\DateTimeRangeSelection $dateTimeRangeSelection = null, \StructType\EcoPerformanceProfileSelection $profile = null)
    {
        $this
            ->setDrivers($drivers)
            ->setDriverGroup($driverGroup)
            ->setDateTimeRangeSelection($dateTimeRangeSelection)
            ->setProfile($profile);
    }
    /**
     * Get Drivers value
     * @return \ArrayType\ArrayOfIdentifier|null
     */
    public function getDrivers()
    {
        return $this->Drivers;
    }
    /**
     * Set Drivers value
     * @param \ArrayType\ArrayOfIdentifier $drivers
     * @return \StructType\EcoPerformanceSelection
     */
    public function setDrivers(\ArrayType\ArrayOfIdentifier $drivers = null)
    {
        $this->Drivers = $drivers;
        return $this;
    }
    /**
     * Get DriverGroup value
     * @return \StructType\GroupIdentifier|null
     */
    public function getDriverGroup()
    {
        return $this->DriverGroup;
    }
    /**
     * Set DriverGroup value
     * @param \StructType\GroupIdentifier $driverGroup
     * @return \StructType\EcoPerformanceSelection
     */
    public function setDriverGroup(\StructType\GroupIdentifier $driverGroup = null)
    {
        $this->DriverGroup = $driverGroup;
        return $this;
    }
    /**
     * Get DateTimeRangeSelection value
     * @return \StructType\DateTimeRangeSelection|null
     */
    public function getDateTimeRangeSelection()
    {
        return $this->DateTimeRangeSelection;
    }
    /**
     * Set DateTimeRangeSelection value
     * @param \StructType\DateTimeRangeSelection $dateTimeRangeSelection
     * @return \StructType\EcoPerformanceSelection
     */
    public function setDateTimeRangeSelection(\StructType\DateTimeRangeSelection $dateTimeRangeSelection = null)
    {
        $this->DateTimeRangeSelection = $dateTimeRangeSelection;
        return $this;
    }
    /**
     * Get Profile value
     * @return \StructType\EcoPerformanceProfileSelection|null
     */
    public function getProfile()
    {
        return $this->Profile;
    }
    /**
     * Set Profile value
     * @param \StructType\EcoPerformanceProfileSelection $profile
     * @return \StructType\EcoPerformanceSelection
     */
    public function setProfile(\StructType\EcoPerformanceProfileSelection $profile = null)
    {
        $this->Profile = $profile;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EcoPerformanceSelection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
