<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExecutionResult StructType
 * @subpackage Structs
 */
class ExecutionResult extends AbstractStructBase
{
    /**
     * The Executiontime
     * Meta informations extracted from the WSDL
     * - use: required
     * @var float
     */
    public $Executiontime;
    /**
     * The Errors
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfError
     */
    public $Errors;
    /**
     * The Warnings
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfWarning
     */
    public $Warnings;
    /**
     * Constructor method for ExecutionResult
     * @uses ExecutionResult::setExecutiontime()
     * @uses ExecutionResult::setErrors()
     * @uses ExecutionResult::setWarnings()
     * @param float $executiontime
     * @param \ArrayType\ArrayOfError $errors
     * @param \ArrayType\ArrayOfWarning $warnings
     */
    public function __construct($executiontime = null, \ArrayType\ArrayOfError $errors = null, \ArrayType\ArrayOfWarning $warnings = null)
    {
        $this
            ->setExecutiontime($executiontime)
            ->setErrors($errors)
            ->setWarnings($warnings);
    }
    /**
     * Get Executiontime value
     * @return float
     */
    public function getExecutiontime()
    {
        return $this->Executiontime;
    }
    /**
     * Set Executiontime value
     * @param float $executiontime
     * @return \StructType\ExecutionResult
     */
    public function setExecutiontime($executiontime = null)
    {
        $this->Executiontime = $executiontime;
        return $this;
    }
    /**
     * Get Errors value
     * @return \ArrayType\ArrayOfError|null
     */
    public function getErrors()
    {
        return $this->Errors;
    }
    /**
     * Set Errors value
     * @param \ArrayType\ArrayOfError $errors
     * @return \StructType\ExecutionResult
     */
    public function setErrors(\ArrayType\ArrayOfError $errors = null)
    {
        $this->Errors = $errors;
        return $this;
    }
    /**
     * Get Warnings value
     * @return \ArrayType\ArrayOfWarning|null
     */
    public function getWarnings()
    {
        return $this->Warnings;
    }
    /**
     * Set Warnings value
     * @param \ArrayType\ArrayOfWarning $warnings
     * @return \StructType\ExecutionResult
     */
    public function setWarnings(\ArrayType\ArrayOfWarning $warnings = null)
    {
        $this->Warnings = $warnings;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ExecutionResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
