<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FollowedDriverCollection StructType
 * @subpackage Structs
 */
class FollowedDriverCollection extends AbstractStructBase
{
    /**
     * The GroupList
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfDriverGroupItem
     */
    public $GroupList;
    /**
     * The SingleDriverList
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTrackedDriver
     */
    public $SingleDriverList;
    /**
     * Constructor method for FollowedDriverCollection
     * @uses FollowedDriverCollection::setGroupList()
     * @uses FollowedDriverCollection::setSingleDriverList()
     * @param \ArrayType\ArrayOfDriverGroupItem $groupList
     * @param \ArrayType\ArrayOfTrackedDriver $singleDriverList
     */
    public function __construct(\ArrayType\ArrayOfDriverGroupItem $groupList = null, \ArrayType\ArrayOfTrackedDriver $singleDriverList = null)
    {
        $this
            ->setGroupList($groupList)
            ->setSingleDriverList($singleDriverList);
    }
    /**
     * Get GroupList value
     * @return \ArrayType\ArrayOfDriverGroupItem|null
     */
    public function getGroupList()
    {
        return $this->GroupList;
    }
    /**
     * Set GroupList value
     * @param \ArrayType\ArrayOfDriverGroupItem $groupList
     * @return \StructType\FollowedDriverCollection
     */
    public function setGroupList(\ArrayType\ArrayOfDriverGroupItem $groupList = null)
    {
        $this->GroupList = $groupList;
        return $this;
    }
    /**
     * Get SingleDriverList value
     * @return \ArrayType\ArrayOfTrackedDriver|null
     */
    public function getSingleDriverList()
    {
        return $this->SingleDriverList;
    }
    /**
     * Set SingleDriverList value
     * @param \ArrayType\ArrayOfTrackedDriver $singleDriverList
     * @return \StructType\FollowedDriverCollection
     */
    public function setSingleDriverList(\ArrayType\ArrayOfTrackedDriver $singleDriverList = null)
    {
        $this->SingleDriverList = $singleDriverList;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FollowedDriverCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
