<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FollowedTrailerCollection StructType
 * @subpackage Structs
 */
class FollowedTrailerCollection extends AbstractStructBase
{
    /**
     * The GroupList
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTrailerGroupItem
     */
    public $GroupList;
    /**
     * The SingleTrailerList
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTrackedVehicle
     */
    public $SingleTrailerList;
    /**
     * Constructor method for FollowedTrailerCollection
     * @uses FollowedTrailerCollection::setGroupList()
     * @uses FollowedTrailerCollection::setSingleTrailerList()
     * @param \ArrayType\ArrayOfTrailerGroupItem $groupList
     * @param \ArrayType\ArrayOfTrackedVehicle $singleTrailerList
     */
    public function __construct(\ArrayType\ArrayOfTrailerGroupItem $groupList = null, \ArrayType\ArrayOfTrackedVehicle $singleTrailerList = null)
    {
        $this
            ->setGroupList($groupList)
            ->setSingleTrailerList($singleTrailerList);
    }
    /**
     * Get GroupList value
     * @return \ArrayType\ArrayOfTrailerGroupItem|null
     */
    public function getGroupList()
    {
        return $this->GroupList;
    }
    /**
     * Set GroupList value
     * @param \ArrayType\ArrayOfTrailerGroupItem $groupList
     * @return \StructType\FollowedTrailerCollection
     */
    public function setGroupList(\ArrayType\ArrayOfTrailerGroupItem $groupList = null)
    {
        $this->GroupList = $groupList;
        return $this;
    }
    /**
     * Get SingleTrailerList value
     * @return \ArrayType\ArrayOfTrackedVehicle|null
     */
    public function getSingleTrailerList()
    {
        return $this->SingleTrailerList;
    }
    /**
     * Set SingleTrailerList value
     * @param \ArrayType\ArrayOfTrackedVehicle $singleTrailerList
     * @return \StructType\FollowedTrailerCollection
     */
    public function setSingleTrailerList(\ArrayType\ArrayOfTrackedVehicle $singleTrailerList = null)
    {
        $this->SingleTrailerList = $singleTrailerList;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FollowedTrailerCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
