<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeoFenceResult_v3 StructType
 * @subpackage Structs
 */
class GeoFenceResult_v3 extends AbstractStructBase
{
    /**
     * The GeoFenceId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $GeoFenceId;
    /**
     * The GeoFenceName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $GeoFenceName;
    /**
     * The GeoZoneStrategy
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\GeoZoneStrategy
     */
    public $GeoZoneStrategy;
    /**
     * Constructor method for GeoFenceResult_v3
     * @uses GeoFenceResult_v3::setGeoFenceId()
     * @uses GeoFenceResult_v3::setGeoFenceName()
     * @uses GeoFenceResult_v3::setGeoZoneStrategy()
     * @param int $geoFenceId
     * @param string $geoFenceName
     * @param \StructType\GeoZoneStrategy $geoZoneStrategy
     */
    public function __construct($geoFenceId = null, $geoFenceName = null, \StructType\GeoZoneStrategy $geoZoneStrategy = null)
    {
        $this
            ->setGeoFenceId($geoFenceId)
            ->setGeoFenceName($geoFenceName)
            ->setGeoZoneStrategy($geoZoneStrategy);
    }
    /**
     * Get GeoFenceId value
     * @return int
     */
    public function getGeoFenceId()
    {
        return $this->GeoFenceId;
    }
    /**
     * Set GeoFenceId value
     * @param int $geoFenceId
     * @return \StructType\GeoFenceResult_v3
     */
    public function setGeoFenceId($geoFenceId = null)
    {
        // validation for constraint: int
        if (!is_null($geoFenceId) && !is_numeric($geoFenceId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($geoFenceId)), __LINE__);
        }
        $this->GeoFenceId = $geoFenceId;
        return $this;
    }
    /**
     * Get GeoFenceName value
     * @return string|null
     */
    public function getGeoFenceName()
    {
        return $this->GeoFenceName;
    }
    /**
     * Set GeoFenceName value
     * @param string $geoFenceName
     * @return \StructType\GeoFenceResult_v3
     */
    public function setGeoFenceName($geoFenceName = null)
    {
        // validation for constraint: string
        if (!is_null($geoFenceName) && !is_string($geoFenceName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($geoFenceName)), __LINE__);
        }
        $this->GeoFenceName = $geoFenceName;
        return $this;
    }
    /**
     * Get GeoZoneStrategy value
     * @return \StructType\GeoZoneStrategy|null
     */
    public function getGeoZoneStrategy()
    {
        return $this->GeoZoneStrategy;
    }
    /**
     * Set GeoZoneStrategy value
     * @param \StructType\GeoZoneStrategy $geoZoneStrategy
     * @return \StructType\GeoFenceResult_v3
     */
    public function setGeoZoneStrategy(\StructType\GeoZoneStrategy $geoZoneStrategy = null)
    {
        $this->GeoZoneStrategy = $geoZoneStrategy;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GeoFenceResult_v3
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
