<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeoFenceVehicleSelection StructType
 * @subpackage Structs
 */
class GeoFenceVehicleSelection extends AbstractStructBase
{
    /**
     * The Vehicle
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\IdentifierVehicle
     */
    public $Vehicle;
    /**
     * The GeoFence
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\IdentifierGeoFence
     */
    public $GeoFence;
    /**
     * Constructor method for GeoFenceVehicleSelection
     * @uses GeoFenceVehicleSelection::setVehicle()
     * @uses GeoFenceVehicleSelection::setGeoFence()
     * @param \StructType\IdentifierVehicle $vehicle
     * @param \StructType\IdentifierGeoFence $geoFence
     */
    public function __construct(\StructType\IdentifierVehicle $vehicle = null, \StructType\IdentifierGeoFence $geoFence = null)
    {
        $this
            ->setVehicle($vehicle)
            ->setGeoFence($geoFence);
    }
    /**
     * Get Vehicle value
     * @return \StructType\IdentifierVehicle|null
     */
    public function getVehicle()
    {
        return $this->Vehicle;
    }
    /**
     * Set Vehicle value
     * @param \StructType\IdentifierVehicle $vehicle
     * @return \StructType\GeoFenceVehicleSelection
     */
    public function setVehicle(\StructType\IdentifierVehicle $vehicle = null)
    {
        $this->Vehicle = $vehicle;
        return $this;
    }
    /**
     * Get GeoFence value
     * @return \StructType\IdentifierGeoFence|null
     */
    public function getGeoFence()
    {
        return $this->GeoFence;
    }
    /**
     * Set GeoFence value
     * @param \StructType\IdentifierGeoFence $geoFence
     * @return \StructType\GeoFenceVehicleSelection
     */
    public function setGeoFence(\StructType\IdentifierGeoFence $geoFence = null)
    {
        $this->GeoFence = $geoFence;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GeoFenceVehicleSelection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
