<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeoZoneStrategy StructType
 * @subpackage Structs
 */
class GeoZoneStrategy extends AbstractStructBase
{
    /**
     * The GeoZoneTransicsId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $GeoZoneTransicsId;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The DriverAlarmText
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DriverAlarmText;
    /**
     * Constructor method for GeoZoneStrategy
     * @uses GeoZoneStrategy::setGeoZoneTransicsId()
     * @uses GeoZoneStrategy::setName()
     * @uses GeoZoneStrategy::setDriverAlarmText()
     * @param int $geoZoneTransicsId
     * @param string $name
     * @param string $driverAlarmText
     */
    public function __construct($geoZoneTransicsId = null, $name = null, $driverAlarmText = null)
    {
        $this
            ->setGeoZoneTransicsId($geoZoneTransicsId)
            ->setName($name)
            ->setDriverAlarmText($driverAlarmText);
    }
    /**
     * Get GeoZoneTransicsId value
     * @return int
     */
    public function getGeoZoneTransicsId()
    {
        return $this->GeoZoneTransicsId;
    }
    /**
     * Set GeoZoneTransicsId value
     * @param int $geoZoneTransicsId
     * @return \StructType\GeoZoneStrategy
     */
    public function setGeoZoneTransicsId($geoZoneTransicsId = null)
    {
        // validation for constraint: int
        if (!is_null($geoZoneTransicsId) && !is_numeric($geoZoneTransicsId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($geoZoneTransicsId)), __LINE__);
        }
        $this->GeoZoneTransicsId = $geoZoneTransicsId;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\GeoZoneStrategy
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get DriverAlarmText value
     * @return string|null
     */
    public function getDriverAlarmText()
    {
        return $this->DriverAlarmText;
    }
    /**
     * Set DriverAlarmText value
     * @param string $driverAlarmText
     * @return \StructType\GeoZoneStrategy
     */
    public function setDriverAlarmText($driverAlarmText = null)
    {
        // validation for constraint: string
        if (!is_null($driverAlarmText) && !is_string($driverAlarmText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($driverAlarmText)), __LINE__);
        }
        $this->DriverAlarmText = $driverAlarmText;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GeoZoneStrategy
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
