<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeofencingResult StructType
 * @subpackage Structs
 */
class GeofencingResult extends Geofencing
{
    /**
     * The GeoEventDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $GeoEventDate;
    /**
     * Constructor method for GeofencingResult
     * @uses GeofencingResult::setGeoEventDate()
     * @param string $geoEventDate
     */
    public function __construct($geoEventDate = null)
    {
        $this
            ->setGeoEventDate($geoEventDate);
    }
    /**
     * Get GeoEventDate value
     * @return string
     */
    public function getGeoEventDate()
    {
        return $this->GeoEventDate;
    }
    /**
     * Set GeoEventDate value
     * @param string $geoEventDate
     * @return \StructType\GeofencingResult
     */
    public function setGeoEventDate($geoEventDate = null)
    {
        // validation for constraint: string
        if (!is_null($geoEventDate) && !is_string($geoEventDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($geoEventDate)), __LINE__);
        }
        $this->GeoEventDate = $geoEventDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GeofencingResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
