<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetEcoPerformanceResult StructType
 * @subpackage Structs
 */
class GetEcoPerformanceResult extends ExecutionResult
{
    /**
     * The EcoPerformanceReports
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfEcoPerformanceReport
     */
    public $EcoPerformanceReports;
    /**
     * The ProfileDetails
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\EcoPerformanceProfileDetails
     */
    public $ProfileDetails;
    /**
     * Constructor method for GetEcoPerformanceResult
     * @uses GetEcoPerformanceResult::setEcoPerformanceReports()
     * @uses GetEcoPerformanceResult::setProfileDetails()
     * @param \ArrayType\ArrayOfEcoPerformanceReport $ecoPerformanceReports
     * @param \StructType\EcoPerformanceProfileDetails $profileDetails
     */
    public function __construct(\ArrayType\ArrayOfEcoPerformanceReport $ecoPerformanceReports = null, \StructType\EcoPerformanceProfileDetails $profileDetails = null)
    {
        $this
            ->setEcoPerformanceReports($ecoPerformanceReports)
            ->setProfileDetails($profileDetails);
    }
    /**
     * Get EcoPerformanceReports value
     * @return \ArrayType\ArrayOfEcoPerformanceReport|null
     */
    public function getEcoPerformanceReports()
    {
        return $this->EcoPerformanceReports;
    }
    /**
     * Set EcoPerformanceReports value
     * @param \ArrayType\ArrayOfEcoPerformanceReport $ecoPerformanceReports
     * @return \StructType\GetEcoPerformanceResult
     */
    public function setEcoPerformanceReports(\ArrayType\ArrayOfEcoPerformanceReport $ecoPerformanceReports = null)
    {
        $this->EcoPerformanceReports = $ecoPerformanceReports;
        return $this;
    }
    /**
     * Get ProfileDetails value
     * @return \StructType\EcoPerformanceProfileDetails|null
     */
    public function getProfileDetails()
    {
        return $this->ProfileDetails;
    }
    /**
     * Set ProfileDetails value
     * @param \StructType\EcoPerformanceProfileDetails $profileDetails
     * @return \StructType\GetEcoPerformanceResult
     */
    public function setProfileDetails(\StructType\EcoPerformanceProfileDetails $profileDetails = null)
    {
        $this->ProfileDetails = $profileDetails;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetEcoPerformanceResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
