<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetGeoFencesResult StructType
 * @subpackage Structs
 */
class GetGeoFencesResult extends ExecutionResult
{
    /**
     * The GeoFences
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfGeofenceResult
     */
    public $GeoFences;
    /**
     * Constructor method for GetGeoFencesResult
     * @uses GetGeoFencesResult::setGeoFences()
     * @param \ArrayType\ArrayOfGeofenceResult $geoFences
     */
    public function __construct(\ArrayType\ArrayOfGeofenceResult $geoFences = null)
    {
        $this
            ->setGeoFences($geoFences);
    }
    /**
     * Get GeoFences value
     * @return \ArrayType\ArrayOfGeofenceResult|null
     */
    public function getGeoFences()
    {
        return $this->GeoFences;
    }
    /**
     * Set GeoFences value
     * @param \ArrayType\ArrayOfGeofenceResult $geoFences
     * @return \StructType\GetGeoFencesResult
     */
    public function setGeoFences(\ArrayType\ArrayOfGeofenceResult $geoFences = null)
    {
        $this->GeoFences = $geoFences;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetGeoFencesResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
