<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetGroupResult StructType
 * @subpackage Structs
 */
class GetGroupResult extends ExecutionResult
{
    /**
     * The Groups
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfGroup
     */
    public $Groups;
    /**
     * Constructor method for GetGroupResult
     * @uses GetGroupResult::setGroups()
     * @param \ArrayType\ArrayOfGroup $groups
     */
    public function __construct(\ArrayType\ArrayOfGroup $groups = null)
    {
        $this
            ->setGroups($groups);
    }
    /**
     * Get Groups value
     * @return \ArrayType\ArrayOfGroup|null
     */
    public function getGroups()
    {
        return $this->Groups;
    }
    /**
     * Set Groups value
     * @param \ArrayType\ArrayOfGroup $groups
     * @return \StructType\GetGroupResult
     */
    public function setGroups(\ArrayType\ArrayOfGroup $groups = null)
    {
        $this->Groups = $groups;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetGroupResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
