<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetMagellanData StructType
 * @subpackage Structs
 */
class GetMagellanData extends ExecutionResult
{
    /**
     * The MagellanTracer
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\MagellanTracerIdentifierResult
     */
    public $MagellanTracer;
    /**
     * The MagellanTracerPositions
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfMagellanTracerPositionInfo
     */
    public $MagellanTracerPositions;
    /**
     * Constructor method for GetMagellanData
     * @uses GetMagellanData::setMagellanTracer()
     * @uses GetMagellanData::setMagellanTracerPositions()
     * @param \StructType\MagellanTracerIdentifierResult $magellanTracer
     * @param \ArrayType\ArrayOfMagellanTracerPositionInfo $magellanTracerPositions
     */
    public function __construct(\StructType\MagellanTracerIdentifierResult $magellanTracer = null, \ArrayType\ArrayOfMagellanTracerPositionInfo $magellanTracerPositions = null)
    {
        $this
            ->setMagellanTracer($magellanTracer)
            ->setMagellanTracerPositions($magellanTracerPositions);
    }
    /**
     * Get MagellanTracer value
     * @return \StructType\MagellanTracerIdentifierResult|null
     */
    public function getMagellanTracer()
    {
        return $this->MagellanTracer;
    }
    /**
     * Set MagellanTracer value
     * @param \StructType\MagellanTracerIdentifierResult $magellanTracer
     * @return \StructType\GetMagellanData
     */
    public function setMagellanTracer(\StructType\MagellanTracerIdentifierResult $magellanTracer = null)
    {
        $this->MagellanTracer = $magellanTracer;
        return $this;
    }
    /**
     * Get MagellanTracerPositions value
     * @return \ArrayType\ArrayOfMagellanTracerPositionInfo|null
     */
    public function getMagellanTracerPositions()
    {
        return $this->MagellanTracerPositions;
    }
    /**
     * Set MagellanTracerPositions value
     * @param \ArrayType\ArrayOfMagellanTracerPositionInfo $magellanTracerPositions
     * @return \StructType\GetMagellanData
     */
    public function setMagellanTracerPositions(\ArrayType\ArrayOfMagellanTracerPositionInfo $magellanTracerPositions = null)
    {
        $this->MagellanTracerPositions = $magellanTracerPositions;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetMagellanData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
