<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetPlanningHistoricalSelectionInterfaceResult_v4
 * StructType
 * @subpackage Structs
 */
class GetPlanningHistoricalSelectionInterfaceResult_v4 extends AbstractStructBase
{
    /**
     * The MaximumModificationID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $MaximumModificationID;
    /**
     * The Plannings
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfPlanningInterfaceResult_v4
     */
    public $Plannings;
    /**
     * The Anomalies
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfAnomaly
     */
    public $Anomalies;
    /**
     * The Comments
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfCommentHistoricalResult
     */
    public $Comments;
    /**
     * Constructor method for GetPlanningHistoricalSelectionInterfaceResult_v4
     * @uses GetPlanningHistoricalSelectionInterfaceResult_v4::setMaximumModificationID()
     * @uses GetPlanningHistoricalSelectionInterfaceResult_v4::setPlannings()
     * @uses GetPlanningHistoricalSelectionInterfaceResult_v4::setAnomalies()
     * @uses GetPlanningHistoricalSelectionInterfaceResult_v4::setComments()
     * @param int $maximumModificationID
     * @param \ArrayType\ArrayOfPlanningInterfaceResult_v4 $plannings
     * @param \ArrayType\ArrayOfAnomaly $anomalies
     * @param \ArrayType\ArrayOfCommentHistoricalResult $comments
     */
    public function __construct($maximumModificationID = null, \ArrayType\ArrayOfPlanningInterfaceResult_v4 $plannings = null, \ArrayType\ArrayOfAnomaly $anomalies = null, \ArrayType\ArrayOfCommentHistoricalResult $comments = null)
    {
        $this
            ->setMaximumModificationID($maximumModificationID)
            ->setPlannings($plannings)
            ->setAnomalies($anomalies)
            ->setComments($comments);
    }
    /**
     * Get MaximumModificationID value
     * @return int
     */
    public function getMaximumModificationID()
    {
        return $this->MaximumModificationID;
    }
    /**
     * Set MaximumModificationID value
     * @param int $maximumModificationID
     * @return \StructType\GetPlanningHistoricalSelectionInterfaceResult_v4
     */
    public function setMaximumModificationID($maximumModificationID = null)
    {
        // validation for constraint: int
        if (!is_null($maximumModificationID) && !is_numeric($maximumModificationID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($maximumModificationID)), __LINE__);
        }
        $this->MaximumModificationID = $maximumModificationID;
        return $this;
    }
    /**
     * Get Plannings value
     * @return \ArrayType\ArrayOfPlanningInterfaceResult_v4|null
     */
    public function getPlannings()
    {
        return $this->Plannings;
    }
    /**
     * Set Plannings value
     * @param \ArrayType\ArrayOfPlanningInterfaceResult_v4 $plannings
     * @return \StructType\GetPlanningHistoricalSelectionInterfaceResult_v4
     */
    public function setPlannings(\ArrayType\ArrayOfPlanningInterfaceResult_v4 $plannings = null)
    {
        $this->Plannings = $plannings;
        return $this;
    }
    /**
     * Get Anomalies value
     * @return \ArrayType\ArrayOfAnomaly|null
     */
    public function getAnomalies()
    {
        return $this->Anomalies;
    }
    /**
     * Set Anomalies value
     * @param \ArrayType\ArrayOfAnomaly $anomalies
     * @return \StructType\GetPlanningHistoricalSelectionInterfaceResult_v4
     */
    public function setAnomalies(\ArrayType\ArrayOfAnomaly $anomalies = null)
    {
        $this->Anomalies = $anomalies;
        return $this;
    }
    /**
     * Get Comments value
     * @return \ArrayType\ArrayOfCommentHistoricalResult|null
     */
    public function getComments()
    {
        return $this->Comments;
    }
    /**
     * Set Comments value
     * @param \ArrayType\ArrayOfCommentHistoricalResult $comments
     * @return \StructType\GetPlanningHistoricalSelectionInterfaceResult_v4
     */
    public function setComments(\ArrayType\ArrayOfCommentHistoricalResult $comments = null)
    {
        $this->Comments = $comments;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetPlanningHistoricalSelectionInterfaceResult_v4
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
