<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetPlanningModificationsResult_V2 StructType
 * @subpackage Structs
 */
class GetPlanningModificationsResult_V2 extends ExecutionResult
{
    /**
     * The Trips
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTripItemResult_v3
     */
    public $Trips;
    /**
     * The Places
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfPlaceItemResult_v2
     */
    public $Places;
    /**
     * The Jobs
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJobItemResult
     */
    public $Jobs;
    /**
     * The Products
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfProductItemResult
     */
    public $Products;
    /**
     * The Comments
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfCommentHistoricalResult
     */
    public $Comments;
    /**
     * The Anomalies
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfAnomaly
     */
    public $Anomalies;
    /**
     * The Consultation
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfConsultation
     */
    public $Consultation;
    /**
     * The PalletInfos
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfExtraInfo
     */
    public $PalletInfos;
    /**
     * The ExtraInfos
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfExtraInfo
     */
    public $ExtraInfos;
    /**
     * The ScannedDocuments
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfDocument
     */
    public $ScannedDocuments;
    /**
     * Constructor method for GetPlanningModificationsResult_V2
     * @uses GetPlanningModificationsResult_V2::setTrips()
     * @uses GetPlanningModificationsResult_V2::setPlaces()
     * @uses GetPlanningModificationsResult_V2::setJobs()
     * @uses GetPlanningModificationsResult_V2::setProducts()
     * @uses GetPlanningModificationsResult_V2::setComments()
     * @uses GetPlanningModificationsResult_V2::setAnomalies()
     * @uses GetPlanningModificationsResult_V2::setConsultation()
     * @uses GetPlanningModificationsResult_V2::setPalletInfos()
     * @uses GetPlanningModificationsResult_V2::setExtraInfos()
     * @uses GetPlanningModificationsResult_V2::setScannedDocuments()
     * @param \ArrayType\ArrayOfTripItemResult_v3 $trips
     * @param \ArrayType\ArrayOfPlaceItemResult_v2 $places
     * @param \ArrayType\ArrayOfJobItemResult $jobs
     * @param \ArrayType\ArrayOfProductItemResult $products
     * @param \ArrayType\ArrayOfCommentHistoricalResult $comments
     * @param \ArrayType\ArrayOfAnomaly $anomalies
     * @param \ArrayType\ArrayOfConsultation $consultation
     * @param \ArrayType\ArrayOfExtraInfo $palletInfos
     * @param \ArrayType\ArrayOfExtraInfo $extraInfos
     * @param \ArrayType\ArrayOfDocument $scannedDocuments
     */
    public function __construct(\ArrayType\ArrayOfTripItemResult_v3 $trips = null, \ArrayType\ArrayOfPlaceItemResult_v2 $places = null, \ArrayType\ArrayOfJobItemResult $jobs = null, \ArrayType\ArrayOfProductItemResult $products = null, \ArrayType\ArrayOfCommentHistoricalResult $comments = null, \ArrayType\ArrayOfAnomaly $anomalies = null, \ArrayType\ArrayOfConsultation $consultation = null, \ArrayType\ArrayOfExtraInfo $palletInfos = null, \ArrayType\ArrayOfExtraInfo $extraInfos = null, \ArrayType\ArrayOfDocument $scannedDocuments = null)
    {
        $this
            ->setTrips($trips)
            ->setPlaces($places)
            ->setJobs($jobs)
            ->setProducts($products)
            ->setComments($comments)
            ->setAnomalies($anomalies)
            ->setConsultation($consultation)
            ->setPalletInfos($palletInfos)
            ->setExtraInfos($extraInfos)
            ->setScannedDocuments($scannedDocuments);
    }
    /**
     * Get Trips value
     * @return \ArrayType\ArrayOfTripItemResult_v3|null
     */
    public function getTrips()
    {
        return $this->Trips;
    }
    /**
     * Set Trips value
     * @param \ArrayType\ArrayOfTripItemResult_v3 $trips
     * @return \StructType\GetPlanningModificationsResult_V2
     */
    public function setTrips(\ArrayType\ArrayOfTripItemResult_v3 $trips = null)
    {
        $this->Trips = $trips;
        return $this;
    }
    /**
     * Get Places value
     * @return \ArrayType\ArrayOfPlaceItemResult_v2|null
     */
    public function getPlaces()
    {
        return $this->Places;
    }
    /**
     * Set Places value
     * @param \ArrayType\ArrayOfPlaceItemResult_v2 $places
     * @return \StructType\GetPlanningModificationsResult_V2
     */
    public function setPlaces(\ArrayType\ArrayOfPlaceItemResult_v2 $places = null)
    {
        $this->Places = $places;
        return $this;
    }
    /**
     * Get Jobs value
     * @return \ArrayType\ArrayOfJobItemResult|null
     */
    public function getJobs()
    {
        return $this->Jobs;
    }
    /**
     * Set Jobs value
     * @param \ArrayType\ArrayOfJobItemResult $jobs
     * @return \StructType\GetPlanningModificationsResult_V2
     */
    public function setJobs(\ArrayType\ArrayOfJobItemResult $jobs = null)
    {
        $this->Jobs = $jobs;
        return $this;
    }
    /**
     * Get Products value
     * @return \ArrayType\ArrayOfProductItemResult|null
     */
    public function getProducts()
    {
        return $this->Products;
    }
    /**
     * Set Products value
     * @param \ArrayType\ArrayOfProductItemResult $products
     * @return \StructType\GetPlanningModificationsResult_V2
     */
    public function setProducts(\ArrayType\ArrayOfProductItemResult $products = null)
    {
        $this->Products = $products;
        return $this;
    }
    /**
     * Get Comments value
     * @return \ArrayType\ArrayOfCommentHistoricalResult|null
     */
    public function getComments()
    {
        return $this->Comments;
    }
    /**
     * Set Comments value
     * @param \ArrayType\ArrayOfCommentHistoricalResult $comments
     * @return \StructType\GetPlanningModificationsResult_V2
     */
    public function setComments(\ArrayType\ArrayOfCommentHistoricalResult $comments = null)
    {
        $this->Comments = $comments;
        return $this;
    }
    /**
     * Get Anomalies value
     * @return \ArrayType\ArrayOfAnomaly|null
     */
    public function getAnomalies()
    {
        return $this->Anomalies;
    }
    /**
     * Set Anomalies value
     * @param \ArrayType\ArrayOfAnomaly $anomalies
     * @return \StructType\GetPlanningModificationsResult_V2
     */
    public function setAnomalies(\ArrayType\ArrayOfAnomaly $anomalies = null)
    {
        $this->Anomalies = $anomalies;
        return $this;
    }
    /**
     * Get Consultation value
     * @return \ArrayType\ArrayOfConsultation|null
     */
    public function getConsultation()
    {
        return $this->Consultation;
    }
    /**
     * Set Consultation value
     * @param \ArrayType\ArrayOfConsultation $consultation
     * @return \StructType\GetPlanningModificationsResult_V2
     */
    public function setConsultation(\ArrayType\ArrayOfConsultation $consultation = null)
    {
        $this->Consultation = $consultation;
        return $this;
    }
    /**
     * Get PalletInfos value
     * @return \ArrayType\ArrayOfExtraInfo|null
     */
    public function getPalletInfos()
    {
        return $this->PalletInfos;
    }
    /**
     * Set PalletInfos value
     * @param \ArrayType\ArrayOfExtraInfo $palletInfos
     * @return \StructType\GetPlanningModificationsResult_V2
     */
    public function setPalletInfos(\ArrayType\ArrayOfExtraInfo $palletInfos = null)
    {
        $this->PalletInfos = $palletInfos;
        return $this;
    }
    /**
     * Get ExtraInfos value
     * @return \ArrayType\ArrayOfExtraInfo|null
     */
    public function getExtraInfos()
    {
        return $this->ExtraInfos;
    }
    /**
     * Set ExtraInfos value
     * @param \ArrayType\ArrayOfExtraInfo $extraInfos
     * @return \StructType\GetPlanningModificationsResult_V2
     */
    public function setExtraInfos(\ArrayType\ArrayOfExtraInfo $extraInfos = null)
    {
        $this->ExtraInfos = $extraInfos;
        return $this;
    }
    /**
     * Get ScannedDocuments value
     * @return \ArrayType\ArrayOfDocument|null
     */
    public function getScannedDocuments()
    {
        return $this->ScannedDocuments;
    }
    /**
     * Set ScannedDocuments value
     * @param \ArrayType\ArrayOfDocument $scannedDocuments
     * @return \StructType\GetPlanningModificationsResult_V2
     */
    public function setScannedDocuments(\ArrayType\ArrayOfDocument $scannedDocuments = null)
    {
        $this->ScannedDocuments = $scannedDocuments;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetPlanningModificationsResult_V2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
