<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetPlanningResult StructType
 * @subpackage Structs
 */
class GetPlanningResult extends ExecutionResult
{
    /**
     * The ItemSelection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\GetPlanningItemSelectionResult
     */
    public $ItemSelection;
    /**
     * The HistoricalSelection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\GetPlanningHistoricalSelectionResult
     */
    public $HistoricalSelection;
    /**
     * Constructor method for GetPlanningResult
     * @uses GetPlanningResult::setItemSelection()
     * @uses GetPlanningResult::setHistoricalSelection()
     * @param \StructType\GetPlanningItemSelectionResult $itemSelection
     * @param \StructType\GetPlanningHistoricalSelectionResult $historicalSelection
     */
    public function __construct(\StructType\GetPlanningItemSelectionResult $itemSelection = null, \StructType\GetPlanningHistoricalSelectionResult $historicalSelection = null)
    {
        $this
            ->setItemSelection($itemSelection)
            ->setHistoricalSelection($historicalSelection);
    }
    /**
     * Get ItemSelection value
     * @return \StructType\GetPlanningItemSelectionResult|null
     */
    public function getItemSelection()
    {
        return $this->ItemSelection;
    }
    /**
     * Set ItemSelection value
     * @param \StructType\GetPlanningItemSelectionResult $itemSelection
     * @return \StructType\GetPlanningResult
     */
    public function setItemSelection(\StructType\GetPlanningItemSelectionResult $itemSelection = null)
    {
        $this->ItemSelection = $itemSelection;
        return $this;
    }
    /**
     * Get HistoricalSelection value
     * @return \StructType\GetPlanningHistoricalSelectionResult|null
     */
    public function getHistoricalSelection()
    {
        return $this->HistoricalSelection;
    }
    /**
     * Set HistoricalSelection value
     * @param \StructType\GetPlanningHistoricalSelectionResult $historicalSelection
     * @return \StructType\GetPlanningResult
     */
    public function setHistoricalSelection(\StructType\GetPlanningHistoricalSelectionResult $historicalSelection = null)
    {
        $this->HistoricalSelection = $historicalSelection;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetPlanningResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
