<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetScannedDocument StructType
 * @subpackage Structs
 */
class GetScannedDocument extends ExecutionResult
{
    /**
     * The Documents
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfDocumentResult
     */
    public $Documents;
    /**
     * Constructor method for GetScannedDocument
     * @uses GetScannedDocument::setDocuments()
     * @param \ArrayType\ArrayOfDocumentResult $documents
     */
    public function __construct(\ArrayType\ArrayOfDocumentResult $documents = null)
    {
        $this
            ->setDocuments($documents);
    }
    /**
     * Get Documents value
     * @return \ArrayType\ArrayOfDocumentResult|null
     */
    public function getDocuments()
    {
        return $this->Documents;
    }
    /**
     * Set Documents value
     * @param \ArrayType\ArrayOfDocumentResult $documents
     * @return \StructType\GetScannedDocument
     */
    public function setDocuments(\ArrayType\ArrayOfDocumentResult $documents = null)
    {
        $this->Documents = $documents;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetScannedDocument
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
