<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetScannedDocuments_V2 StructType
 * @subpackage Structs
 */
class GetScannedDocuments_V2 extends ExecutionResult
{
    /**
     * The MaximumModificationID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $MaximumModificationID;
    /**
     * The Documents
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfDocument_V3
     */
    public $Documents;
    /**
     * Constructor method for GetScannedDocuments_V2
     * @uses GetScannedDocuments_V2::setMaximumModificationID()
     * @uses GetScannedDocuments_V2::setDocuments()
     * @param int $maximumModificationID
     * @param \ArrayType\ArrayOfDocument_V3 $documents
     */
    public function __construct($maximumModificationID = null, \ArrayType\ArrayOfDocument_V3 $documents = null)
    {
        $this
            ->setMaximumModificationID($maximumModificationID)
            ->setDocuments($documents);
    }
    /**
     * Get MaximumModificationID value
     * @return int
     */
    public function getMaximumModificationID()
    {
        return $this->MaximumModificationID;
    }
    /**
     * Set MaximumModificationID value
     * @param int $maximumModificationID
     * @return \StructType\GetScannedDocuments_V2
     */
    public function setMaximumModificationID($maximumModificationID = null)
    {
        // validation for constraint: int
        if (!is_null($maximumModificationID) && !is_numeric($maximumModificationID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($maximumModificationID)), __LINE__);
        }
        $this->MaximumModificationID = $maximumModificationID;
        return $this;
    }
    /**
     * Get Documents value
     * @return \ArrayType\ArrayOfDocument_V3|null
     */
    public function getDocuments()
    {
        return $this->Documents;
    }
    /**
     * Set Documents value
     * @param \ArrayType\ArrayOfDocument_V3 $documents
     * @return \StructType\GetScannedDocuments_V2
     */
    public function setDocuments(\ArrayType\ArrayOfDocument_V3 $documents = null)
    {
        $this->Documents = $documents;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetScannedDocuments_V2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
