<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Get_AlarmMessages_V4 StructType
 * @subpackage Structs
 */
class Get_AlarmMessages_V4 extends AbstractStructBase
{
    /**
     * The OnlyVisiblePopups
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $OnlyVisiblePopups;
    /**
     * The Login
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Login
     */
    public $Login;
    /**
     * The AlarmMessageSelection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AlarmMessageSelection
     */
    public $AlarmMessageSelection;
    /**
     * Constructor method for Get_AlarmMessages_V4
     * @uses Get_AlarmMessages_V4::setOnlyVisiblePopups()
     * @uses Get_AlarmMessages_V4::setLogin()
     * @uses Get_AlarmMessages_V4::setAlarmMessageSelection()
     * @param bool $onlyVisiblePopups
     * @param \StructType\Login $login
     * @param \StructType\AlarmMessageSelection $alarmMessageSelection
     */
    public function __construct($onlyVisiblePopups = null, \StructType\Login $login = null, \StructType\AlarmMessageSelection $alarmMessageSelection = null)
    {
        $this
            ->setOnlyVisiblePopups($onlyVisiblePopups)
            ->setLogin($login)
            ->setAlarmMessageSelection($alarmMessageSelection);
    }
    /**
     * Get OnlyVisiblePopups value
     * @return bool
     */
    public function getOnlyVisiblePopups()
    {
        return $this->OnlyVisiblePopups;
    }
    /**
     * Set OnlyVisiblePopups value
     * @param bool $onlyVisiblePopups
     * @return \StructType\Get_AlarmMessages_V4
     */
    public function setOnlyVisiblePopups($onlyVisiblePopups = null)
    {
        // validation for constraint: boolean
        if (!is_null($onlyVisiblePopups) && !is_bool($onlyVisiblePopups)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($onlyVisiblePopups)), __LINE__);
        }
        $this->OnlyVisiblePopups = $onlyVisiblePopups;
        return $this;
    }
    /**
     * Get Login value
     * @return \StructType\Login|null
     */
    public function getLogin()
    {
        return $this->Login;
    }
    /**
     * Set Login value
     * @param \StructType\Login $login
     * @return \StructType\Get_AlarmMessages_V4
     */
    public function setLogin(\StructType\Login $login = null)
    {
        $this->Login = $login;
        return $this;
    }
    /**
     * Get AlarmMessageSelection value
     * @return \StructType\AlarmMessageSelection|null
     */
    public function getAlarmMessageSelection()
    {
        return $this->AlarmMessageSelection;
    }
    /**
     * Set AlarmMessageSelection value
     * @param \StructType\AlarmMessageSelection $alarmMessageSelection
     * @return \StructType\Get_AlarmMessages_V4
     */
    public function setAlarmMessageSelection(\StructType\AlarmMessageSelection $alarmMessageSelection = null)
    {
        $this->AlarmMessageSelection = $alarmMessageSelection;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Get_AlarmMessages_V4
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
