<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Get_InfringementReportResult StructType
 * @subpackage Structs
 */
class Get_InfringementReportResult extends ExecutionResult
{
    /**
     * The SynchronizedUntilDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $SynchronizedUntilDate;
    /**
     * The InfringementReportItems
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInfringementReportItem
     */
    public $InfringementReportItems;
    /**
     * Constructor method for Get_InfringementReportResult
     * @uses Get_InfringementReportResult::setSynchronizedUntilDate()
     * @uses Get_InfringementReportResult::setInfringementReportItems()
     * @param string $synchronizedUntilDate
     * @param \ArrayType\ArrayOfInfringementReportItem $infringementReportItems
     */
    public function __construct($synchronizedUntilDate = null, \ArrayType\ArrayOfInfringementReportItem $infringementReportItems = null)
    {
        $this
            ->setSynchronizedUntilDate($synchronizedUntilDate)
            ->setInfringementReportItems($infringementReportItems);
    }
    /**
     * Get SynchronizedUntilDate value
     * @return string
     */
    public function getSynchronizedUntilDate()
    {
        return $this->SynchronizedUntilDate;
    }
    /**
     * Set SynchronizedUntilDate value
     * @param string $synchronizedUntilDate
     * @return \StructType\Get_InfringementReportResult
     */
    public function setSynchronizedUntilDate($synchronizedUntilDate = null)
    {
        // validation for constraint: string
        if (!is_null($synchronizedUntilDate) && !is_string($synchronizedUntilDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($synchronizedUntilDate)), __LINE__);
        }
        $this->SynchronizedUntilDate = $synchronizedUntilDate;
        return $this;
    }
    /**
     * Get InfringementReportItems value
     * @return \ArrayType\ArrayOfInfringementReportItem|null
     */
    public function getInfringementReportItems()
    {
        return $this->InfringementReportItems;
    }
    /**
     * Set InfringementReportItems value
     * @param \ArrayType\ArrayOfInfringementReportItem $infringementReportItems
     * @return \StructType\Get_InfringementReportResult
     */
    public function setInfringementReportItems(\ArrayType\ArrayOfInfringementReportItem $infringementReportItems = null)
    {
        $this->InfringementReportItems = $infringementReportItems;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Get_InfringementReportResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
