<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InfoFieldItem StructType
 * @subpackage Structs
 */
class InfoFieldItem extends AbstractStructBase
{
    /**
     * The DateLastUpdate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $DateLastUpdate;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Value
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Value;
    /**
     * Constructor method for InfoFieldItem
     * @uses InfoFieldItem::setDateLastUpdate()
     * @uses InfoFieldItem::setName()
     * @uses InfoFieldItem::setValue()
     * @param string $dateLastUpdate
     * @param string $name
     * @param string $value
     */
    public function __construct($dateLastUpdate = null, $name = null, $value = null)
    {
        $this
            ->setDateLastUpdate($dateLastUpdate)
            ->setName($name)
            ->setValue($value);
    }
    /**
     * Get DateLastUpdate value
     * @return string
     */
    public function getDateLastUpdate()
    {
        return $this->DateLastUpdate;
    }
    /**
     * Set DateLastUpdate value
     * @param string $dateLastUpdate
     * @return \StructType\InfoFieldItem
     */
    public function setDateLastUpdate($dateLastUpdate = null)
    {
        // validation for constraint: string
        if (!is_null($dateLastUpdate) && !is_string($dateLastUpdate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dateLastUpdate)), __LINE__);
        }
        $this->DateLastUpdate = $dateLastUpdate;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\InfoFieldItem
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Value value
     * @return string|null
     */
    public function getValue()
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @param string $value
     * @return \StructType\InfoFieldItem
     */
    public function setValue($value = null)
    {
        // validation for constraint: string
        if (!is_null($value) && !is_string($value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($value)), __LINE__);
        }
        $this->Value = $value;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InfoFieldItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
