<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InfringementReportSelection StructType
 * @subpackage Structs
 */
class InfringementReportSelection extends AbstractStructBase
{
    /**
     * The Persons
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifier
     */
    public $Persons;
    /**
     * The ReportingSelection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ReportingSelection
     */
    public $ReportingSelection;
    /**
     * The SynchronizationSelection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SynchronizationSelection
     */
    public $SynchronizationSelection;
    /**
     * Constructor method for InfringementReportSelection
     * @uses InfringementReportSelection::setPersons()
     * @uses InfringementReportSelection::setReportingSelection()
     * @uses InfringementReportSelection::setSynchronizationSelection()
     * @param \ArrayType\ArrayOfIdentifier $persons
     * @param \StructType\ReportingSelection $reportingSelection
     * @param \StructType\SynchronizationSelection $synchronizationSelection
     */
    public function __construct(\ArrayType\ArrayOfIdentifier $persons = null, \StructType\ReportingSelection $reportingSelection = null, \StructType\SynchronizationSelection $synchronizationSelection = null)
    {
        $this
            ->setPersons($persons)
            ->setReportingSelection($reportingSelection)
            ->setSynchronizationSelection($synchronizationSelection);
    }
    /**
     * Get Persons value
     * @return \ArrayType\ArrayOfIdentifier|null
     */
    public function getPersons()
    {
        return $this->Persons;
    }
    /**
     * Set Persons value
     * @param \ArrayType\ArrayOfIdentifier $persons
     * @return \StructType\InfringementReportSelection
     */
    public function setPersons(\ArrayType\ArrayOfIdentifier $persons = null)
    {
        $this->Persons = $persons;
        return $this;
    }
    /**
     * Get ReportingSelection value
     * @return \StructType\ReportingSelection|null
     */
    public function getReportingSelection()
    {
        return $this->ReportingSelection;
    }
    /**
     * Set ReportingSelection value
     * @param \StructType\ReportingSelection $reportingSelection
     * @return \StructType\InfringementReportSelection
     */
    public function setReportingSelection(\StructType\ReportingSelection $reportingSelection = null)
    {
        $this->ReportingSelection = $reportingSelection;
        return $this;
    }
    /**
     * Get SynchronizationSelection value
     * @return \StructType\SynchronizationSelection|null
     */
    public function getSynchronizationSelection()
    {
        return $this->SynchronizationSelection;
    }
    /**
     * Set SynchronizationSelection value
     * @param \StructType\SynchronizationSelection $synchronizationSelection
     * @return \StructType\InfringementReportSelection
     */
    public function setSynchronizationSelection(\StructType\SynchronizationSelection $synchronizationSelection = null)
    {
        $this->SynchronizationSelection = $synchronizationSelection;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InfringementReportSelection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
