<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InsertGeoZoneResult StructType
 * @subpackage Structs
 */
class InsertGeoZoneResult extends AbstractStructBase
{
    /**
     * The GeoZoneTNR
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $GeoZoneTNR;
    /**
     * The GeoZoneSeq
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $GeoZoneSeq;
    /**
     * The GeoZoneName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $GeoZoneName;
    /**
     * Constructor method for InsertGeoZoneResult
     * @uses InsertGeoZoneResult::setGeoZoneTNR()
     * @uses InsertGeoZoneResult::setGeoZoneSeq()
     * @uses InsertGeoZoneResult::setGeoZoneName()
     * @param int $geoZoneTNR
     * @param int $geoZoneSeq
     * @param string $geoZoneName
     */
    public function __construct($geoZoneTNR = null, $geoZoneSeq = null, $geoZoneName = null)
    {
        $this
            ->setGeoZoneTNR($geoZoneTNR)
            ->setGeoZoneSeq($geoZoneSeq)
            ->setGeoZoneName($geoZoneName);
    }
    /**
     * Get GeoZoneTNR value
     * @return int
     */
    public function getGeoZoneTNR()
    {
        return $this->GeoZoneTNR;
    }
    /**
     * Set GeoZoneTNR value
     * @param int $geoZoneTNR
     * @return \StructType\InsertGeoZoneResult
     */
    public function setGeoZoneTNR($geoZoneTNR = null)
    {
        // validation for constraint: int
        if (!is_null($geoZoneTNR) && !is_numeric($geoZoneTNR)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($geoZoneTNR)), __LINE__);
        }
        $this->GeoZoneTNR = $geoZoneTNR;
        return $this;
    }
    /**
     * Get GeoZoneSeq value
     * @return int
     */
    public function getGeoZoneSeq()
    {
        return $this->GeoZoneSeq;
    }
    /**
     * Set GeoZoneSeq value
     * @param int $geoZoneSeq
     * @return \StructType\InsertGeoZoneResult
     */
    public function setGeoZoneSeq($geoZoneSeq = null)
    {
        // validation for constraint: int
        if (!is_null($geoZoneSeq) && !is_numeric($geoZoneSeq)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($geoZoneSeq)), __LINE__);
        }
        $this->GeoZoneSeq = $geoZoneSeq;
        return $this;
    }
    /**
     * Get GeoZoneName value
     * @return string|null
     */
    public function getGeoZoneName()
    {
        return $this->GeoZoneName;
    }
    /**
     * Set GeoZoneName value
     * @param string $geoZoneName
     * @return \StructType\InsertGeoZoneResult
     */
    public function setGeoZoneName($geoZoneName = null)
    {
        // validation for constraint: string
        if (!is_null($geoZoneName) && !is_string($geoZoneName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($geoZoneName)), __LINE__);
        }
        $this->GeoZoneName = $geoZoneName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InsertGeoZoneResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
