<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InterfaceBlockedVehicleResult StructType
 * @subpackage Structs
 */
class InterfaceBlockedVehicleResult extends AbstractStructBase
{
    /**
     * The Date
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Date;
    /**
     * The Activated
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Activated;
    /**
     * Constructor method for InterfaceBlockedVehicleResult
     * @uses InterfaceBlockedVehicleResult::setDate()
     * @uses InterfaceBlockedVehicleResult::setActivated()
     * @param string $date
     * @param bool $activated
     */
    public function __construct($date = null, $activated = null)
    {
        $this
            ->setDate($date)
            ->setActivated($activated);
    }
    /**
     * Get Date value
     * @return string
     */
    public function getDate()
    {
        return $this->Date;
    }
    /**
     * Set Date value
     * @param string $date
     * @return \StructType\InterfaceBlockedVehicleResult
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($date)), __LINE__);
        }
        $this->Date = $date;
        return $this;
    }
    /**
     * Get Activated value
     * @return bool
     */
    public function getActivated()
    {
        return $this->Activated;
    }
    /**
     * Set Activated value
     * @param bool $activated
     * @return \StructType\InterfaceBlockedVehicleResult
     */
    public function setActivated($activated = null)
    {
        // validation for constraint: boolean
        if (!is_null($activated) && !is_bool($activated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($activated)), __LINE__);
        }
        $this->Activated = $activated;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InterfaceBlockedVehicleResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
