<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LastVehicleInfo StructType
 * @subpackage Structs
 */
class LastVehicleInfo extends AbstractStructBase
{
    /**
     * The DateLastVehicle
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $DateLastVehicle;
    /**
     * The LastVehicle
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\IdentifierVehicleResult
     */
    public $LastVehicle;
    /**
     * The Position
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Position
     */
    public $Position;
    /**
     * Constructor method for LastVehicleInfo
     * @uses LastVehicleInfo::setDateLastVehicle()
     * @uses LastVehicleInfo::setLastVehicle()
     * @uses LastVehicleInfo::setPosition()
     * @param string $dateLastVehicle
     * @param \StructType\IdentifierVehicleResult $lastVehicle
     * @param \StructType\Position $position
     */
    public function __construct($dateLastVehicle = null, \StructType\IdentifierVehicleResult $lastVehicle = null, \StructType\Position $position = null)
    {
        $this
            ->setDateLastVehicle($dateLastVehicle)
            ->setLastVehicle($lastVehicle)
            ->setPosition($position);
    }
    /**
     * Get DateLastVehicle value
     * @return string
     */
    public function getDateLastVehicle()
    {
        return $this->DateLastVehicle;
    }
    /**
     * Set DateLastVehicle value
     * @param string $dateLastVehicle
     * @return \StructType\LastVehicleInfo
     */
    public function setDateLastVehicle($dateLastVehicle = null)
    {
        // validation for constraint: string
        if (!is_null($dateLastVehicle) && !is_string($dateLastVehicle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dateLastVehicle)), __LINE__);
        }
        $this->DateLastVehicle = $dateLastVehicle;
        return $this;
    }
    /**
     * Get LastVehicle value
     * @return \StructType\IdentifierVehicleResult|null
     */
    public function getLastVehicle()
    {
        return $this->LastVehicle;
    }
    /**
     * Set LastVehicle value
     * @param \StructType\IdentifierVehicleResult $lastVehicle
     * @return \StructType\LastVehicleInfo
     */
    public function setLastVehicle(\StructType\IdentifierVehicleResult $lastVehicle = null)
    {
        $this->LastVehicle = $lastVehicle;
        return $this;
    }
    /**
     * Get Position value
     * @return \StructType\Position|null
     */
    public function getPosition()
    {
        return $this->Position;
    }
    /**
     * Set Position value
     * @param \StructType\Position $position
     * @return \StructType\LastVehicleInfo
     */
    public function setPosition(\StructType\Position $position = null)
    {
        $this->Position = $position;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\LastVehicleInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
