<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NearestPositionSelection StructType
 * @subpackage Structs
 */
class NearestPositionSelection extends AbstractStructBase
{
    /**
     * The KmsAround
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $KmsAround;
    /**
     * The DateTimeRange
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateTimeRangeSelection
     */
    public $DateTimeRange;
    /**
     * The Position
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Position
     */
    public $Position;
    /**
     * Constructor method for NearestPositionSelection
     * @uses NearestPositionSelection::setKmsAround()
     * @uses NearestPositionSelection::setDateTimeRange()
     * @uses NearestPositionSelection::setPosition()
     * @param float $kmsAround
     * @param \StructType\DateTimeRangeSelection $dateTimeRange
     * @param \StructType\Position $position
     */
    public function __construct($kmsAround = null, \StructType\DateTimeRangeSelection $dateTimeRange = null, \StructType\Position $position = null)
    {
        $this
            ->setKmsAround($kmsAround)
            ->setDateTimeRange($dateTimeRange)
            ->setPosition($position);
    }
    /**
     * Get KmsAround value
     * @return float
     */
    public function getKmsAround()
    {
        return $this->KmsAround;
    }
    /**
     * Set KmsAround value
     * @param float $kmsAround
     * @return \StructType\NearestPositionSelection
     */
    public function setKmsAround($kmsAround = null)
    {
        $this->KmsAround = $kmsAround;
        return $this;
    }
    /**
     * Get DateTimeRange value
     * @return \StructType\DateTimeRangeSelection|null
     */
    public function getDateTimeRange()
    {
        return $this->DateTimeRange;
    }
    /**
     * Set DateTimeRange value
     * @param \StructType\DateTimeRangeSelection $dateTimeRange
     * @return \StructType\NearestPositionSelection
     */
    public function setDateTimeRange(\StructType\DateTimeRangeSelection $dateTimeRange = null)
    {
        $this->DateTimeRange = $dateTimeRange;
        return $this;
    }
    /**
     * Get Position value
     * @return \StructType\Position|null
     */
    public function getPosition()
    {
        return $this->Position;
    }
    /**
     * Set Position value
     * @param \StructType\Position $position
     * @return \StructType\NearestPositionSelection
     */
    public function setPosition(\StructType\Position $position = null)
    {
        $this->Position = $position;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NearestPositionSelection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
