<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NextStopPosition StructType
 * @subpackage Structs
 */
class NextStopPosition extends Position
{
    /**
     * The StreetInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\NextStopStreetInfo
     */
    public $StreetInfo;
    /**
     * Constructor method for NextStopPosition
     * @uses NextStopPosition::setStreetInfo()
     * @param \StructType\NextStopStreetInfo $streetInfo
     */
    public function __construct(\StructType\NextStopStreetInfo $streetInfo = null)
    {
        $this
            ->setStreetInfo($streetInfo);
    }
    /**
     * Get StreetInfo value
     * @return \StructType\NextStopStreetInfo|null
     */
    public function getStreetInfo()
    {
        return $this->StreetInfo;
    }
    /**
     * Set StreetInfo value
     * @param \StructType\NextStopStreetInfo $streetInfo
     * @return \StructType\NextStopPosition
     */
    public function setStreetInfo(\StructType\NextStopStreetInfo $streetInfo = null)
    {
        $this->StreetInfo = $streetInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NextStopPosition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
