<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PathResult StructType
 * @subpackage Structs
 */
class PathResult extends PathBase
{
    /**
     * The Answer
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Answer
     */
    public $Answer;
    /**
     * Constructor method for PathResult
     * @uses PathResult::setAnswer()
     * @param \StructType\Answer $answer
     */
    public function __construct(\StructType\Answer $answer = null)
    {
        $this
            ->setAnswer($answer);
    }
    /**
     * Get Answer value
     * @return \StructType\Answer|null
     */
    public function getAnswer()
    {
        return $this->Answer;
    }
    /**
     * Set Answer value
     * @param \StructType\Answer $answer
     * @return \StructType\PathResult
     */
    public function setAnswer(\StructType\Answer $answer = null)
    {
        $this->Answer = $answer;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PathResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
