<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PlanningInsert StructType
 * @subpackage Structs
 */
class PlanningInsert extends Planning
{
    /**
     * The IgnoreViaRouteNotFoundError
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IgnoreViaRouteNotFoundError;
    /**
     * The Trips
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTripInsert
     */
    public $Trips;
    /**
     * The Places
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfPlaceInsert
     */
    public $Places;
    /**
     * Constructor method for PlanningInsert
     * @uses PlanningInsert::setIgnoreViaRouteNotFoundError()
     * @uses PlanningInsert::setTrips()
     * @uses PlanningInsert::setPlaces()
     * @param bool $ignoreViaRouteNotFoundError
     * @param \ArrayType\ArrayOfTripInsert $trips
     * @param \ArrayType\ArrayOfPlaceInsert $places
     */
    public function __construct($ignoreViaRouteNotFoundError = null, \ArrayType\ArrayOfTripInsert $trips = null, \ArrayType\ArrayOfPlaceInsert $places = null)
    {
        $this
            ->setIgnoreViaRouteNotFoundError($ignoreViaRouteNotFoundError)
            ->setTrips($trips)
            ->setPlaces($places);
    }
    /**
     * Get IgnoreViaRouteNotFoundError value
     * @return bool
     */
    public function getIgnoreViaRouteNotFoundError()
    {
        return $this->IgnoreViaRouteNotFoundError;
    }
    /**
     * Set IgnoreViaRouteNotFoundError value
     * @param bool $ignoreViaRouteNotFoundError
     * @return \StructType\PlanningInsert
     */
    public function setIgnoreViaRouteNotFoundError($ignoreViaRouteNotFoundError = null)
    {
        // validation for constraint: boolean
        if (!is_null($ignoreViaRouteNotFoundError) && !is_bool($ignoreViaRouteNotFoundError)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($ignoreViaRouteNotFoundError)), __LINE__);
        }
        $this->IgnoreViaRouteNotFoundError = $ignoreViaRouteNotFoundError;
        return $this;
    }
    /**
     * Get Trips value
     * @return \ArrayType\ArrayOfTripInsert|null
     */
    public function getTrips()
    {
        return $this->Trips;
    }
    /**
     * Set Trips value
     * @param \ArrayType\ArrayOfTripInsert $trips
     * @return \StructType\PlanningInsert
     */
    public function setTrips(\ArrayType\ArrayOfTripInsert $trips = null)
    {
        $this->Trips = $trips;
        return $this;
    }
    /**
     * Get Places value
     * @return \ArrayType\ArrayOfPlaceInsert|null
     */
    public function getPlaces()
    {
        return $this->Places;
    }
    /**
     * Set Places value
     * @param \ArrayType\ArrayOfPlaceInsert $places
     * @return \StructType\PlanningInsert
     */
    public function setPlaces(\ArrayType\ArrayOfPlaceInsert $places = null)
    {
        $this->Places = $places;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PlanningInsert
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
