<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PlanningModificationsSelection_V3 StructType
 * @subpackage Structs
 */
class PlanningModificationsSelection_V3 extends AbstractStructBase
{
    /**
     * The PlanningSelectionType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $PlanningSelectionType;
    /**
     * The SynchronizationSelection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SynchronizationSelection
     */
    public $SynchronizationSelection;
    /**
     * Constructor method for PlanningModificationsSelection_V3
     * @uses PlanningModificationsSelection_V3::setPlanningSelectionType()
     * @uses PlanningModificationsSelection_V3::setSynchronizationSelection()
     * @param string $planningSelectionType
     * @param \StructType\SynchronizationSelection $synchronizationSelection
     */
    public function __construct($planningSelectionType = null, \StructType\SynchronizationSelection $synchronizationSelection = null)
    {
        $this
            ->setPlanningSelectionType($planningSelectionType)
            ->setSynchronizationSelection($synchronizationSelection);
    }
    /**
     * Get PlanningSelectionType value
     * @return string
     */
    public function getPlanningSelectionType()
    {
        return $this->PlanningSelectionType;
    }
    /**
     * Set PlanningSelectionType value
     * @uses \EnumType\EnumPlanningSelectionModificationsType_V2::valueIsValid()
     * @uses \EnumType\EnumPlanningSelectionModificationsType_V2::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $planningSelectionType
     * @return \StructType\PlanningModificationsSelection_V3
     */
    public function setPlanningSelectionType($planningSelectionType = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\EnumPlanningSelectionModificationsType_V2::valueIsValid($planningSelectionType)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $planningSelectionType, implode(', ', \EnumType\EnumPlanningSelectionModificationsType_V2::getValidValues())), __LINE__);
        }
        $this->PlanningSelectionType = $planningSelectionType;
        return $this;
    }
    /**
     * Get SynchronizationSelection value
     * @return \StructType\SynchronizationSelection|null
     */
    public function getSynchronizationSelection()
    {
        return $this->SynchronizationSelection;
    }
    /**
     * Set SynchronizationSelection value
     * @param \StructType\SynchronizationSelection $synchronizationSelection
     * @return \StructType\PlanningModificationsSelection_V3
     */
    public function setSynchronizationSelection(\StructType\SynchronizationSelection $synchronizationSelection = null)
    {
        $this->SynchronizationSelection = $synchronizationSelection;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PlanningModificationsSelection_V3
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
