<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PlanningResultInsert StructType
 * @subpackage Structs
 */
class PlanningResultInsert extends ExecutionResult
{
    /**
     * The Trips
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTripResultInsert
     */
    public $Trips;
    /**
     * The Places
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfPlaceResultInsert
     */
    public $Places;
    /**
     * Constructor method for PlanningResultInsert
     * @uses PlanningResultInsert::setTrips()
     * @uses PlanningResultInsert::setPlaces()
     * @param \ArrayType\ArrayOfTripResultInsert $trips
     * @param \ArrayType\ArrayOfPlaceResultInsert $places
     */
    public function __construct(\ArrayType\ArrayOfTripResultInsert $trips = null, \ArrayType\ArrayOfPlaceResultInsert $places = null)
    {
        $this
            ->setTrips($trips)
            ->setPlaces($places);
    }
    /**
     * Get Trips value
     * @return \ArrayType\ArrayOfTripResultInsert|null
     */
    public function getTrips()
    {
        return $this->Trips;
    }
    /**
     * Set Trips value
     * @param \ArrayType\ArrayOfTripResultInsert $trips
     * @return \StructType\PlanningResultInsert
     */
    public function setTrips(\ArrayType\ArrayOfTripResultInsert $trips = null)
    {
        $this->Trips = $trips;
        return $this;
    }
    /**
     * Get Places value
     * @return \ArrayType\ArrayOfPlaceResultInsert|null
     */
    public function getPlaces()
    {
        return $this->Places;
    }
    /**
     * Set Places value
     * @param \ArrayType\ArrayOfPlaceResultInsert $places
     * @return \StructType\PlanningResultInsert
     */
    public function setPlaces(\ArrayType\ArrayOfPlaceResultInsert $places = null)
    {
        $this->Places = $places;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PlanningResultInsert
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
