<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RemoveIdentifiersFromDispatchers StructType
 * @subpackage Structs
 */
class RemoveIdentifiersFromDispatchers extends AbstractStructBase
{
    /**
     * The VehicleItemList
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifierVehicle
     */
    public $VehicleItemList;
    /**
     * The DispatcherItemList
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifier
     */
    public $DispatcherItemList;
    /**
     * The Company
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CompanyIdentifier
     */
    public $Company;
    /**
     * Constructor method for RemoveIdentifiersFromDispatchers
     * @uses RemoveIdentifiersFromDispatchers::setVehicleItemList()
     * @uses RemoveIdentifiersFromDispatchers::setDispatcherItemList()
     * @uses RemoveIdentifiersFromDispatchers::setCompany()
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicleItemList
     * @param \ArrayType\ArrayOfIdentifier $dispatcherItemList
     * @param \StructType\CompanyIdentifier $company
     */
    public function __construct(\ArrayType\ArrayOfIdentifierVehicle $vehicleItemList = null, \ArrayType\ArrayOfIdentifier $dispatcherItemList = null, \StructType\CompanyIdentifier $company = null)
    {
        $this
            ->setVehicleItemList($vehicleItemList)
            ->setDispatcherItemList($dispatcherItemList)
            ->setCompany($company);
    }
    /**
     * Get VehicleItemList value
     * @return \ArrayType\ArrayOfIdentifierVehicle|null
     */
    public function getVehicleItemList()
    {
        return $this->VehicleItemList;
    }
    /**
     * Set VehicleItemList value
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicleItemList
     * @return \StructType\RemoveIdentifiersFromDispatchers
     */
    public function setVehicleItemList(\ArrayType\ArrayOfIdentifierVehicle $vehicleItemList = null)
    {
        $this->VehicleItemList = $vehicleItemList;
        return $this;
    }
    /**
     * Get DispatcherItemList value
     * @return \ArrayType\ArrayOfIdentifier|null
     */
    public function getDispatcherItemList()
    {
        return $this->DispatcherItemList;
    }
    /**
     * Set DispatcherItemList value
     * @param \ArrayType\ArrayOfIdentifier $dispatcherItemList
     * @return \StructType\RemoveIdentifiersFromDispatchers
     */
    public function setDispatcherItemList(\ArrayType\ArrayOfIdentifier $dispatcherItemList = null)
    {
        $this->DispatcherItemList = $dispatcherItemList;
        return $this;
    }
    /**
     * Get Company value
     * @return \StructType\CompanyIdentifier|null
     */
    public function getCompany()
    {
        return $this->Company;
    }
    /**
     * Set Company value
     * @param \StructType\CompanyIdentifier $company
     * @return \StructType\RemoveIdentifiersFromDispatchers
     */
    public function setCompany(\StructType\CompanyIdentifier $company = null)
    {
        $this->Company = $company;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RemoveIdentifiersFromDispatchers
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
