<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceTimeTachoDetail StructType
 * @subpackage Structs
 */
class ServiceTimeTachoDetail extends AbstractStructBase
{
    /**
     * The BeginDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $BeginDate;
    /**
     * The EndDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $EndDate;
    /**
     * The KmsEnd
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $KmsEnd;
    /**
     * The KmsStart
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $KmsStart;
    /**
     * The ReadOutDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $ReadOutDate;
    /**
     * The Driver
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\IdentifierPerson
     */
    public $Driver;
    /**
     * The Vehicle
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\IdentifierVehicleResult
     */
    public $Vehicle;
    /**
     * The WorkingCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CodeInfo
     */
    public $WorkingCode;
    /**
     * Constructor method for ServiceTimeTachoDetail
     * @uses ServiceTimeTachoDetail::setBeginDate()
     * @uses ServiceTimeTachoDetail::setEndDate()
     * @uses ServiceTimeTachoDetail::setKmsEnd()
     * @uses ServiceTimeTachoDetail::setKmsStart()
     * @uses ServiceTimeTachoDetail::setReadOutDate()
     * @uses ServiceTimeTachoDetail::setDriver()
     * @uses ServiceTimeTachoDetail::setVehicle()
     * @uses ServiceTimeTachoDetail::setWorkingCode()
     * @param string $beginDate
     * @param string $endDate
     * @param int $kmsEnd
     * @param int $kmsStart
     * @param string $readOutDate
     * @param \StructType\IdentifierPerson $driver
     * @param \StructType\IdentifierVehicleResult $vehicle
     * @param \StructType\CodeInfo $workingCode
     */
    public function __construct($beginDate = null, $endDate = null, $kmsEnd = null, $kmsStart = null, $readOutDate = null, \StructType\IdentifierPerson $driver = null, \StructType\IdentifierVehicleResult $vehicle = null, \StructType\CodeInfo $workingCode = null)
    {
        $this
            ->setBeginDate($beginDate)
            ->setEndDate($endDate)
            ->setKmsEnd($kmsEnd)
            ->setKmsStart($kmsStart)
            ->setReadOutDate($readOutDate)
            ->setDriver($driver)
            ->setVehicle($vehicle)
            ->setWorkingCode($workingCode);
    }
    /**
     * Get BeginDate value
     * @return string
     */
    public function getBeginDate()
    {
        return $this->BeginDate;
    }
    /**
     * Set BeginDate value
     * @param string $beginDate
     * @return \StructType\ServiceTimeTachoDetail
     */
    public function setBeginDate($beginDate = null)
    {
        // validation for constraint: string
        if (!is_null($beginDate) && !is_string($beginDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($beginDate)), __LINE__);
        }
        $this->BeginDate = $beginDate;
        return $this;
    }
    /**
     * Get EndDate value
     * @return string
     */
    public function getEndDate()
    {
        return $this->EndDate;
    }
    /**
     * Set EndDate value
     * @param string $endDate
     * @return \StructType\ServiceTimeTachoDetail
     */
    public function setEndDate($endDate = null)
    {
        // validation for constraint: string
        if (!is_null($endDate) && !is_string($endDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($endDate)), __LINE__);
        }
        $this->EndDate = $endDate;
        return $this;
    }
    /**
     * Get KmsEnd value
     * @return int
     */
    public function getKmsEnd()
    {
        return $this->KmsEnd;
    }
    /**
     * Set KmsEnd value
     * @param int $kmsEnd
     * @return \StructType\ServiceTimeTachoDetail
     */
    public function setKmsEnd($kmsEnd = null)
    {
        // validation for constraint: int
        if (!is_null($kmsEnd) && !is_numeric($kmsEnd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($kmsEnd)), __LINE__);
        }
        $this->KmsEnd = $kmsEnd;
        return $this;
    }
    /**
     * Get KmsStart value
     * @return int
     */
    public function getKmsStart()
    {
        return $this->KmsStart;
    }
    /**
     * Set KmsStart value
     * @param int $kmsStart
     * @return \StructType\ServiceTimeTachoDetail
     */
    public function setKmsStart($kmsStart = null)
    {
        // validation for constraint: int
        if (!is_null($kmsStart) && !is_numeric($kmsStart)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($kmsStart)), __LINE__);
        }
        $this->KmsStart = $kmsStart;
        return $this;
    }
    /**
     * Get ReadOutDate value
     * @return string
     */
    public function getReadOutDate()
    {
        return $this->ReadOutDate;
    }
    /**
     * Set ReadOutDate value
     * @param string $readOutDate
     * @return \StructType\ServiceTimeTachoDetail
     */
    public function setReadOutDate($readOutDate = null)
    {
        // validation for constraint: string
        if (!is_null($readOutDate) && !is_string($readOutDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($readOutDate)), __LINE__);
        }
        $this->ReadOutDate = $readOutDate;
        return $this;
    }
    /**
     * Get Driver value
     * @return \StructType\IdentifierPerson|null
     */
    public function getDriver()
    {
        return $this->Driver;
    }
    /**
     * Set Driver value
     * @param \StructType\IdentifierPerson $driver
     * @return \StructType\ServiceTimeTachoDetail
     */
    public function setDriver(\StructType\IdentifierPerson $driver = null)
    {
        $this->Driver = $driver;
        return $this;
    }
    /**
     * Get Vehicle value
     * @return \StructType\IdentifierVehicleResult|null
     */
    public function getVehicle()
    {
        return $this->Vehicle;
    }
    /**
     * Set Vehicle value
     * @param \StructType\IdentifierVehicleResult $vehicle
     * @return \StructType\ServiceTimeTachoDetail
     */
    public function setVehicle(\StructType\IdentifierVehicleResult $vehicle = null)
    {
        $this->Vehicle = $vehicle;
        return $this;
    }
    /**
     * Get WorkingCode value
     * @return \StructType\CodeInfo|null
     */
    public function getWorkingCode()
    {
        return $this->WorkingCode;
    }
    /**
     * Set WorkingCode value
     * @param \StructType\CodeInfo $workingCode
     * @return \StructType\ServiceTimeTachoDetail
     */
    public function setWorkingCode(\StructType\CodeInfo $workingCode = null)
    {
        $this->WorkingCode = $workingCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ServiceTimeTachoDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
