<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SmsCommunicationSelection StructType
 * @subpackage Structs
 */
class SmsCommunicationSelection extends AbstractStructBase
{
    /**
     * The Vehicles
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifierVehicle
     */
    public $Vehicles;
    /**
     * The Trailers
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifierVehicle
     */
    public $Trailers;
    /**
     * The ReportingSelection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ReportingSelection
     */
    public $ReportingSelection;
    /**
     * The SynchronizationSelection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SynchronizationSelection
     */
    public $SynchronizationSelection;
    /**
     * Constructor method for SmsCommunicationSelection
     * @uses SmsCommunicationSelection::setVehicles()
     * @uses SmsCommunicationSelection::setTrailers()
     * @uses SmsCommunicationSelection::setReportingSelection()
     * @uses SmsCommunicationSelection::setSynchronizationSelection()
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @param \ArrayType\ArrayOfIdentifierVehicle $trailers
     * @param \StructType\ReportingSelection $reportingSelection
     * @param \StructType\SynchronizationSelection $synchronizationSelection
     */
    public function __construct(\ArrayType\ArrayOfIdentifierVehicle $vehicles = null, \ArrayType\ArrayOfIdentifierVehicle $trailers = null, \StructType\ReportingSelection $reportingSelection = null, \StructType\SynchronizationSelection $synchronizationSelection = null)
    {
        $this
            ->setVehicles($vehicles)
            ->setTrailers($trailers)
            ->setReportingSelection($reportingSelection)
            ->setSynchronizationSelection($synchronizationSelection);
    }
    /**
     * Get Vehicles value
     * @return \ArrayType\ArrayOfIdentifierVehicle|null
     */
    public function getVehicles()
    {
        return $this->Vehicles;
    }
    /**
     * Set Vehicles value
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @return \StructType\SmsCommunicationSelection
     */
    public function setVehicles(\ArrayType\ArrayOfIdentifierVehicle $vehicles = null)
    {
        $this->Vehicles = $vehicles;
        return $this;
    }
    /**
     * Get Trailers value
     * @return \ArrayType\ArrayOfIdentifierVehicle|null
     */
    public function getTrailers()
    {
        return $this->Trailers;
    }
    /**
     * Set Trailers value
     * @param \ArrayType\ArrayOfIdentifierVehicle $trailers
     * @return \StructType\SmsCommunicationSelection
     */
    public function setTrailers(\ArrayType\ArrayOfIdentifierVehicle $trailers = null)
    {
        $this->Trailers = $trailers;
        return $this;
    }
    /**
     * Get ReportingSelection value
     * @return \StructType\ReportingSelection|null
     */
    public function getReportingSelection()
    {
        return $this->ReportingSelection;
    }
    /**
     * Set ReportingSelection value
     * @param \StructType\ReportingSelection $reportingSelection
     * @return \StructType\SmsCommunicationSelection
     */
    public function setReportingSelection(\StructType\ReportingSelection $reportingSelection = null)
    {
        $this->ReportingSelection = $reportingSelection;
        return $this;
    }
    /**
     * Get SynchronizationSelection value
     * @return \StructType\SynchronizationSelection|null
     */
    public function getSynchronizationSelection()
    {
        return $this->SynchronizationSelection;
    }
    /**
     * Set SynchronizationSelection value
     * @param \StructType\SynchronizationSelection $synchronizationSelection
     * @return \StructType\SmsCommunicationSelection
     */
    public function setSynchronizationSelection(\StructType\SynchronizationSelection $synchronizationSelection = null)
    {
        $this->SynchronizationSelection = $synchronizationSelection;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SmsCommunicationSelection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
