<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SocialSubGroup StructType
 * @subpackage Structs
 */
class SocialSubGroup extends AbstractStructBase
{
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The SocialGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SocialSubGroup
     */
    public $SocialGroup;
    /**
     * Constructor method for SocialSubGroup
     * @uses SocialSubGroup::setName()
     * @uses SocialSubGroup::setSocialGroup()
     * @param string $name
     * @param \StructType\SocialSubGroup $socialGroup
     */
    public function __construct($name = null, \StructType\SocialSubGroup $socialGroup = null)
    {
        $this
            ->setName($name)
            ->setSocialGroup($socialGroup);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\SocialSubGroup
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get SocialGroup value
     * @return \StructType\SocialSubGroup|null
     */
    public function getSocialGroup()
    {
        return $this->SocialGroup;
    }
    /**
     * Set SocialGroup value
     * @param \StructType\SocialSubGroup $socialGroup
     * @return \StructType\SocialSubGroup
     */
    public function setSocialGroup(\StructType\SocialSubGroup $socialGroup = null)
    {
        $this->SocialGroup = $socialGroup;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SocialSubGroup
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
