<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SubcontractedVehicleSelection StructType
 * @subpackage Structs
 */
class SubcontractedVehicleSelection extends AbstractStructBase
{
    /**
     * The IncludeInactive
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IncludeInactive;
    /**
     * The IdentifierVehicleStrategy
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\IdentifierVehicleStrategy
     */
    public $IdentifierVehicleStrategy;
    /**
     * The CompanyStrategySelection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CompanyStrategySelection
     */
    public $CompanyStrategySelection;
    /**
     * The DateStrategySelection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateStrategySelection
     */
    public $DateStrategySelection;
    /**
     * Constructor method for SubcontractedVehicleSelection
     * @uses SubcontractedVehicleSelection::setIncludeInactive()
     * @uses SubcontractedVehicleSelection::setIdentifierVehicleStrategy()
     * @uses SubcontractedVehicleSelection::setCompanyStrategySelection()
     * @uses SubcontractedVehicleSelection::setDateStrategySelection()
     * @param bool $includeInactive
     * @param \StructType\IdentifierVehicleStrategy $identifierVehicleStrategy
     * @param \StructType\CompanyStrategySelection $companyStrategySelection
     * @param \StructType\DateStrategySelection $dateStrategySelection
     */
    public function __construct($includeInactive = null, \StructType\IdentifierVehicleStrategy $identifierVehicleStrategy = null, \StructType\CompanyStrategySelection $companyStrategySelection = null, \StructType\DateStrategySelection $dateStrategySelection = null)
    {
        $this
            ->setIncludeInactive($includeInactive)
            ->setIdentifierVehicleStrategy($identifierVehicleStrategy)
            ->setCompanyStrategySelection($companyStrategySelection)
            ->setDateStrategySelection($dateStrategySelection);
    }
    /**
     * Get IncludeInactive value
     * @return bool
     */
    public function getIncludeInactive()
    {
        return $this->IncludeInactive;
    }
    /**
     * Set IncludeInactive value
     * @param bool $includeInactive
     * @return \StructType\SubcontractedVehicleSelection
     */
    public function setIncludeInactive($includeInactive = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeInactive) && !is_bool($includeInactive)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($includeInactive)), __LINE__);
        }
        $this->IncludeInactive = $includeInactive;
        return $this;
    }
    /**
     * Get IdentifierVehicleStrategy value
     * @return \StructType\IdentifierVehicleStrategy|null
     */
    public function getIdentifierVehicleStrategy()
    {
        return $this->IdentifierVehicleStrategy;
    }
    /**
     * Set IdentifierVehicleStrategy value
     * @param \StructType\IdentifierVehicleStrategy $identifierVehicleStrategy
     * @return \StructType\SubcontractedVehicleSelection
     */
    public function setIdentifierVehicleStrategy(\StructType\IdentifierVehicleStrategy $identifierVehicleStrategy = null)
    {
        $this->IdentifierVehicleStrategy = $identifierVehicleStrategy;
        return $this;
    }
    /**
     * Get CompanyStrategySelection value
     * @return \StructType\CompanyStrategySelection|null
     */
    public function getCompanyStrategySelection()
    {
        return $this->CompanyStrategySelection;
    }
    /**
     * Set CompanyStrategySelection value
     * @param \StructType\CompanyStrategySelection $companyStrategySelection
     * @return \StructType\SubcontractedVehicleSelection
     */
    public function setCompanyStrategySelection(\StructType\CompanyStrategySelection $companyStrategySelection = null)
    {
        $this->CompanyStrategySelection = $companyStrategySelection;
        return $this;
    }
    /**
     * Get DateStrategySelection value
     * @return \StructType\DateStrategySelection|null
     */
    public function getDateStrategySelection()
    {
        return $this->DateStrategySelection;
    }
    /**
     * Set DateStrategySelection value
     * @param \StructType\DateStrategySelection $dateStrategySelection
     * @return \StructType\SubcontractedVehicleSelection
     */
    public function setDateStrategySelection(\StructType\DateStrategySelection $dateStrategySelection = null)
    {
        $this->DateStrategySelection = $dateStrategySelection;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SubcontractedVehicleSelection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
