<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TachoReadoutResult StructType
 * @subpackage Structs
 */
class TachoReadoutResult extends ExecutionResult
{
    /**
     * The NextItemsAlreadyAvailable
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $NextItemsAlreadyAvailable;
    /**
     * The TachoReadoutItems
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTachoReadoutItem
     */
    public $TachoReadoutItems;
    /**
     * Constructor method for TachoReadoutResult
     * @uses TachoReadoutResult::setNextItemsAlreadyAvailable()
     * @uses TachoReadoutResult::setTachoReadoutItems()
     * @param bool $nextItemsAlreadyAvailable
     * @param \ArrayType\ArrayOfTachoReadoutItem $tachoReadoutItems
     */
    public function __construct($nextItemsAlreadyAvailable = null, \ArrayType\ArrayOfTachoReadoutItem $tachoReadoutItems = null)
    {
        $this
            ->setNextItemsAlreadyAvailable($nextItemsAlreadyAvailable)
            ->setTachoReadoutItems($tachoReadoutItems);
    }
    /**
     * Get NextItemsAlreadyAvailable value
     * @return bool
     */
    public function getNextItemsAlreadyAvailable()
    {
        return $this->NextItemsAlreadyAvailable;
    }
    /**
     * Set NextItemsAlreadyAvailable value
     * @param bool $nextItemsAlreadyAvailable
     * @return \StructType\TachoReadoutResult
     */
    public function setNextItemsAlreadyAvailable($nextItemsAlreadyAvailable = null)
    {
        // validation for constraint: boolean
        if (!is_null($nextItemsAlreadyAvailable) && !is_bool($nextItemsAlreadyAvailable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($nextItemsAlreadyAvailable)), __LINE__);
        }
        $this->NextItemsAlreadyAvailable = $nextItemsAlreadyAvailable;
        return $this;
    }
    /**
     * Get TachoReadoutItems value
     * @return \ArrayType\ArrayOfTachoReadoutItem|null
     */
    public function getTachoReadoutItems()
    {
        return $this->TachoReadoutItems;
    }
    /**
     * Set TachoReadoutItems value
     * @param \ArrayType\ArrayOfTachoReadoutItem $tachoReadoutItems
     * @return \StructType\TachoReadoutResult
     */
    public function setTachoReadoutItems(\ArrayType\ArrayOfTachoReadoutItem $tachoReadoutItems = null)
    {
        $this->TachoReadoutItems = $tachoReadoutItems;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TachoReadoutResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
