<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TemperatureSelection_With_Trailer_Info StructType
 * @subpackage Structs
 */
class TemperatureSelection_With_Trailer_Info extends TemperatureSelection
{
    /**
     * The UseTemperatureSensorConfig
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $UseTemperatureSensorConfig;
    /**
     * The Trailers
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifierVehicle
     */
    public $Trailers;
    /**
     * Constructor method for TemperatureSelection_With_Trailer_Info
     * @uses TemperatureSelection_With_Trailer_Info::setUseTemperatureSensorConfig()
     * @uses TemperatureSelection_With_Trailer_Info::setTrailers()
     * @param bool $useTemperatureSensorConfig
     * @param \ArrayType\ArrayOfIdentifierVehicle $trailers
     */
    public function __construct($useTemperatureSensorConfig = null, \ArrayType\ArrayOfIdentifierVehicle $trailers = null)
    {
        $this
            ->setUseTemperatureSensorConfig($useTemperatureSensorConfig)
            ->setTrailers($trailers);
    }
    /**
     * Get UseTemperatureSensorConfig value
     * @return bool
     */
    public function getUseTemperatureSensorConfig()
    {
        return $this->UseTemperatureSensorConfig;
    }
    /**
     * Set UseTemperatureSensorConfig value
     * @param bool $useTemperatureSensorConfig
     * @return \StructType\TemperatureSelection_With_Trailer_Info
     */
    public function setUseTemperatureSensorConfig($useTemperatureSensorConfig = null)
    {
        // validation for constraint: boolean
        if (!is_null($useTemperatureSensorConfig) && !is_bool($useTemperatureSensorConfig)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($useTemperatureSensorConfig)), __LINE__);
        }
        $this->UseTemperatureSensorConfig = $useTemperatureSensorConfig;
        return $this;
    }
    /**
     * Get Trailers value
     * @return \ArrayType\ArrayOfIdentifierVehicle|null
     */
    public function getTrailers()
    {
        return $this->Trailers;
    }
    /**
     * Set Trailers value
     * @param \ArrayType\ArrayOfIdentifierVehicle $trailers
     * @return \StructType\TemperatureSelection_With_Trailer_Info
     */
    public function setTrailers(\ArrayType\ArrayOfIdentifierVehicle $trailers = null)
    {
        $this->Trailers = $trailers;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TemperatureSelection_With_Trailer_Info
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
