<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VehicleTachoReadoutIdentifier StructType
 * @subpackage Structs
 */
class VehicleTachoReadoutIdentifier extends TachoReadoutIdentifier
{
    /**
     * The Vehicles
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifierVehicle
     */
    public $Vehicles;
    /**
     * The VehicleGroups
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfGroupIdentifier
     */
    public $VehicleGroups;
    /**
     * Constructor method for VehicleTachoReadoutIdentifier
     * @uses VehicleTachoReadoutIdentifier::setVehicles()
     * @uses VehicleTachoReadoutIdentifier::setVehicleGroups()
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @param \ArrayType\ArrayOfGroupIdentifier $vehicleGroups
     */
    public function __construct(\ArrayType\ArrayOfIdentifierVehicle $vehicles = null, \ArrayType\ArrayOfGroupIdentifier $vehicleGroups = null)
    {
        $this
            ->setVehicles($vehicles)
            ->setVehicleGroups($vehicleGroups);
    }
    /**
     * Get Vehicles value
     * @return \ArrayType\ArrayOfIdentifierVehicle|null
     */
    public function getVehicles()
    {
        return $this->Vehicles;
    }
    /**
     * Set Vehicles value
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @return \StructType\VehicleTachoReadoutIdentifier
     */
    public function setVehicles(\ArrayType\ArrayOfIdentifierVehicle $vehicles = null)
    {
        $this->Vehicles = $vehicles;
        return $this;
    }
    /**
     * Get VehicleGroups value
     * @return \ArrayType\ArrayOfGroupIdentifier|null
     */
    public function getVehicleGroups()
    {
        return $this->VehicleGroups;
    }
    /**
     * Set VehicleGroups value
     * @param \ArrayType\ArrayOfGroupIdentifier $vehicleGroups
     * @return \StructType\VehicleTachoReadoutIdentifier
     */
    public function setVehicleGroups(\ArrayType\ArrayOfGroupIdentifier $vehicleGroups = null)
    {
        $this->VehicleGroups = $vehicleGroups;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VehicleTachoReadoutIdentifier
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
