<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VehicleTimeDiagnostics StructType
 * @subpackage Structs
 */
class VehicleTimeDiagnostics extends AbstractStructBase
{
    /**
     * The LocalTimeZone
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LocalTimeZone;
    /**
     * The SummerWinterChangeOver
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SummerWinterChangeOver;
    /**
     * The ClockStatus
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ClockStatus;
    /**
     * Constructor method for VehicleTimeDiagnostics
     * @uses VehicleTimeDiagnostics::setLocalTimeZone()
     * @uses VehicleTimeDiagnostics::setSummerWinterChangeOver()
     * @uses VehicleTimeDiagnostics::setClockStatus()
     * @param string $localTimeZone
     * @param string $summerWinterChangeOver
     * @param string $clockStatus
     */
    public function __construct($localTimeZone = null, $summerWinterChangeOver = null, $clockStatus = null)
    {
        $this
            ->setLocalTimeZone($localTimeZone)
            ->setSummerWinterChangeOver($summerWinterChangeOver)
            ->setClockStatus($clockStatus);
    }
    /**
     * Get LocalTimeZone value
     * @return string|null
     */
    public function getLocalTimeZone()
    {
        return $this->LocalTimeZone;
    }
    /**
     * Set LocalTimeZone value
     * @param string $localTimeZone
     * @return \StructType\VehicleTimeDiagnostics
     */
    public function setLocalTimeZone($localTimeZone = null)
    {
        // validation for constraint: string
        if (!is_null($localTimeZone) && !is_string($localTimeZone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($localTimeZone)), __LINE__);
        }
        $this->LocalTimeZone = $localTimeZone;
        return $this;
    }
    /**
     * Get SummerWinterChangeOver value
     * @return string|null
     */
    public function getSummerWinterChangeOver()
    {
        return $this->SummerWinterChangeOver;
    }
    /**
     * Set SummerWinterChangeOver value
     * @param string $summerWinterChangeOver
     * @return \StructType\VehicleTimeDiagnostics
     */
    public function setSummerWinterChangeOver($summerWinterChangeOver = null)
    {
        // validation for constraint: string
        if (!is_null($summerWinterChangeOver) && !is_string($summerWinterChangeOver)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($summerWinterChangeOver)), __LINE__);
        }
        $this->SummerWinterChangeOver = $summerWinterChangeOver;
        return $this;
    }
    /**
     * Get ClockStatus value
     * @return string|null
     */
    public function getClockStatus()
    {
        return $this->ClockStatus;
    }
    /**
     * Set ClockStatus value
     * @param string $clockStatus
     * @return \StructType\VehicleTimeDiagnostics
     */
    public function setClockStatus($clockStatus = null)
    {
        // validation for constraint: string
        if (!is_null($clockStatus) && !is_string($clockStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($clockStatus)), __LINE__);
        }
        $this->ClockStatus = $clockStatus;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VehicleTimeDiagnostics
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
