<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ViaRoute_WithBehavior StructType
 * @subpackage Structs
 */
class ViaRoute_WithBehavior extends ViaRoute
{
    /**
     * The ViaRouteBehavior
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $ViaRouteBehavior;
    /**
     * Constructor method for ViaRoute_WithBehavior
     * @uses ViaRoute_WithBehavior::setViaRouteBehavior()
     * @param string $viaRouteBehavior
     */
    public function __construct($viaRouteBehavior = null)
    {
        $this
            ->setViaRouteBehavior($viaRouteBehavior);
    }
    /**
     * Get ViaRouteBehavior value
     * @return string
     */
    public function getViaRouteBehavior()
    {
        return $this->ViaRouteBehavior;
    }
    /**
     * Set ViaRouteBehavior value
     * @uses \EnumType\EnumViaRouteBehavior::valueIsValid()
     * @uses \EnumType\EnumViaRouteBehavior::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $viaRouteBehavior
     * @return \StructType\ViaRoute_WithBehavior
     */
    public function setViaRouteBehavior($viaRouteBehavior = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\EnumViaRouteBehavior::valueIsValid($viaRouteBehavior)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $viaRouteBehavior, implode(', ', \EnumType\EnumViaRouteBehavior::getValidValues())), __LINE__);
        }
        $this->ViaRouteBehavior = $viaRouteBehavior;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ViaRoute_WithBehavior
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
